#line 1 "ad_s390.cpp"
//
// Copyright (c) 2017, 2024, Oracle and/or its affiliates. All rights reserved.
// Copyright (c) 2017, 2024 SAP SE. All rights reserved.
// DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
//
// This code is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License version 2 only, as
// published by the Free Software Foundation.
//
// This code is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// version 2 for more details (a copy is included in the LICENSE file that
// accompanied this code).
//
// You should have received a copy of the GNU General Public License version
// 2 along with this work; if not, write to the Free Software Foundation,
// Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
//
// Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
// or visit www.oracle.com if you need additional information or have any
// questions.
//

// Machine Generated File.  Do Not Edit!

#include "precompiled.hpp"
#include "adfiles/adGlobals_s390.hpp"
#include "adfiles/ad_s390.hpp"
#include "memory/allocation.inline.hpp"
#include "code/codeCache.hpp"
#include "code/compiledIC.hpp"
#include "code/nativeInst.hpp"
#include "code/vmreg.inline.hpp"
#include "gc/shared/collectedHeap.inline.hpp"
#include "oops/compressedOops.hpp"
#include "oops/markWord.hpp"
#include "oops/method.hpp"
#include "oops/oop.inline.hpp"
#include "opto/c2_MacroAssembler.hpp"
#include "opto/cfgnode.hpp"
#include "opto/intrinsicnode.hpp"
#include "opto/locknode.hpp"
#include "opto/opcodes.hpp"
#include "opto/regalloc.hpp"
#include "opto/regmask.hpp"
#include "opto/runtime.hpp"
#include "runtime/safepointMechanism.hpp"
#include "runtime/sharedRuntime.hpp"
#include "runtime/stubRoutines.hpp"
#include "utilities/growableArray.hpp"
#include "utilities/powerOfTwo.hpp"

//SourceForm

#line 577 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"


#ifdef PRODUCT
#define BLOCK_COMMENT(str)
#define BIND(label)        __ bind(label)
#else
#define BLOCK_COMMENT(str) __ block_comment(str)
#define BIND(label)        __ bind(label); BLOCK_COMMENT(#label ":")
#endif

#define __ masm->

#define Z_DISP_SIZE Immediate::is_uimm12((long)opnd_array(1)->disp(ra_,this,2)) ?  4 : 6
#define Z_DISP3_SIZE 6

// Tertiary op of a LoadP or StoreP encoding.
#define REGP_OP true

// Given a register encoding, produce an Integer Register object.
static Register reg_to_register_object(int register_encoding);

// ****************************************************************************

// REQUIRED FUNCTIONALITY

// !!!!! Special hack to get all type of calls to specify the byte offset
//       from the start of the call to the point where the return address
//       will point.

void PhaseOutput::pd_perform_mach_node_analysis() {
}

int MachNode::pd_alignment_required() const {
  return 1;
}

int MachNode::compute_padding(int current_offset) const {
  return 0;
}

int MachCallStaticJavaNode::ret_addr_offset() {
  if (_method) {
    return 8;
  } else {
    return MacroAssembler::call_far_patchable_ret_addr_offset();
  }
}

int MachCallDynamicJavaNode::ret_addr_offset() {
  // Consider size of receiver type profiling (C2 tiers).
  int profile_receiver_type_size = 0;

  int vtable_index = this->_vtable_index;
  if (vtable_index == -4) {
    return 14 + profile_receiver_type_size;
  } else {
    assert(!UseInlineCaches, "expect vtable calls only if not using ICs");
    return 36 + profile_receiver_type_size;
  }
}

int MachCallRuntimeNode::ret_addr_offset() {
  return 12 + MacroAssembler::call_far_patchable_ret_addr_offset();
}

// Compute padding required for nodes which need alignment
//
// The addresses of the call instructions needs to be 4-byte aligned to
// ensure that they don't span a cache line so that they are atomically patchable.
// The actual calls get emitted at different offsets within the node emitters.
// ins_alignment needs to be set to 2 which means that up to 1 nop may get inserted.

int CallStaticJavaDirect_dynTOCNode::compute_padding(int current_offset) const {
  return (0 - current_offset) & 2;
}

int CallDynamicJavaDirect_dynTOCNode::compute_padding(int current_offset) const {
  return (6 - current_offset) & 2;
}

int CallRuntimeDirectNode::compute_padding(int current_offset) const {
  return (12 - current_offset) & 2;
}

int CallLeafDirectNode::compute_padding(int current_offset) const {
  return (12 - current_offset) & 2;
}

int CallLeafNoFPDirectNode::compute_padding(int current_offset) const {
  return (12 - current_offset) & 2;
}

void emit_nop(C2_MacroAssembler *masm) {
  __ z_nop();
}

// Emit an interrupt that is caught by the debugger (for debugging compiler).
void emit_break(C2_MacroAssembler *masm) {
  __ z_illtrap();
}

#if !defined(PRODUCT)
void MachBreakpointNode::format(PhaseRegAlloc *, outputStream *os) const {
  os->print("TA");
}
#endif

void MachBreakpointNode::emit(C2_MacroAssembler *masm, PhaseRegAlloc *ra_) const {
  emit_break(masm);
}

uint MachBreakpointNode::size(PhaseRegAlloc *ra_) const {
  return MachNode::size(ra_);
}

static inline void z_emit16(C2_MacroAssembler *masm, long value) {
  __ emit_instruction((unsigned long)value, 2);
}

static inline void z_emit32(C2_MacroAssembler *masm, long value) {
  __ emit_instruction((unsigned long)value, 4);
}

static inline void z_emit48(C2_MacroAssembler *masm, long value) {
  __ emit_instruction((unsigned long)value, 6);
}

static inline unsigned int z_emit_inst(C2_MacroAssembler *masm, long value) {
  if (value < 0) {
    // There obviously has been an unintended sign extension (int->long). Revert it.
    value = (long)((unsigned long)((unsigned int)value));
  }

  int len = __ emit_instruction((unsigned long)value, 0);
  return len;
}

// Check effective address (at runtime) for required alignment.
static inline void z_assert_aligned(C2_MacroAssembler *masm, int disp, Register index, Register base, int alignment) {
  __ z_lay(Z_R0, disp, index, base);
  __ z_nill(Z_R0, alignment-1);
  __ z_brc(Assembler::bcondEqual, +3);
  __ z_illtrap();
}

int emit_call_reloc(C2_MacroAssembler *masm, intptr_t entry_point, relocInfo::relocType rtype,
                    PhaseRegAlloc* ra_, bool is_native_call = false) {
  __ set_inst_mark(); // Used in z_enc_java_static_call() and emit_java_to_interp().
  address old_mark = __ inst_mark();
  unsigned int start_off = __ offset();

  if (is_native_call) {
    ShouldNotReachHere();
  }

  if (rtype == relocInfo::runtime_call_w_cp_type) {
    assert((__ offset() & 2) == 0, "misaligned emit_call_reloc");
    address call_addr = __ call_c_opt((address)entry_point);
    if (call_addr == nullptr) {
      Compile::current()->env()->record_out_of_memory_failure();
      return -1;
    }
  } else {
    assert(rtype == relocInfo::none || rtype == relocInfo::opt_virtual_call_type ||
           rtype == relocInfo::static_call_type, "unexpected rtype");
    __ relocate(rtype);
    // BRASL must be prepended with a nop to identify it in the instruction stream.
    __ z_nop();
    __ z_brasl(Z_R14, (address)entry_point);
  }

  unsigned int ret_off = __ offset();

  return (ret_off - start_off);
}

static int emit_call_reloc(C2_MacroAssembler *masm, intptr_t entry_point, RelocationHolder const& rspec) {
  __ set_inst_mark(); // Used in z_enc_java_static_call() and emit_java_to_interp().
  address old_mark = __ inst_mark();
  unsigned int start_off = __ offset();

  relocInfo::relocType rtype = rspec.type();
  assert(rtype == relocInfo::opt_virtual_call_type || rtype == relocInfo::static_call_type,
         "unexpected rtype");

  __ relocate(rspec);
  __ z_nop();
  __ z_brasl(Z_R14, (address)entry_point);

  unsigned int ret_off = __ offset();

  return (ret_off - start_off);
}

//=============================================================================

const RegMask& MachConstantBaseNode::_out_RegMask = _Z_PTR_REG_mask;
int ConstantTable::calculate_table_base_offset() const {
  return 0;  // absolute addressing, no offset
}

bool MachConstantBaseNode::requires_postalloc_expand() const { return false; }
void MachConstantBaseNode::postalloc_expand(GrowableArray <Node *> *nodes, PhaseRegAlloc *ra_) {
  ShouldNotReachHere();
}

// Even with PC-relative TOC addressing, we still need this node.
// Float loads/stores do not support PC-relative addresses.
void MachConstantBaseNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  Register Rtoc = as_Register(ra_->get_encode(this));
  __ load_toc(Rtoc);
}

uint MachConstantBaseNode::size(PhaseRegAlloc* ra_) const {
  // PCrelative TOC access.
  return 6;   // sizeof(LARL)
}

#if !defined(PRODUCT)
void MachConstantBaseNode::format(PhaseRegAlloc* ra_, outputStream* st) const {
  Register r = as_Register(ra_->get_encode(this));
  st->print("LARL    %s,&constant_pool # MachConstantBaseNode", r->name());
}
#endif

//=============================================================================

#include "gc/shared/barrierSetAssembler.hpp"

#if !defined(PRODUCT)
void MachPrologNode::format(PhaseRegAlloc *ra_, outputStream *st) const {
  Compile* C = ra_->C;
  st->print_cr("--- MachPrologNode ---");
  st->print("\t");
  for (int i = 0; i < OptoPrologueNops; i++) {
    st->print_cr("NOP"); st->print("\t");
  }

  long framesize = C->output()->frame_size_in_bytes();
  int bangsize   = C->output()->bang_size_in_bytes();

  // Calls to C2R adapters often do not accept exceptional returns.
  // We require that their callers must bang for them. But be
  // careful, because some VM calls (such as call site linkage) can
  // use several kilobytes of stack. But the stack safety zone should
  // account for that. See bugs 4446381, 4468289, 4497237.
  if (C->output()->need_stack_bang(bangsize)) {
    st->print_cr("# stack bang"); st->print("\t");
  }
  st->print_cr("push_frame %d", (int)-framesize);
  st->print("\t");

  if (C->stub_function() == nullptr) {
    st->print("nmethod entry barrier\n\t");
  }
}
#endif

void MachPrologNode::emit(C2_MacroAssembler *masm, PhaseRegAlloc *ra_) const {
  Compile* C = ra_->C;

  size_t framesize = C->output()->frame_size_in_bytes();
  size_t bangsize  = C->output()->bang_size_in_bytes();

  assert(framesize % wordSize == 0, "must preserve wordSize alignment");

  if (C->clinit_barrier_on_entry()) {
    assert(!C->method()->holder()->is_not_initialized(), "initialization should have been started");

    Label L_skip_barrier;
    Register klass = Z_R1_scratch;

    // Notify OOP recorder (don't need the relocation)
    AddressLiteral md = __ constant_metadata_address(C->method()->holder()->constant_encoding());
    __ load_const_optimized(klass, md.value());
    __ clinit_barrier(klass, Z_thread, &L_skip_barrier /*L_fast_path*/);

    __ load_const_optimized(klass, SharedRuntime::get_handle_wrong_method_stub());
    __ z_br(klass);

    __ bind(L_skip_barrier);
  }

  // Calls to C2R adapters often do not accept exceptional returns.
  // We require that their callers must bang for them. But be
  // careful, because some VM calls (such as call site linkage) can
  // use several kilobytes of stack. But the stack safety zone should
  // account for that. See bugs 4446381, 4468289, 4497237.
  if (C->output()->need_stack_bang(bangsize)) {
    __ generate_stack_overflow_check(bangsize);
  }

  assert(Immediate::is_uimm32((long)framesize), "to do: choose suitable types!");
  __ save_return_pc();

  // The z/Architecture abi is already accounted for in `framesize' via the
  // 'out_preserve_stack_slots' declaration.
  __ push_frame((unsigned int)framesize/*includes JIT ABI*/);

  if (C->has_mach_constant_base_node()) {
    // NOTE: We set the table base offset here because users might be
    // emitted before MachConstantBaseNode.
    ConstantTable& constant_table = C->output()->constant_table();
    constant_table.set_table_base_offset(constant_table.calculate_table_base_offset());
  }

  if (C->stub_function() == nullptr) {
    BarrierSetAssembler* bs = BarrierSet::barrier_set()->barrier_set_assembler();
    bs->nmethod_entry_barrier(masm);
  }

  C->output()->set_frame_complete(__ offset());
}

uint MachPrologNode::size(PhaseRegAlloc *ra_) const {
  // Variable size. Determine dynamically.
  return MachNode::size(ra_);
}

int MachPrologNode::reloc() const {
  // Return number of relocatable values contained in this instruction.
  return 1; // One reloc entry for load_const(toc).
}

//=============================================================================

#if !defined(PRODUCT)
void MachEpilogNode::format(PhaseRegAlloc *ra_, outputStream *os) const {
  os->print_cr("epilog");
  os->print("\t");
  if (do_polling() && ra_->C->is_method_compilation()) {
    os->print_cr("load_from_polling_page Z_R1_scratch");
    os->print("\t");
  }
}
#endif

void MachEpilogNode::emit(C2_MacroAssembler *masm, PhaseRegAlloc *ra_) const {
  Compile* C = ra_->C;

  // If this does safepoint polling, then do it here.
  bool need_polling = do_polling() && C->is_method_compilation();

  // Pop frame, restore return_pc, and all stuff needed by interpreter.
  int frame_size_in_bytes = Assembler::align((C->output()->frame_slots() << LogBytesPerInt), frame::alignment_in_bytes);
  __ pop_frame_restore_retPC(frame_size_in_bytes);

  if (StackReservedPages > 0 && C->has_reserved_stack_access()) {
    __ reserved_stack_check(Z_R14);
  }

  // Touch the polling page.
  if (need_polling) {
    __ z_lg(Z_R1_scratch, Address(Z_thread, JavaThread::polling_page_offset()));
    // We need to mark the code position where the load from the safepoint
    // polling page was emitted as relocInfo::poll_return_type here.
    __ relocate(relocInfo::poll_return_type);
    __ load_from_polling_page(Z_R1_scratch);
  }
}

uint MachEpilogNode::size(PhaseRegAlloc *ra_) const {
  // Variable size. determine dynamically.
  return MachNode::size(ra_);
}

int MachEpilogNode::reloc() const {
  // Return number of relocatable values contained in this instruction.
  return 1; // One for load_from_polling_page.
}

const Pipeline * MachEpilogNode::pipeline() const {
  return MachNode::pipeline_class();
}

//=============================================================================

// Figure out which register class each belongs in: rc_int, rc_float, rc_stack.
enum RC { rc_bad, rc_int, rc_float, rc_stack };

static enum RC rc_class(OptoReg::Name reg) {
  // Return the register class for the given register. The given register
  // reg is a <register>_num value, which is an index into the MachRegisterNumbers
  // enumeration in adGlobals_s390.hpp.

  if (reg == OptoReg::Bad) {
    return rc_bad;
  }

  // We have 32 integer register halves, starting at index 0.
  if (reg < 32) {
    return rc_int;
  }

  // We have 32 floating-point register halves, starting at index 32.
  if (reg < 32+32) {
    return rc_float;
  }

  // Between float regs & stack are the flags regs.
  assert(reg >= OptoReg::stack0(), "blow up if spilling flags");
  return rc_stack;
}

// Returns size as obtained from z_emit_instr.
static unsigned int z_ld_st_helper(C2_MacroAssembler *masm, const char *op_str, unsigned long opcode,
                                   int reg, int offset, bool do_print, outputStream *os) {

  if (masm) {
    if (opcode > (1L<<32)) {
      return z_emit_inst(masm, opcode | Assembler::reg(Matcher::_regEncode[reg], 8, 48) |
                         Assembler::simm20(offset) | Assembler::reg(Z_R0, 12, 48) | Assembler::regz(Z_SP, 16, 48));
    } else {
      return z_emit_inst(masm, opcode | Assembler::reg(Matcher::_regEncode[reg], 8, 32) |
                         Assembler::uimm12(offset, 20, 32) | Assembler::reg(Z_R0, 12, 32) | Assembler::regz(Z_SP, 16, 32));
    }
  }

#if !defined(PRODUCT)
  if (do_print) {
    os->print("%s    %s,#%d[,SP]\t # MachCopy spill code",op_str, Matcher::regName[reg], offset);
  }
#endif
  return (opcode > (1L << 32)) ? 6 : 4;
}

static unsigned int z_mvc_helper(C2_MacroAssembler *masm, int len, int dst_off, int src_off, bool do_print, outputStream *os) {
  if (masm) {
    __ z_mvc(dst_off, len-1, Z_SP, src_off, Z_SP);
  }

#if !defined(PRODUCT)
  else if (do_print) {
    os->print("MVC     %d(%d,SP),%d(SP)\t # MachCopy spill code",dst_off, len, src_off);
  }
#endif

  return 6;
}

uint MachSpillCopyNode::implementation(C2_MacroAssembler *masm, PhaseRegAlloc *ra_, bool do_size, outputStream *os) const {
  // Get registers to move.
  OptoReg::Name src_hi = ra_->get_reg_second(in(1));
  OptoReg::Name src_lo = ra_->get_reg_first(in(1));
  OptoReg::Name dst_hi = ra_->get_reg_second(this);
  OptoReg::Name dst_lo = ra_->get_reg_first(this);

  enum RC src_hi_rc = rc_class(src_hi);
  enum RC src_lo_rc = rc_class(src_lo);
  enum RC dst_hi_rc = rc_class(dst_hi);
  enum RC dst_lo_rc = rc_class(dst_lo);

  assert(src_lo != OptoReg::Bad && dst_lo != OptoReg::Bad, "must move at least 1 register");
  bool is64 = (src_hi_rc != rc_bad);
  assert(!is64 ||
         ((src_lo&1) == 0 && src_lo+1 == src_hi && (dst_lo&1) == 0 && dst_lo+1 == dst_hi),
         "expected aligned-adjacent pairs");

  // Generate spill code!

  if (src_lo == dst_lo && src_hi == dst_hi) {
    return 0;            // Self copy, no move.
  }

  int  src_offset = ra_->reg2offset(src_lo);
  int  dst_offset = ra_->reg2offset(dst_lo);
  bool print = !do_size;
  bool src12 = Immediate::is_uimm12(src_offset);
  bool dst12 = Immediate::is_uimm12(dst_offset);

  const char   *mnemo = nullptr;
  unsigned long opc = 0;

  // Memory->Memory Spill. Use Z_R0 to hold the value.
  if (src_lo_rc == rc_stack && dst_lo_rc == rc_stack) {

    assert(!is64 || (src_hi_rc==rc_stack && dst_hi_rc==rc_stack),
           "expected same type of move for high parts");

    if (src12 && dst12) {
      return z_mvc_helper(masm, is64 ? 8 : 4, dst_offset, src_offset, print, os);
    }

    int r0 = Z_R0_num;
    if (is64) {
      return z_ld_st_helper(masm, "LG  ", LG_ZOPC, r0, src_offset, print, os) +
             z_ld_st_helper(masm, "STG ", STG_ZOPC, r0, dst_offset, print, os);
    }

    return z_ld_st_helper(masm, "LY   ", LY_ZOPC, r0, src_offset, print, os) +
           z_ld_st_helper(masm, "STY  ", STY_ZOPC, r0, dst_offset, print, os);
  }

  // Check for float->int copy. Requires a trip through memory.
  if (src_lo_rc == rc_float && dst_lo_rc == rc_int) {
    Unimplemented();  // Unsafe, do not remove!
  }

  // Check for integer reg-reg copy.
  if (src_lo_rc == rc_int && dst_lo_rc == rc_int) {
    if (masm) {
      Register Rsrc = as_Register(Matcher::_regEncode[src_lo]);
      Register Rdst = as_Register(Matcher::_regEncode[dst_lo]);
      __ z_lgr(Rdst, Rsrc);
      return 4;
    }
#if !defined(PRODUCT)
    // else
    if (print) {
      os->print("LGR     %s,%s\t # MachCopy spill code", Matcher::regName[dst_lo], Matcher::regName[src_lo]);
    }
#endif
    return 4;
  }

  // Check for integer store.
  if (src_lo_rc == rc_int && dst_lo_rc == rc_stack) {
    assert(!is64 || (src_hi_rc==rc_int && dst_hi_rc==rc_stack),
           "expected same type of move for high parts");

    if (is64) {
      return z_ld_st_helper(masm, "STG ", STG_ZOPC, src_lo, dst_offset, print, os);
    }

    // else
    mnemo = dst12 ? "ST  " : "STY ";
    opc = dst12 ? ST_ZOPC : STY_ZOPC;

    return z_ld_st_helper(masm, mnemo, opc, src_lo, dst_offset, print, os);
  }

  // Check for integer load
  // Always load cOops zero-extended. That doesn't hurt int loads.
  if (dst_lo_rc == rc_int && src_lo_rc == rc_stack) {

    assert(!is64 || (dst_hi_rc==rc_int && src_hi_rc==rc_stack),
           "expected same type of move for high parts");

    mnemo = is64 ? "LG  " : "LLGF";
    opc = is64 ? LG_ZOPC : LLGF_ZOPC;

    return z_ld_st_helper(masm, mnemo, opc, dst_lo, src_offset, print, os);
  }

  // Check for float reg-reg copy.
  if (src_lo_rc == rc_float && dst_lo_rc == rc_float) {
    if (masm) {
      FloatRegister Rsrc = as_FloatRegister(Matcher::_regEncode[src_lo]);
      FloatRegister Rdst = as_FloatRegister(Matcher::_regEncode[dst_lo]);
      __ z_ldr(Rdst, Rsrc);
      return 2;
    }
#if !defined(PRODUCT)
    // else
    if (print) {
      os->print("LDR      %s,%s\t # MachCopy spill code", Matcher::regName[dst_lo], Matcher::regName[src_lo]);
    }
#endif
    return 2;
  }

  // Check for float store.
  if (src_lo_rc == rc_float && dst_lo_rc == rc_stack) {
    assert(!is64 || (src_hi_rc==rc_float && dst_hi_rc==rc_stack),
           "expected same type of move for high parts");

    if (is64) {
      mnemo = dst12 ? "STD  " : "STDY ";
      opc = dst12 ? STD_ZOPC : STDY_ZOPC;
      return z_ld_st_helper(masm, mnemo, opc, src_lo, dst_offset, print, os);
    }
    // else

    mnemo = dst12 ? "STE  " : "STEY ";
    opc = dst12 ? STE_ZOPC : STEY_ZOPC;
    return z_ld_st_helper(masm, mnemo, opc, src_lo, dst_offset, print, os);
  }

  // Check for float load.
  if (dst_lo_rc == rc_float && src_lo_rc == rc_stack) {
    assert(!is64 || (dst_hi_rc==rc_float && src_hi_rc==rc_stack),
           "expected same type of move for high parts");

    if (is64) {
      mnemo = src12 ? "LD   " : "LDY  ";
      opc = src12 ? LD_ZOPC : LDY_ZOPC;
      return z_ld_st_helper(masm, mnemo, opc, dst_lo, src_offset, print, os);
    }
    // else

    mnemo = src12 ? "LE   " : "LEY  ";
    opc = src12 ? LE_ZOPC : LEY_ZOPC;
    return z_ld_st_helper(masm, mnemo, opc, dst_lo, src_offset, print, os);
  }

  // --------------------------------------------------------------------
  // Check for hi bits still needing moving. Only happens for misaligned
  // arguments to native calls.
  if (src_hi == dst_hi) {
    return 0;               // Self copy, no move.
  }

  assert(is64 && dst_hi_rc != rc_bad, "src_hi & dst_hi cannot be Bad");
  Unimplemented();  // Unsafe, do not remove!

  return 0; // never reached, but make the compiler shut up!
}

#if !defined(PRODUCT)
void MachSpillCopyNode::format(PhaseRegAlloc *ra_, outputStream *os) const {
  if (ra_ && ra_->node_regs_max_index() > 0) {
    implementation(nullptr, ra_, false, os);
  } else {
    if (req() == 2 && in(1)) {
      os->print("N%d = N%d\n", _idx, in(1)->_idx);
    } else {
      const char *c = "(";
      os->print("N%d = ", _idx);
      for (uint i = 1; i < req(); ++i) {
        os->print("%sN%d", c, in(i)->_idx);
        c = ", ";
      }
      os->print(")");
    }
  }
}
#endif

void MachSpillCopyNode::emit(C2_MacroAssembler *masm, PhaseRegAlloc *ra_) const {
  implementation(masm, ra_, false, nullptr);
}

uint MachSpillCopyNode::size(PhaseRegAlloc *ra_) const {
  return implementation(nullptr, ra_, true, nullptr);
}

//=============================================================================

#if !defined(PRODUCT)
void MachNopNode::format(PhaseRegAlloc *, outputStream *os) const {
  os->print("NOP     # pad for alignment (%d nops, %d bytes)", _count, _count*MacroAssembler::nop_size());
}
#endif

void MachNopNode::emit(C2_MacroAssembler *masm, PhaseRegAlloc * ra_) const {
  int rem_space = 0;
  if (!(ra_->C->output()->in_scratch_emit_size())) {
    rem_space = __ code()->insts()->remaining();
    if (rem_space <= _count*2 + 8) {
      tty->print("NopNode: _count = %3.3d, remaining space before = %d", _count, rem_space);
    }
  }

  for (int i = 0; i < _count; i++) {
    __ z_nop();
  }

  if (!(ra_->C->output()->in_scratch_emit_size())) {
    if (rem_space <= _count*2 + 8) {
      int rem_space2 = __ code()->insts()->remaining();
      tty->print_cr(", after = %d", rem_space2);
    }
  }
}

uint MachNopNode::size(PhaseRegAlloc *ra_) const {
   return 2 * _count;
}

#if !defined(PRODUCT)
void BoxLockNode::format(PhaseRegAlloc *ra_, outputStream *os) const {
  int offset = ra_->reg2offset(in_RegMask(0).find_first_elem());
  if (ra_ && ra_->node_regs_max_index() > 0) {
    int reg = ra_->get_reg_first(this);
    os->print("ADDHI  %s, SP, %d\t//box node", Matcher::regName[reg], offset);
  } else {
    os->print("ADDHI  N%d = SP + %d\t// box node", _idx, offset);
  }
}
#endif

// Take care of the size function, if you make changes here!
void BoxLockNode::emit(C2_MacroAssembler *masm, PhaseRegAlloc *ra_) const {
  int offset = ra_->reg2offset(in_RegMask(0).find_first_elem());
  int reg = ra_->get_encode(this);
  __ z_lay(as_Register(reg), offset, Z_SP);
}

uint BoxLockNode::size(PhaseRegAlloc *ra_) const {
  // BoxLockNode is not a MachNode, so we can't just call MachNode::size(ra_)
  return 6;
}

 
#line 752 "ad_s390.cpp"


//SourceForm

#line 1309 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"


#if !defined(PRODUCT)
void MachUEPNode::format(PhaseRegAlloc *ra_, outputStream *os) const {
  os->print_cr("---- MachUEPNode ----");
  os->print_cr("\tTA");
  os->print_cr("\tload_const Z_R1, SharedRuntime::get_ic_miss_stub()");
  os->print_cr("\tBR(Z_R1)");
  os->print_cr("\tTA  # pad with illtraps");
  os->print_cr("\t...");
  os->print_cr("\tTA");
  os->print_cr("\tLTGR    Z_R2, Z_R2");
  os->print_cr("\tBRU     ic_miss");
}
#endif

void MachUEPNode::emit(C2_MacroAssembler *masm, PhaseRegAlloc *ra_) const {
  // This is Unverified Entry Point
  __ ic_check(CodeEntryAlignment);
}

uint MachUEPNode::size(PhaseRegAlloc *ra_) const {
  // Determine size dynamically.
  return MachNode::size(ra_);
}

//=============================================================================


#line 787 "ad_s390.cpp"


//SourceForm

#line 1365 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"


// This exception handler code snippet is placed after the method's
// code. It is the return point if an exception occurred. it jumps to
// the exception blob.
//
// If the method gets deoptimized, the method and this code snippet
// get patched.
//
// 1) Trampoline code gets patched into the end of this exception
//   handler. the trampoline code jumps to the deoptimization blob.
//
// 2) The return address in the method's code will get patched such
//   that it jumps to the trampoline.
//
// 3) The handler will get patched such that it does not jump to the
//   exception blob, but to an entry in the deoptimization blob being
//   aware of the exception.
int HandlerImpl::emit_exception_handler(C2_MacroAssembler *masm) {
  Register temp_reg = Z_R1;

  address base = __ start_a_stub(size_exception_handler());
  if (base == nullptr) {
    ciEnv::current()->record_failure("CodeCache is full");
    return 0;          // CodeBuffer::expand failed
  }

  int offset = __ offset();
  // Use unconditional pc-relative jump with 32-bit range here.
  __ load_const_optimized(temp_reg, (address)OptoRuntime::exception_blob()->content_begin());
  __ z_br(temp_reg);

  assert(__ offset() - offset <= (int) size_exception_handler(), "overflow");

  __ end_a_stub();

  return offset;
}

// Emit deopt handler code.
int HandlerImpl::emit_deopt_handler(C2_MacroAssembler* masm) {
  address        base = __ start_a_stub(size_deopt_handler());

  if (base == nullptr) {
    ciEnv::current()->record_failure("CodeCache is full");
    return 0;  // CodeBuffer::expand failed
  }

  int offset = __ offset();

  // Size_deopt_handler() must be exact on zarch, so for simplicity
  // we do not use load_const_opt here.
  __ load_const(Z_R1, SharedRuntime::deopt_blob()->unpack());
  __ call(Z_R1);
  assert(__ offset() - offset == (int) size_deopt_handler(), "must be fixed size");

  __ end_a_stub();
  return offset;
}

//=============================================================================


// Given a register encoding, produce an Integer Register object.
static Register reg_to_register_object(int register_encoding) {
  assert(Z_R12->encoding() == Z_R12_enc, "wrong coding");
  return as_Register(register_encoding);
}

bool Matcher::match_rule_supported(int opcode) {
  if (!has_match_rule(opcode)) {
    return false; // no match rule present
  }

  switch (opcode) {
    case Op_ReverseBytesI:
    case Op_ReverseBytesL:
      return UseByteReverseInstruction;
    case Op_PopCountI:
    case Op_PopCountL:
      // PopCount supported by H/W from z/Architecture G5 (z196) on.
      return (UsePopCountInstruction && VM_Version::has_PopCount());
    case Op_FmaF:
    case Op_FmaD:
      return UseFMA;
  }

  return true; // Per default match rules are supported.
}

bool Matcher::match_rule_supported_auto_vectorization(int opcode, int vlen, BasicType bt) {
  return match_rule_supported_vector(opcode, vlen, bt);
}

bool Matcher::match_rule_supported_vector(int opcode, int vlen, BasicType bt) {
  if (!match_rule_supported(opcode) || !vector_size_supported(bt, vlen)) {
    return false;
  }
  return true; // Per default match rules are supported.
}

bool Matcher::match_rule_supported_vector_masked(int opcode, int vlen, BasicType bt) {
  return false;
}

bool Matcher::vector_needs_partial_operations(Node* node, const TypeVect* vt) {
  return false;
}

const RegMask* Matcher::predicate_reg_mask(void) {
  return nullptr;
}

const TypeVectMask* Matcher::predicate_reg_type(const Type* elemTy, int length) {
  return nullptr;
}

// Vector calling convention not yet implemented.
bool Matcher::supports_vector_calling_convention(void) {
  return false;
}

OptoRegPair Matcher::vector_return_value(uint ideal_reg) {
  Unimplemented();
  return OptoRegPair(0, 0);
}

//----------SUPERWORD HELPERS----------------------------------------

// Vector width in bytes.
int Matcher::vector_width_in_bytes(BasicType bt) {
  assert(MaxVectorSize == 8, "");
  return 8;
}

// Vector ideal reg.
uint Matcher::vector_ideal_reg(int size) {
  assert(MaxVectorSize == 8 && size == 8, "");
  return Op_RegL;
}

// Limits on vector size (number of elements) loaded into vector.
int Matcher::max_vector_size(const BasicType bt) {
  assert(is_java_primitive(bt), "only primitive type vectors");
  return vector_width_in_bytes(bt)/type2aelembytes(bt);
}

int Matcher::min_vector_size(const BasicType bt) {
  return max_vector_size(bt); // Same as max.
}

int Matcher::max_vector_size_auto_vectorization(const BasicType bt) {
  return Matcher::max_vector_size(bt);
}

int Matcher::scalable_vector_reg_size(const BasicType bt) {
  return -1;
}

// RETURNS: whether this branch offset is short enough that a short
// branch can be used.
//
// If the platform does not provide any short branch variants, then
// this method should return `false' for offset 0.
//
// `Compile::Fill_buffer' will decide on basis of this information
// whether to do the pass `Compile::Shorten_branches' at all.
//
// And `Compile::Shorten_branches' will decide on basis of this
// information whether to replace particular branch sites by short
// ones.
bool Matcher::is_short_branch_offset(int rule, int br_size, int offset) {
  // On zarch short branches use a 16 bit signed immediate that
  // is the pc-relative offset in halfword (= 2 bytes) units.
  return Assembler::is_within_range_of_RelAddr16((address)((long)offset), (address)0);
}

MachOper* Matcher::pd_specialize_generic_vector_operand(MachOper* original_opnd, uint ideal_reg, bool is_temp) {
  ShouldNotReachHere(); // generic vector operands not supported
  return nullptr;
}

bool Matcher::is_reg2reg_move(MachNode* m) {
  ShouldNotReachHere();  // generic vector operands not supported
  return false;
}

bool Matcher::is_generic_vector(MachOper* opnd)  {
  ShouldNotReachHere();  // generic vector operands not supported
  return false;
}

// Constants for c2c and c calling conventions.

const MachRegisterNumbers z_iarg_reg[5] = {
  Z_R2_num, Z_R3_num, Z_R4_num, Z_R5_num, Z_R6_num
};

const MachRegisterNumbers z_farg_reg[4] = {
  Z_F0_num, Z_F2_num, Z_F4_num, Z_F6_num
};

const int z_num_iarg_registers = sizeof(z_iarg_reg) / sizeof(z_iarg_reg[0]);

const int z_num_farg_registers = sizeof(z_farg_reg) / sizeof(z_farg_reg[0]);

// Return whether or not this register is ever used as an argument. This
// function is used on startup to build the trampoline stubs in generateOptoStub.
// Registers not mentioned will be killed by the VM call in the trampoline, and
// arguments in those registers not be available to the callee.
bool Matcher::can_be_java_arg(int reg) {
  // We return true for all registers contained in z_iarg_reg[] and
  // z_farg_reg[] and their virtual halves.
  // We must include the virtual halves in order to get STDs and LDs
  // instead of STWs and LWs in the trampoline stubs.

  if (reg == Z_R2_num || reg == Z_R2_H_num ||
      reg == Z_R3_num || reg == Z_R3_H_num ||
      reg == Z_R4_num || reg == Z_R4_H_num ||
      reg == Z_R5_num || reg == Z_R5_H_num ||
      reg == Z_R6_num || reg == Z_R6_H_num) {
    return true;
  }

  if (reg == Z_F0_num || reg == Z_F0_H_num ||
      reg == Z_F2_num || reg == Z_F2_H_num ||
      reg == Z_F4_num || reg == Z_F4_H_num ||
      reg == Z_F6_num || reg == Z_F6_H_num) {
    return true;
  }

  return false;
}

bool Matcher::is_spillable_arg(int reg) {
  return can_be_java_arg(reg);
}

uint Matcher::int_pressure_limit()
{
  // Medium size register set, 6 special purpose regs, 3 SOE regs.
  return (INTPRESSURE == -1) ? 10 : INTPRESSURE;
}

uint Matcher::float_pressure_limit()
{
  return (FLOATPRESSURE == -1) ? 15 : FLOATPRESSURE;
}

bool Matcher::use_asm_for_ldiv_by_con(jlong divisor) {
  return false;
}

// Register for DIVI projection of divmodI
RegMask Matcher::divI_proj_mask() {
  return _Z_RARG4_INT_REG_mask;
}

// Register for MODI projection of divmodI
RegMask Matcher::modI_proj_mask() {
  return _Z_RARG3_INT_REG_mask;
}

// Register for DIVL projection of divmodL
RegMask Matcher::divL_proj_mask() {
  return _Z_RARG4_LONG_REG_mask;
}

// Register for MODL projection of divmodL
RegMask Matcher::modL_proj_mask() {
  return _Z_RARG3_LONG_REG_mask;
}

// Copied from sparc.
const RegMask Matcher::method_handle_invoke_SP_save_mask() {
  return RegMask();
}

// Should the matcher clone input 'm' of node 'n'?
bool Matcher::pd_clone_node(Node* n, Node* m, Matcher::MStack& mstack) {
  return false;
}

// Should the Matcher clone shifts on addressing modes, expecting them
// to be subsumed into complex addressing expressions or compute them
// into registers?
bool Matcher::pd_clone_address_expressions(AddPNode* m, Matcher::MStack& mstack, VectorSet& address_visited) {
  return clone_base_plus_offset_address(m, mstack, address_visited);
}


#line 1084 "ad_s390.cpp"


//SourceForm

#line 2241 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"


  // Check whether outs are all Stores. If so, we can omit clearing the upper
  // 32 bits after encoding.
  static bool all_outs_are_Stores(const Node *n) {
    for (DUIterator_Fast imax, k = n->fast_outs(imax); k < imax; k++) {
      Node *out = n->fast_out(k);
      if (!out->is_Mach() || out->as_Mach()->ideal_Opcode() != Op_StoreN) {
        // Most other outs are SpillCopy, but there are various other.
        // jvm98 has arond 9% Encodes where we return false.
        return false;
      }
    }
    return true;
  }


#line 1107 "ad_s390.cpp"


#ifndef PRODUCT
void Compile::adlc_verification() {

  // Following assertions generated from definition section
  assert( DEFAULT_COST == 100, "Expect (100) to equal 100");
  assert( DEFAULT_COST_LOW == 80, "Expect (80) to equal 80");
  assert( DEFAULT_COST_HIGH == 120, "Expect (120) to equal 120");
  assert( HUGE_COST == 1000000, "Expect (1000000) to equal 1000000");
  assert( ALU_REG_COST == 100, "Expect (DEFAULT_COST) to equal 100");
  assert( ALU_MEMORY_COST == 150, "Expect (150) to equal 150");
  assert( MEMORY_REF_COST_HI == 220, "Expect (2 * DEFAULT_COST+20) to equal 220");
  assert( MEMORY_REF_COST == 200, "Expect (2 * DEFAULT_COST) to equal 200");
  assert( MEMORY_REF_COST_LO == 180, "Expect (2 * DEFAULT_COST-20) to equal 180");
  assert( BRANCH_COST == 300, "Expect (DEFAULT_COST * 3) to equal 300");
  assert( CALL_COST == 300, "Expect (DEFAULT_COST * 3) to equal 300");
}
#endif

// Map from machine-independent register number to register_save_policy
const        char register_save_policy[] = {
  'C', // Z_R13
  'C', // Z_R13_H
  'C', // Z_R12
  'C', // Z_R12_H
  'C', // Z_R11
  'C', // Z_R11_H
  'C', // Z_R10
  'C', // Z_R10_H
  'C', // Z_R9
  'C', // Z_R9_H
  'C', // Z_R8
  'C', // Z_R8_H
  'C', // Z_R7
  'C', // Z_R7_H
  'C', // Z_R1
  'C', // Z_R1_H
  'C', // Z_R0
  'C', // Z_R0_H
  'C', // Z_R6
  'C', // Z_R6_H
  'C', // Z_R5
  'C', // Z_R5_H
  'C', // Z_R4
  'C', // Z_R4_H
  'C', // Z_R3
  'C', // Z_R3_H
  'C', // Z_R2
  'C', // Z_R2_H
  'N', // Z_R14
  'N', // Z_R14_H
  'N', // Z_R15
  'N', // Z_R15_H
  'C', // Z_F15
  'C', // Z_F15_H
  'C', // Z_F14
  'C', // Z_F14_H
  'C', // Z_F13
  'C', // Z_F13_H
  'C', // Z_F12
  'C', // Z_F12_H
  'C', // Z_F11
  'C', // Z_F11_H
  'C', // Z_F10
  'C', // Z_F10_H
  'C', // Z_F9
  'C', // Z_F9_H
  'C', // Z_F8
  'C', // Z_F8_H
  'C', // Z_F7
  'C', // Z_F7_H
  'C', // Z_F5
  'C', // Z_F5_H
  'C', // Z_F3
  'C', // Z_F3_H
  'C', // Z_F1
  'C', // Z_F1_H
  'C', // Z_F6
  'C', // Z_F6_H
  'C', // Z_F4
  'C', // Z_F4_H
  'C', // Z_F2
  'C', // Z_F2_H
  'C', // Z_F0
  'C', // Z_F0_H
  'C' // no trailing comma // Z_CR
};

// Map from machine-independent register number to c_reg_save_policy
const        char c_reg_save_policy[] = {
  'E', // Z_R13
  'E', // Z_R13_H
  'E', // Z_R12
  'E', // Z_R12_H
  'E', // Z_R11
  'E', // Z_R11_H
  'E', // Z_R10
  'E', // Z_R10_H
  'E', // Z_R9
  'E', // Z_R9_H
  'E', // Z_R8
  'E', // Z_R8_H
  'E', // Z_R7
  'E', // Z_R7_H
  'C', // Z_R1
  'C', // Z_R1_H
  'C', // Z_R0
  'C', // Z_R0_H
  'E', // Z_R6
  'E', // Z_R6_H
  'C', // Z_R5
  'C', // Z_R5_H
  'C', // Z_R4
  'C', // Z_R4_H
  'C', // Z_R3
  'C', // Z_R3_H
  'C', // Z_R2
  'C', // Z_R2_H
  'N', // Z_R14
  'N', // Z_R14_H
  'N', // Z_R15
  'N', // Z_R15_H
  'E', // Z_F15
  'E', // Z_F15_H
  'E', // Z_F14
  'E', // Z_F14_H
  'E', // Z_F13
  'E', // Z_F13_H
  'E', // Z_F12
  'E', // Z_F12_H
  'E', // Z_F11
  'E', // Z_F11_H
  'E', // Z_F10
  'E', // Z_F10_H
  'E', // Z_F9
  'E', // Z_F9_H
  'E', // Z_F8
  'E', // Z_F8_H
  'C', // Z_F7
  'C', // Z_F7_H
  'C', // Z_F5
  'C', // Z_F5_H
  'C', // Z_F3
  'C', // Z_F3_H
  'C', // Z_F1
  'C', // Z_F1_H
  'C', // Z_F6
  'C', // Z_F6_H
  'C', // Z_F4
  'C', // Z_F4_H
  'C', // Z_F2
  'C', // Z_F2_H
  'C', // Z_F0
  'C', // Z_F0_H
  'C' // no trailing comma // Z_CR
};

// Map from machine-independent register number to register_save_type
const        int register_save_type[] = {
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegFlags // no trailing comma
};


const        int   reduceOp[] = {
  /*    0 */  0,
  /*    1 */  0,
  /*    2 */  0,
  /*    3 */  0,
  /*    4 */  0,
  /*    5 */  0,
  /*    6 */  0,
  /*    7 */  0,
  /*    8 */  immB_minus1_rule,
  /*    9 */  immB_n0m1_rule,
  /*   10 */  immS_minus1_rule,
  /*   11 */  immS_n0m1_rule,
  /*   12 */  immI_rule,
  /*   13 */  immI20_rule,
  /*   14 */  immI16_rule,
  /*   15 */  immI8_rule,
  /*   16 */  immI_0_rule,
  /*   17 */  immI_minus1_rule,
  /*   18 */  immI_n0m1_rule,
  /*   19 */  uimmI_rule,
  /*   20 */  uimmI16_rule,
  /*   21 */  uimmI12_rule,
  /*   22 */  uimmI8_rule,
  /*   23 */  SSlenDW_rule,
  /*   24 */  immI_1_rule,
  /*   25 */  immI_16_rule,
  /*   26 */  immI_24_rule,
  /*   27 */  immI_32_63_rule,
  /*   28 */  uimmI_LL1_rule,
  /*   29 */  uimmI_LH1_rule,
  /*   30 */  immL_rule,
  /*   31 */  immL32_rule,
  /*   32 */  immL20_rule,
  /*   33 */  immL16_rule,
  /*   34 */  immL8_rule,
  /*   35 */  uimmL32_rule,
  /*   36 */  uimmL16_rule,
  /*   37 */  uimmL12_rule,
  /*   38 */  immL_FFFFFFFF_rule,
  /*   39 */  immL_0_rule,
  /*   40 */  uimmL_LL1_rule,
  /*   41 */  uimmL_LH1_rule,
  /*   42 */  uimmL_HL1_rule,
  /*   43 */  uimmL_HH1_rule,
  /*   44 */  immL_32bits_rule,
  /*   45 */  immP_rule,
  /*   46 */  immP16_rule,
  /*   47 */  immP8_rule,
  /*   48 */  immP0_rule,
  /*   49 */  immN_rule,
  /*   50 */  immNKlass_rule,
  /*   51 */  immN8_rule,
  /*   52 */  immN0_rule,
  /*   53 */  immD_rule,
  /*   54 */  immDpm0_rule,
  /*   55 */  immDp0_rule,
  /*   56 */  immF_rule,
  /*   57 */  immFpm0_rule,
  /*   58 */  immFp0_rule,
  /*   59 */  iRegI_rule,
  /*   60 */  noArg_iRegI_rule,
  /*   61 */  revenRegI_rule,
  /*   62 */  roddRegI_rule,
  /*   63 */  rarg1RegI_rule,
  /*   64 */  rarg2RegI_rule,
  /*   65 */  rarg3RegI_rule,
  /*   66 */  rarg4RegI_rule,
  /*   67 */  rarg5RegI_rule,
  /*   68 */  noOdd_iRegI_rule,
  /*   69 */  iRegP_rule,
  /*   70 */  threadRegP_rule,
  /*   71 */  noArg_iRegP_rule,
  /*   72 */  rarg1RegP_rule,
  /*   73 */  rarg2RegP_rule,
  /*   74 */  rarg3RegP_rule,
  /*   75 */  rarg4RegP_rule,
  /*   76 */  rarg5RegP_rule,
  /*   77 */  memoryRegP_rule,
  /*   78 */  revenRegP_rule,
  /*   79 */  roddRegP_rule,
  /*   80 */  iRegN_rule,
  /*   81 */  noArg_iRegN_rule,
  /*   82 */  rarg1RegN_rule,
  /*   83 */  rarg2RegN_rule,
  /*   84 */  rarg3RegN_rule,
  /*   85 */  rarg4RegN_rule,
  /*   86 */  rarg5RegN_rule,
  /*   87 */  iRegL_rule,
  /*   88 */  revenRegL_rule,
  /*   89 */  roddRegL_rule,
  /*   90 */  allRoddRegL_rule,
  /*   91 */  rarg1RegL_rule,
  /*   92 */  rarg5RegL_rule,
  /*   93 */  flagsReg_rule,
  /*   94 */  regD_rule,
  /*   95 */  regF_rule,
  /*   96 */  inline_cache_regP_rule,
  /*   97 */  indirect_rule,
  /*   98 */  indOffset20_rule,
  /*   99 */  indOffset20Narrow_rule,
  /*  100 */  indOffset12_rule,
  /*  101 */  indOffset12Narrow_rule,
  /*  102 */  indIndex_rule,
  /*  103 */  indOffset20index_rule,
  /*  104 */  indOffset20indexNarrow_rule,
  /*  105 */  indOffset12index_rule,
  /*  106 */  indOffset12indexNarrow_rule,
  /*  107 */  stackSlotI_rule,
  /*  108 */  stackSlotP_rule,
  /*  109 */  stackSlotF_rule,
  /*  110 */  stackSlotD_rule,
  /*  111 */  stackSlotL_rule,
  /*  112 */  cmpOpT_rule,
  /*  113 */  cmpOpF_rule,
  /*  114 */  cmpOp_rule,
  // last operand
  /*  115 */  memory_rule,
  /*  116 */  memoryRXY_rule,
  /*  117 */  memoryRX_rule,
  /*  118 */  memoryRSY_rule,
  /*  119 */  memoryRS_rule,
  /*  120 */  iRegN_P2N_rule,
  /*  121 */  iRegP_N2P_rule,
  // last operand class
  /*  122 */  _DecodeN_iRegN__rule,
  /*  123 */  _AddP_memoryRegP_iRegL_rule,
  /*  124 */  _AddP__DecodeN_iRegN__iRegL_rule,
  /*  125 */  _LoadB_memory__rule,
  /*  126 */  _LoadUB_memory__rule,
  /*  127 */  _LoadS_memory__rule,
  /*  128 */  _LoadUS_memory__rule,
  /*  129 */  _LoadI_memory__rule,
  /*  130 */  _ConvI2L__LoadI_memory___rule,
  /*  131 */  _LoadP_memory__rule,
  /*  132 */  _LoadN_memory__rule,
  /*  133 */  _LoadNKlass_memory__rule,
  /*  134 */  _Binary_iRegL_iRegN_rule,
  /*  135 */  _Binary_cmpOp_flagsReg_rule,
  /*  136 */  _Binary_iRegN_iRegN_P2N_rule,
  /*  137 */  _Binary_iRegN_immN0_rule,
  /*  138 */  _Binary_iRegI_iRegI_rule,
  /*  139 */  _Binary_iRegI_immI16_rule,
  /*  140 */  _Binary_iRegP_iRegP_N2P_rule,
  /*  141 */  _Binary_iRegP_immP0_rule,
  /*  142 */  _Binary_cmpOpF_flagsReg_rule,
  /*  143 */  _Binary_regF_regF_rule,
  /*  144 */  _Binary_regD_regD_rule,
  /*  145 */  _Binary_iRegL_iRegL_rule,
  /*  146 */  _Binary_iRegL_immL16_rule,
  /*  147 */  _Binary_rarg5RegI_iRegI_rule,
  /*  148 */  _Binary_rarg5RegL_iRegL_rule,
  /*  149 */  _Binary_rarg5RegP_iRegP_N2P_rule,
  /*  150 */  _Binary_rarg5RegN_iRegN_P2N_rule,
  /*  151 */  _AddI_iRegI_iRegI_rule,
  /*  152 */  _LoadI_memoryRSY__rule,
  /*  153 */  _AddI__LoadI_memoryRSY__immI8_rule,
  /*  154 */  _ConvI2L_iRegI__rule,
  /*  155 */  _LoadL_memory__rule,
  /*  156 */  _AddL_iRegL_iRegL_rule,
  /*  157 */  _LoadL_memoryRSY__rule,
  /*  158 */  _AddL__LoadL_memoryRSY__immL8_rule,
  /*  159 */  _AddP_iRegP_N2P_iRegL_rule,
  /*  160 */  _LoadP_memoryRSY__rule,
  /*  161 */  _AddP__LoadP_memoryRSY__immL8_rule,
  /*  162 */  _CastP2X_iRegP_N2P__rule,
  /*  163 */  _LShiftI_iRegI_immI8_rule,
  /*  164 */  _URShiftI_iRegI_immI8_rule,
  /*  165 */  _LShiftL_iRegL_immI8_rule,
  /*  166 */  _URShiftL_iRegL_immI8_rule,
  /*  167 */  _LoadF_memoryRX__rule,
  /*  168 */  _LoadD_memoryRX__rule,
  /*  169 */  _NegF_regF__rule,
  /*  170 */  _NegD_regD__rule,
  /*  171 */  _Binary_regF__LoadF_memoryRX__rule,
  /*  172 */  _Binary_regD__LoadD_memoryRX__rule,
  /*  173 */  _Binary__LoadF_memoryRX__regF_rule,
  /*  174 */  _Binary__LoadD_memoryRX__regD_rule,
  /*  175 */  _AbsF_regF__rule,
  /*  176 */  _AbsD_regD__rule,
  /*  177 */  _LShiftI_iRegI_immI_16_rule,
  /*  178 */  _LShiftI_iRegI_immI_24_rule,
  /*  179 */  _RShiftL_iRegL_immI_32_63_rule,
  /*  180 */  _CmpU_iRegI_uimmI16_rule,
  /*  181 */  _CmpU_iRegI_iRegI_rule,
  /*  182 */  _CmpP_iRegP_N2P_immP0_rule,
  /*  183 */  _CmpN_iRegN_P2N_immN0_rule,
  /*  184 */  _AbsI_iRegI__rule,
  /*  185 */  _CmpI_iRegI_iRegI_rule,
  /*  186 */  _CmpL_iRegL_iRegL_rule,
  /*  187 */  _CmpP_iRegP_iRegP_rule,
  /*  188 */  _CmpP__DecodeN_iRegN___DecodeN_iRegN__rule,
  /*  189 */  _CmpI_iRegI_immI8_rule,
  /*  190 */  _CmpU_iRegI_uimmI8_rule,
  /*  191 */  _CmpL_iRegL_immL8_rule,
  /*  192 */  _CmpP_iRegP_immP8_rule,
  /*  193 */  _CmpP__DecodeN_iRegN__immP0_rule,
  /*  194 */  _DecodeN_immN8__rule,
  /*  195 */  _CmpP__DecodeN_iRegN___DecodeN_immN8__rule,
  /*  196 */  _PartialSubtypeCheck_rarg2RegP_rarg3RegP_rule,
  /*  197 */  _Binary_iRegP_iRegP_rule,
  /*  198 */  _Binary_iRegP_rarg2RegI_rule,
  /*  199 */  _Binary_iRegP_rarg5RegI_rule,
  /*  200 */  _Binary_iRegP_iRegI_rule,
  /*  201 */  _Binary_immP_immI_1_rule,
  /*  202 */  _Binary_iRegP_immI16_rule,
  /*  203 */  _Binary_iRegP_immI_rule,
  // last internally defined operand
  /*  204 */  stackSlotI_rule,
  /*  205 */  stackSlotL_rule,
  /*  206 */  stackSlotP_rule,
  /*  207 */  stackSlotF_rule,
  /*  208 */  stackSlotD_rule,
  /*  209 */  stackSlotD_rule,
  /*  210 */  stackSlotF_rule,
  /*  211 */  iRegI_rule,
  /*  212 */  iRegL_rule,
  /*  213 */  iRegP_rule,
  /*  214 */  regF_rule,
  /*  215 */  regD_rule,
  /*  216 */  iRegI_rule,
  /*  217 */  iRegI_rule,
  /*  218 */  iRegI_rule,
  /*  219 */  iRegI_rule,
  /*  220 */  iRegL_rule,
  /*  221 */  iRegL_rule,
  /*  222 */  iRegL_rule,
  /*  223 */  iRegL_rule,
  /*  224 */  iRegP_rule,
  /*  225 */  iRegP_rule,
  /*  226 */  regF_rule,
  /*  227 */  regD_rule,
  /*  228 */  regF_rule,
  /*  229 */  regD_rule,
  /*  230 */  iRegN_rule,
  /*  231 */  iRegN_rule,
  /*  232 */  iRegN_rule,
  /*  233 */  iRegL_rule,
  /*  234 */  0,
  /*  235 */  flagsReg_rule,
  /*  236 */  flagsReg_rule,
  /*  237 */  flagsReg_rule,
  /*  238 */  flagsReg_rule,
  /*  239 */  regD_rule,
  /*  240 */  regF_rule,
  /*  241 */  iRegP_rule,
  /*  242 */  iRegL_rule,
  /*  243 */  threadRegP_rule,
  /*  244 */  iRegP_rule,
  /*  245 */  iRegP_rule,
  /*  246 */  iRegI_rule,
  /*  247 */  iRegL_rule,
  /*  248 */  regF_rule,
  /*  249 */  regD_rule,
  /*  250 */  iRegL_rule,
  /*  251 */  flagsReg_rule,
  /*  252 */  flagsReg_rule,
  /*  253 */  flagsReg_rule,
  /*  254 */  flagsReg_rule,
  /*  255 */  flagsReg_rule,
  /*  256 */  flagsReg_rule,
  /*  257 */  flagsReg_rule,
  /*  258 */  flagsReg_rule,
  /*  259 */  flagsReg_rule,
  /*  260 */  flagsReg_rule,
  /*  261 */  iRegI_rule,
  /*  262 */  regF_rule,
  /*  263 */  iRegL_rule,
  /*  264 */  regD_rule,
  /*  265 */  flagsReg_rule,
  /*  266 */  flagsReg_rule,
  /*  267 */  flagsReg_rule,
  /*  268 */  flagsReg_rule,
  /*  269 */  flagsReg_rule,
  /*  270 */  flagsReg_rule,
  /*  271 */  flagsReg_rule,
  /*  272 */  flagsReg_rule,
  /*  273 */  flagsReg_rule,
  /*  274 */  flagsReg_rule,
  /*  275 */  flagsReg_rule,
  /*  276 */  flagsReg_rule,
  /*  277 */  flagsReg_rule,
  /*  278 */  flagsReg_rule,
  /*  279 */  flagsReg_rule,
  /*  280 */  flagsReg_rule,
  /*  281 */  flagsReg_rule,
  /*  282 */  flagsReg_rule,
  /*  283 */  flagsReg_rule,
  /*  284 */  flagsReg_rule,
  /*  285 */  flagsReg_rule,
  /*  286 */  flagsReg_rule,
  /*  287 */  flagsReg_rule,
  /*  288 */  flagsReg_rule,
  /*  289 */  flagsReg_rule,
  /*  290 */  flagsReg_rule,
  /*  291 */  flagsReg_rule,
  /*  292 */  flagsReg_rule,
  /*  293 */  flagsReg_rule,
  /*  294 */  flagsReg_rule,
  /*  295 */  flagsReg_rule,
  /*  296 */  0,
  /*  297 */  iRegL_rule,
  /*  298 */  iRegL_rule,
  /*  299 */  iRegL_rule,
  /*  300 */  iRegL_rule,
  /*  301 */  iRegL_rule,
  /*  302 */  iRegL_rule,
  /*  303 */  iRegL_rule,
  /*  304 */  iRegL_rule,
  /*  305 */  iRegL_rule,
  /*  306 */  iRegL_rule,
  /*  307 */  iRegL_rule,
  /*  308 */  iRegL_rule,
  /*  309 */  iRegI_rule,
  /*  310 */  iRegL_rule,
  /*  311 */  iRegI_rule,
  /*  312 */  iRegL_rule,
  /*  313 */  iRegI_rule,
  /*  314 */  iRegL_rule,
  /*  315 */  iRegI_rule,
  /*  316 */  iRegL_rule,
  /*  317 */  iRegI_rule,
  /*  318 */  iRegL_rule,
  /*  319 */  iRegL_rule,
  /*  320 */  iRegI_rule,
  /*  321 */  iRegL_rule,
  /*  322 */  iRegL_rule,
  /*  323 */  iRegP_rule,
  /*  324 */  iRegP_rule,
  /*  325 */  0,
  /*  326 */  regF_rule,
  /*  327 */  regD_rule,
  /*  328 */  regD_rule,
  /*  329 */  Universe_rule,
  /*  330 */  Universe_rule,
  /*  331 */  Universe_rule,
  /*  332 */  Universe_rule,
  /*  333 */  Universe_rule,
  /*  334 */  Universe_rule,
  /*  335 */  Universe_rule,
  /*  336 */  Universe_rule,
  /*  337 */  Universe_rule,
  /*  338 */  Universe_rule,
  /*  339 */  Universe_rule,
  /*  340 */  Universe_rule,
  /*  341 */  Universe_rule,
  /*  342 */  Universe_rule,
  /*  343 */  iRegL_rule,
  /*  344 */  iRegN_rule,
  /*  345 */  iRegN_rule,
  /*  346 */  iRegP_rule,
  /*  347 */  iRegP_rule,
  /*  348 */  iRegP_rule,
  /*  349 */  iRegP_rule,
  /*  350 */  iRegP_rule,
  /*  351 */  iRegP_rule,
  /*  352 */  iRegP_rule,
  /*  353 */  iRegP_rule,
  /*  354 */  iRegP_rule,
  /*  355 */  iRegP_rule,
  /*  356 */  iRegN_rule,
  /*  357 */  iRegN_rule,
  /*  358 */  iRegN_rule,
  /*  359 */  iRegN_rule,
  /*  360 */  iRegN_rule,
  /*  361 */  iRegN_rule,
  /*  362 */  iRegN_rule,
  /*  363 */  Universe_rule,
  /*  364 */  Universe_rule,
  /*  365 */  Universe_rule,
  /*  366 */  Universe_rule,
  /*  367 */  Universe_rule,
  /*  368 */  Universe_rule,
  /*  369 */  Universe_rule,
  /*  370 */  Universe_rule,
  /*  371 */  Universe_rule,
  /*  372 */  Universe_rule,
  /*  373 */  Universe_rule,
  /*  374 */  Universe_rule,
  /*  375 */  Universe_rule,
  /*  376 */  iRegN_rule,
  /*  377 */  iRegN_rule,
  /*  378 */  iRegI_rule,
  /*  379 */  iRegI_rule,
  /*  380 */  iRegP_rule,
  /*  381 */  iRegP_rule,
  /*  382 */  regF_rule,
  /*  383 */  regD_rule,
  /*  384 */  iRegL_rule,
  /*  385 */  iRegL_rule,
  /*  386 */  iRegI_rule,
  /*  387 */  iRegI_rule,
  /*  388 */  iRegI_rule,
  /*  389 */  iRegI_rule,
  /*  390 */  Universe_rule,
  /*  391 */  iRegI_rule,
  /*  392 */  iRegI_rule,
  /*  393 */  iRegI_rule,
  /*  394 */  Universe_rule,
  /*  395 */  iRegL_rule,
  /*  396 */  iRegL_rule,
  /*  397 */  iRegL_rule,
  /*  398 */  iRegI_rule,
  /*  399 */  iRegL_rule,
  /*  400 */  iRegI_rule,
  /*  401 */  iRegL_rule,
  /*  402 */  iRegN_rule,
  /*  403 */  iRegP_rule,
  /*  404 */  iRegI_rule,
  /*  405 */  iRegI_rule,
  /*  406 */  iRegI_rule,
  /*  407 */  iRegI_rule,
  /*  408 */  iRegI_rule,
  /*  409 */  iRegI_rule,
  /*  410 */  iRegI_rule,
  /*  411 */  iRegI_rule,
  /*  412 */  iRegI_rule,
  /*  413 */  iRegI_rule,
  /*  414 */  iRegI_rule,
  /*  415 */  Universe_rule,
  /*  416 */  iRegL_rule,
  /*  417 */  iRegL_rule,
  /*  418 */  iRegL_rule,
  /*  419 */  iRegL_rule,
  /*  420 */  iRegL_rule,
  /*  421 */  iRegL_rule,
  /*  422 */  iRegL_rule,
  /*  423 */  iRegL_rule,
  /*  424 */  iRegL_rule,
  /*  425 */  iRegL_rule,
  /*  426 */  iRegL_rule,
  /*  427 */  iRegL_rule,
  /*  428 */  iRegL_rule,
  /*  429 */  iRegL_rule,
  /*  430 */  iRegL_rule,
  /*  431 */  Universe_rule,
  /*  432 */  iRegP_rule,
  /*  433 */  iRegP_rule,
  /*  434 */  iRegP_rule,
  /*  435 */  iRegP_rule,
  /*  436 */  iRegP_rule,
  /*  437 */  iRegP_rule,
  /*  438 */  iRegP_rule,
  /*  439 */  iRegP_rule,
  /*  440 */  iRegP_rule,
  /*  441 */  iRegP_rule,
  /*  442 */  iRegP_rule,
  /*  443 */  iRegP_rule,
  /*  444 */  Universe_rule,
  /*  445 */  iRegI_rule,
  /*  446 */  iRegI_rule,
  /*  447 */  iRegI_rule,
  /*  448 */  iRegI_rule,
  /*  449 */  iRegL_rule,
  /*  450 */  iRegL_rule,
  /*  451 */  iRegL_rule,
  /*  452 */  iRegL_rule,
  /*  453 */  iRegL_rule,
  /*  454 */  iRegI_rule,
  /*  455 */  iRegI_rule,
  /*  456 */  iRegI_rule,
  /*  457 */  iRegI_rule,
  /*  458 */  iRegI_rule,
  /*  459 */  iRegL_rule,
  /*  460 */  iRegL_rule,
  /*  461 */  iRegL_rule,
  /*  462 */  iRegL_rule,
  /*  463 */  iRegL_rule,
  /*  464 */  iRegL_rule,
  /*  465 */  iRegL_rule,
  /*  466 */  iRegL_rule,
  /*  467 */  iRegL_rule,
  /*  468 */  revenRegL_rule,
  /*  469 */  Universe_rule,
  /*  470 */  roddRegI_rule,
  /*  471 */  roddRegI_rule,
  /*  472 */  Universe_rule,
  /*  473 */  roddRegL_rule,
  /*  474 */  roddRegL_rule,
  /*  475 */  revenRegI_rule,
  /*  476 */  revenRegI_rule,
  /*  477 */  revenRegL_rule,
  /*  478 */  revenRegL_rule,
  /*  479 */  iRegI_rule,
  /*  480 */  iRegI_rule,
  /*  481 */  iRegI_rule,
  /*  482 */  iRegL_rule,
  /*  483 */  iRegL_rule,
  /*  484 */  iRegL_rule,
  /*  485 */  iRegI_rule,
  /*  486 */  iRegI_rule,
  /*  487 */  iRegL_rule,
  /*  488 */  iRegL_rule,
  /*  489 */  iRegI_rule,
  /*  490 */  iRegI_rule,
  /*  491 */  iRegL_rule,
  /*  492 */  iRegL_rule,
  /*  493 */  iRegL_rule,
  /*  494 */  iRegI_rule,
  /*  495 */  iRegI_rule,
  /*  496 */  iRegL_rule,
  /*  497 */  iRegL_rule,
  /*  498 */  iRegI_rule,
  /*  499 */  iRegI_rule,
  /*  500 */  iRegL_rule,
  /*  501 */  iRegL_rule,
  /*  502 */  regF_rule,
  /*  503 */  regF_rule,
  /*  504 */  regF_rule,
  /*  505 */  regD_rule,
  /*  506 */  regD_rule,
  /*  507 */  regD_rule,
  /*  508 */  regF_rule,
  /*  509 */  regF_rule,
  /*  510 */  regD_rule,
  /*  511 */  regD_rule,
  /*  512 */  regF_rule,
  /*  513 */  regF_rule,
  /*  514 */  regF_rule,
  /*  515 */  regD_rule,
  /*  516 */  regD_rule,
  /*  517 */  regD_rule,
  /*  518 */  regF_rule,
  /*  519 */  regD_rule,
  /*  520 */  regF_rule,
  /*  521 */  regD_rule,
  /*  522 */  regF_rule,
  /*  523 */  regD_rule,
  /*  524 */  regF_rule,
  /*  525 */  regD_rule,
  /*  526 */  regF_rule,
  /*  527 */  regD_rule,
  /*  528 */  regF_rule,
  /*  529 */  regD_rule,
  /*  530 */  regF_rule,
  /*  531 */  regF_rule,
  /*  532 */  regD_rule,
  /*  533 */  regD_rule,
  /*  534 */  regF_rule,
  /*  535 */  regD_rule,
  /*  536 */  regF_rule,
  /*  537 */  regD_rule,
  /*  538 */  regF_rule,
  /*  539 */  regD_rule,
  /*  540 */  regF_rule,
  /*  541 */  regD_rule,
  /*  542 */  regF_rule,
  /*  543 */  regD_rule,
  /*  544 */  iRegI_rule,
  /*  545 */  iRegI_rule,
  /*  546 */  iRegI_rule,
  /*  547 */  iRegI_rule,
  /*  548 */  iRegI_rule,
  /*  549 */  iRegI_rule,
  /*  550 */  iRegL_rule,
  /*  551 */  iRegL_rule,
  /*  552 */  iRegL_rule,
  /*  553 */  iRegL_rule,
  /*  554 */  iRegL_rule,
  /*  555 */  iRegL_rule,
  /*  556 */  iRegL_rule,
  /*  557 */  iRegI_rule,
  /*  558 */  iRegI_rule,
  /*  559 */  iRegI_rule,
  /*  560 */  iRegI_rule,
  /*  561 */  iRegI_rule,
  /*  562 */  iRegL_rule,
  /*  563 */  iRegL_rule,
  /*  564 */  iRegL_rule,
  /*  565 */  iRegL_rule,
  /*  566 */  iRegI_rule,
  /*  567 */  iRegI_rule,
  /*  568 */  iRegI_rule,
  /*  569 */  iRegI_rule,
  /*  570 */  iRegI_rule,
  /*  571 */  iRegL_rule,
  /*  572 */  iRegL_rule,
  /*  573 */  iRegL_rule,
  /*  574 */  iRegL_rule,
  /*  575 */  iRegI_rule,
  /*  576 */  iRegI_rule,
  /*  577 */  iRegI_rule,
  /*  578 */  iRegI_rule,
  /*  579 */  regF_rule,
  /*  580 */  iRegI_rule,
  /*  581 */  iRegI_rule,
  /*  582 */  iRegL_rule,
  /*  583 */  iRegL_rule,
  /*  584 */  regD_rule,
  /*  585 */  regD_rule,
  /*  586 */  regD_rule,
  /*  587 */  regF_rule,
  /*  588 */  iRegL_rule,
  /*  589 */  iRegL_rule,
  /*  590 */  iRegL_rule,
  /*  591 */  iRegL_rule,
  /*  592 */  iRegI_rule,
  /*  593 */  iRegI_rule,
  /*  594 */  stackSlotF_rule,
  /*  595 */  stackSlotL_rule,
  /*  596 */  stackSlotD_rule,
  /*  597 */  regF_rule,
  /*  598 */  regD_rule,
  /*  599 */  iRegI_rule,
  /*  600 */  iRegI_rule,
  /*  601 */  Universe_rule,
  /*  602 */  Universe_rule,
  /*  603 */  Universe_rule,
  /*  604 */  Universe_rule,
  /*  605 */  Universe_rule,
  /*  606 */  iRegI_rule,
  /*  607 */  iRegI_rule,
  /*  608 */  iRegI_rule,
  /*  609 */  iRegI_rule,
  /*  610 */  iRegI_rule,
  /*  611 */  iRegI_rule,
  /*  612 */  iRegI_rule,
  /*  613 */  iRegI_rule,
  /*  614 */  iRegI_rule,
  /*  615 */  iRegI_rule,
  /*  616 */  iRegI_rule,
  /*  617 */  iRegI_rule,
  /*  618 */  iRegI_rule,
  /*  619 */  iRegI_rule,
  /*  620 */  iRegI_rule,
  /*  621 */  iRegI_rule,
  /*  622 */  iRegI_rule,
  /*  623 */  iRegL_rule,
  /*  624 */  iRegI_rule,
  /*  625 */  iRegI_rule,
  /*  626 */  iRegI_rule,
  /*  627 */  Universe_rule,
  /*  628 */  Universe_rule,
  /*  629 */  Universe_rule,
  /*  630 */  Universe_rule,
  /*  631 */  Universe_rule,
  /*  632 */  Universe_rule,
  /*  633 */  Universe_rule,
  /*  634 */  Universe_rule,
  /*  635 */  Universe_rule,
  /*  636 */  Universe_rule,
  /*  637 */  Universe_rule,
  /*  638 */  Universe_rule,
  /*  639 */  Universe_rule,
  /*  640 */  Universe_rule,
  /*  641 */  Universe_rule,
  /*  642 */  Universe_rule,
  /*  643 */  Universe_rule,
  /*  644 */  Universe_rule,
  /*  645 */  Universe_rule,
  /*  646 */  Universe_rule,
  /*  647 */  Universe_rule,
  /*  648 */  Universe_rule,
  /*  649 */  Universe_rule,
  /*  650 */  Universe_rule,
  /*  651 */  Universe_rule,
  /*  652 */  Universe_rule,
  /*  653 */  Universe_rule,
  /*  654 */  Universe_rule,
  /*  655 */  Universe_rule,
  /*  656 */  Universe_rule,
  /*  657 */  Universe_rule,
  /*  658 */  Universe_rule,
  /*  659 */  iRegI_rule,
  /*  660 */  Universe_rule,
  /*  661 */  Universe_rule,
  /*  662 */  Universe_rule,
  /*  663 */  Universe_rule,
  /*  664 */  Universe_rule,
  /*  665 */  Universe_rule,
  /*  666 */  Universe_rule,
  /*  667 */  Universe_rule,
  /*  668 */  Universe_rule,
  /*  669 */  Universe_rule,
  /*  670 */  rarg1RegP_rule,
  /*  671 */  Universe_rule,
  /*  672 */  Universe_rule,
  /*  673 */  rarg1RegP_rule,
  /*  674 */  Universe_rule,
  /*  675 */  Universe_rule,
  /*  676 */  Universe_rule,
  /*  677 */  iRegI_rule,
  /*  678 */  iRegI_rule,
  /*  679 */  iRegI_rule,
  /*  680 */  iRegI_rule,
  /*  681 */  iRegI_rule,
  /*  682 */  iRegI_rule,
  /*  683 */  iRegI_rule,
  /*  684 */  iRegI_rule,
  /*  685 */  iRegI_rule,
  /*  686 */  iRegI_rule,
  /*  687 */  iRegI_rule,
  /*  688 */  iRegI_rule,
  /*  689 */  iRegI_rule,
  /*  690 */  iRegI_rule,
  /*  691 */  iRegI_rule,
  /*  692 */  iRegI_rule,
  /*  693 */  iRegI_rule,
  /*  694 */  iRegI_rule,
  /*  695 */  iRegI_rule,
  /*  696 */  iRegI_rule,
  /*  697 */  iRegI_rule,
  /*  698 */  Universe_rule,
  /*  699 */  Universe_rule,
  /*  700 */  iRegI_rule,
  /*  701 */  iRegI_rule,
  /*  702 */  iRegI_rule,
  /*  703 */  0,
  /*  704 */  iRegL_rule,
  /*  705 */  iRegL_rule,
  /*  706 */  iRegL_rule,
  /*  707 */  iRegL_rule,
  /*  708 */  iRegL_rule,
  /*  709 */  iRegL_rule,
  /*  710 */  Universe_rule,
  /*  711 */  iRegL_rule,
  /*  712 */  iRegI_rule,
  /*  713 */  iRegL_rule,
  /*  714 */  revenRegI_rule,
  /*  715 */  revenRegI_rule,
  /*  716 */  revenRegI_rule,
  /*  717 */  revenRegI_rule,
  /*  718 */  iRegI_rule,
  /*  719 */  iRegI_rule,
  // last instruction
  0 // no trailing comma
};

const        int   leftOp[] = {
  /*    0 */  0,
  /*    1 */  0,
  /*    2 */  0,
  /*    3 */  0,
  /*    4 */  0,
  /*    5 */  0,
  /*    6 */  0,
  /*    7 */  0,
  /*    8 */  0,
  /*    9 */  0,
  /*   10 */  0,
  /*   11 */  0,
  /*   12 */  0,
  /*   13 */  0,
  /*   14 */  0,
  /*   15 */  0,
  /*   16 */  0,
  /*   17 */  0,
  /*   18 */  0,
  /*   19 */  0,
  /*   20 */  0,
  /*   21 */  0,
  /*   22 */  0,
  /*   23 */  0,
  /*   24 */  0,
  /*   25 */  0,
  /*   26 */  0,
  /*   27 */  0,
  /*   28 */  0,
  /*   29 */  0,
  /*   30 */  0,
  /*   31 */  0,
  /*   32 */  0,
  /*   33 */  0,
  /*   34 */  0,
  /*   35 */  0,
  /*   36 */  0,
  /*   37 */  0,
  /*   38 */  0,
  /*   39 */  0,
  /*   40 */  0,
  /*   41 */  0,
  /*   42 */  0,
  /*   43 */  0,
  /*   44 */  0,
  /*   45 */  0,
  /*   46 */  0,
  /*   47 */  0,
  /*   48 */  0,
  /*   49 */  0,
  /*   50 */  0,
  /*   51 */  0,
  /*   52 */  0,
  /*   53 */  0,
  /*   54 */  0,
  /*   55 */  0,
  /*   56 */  0,
  /*   57 */  0,
  /*   58 */  0,
  /*   59 */  0,
  /*   60 */  0,
  /*   61 */  0,
  /*   62 */  0,
  /*   63 */  0,
  /*   64 */  0,
  /*   65 */  0,
  /*   66 */  0,
  /*   67 */  0,
  /*   68 */  0,
  /*   69 */  0,
  /*   70 */  0,
  /*   71 */  0,
  /*   72 */  0,
  /*   73 */  0,
  /*   74 */  0,
  /*   75 */  0,
  /*   76 */  0,
  /*   77 */  0,
  /*   78 */  0,
  /*   79 */  0,
  /*   80 */  0,
  /*   81 */  0,
  /*   82 */  0,
  /*   83 */  0,
  /*   84 */  0,
  /*   85 */  0,
  /*   86 */  0,
  /*   87 */  0,
  /*   88 */  0,
  /*   89 */  0,
  /*   90 */  0,
  /*   91 */  0,
  /*   92 */  0,
  /*   93 */  0,
  /*   94 */  0,
  /*   95 */  0,
  /*   96 */  0,
  /*   97 */  0,
  /*   98 */  memoryRegP_rule,
  /*   99 */  _DecodeN_iRegN__rule,
  /*  100 */  memoryRegP_rule,
  /*  101 */  _DecodeN_iRegN__rule,
  /*  102 */  memoryRegP_rule,
  /*  103 */  _AddP_memoryRegP_iRegL_rule,
  /*  104 */  _AddP__DecodeN_iRegN__iRegL_rule,
  /*  105 */  _AddP_memoryRegP_iRegL_rule,
  /*  106 */  _AddP__DecodeN_iRegN__iRegL_rule,
  /*  107 */  0,
  /*  108 */  0,
  /*  109 */  0,
  /*  110 */  0,
  /*  111 */  0,
  /*  112 */  0,
  /*  113 */  0,
  /*  114 */  0,
  // last operand
  /*  115 */  0,
  /*  116 */  0,
  /*  117 */  0,
  /*  118 */  0,
  /*  119 */  0,
  /*  120 */  0,
  /*  121 */  0,
  // last operand class
  /*  122 */  iRegN_rule,
  /*  123 */  memoryRegP_rule,
  /*  124 */  _DecodeN_iRegN__rule,
  /*  125 */  memory_rule,
  /*  126 */  memory_rule,
  /*  127 */  memory_rule,
  /*  128 */  memory_rule,
  /*  129 */  memory_rule,
  /*  130 */  _LoadI_memory__rule,
  /*  131 */  memory_rule,
  /*  132 */  memory_rule,
  /*  133 */  memory_rule,
  /*  134 */  iRegL_rule,
  /*  135 */  cmpOp_rule,
  /*  136 */  iRegN_rule,
  /*  137 */  iRegN_rule,
  /*  138 */  iRegI_rule,
  /*  139 */  iRegI_rule,
  /*  140 */  iRegP_rule,
  /*  141 */  iRegP_rule,
  /*  142 */  cmpOpF_rule,
  /*  143 */  regF_rule,
  /*  144 */  regD_rule,
  /*  145 */  iRegL_rule,
  /*  146 */  iRegL_rule,
  /*  147 */  rarg5RegI_rule,
  /*  148 */  rarg5RegL_rule,
  /*  149 */  rarg5RegP_rule,
  /*  150 */  rarg5RegN_rule,
  /*  151 */  iRegI_rule,
  /*  152 */  memoryRSY_rule,
  /*  153 */  _LoadI_memoryRSY__rule,
  /*  154 */  iRegI_rule,
  /*  155 */  memory_rule,
  /*  156 */  iRegL_rule,
  /*  157 */  memoryRSY_rule,
  /*  158 */  _LoadL_memoryRSY__rule,
  /*  159 */  iRegP_N2P_rule,
  /*  160 */  memoryRSY_rule,
  /*  161 */  _LoadP_memoryRSY__rule,
  /*  162 */  iRegP_N2P_rule,
  /*  163 */  iRegI_rule,
  /*  164 */  iRegI_rule,
  /*  165 */  iRegL_rule,
  /*  166 */  iRegL_rule,
  /*  167 */  memoryRX_rule,
  /*  168 */  memoryRX_rule,
  /*  169 */  regF_rule,
  /*  170 */  regD_rule,
  /*  171 */  regF_rule,
  /*  172 */  regD_rule,
  /*  173 */  _LoadF_memoryRX__rule,
  /*  174 */  _LoadD_memoryRX__rule,
  /*  175 */  regF_rule,
  /*  176 */  regD_rule,
  /*  177 */  iRegI_rule,
  /*  178 */  iRegI_rule,
  /*  179 */  iRegL_rule,
  /*  180 */  iRegI_rule,
  /*  181 */  iRegI_rule,
  /*  182 */  iRegP_N2P_rule,
  /*  183 */  iRegN_P2N_rule,
  /*  184 */  iRegI_rule,
  /*  185 */  iRegI_rule,
  /*  186 */  iRegL_rule,
  /*  187 */  iRegP_rule,
  /*  188 */  _DecodeN_iRegN__rule,
  /*  189 */  iRegI_rule,
  /*  190 */  iRegI_rule,
  /*  191 */  iRegL_rule,
  /*  192 */  iRegP_rule,
  /*  193 */  _DecodeN_iRegN__rule,
  /*  194 */  immN8_rule,
  /*  195 */  _DecodeN_iRegN__rule,
  /*  196 */  rarg2RegP_rule,
  /*  197 */  iRegP_rule,
  /*  198 */  iRegP_rule,
  /*  199 */  iRegP_rule,
  /*  200 */  iRegP_rule,
  /*  201 */  immP_rule,
  /*  202 */  iRegP_rule,
  /*  203 */  iRegP_rule,
  // last internally defined operand
  /*  204 */  iRegI_rule,
  /*  205 */  iRegL_rule,
  /*  206 */  iRegP_rule,
  /*  207 */  regF_rule,
  /*  208 */  regD_rule,
  /*  209 */  regD_rule,
  /*  210 */  regF_rule,
  /*  211 */  stackSlotI_rule,
  /*  212 */  stackSlotL_rule,
  /*  213 */  stackSlotP_rule,
  /*  214 */  stackSlotF_rule,
  /*  215 */  stackSlotD_rule,
  /*  216 */  immI_rule,
  /*  217 */  immI16_rule,
  /*  218 */  immI_0_rule,
  /*  219 */  uimmI16_rule,
  /*  220 */  immL_rule,
  /*  221 */  immL32_rule,
  /*  222 */  immL16_rule,
  /*  223 */  immL_0_rule,
  /*  224 */  immP_rule,
  /*  225 */  immP0_rule,
  /*  226 */  immF_rule,
  /*  227 */  immD_rule,
  /*  228 */  immFp0_rule,
  /*  229 */  immDp0_rule,
  /*  230 */  immN_rule,
  /*  231 */  immN0_rule,
  /*  232 */  immNKlass_rule,
  /*  233 */  _LoadP_memory__rule,
  /*  234 */  0,
  /*  235 */  iRegN_P2N_rule,
  /*  236 */  iRegN_P2N_rule,
  /*  237 */  iRegN_rule,
  /*  238 */  iRegN_P2N_rule,
  /*  239 */  regD_rule,
  /*  240 */  regF_rule,
  /*  241 */  iRegL_rule,
  /*  242 */  iRegP_N2P_rule,
  /*  243 */  0,
  /*  244 */  iRegP_rule,
  /*  245 */  iRegP_rule,
  /*  246 */  iRegI_rule,
  /*  247 */  iRegL_rule,
  /*  248 */  regF_rule,
  /*  249 */  regD_rule,
  /*  250 */  iRegL_rule,
  /*  251 */  iRegI_rule,
  /*  252 */  iRegI_rule,
  /*  253 */  iRegL_rule,
  /*  254 */  iRegL_rule,
  /*  255 */  iRegI_rule,
  /*  256 */  iRegI_rule,
  /*  257 */  iRegL_rule,
  /*  258 */  iRegL_rule,
  /*  259 */  immI_0_rule,
  /*  260 */  immL_0_rule,
  /*  261 */  stackSlotF_rule,
  /*  262 */  stackSlotI_rule,
  /*  263 */  stackSlotD_rule,
  /*  264 */  stackSlotL_rule,
  /*  265 */  iRegI_rule,
  /*  266 */  iRegI_rule,
  /*  267 */  iRegI_rule,
  /*  268 */  iRegI_rule,
  /*  269 */  iRegI_rule,
  /*  270 */  iRegI_rule,
  /*  271 */  iRegI_rule,
  /*  272 */  iRegI_rule,
  /*  273 */  iRegL_rule,
  /*  274 */  iRegL_rule,
  /*  275 */  iRegL_rule,
  /*  276 */  iRegL_rule,
  /*  277 */  iRegL_rule,
  /*  278 */  _ConvI2L_iRegI__rule,
  /*  279 */  iRegL_rule,
  /*  280 */  iRegL_rule,
  /*  281 */  iRegL_rule,
  /*  282 */  iRegL_rule,
  /*  283 */  iRegP_N2P_rule,
  /*  284 */  iRegP_N2P_rule,
  /*  285 */  _DecodeN_iRegN__rule,
  /*  286 */  iRegP_rule,
  /*  287 */  regF_rule,
  /*  288 */  regD_rule,
  /*  289 */  regF_rule,
  /*  290 */  regD_rule,
  /*  291 */  regF_rule,
  /*  292 */  regD_rule,
  /*  293 */  _PartialSubtypeCheck_rarg2RegP_rarg3RegP_rule,
  /*  294 */  iRegP_N2P_rule,
  /*  295 */  iRegP_N2P_rule,
  /*  296 */  0,
  /*  297 */  immB_n0m1_rule,
  /*  298 */  immI_0_rule,
  /*  299 */  immB_minus1_rule,
  /*  300 */  immS_n0m1_rule,
  /*  301 */  immI_0_rule,
  /*  302 */  immS_minus1_rule,
  /*  303 */  immI_n0m1_rule,
  /*  304 */  immI_0_rule,
  /*  305 */  immI_minus1_rule,
  /*  306 */  immF_rule,
  /*  307 */  immFp0_rule,
  /*  308 */  iRegL_rule,
  /*  309 */  memory_rule,
  /*  310 */  _LoadB_memory__rule,
  /*  311 */  memory_rule,
  /*  312 */  _LoadUB_memory__rule,
  /*  313 */  memory_rule,
  /*  314 */  _LoadS_memory__rule,
  /*  315 */  memory_rule,
  /*  316 */  _LoadUS_memory__rule,
  /*  317 */  memory_rule,
  /*  318 */  _LoadI_memory__rule,
  /*  319 */  _ConvI2L__LoadI_memory___rule,
  /*  320 */  memory_rule,
  /*  321 */  memory_rule,
  /*  322 */  memory_rule,
  /*  323 */  memory_rule,
  /*  324 */  memory_rule,
  /*  325 */  0,
  /*  326 */  memory_rule,
  /*  327 */  memory_rule,
  /*  328 */  memory_rule,
  /*  329 */  memory_rule,
  /*  330 */  memory_rule,
  /*  331 */  memory_rule,
  /*  332 */  memory_rule,
  /*  333 */  memory_rule,
  /*  334 */  memory_rule,
  /*  335 */  memory_rule,
  /*  336 */  memory_rule,
  /*  337 */  memory_rule,
  /*  338 */  memoryRSY_rule,
  /*  339 */  memoryRS_rule,
  /*  340 */  memoryRS_rule,
  /*  341 */  memoryRS_rule,
  /*  342 */  memoryRS_rule,
  /*  343 */  immL_0_rule,
  /*  344 */  memory_rule,
  /*  345 */  memory_rule,
  /*  346 */  _LoadN_memory__rule,
  /*  347 */  _LoadNKlass_memory__rule,
  /*  348 */  immNKlass_rule,
  /*  349 */  iRegN_rule,
  /*  350 */  iRegN_rule,
  /*  351 */  iRegN_rule,
  /*  352 */  iRegN_rule,
  /*  353 */  iRegN_rule,
  /*  354 */  iRegN_rule,
  /*  355 */  iRegN_rule,
  /*  356 */  iRegP_rule,
  /*  357 */  iRegP_rule,
  /*  358 */  iRegP_rule,
  /*  359 */  iRegP_rule,
  /*  360 */  iRegP_rule,
  /*  361 */  iRegP_rule,
  /*  362 */  iRegP_rule,
  /*  363 */  memory_rule,
  /*  364 */  memory_rule,
  /*  365 */  0,
  /*  366 */  0,
  /*  367 */  0,
  /*  368 */  0,
  /*  369 */  0,
  /*  370 */  0,
  /*  371 */  0,
  /*  372 */  0,
  /*  373 */  0,
  /*  374 */  0,
  /*  375 */  0,
  /*  376 */  _Binary_cmpOp_flagsReg_rule,
  /*  377 */  _Binary_cmpOp_flagsReg_rule,
  /*  378 */  _Binary_cmpOp_flagsReg_rule,
  /*  379 */  _Binary_cmpOp_flagsReg_rule,
  /*  380 */  _Binary_cmpOp_flagsReg_rule,
  /*  381 */  _Binary_cmpOp_flagsReg_rule,
  /*  382 */  _Binary_cmpOpF_flagsReg_rule,
  /*  383 */  _Binary_cmpOpF_flagsReg_rule,
  /*  384 */  _Binary_cmpOp_flagsReg_rule,
  /*  385 */  _Binary_cmpOp_flagsReg_rule,
  /*  386 */  iRegP_rule,
  /*  387 */  iRegP_rule,
  /*  388 */  iRegP_rule,
  /*  389 */  iRegP_rule,
  /*  390 */  memoryRSY_rule,
  /*  391 */  memoryRSY_rule,
  /*  392 */  memoryRSY_rule,
  /*  393 */  memoryRSY_rule,
  /*  394 */  memoryRSY_rule,
  /*  395 */  memoryRSY_rule,
  /*  396 */  memoryRSY_rule,
  /*  397 */  memoryRSY_rule,
  /*  398 */  memoryRSY_rule,
  /*  399 */  memoryRSY_rule,
  /*  400 */  memoryRSY_rule,
  /*  401 */  memoryRSY_rule,
  /*  402 */  memoryRSY_rule,
  /*  403 */  memoryRSY_rule,
  /*  404 */  iRegI_rule,
  /*  405 */  iRegI_rule,
  /*  406 */  iRegI_rule,
  /*  407 */  iRegI_rule,
  /*  408 */  iRegI_rule,
  /*  409 */  iRegI_rule,
  /*  410 */  iRegI_rule,
  /*  411 */  _AddI_iRegI_iRegI_rule,
  /*  412 */  _AddI_iRegI_iRegI_rule,
  /*  413 */  iRegI_rule,
  /*  414 */  _LoadI_memory__rule,
  /*  415 */  memoryRSY_rule,
  /*  416 */  iRegL_rule,
  /*  417 */  _ConvI2L_iRegI__rule,
  /*  418 */  iRegL_rule,
  /*  419 */  iRegL_rule,
  /*  420 */  iRegL_rule,
  /*  421 */  iRegL_rule,
  /*  422 */  iRegL_rule,
  /*  423 */  iRegL_rule,
  /*  424 */  iRegL_rule,
  /*  425 */  iRegL_rule,
  /*  426 */  _ConvI2L__LoadI_memory___rule,
  /*  427 */  iRegL_rule,
  /*  428 */  _LoadL_memory__rule,
  /*  429 */  _AddL_iRegL_iRegL_rule,
  /*  430 */  _AddL_iRegL_iRegL_rule,
  /*  431 */  memoryRSY_rule,
  /*  432 */  iRegP_N2P_rule,
  /*  433 */  iRegP_rule,
  /*  434 */  iRegP_N2P_rule,
  /*  435 */  iRegP_N2P_rule,
  /*  436 */  iRegP_rule,
  /*  437 */  iRegP_N2P_rule,
  /*  438 */  memoryRegP_rule,
  /*  439 */  iRegP_rule,
  /*  440 */  _AddP_memoryRegP_iRegL_rule,
  /*  441 */  _AddP_iRegP_N2P_iRegL_rule,
  /*  442 */  _AddP_memoryRegP_iRegL_rule,
  /*  443 */  _AddP_iRegP_N2P_iRegL_rule,
  /*  444 */  memoryRSY_rule,
  /*  445 */  iRegI_rule,
  /*  446 */  iRegI_rule,
  /*  447 */  iRegI_rule,
  /*  448 */  immI_0_rule,
  /*  449 */  iRegL_rule,
  /*  450 */  iRegL_rule,
  /*  451 */  iRegL_rule,
  /*  452 */  iRegL_rule,
  /*  453 */  iRegL_rule,
  /*  454 */  iRegI_rule,
  /*  455 */  iRegI_rule,
  /*  456 */  iRegI_rule,
  /*  457 */  iRegI_rule,
  /*  458 */  _LoadI_memory__rule,
  /*  459 */  iRegL_rule,
  /*  460 */  _ConvI2L_iRegI__rule,
  /*  461 */  iRegL_rule,
  /*  462 */  iRegL_rule,
  /*  463 */  iRegL_rule,
  /*  464 */  iRegL_rule,
  /*  465 */  _ConvI2L__LoadI_memory___rule,
  /*  466 */  iRegL_rule,
  /*  467 */  _LoadL_memory__rule,
  /*  468 */  roddRegL_rule,
  /*  469 */  roddRegI_rule,
  /*  470 */  iRegI_rule,
  /*  471 */  iRegI_rule,
  /*  472 */  roddRegL_rule,
  /*  473 */  roddRegL_rule,
  /*  474 */  iRegL_rule,
  /*  475 */  iRegI_rule,
  /*  476 */  iRegI_rule,
  /*  477 */  roddRegL_rule,
  /*  478 */  iRegL_rule,
  /*  479 */  iRegI_rule,
  /*  480 */  iRegI_rule,
  /*  481 */  iRegI_rule,
  /*  482 */  iRegL_rule,
  /*  483 */  iRegL_rule,
  /*  484 */  iRegL_rule,
  /*  485 */  iRegI_rule,
  /*  486 */  iRegI_rule,
  /*  487 */  iRegL_rule,
  /*  488 */  iRegL_rule,
  /*  489 */  iRegI_rule,
  /*  490 */  iRegI_rule,
  /*  491 */  iRegL_rule,
  /*  492 */  iRegL_rule,
  /*  493 */  _CastP2X_iRegP_N2P__rule,
  /*  494 */  _LShiftI_iRegI_immI8_rule,
  /*  495 */  _URShiftI_iRegI_immI8_rule,
  /*  496 */  _LShiftL_iRegL_immI8_rule,
  /*  497 */  _URShiftL_iRegL_immI8_rule,
  /*  498 */  _URShiftI_iRegI_immI8_rule,
  /*  499 */  _LShiftI_iRegI_immI8_rule,
  /*  500 */  _URShiftL_iRegL_immI8_rule,
  /*  501 */  _LShiftL_iRegL_immI8_rule,
  /*  502 */  regF_rule,
  /*  503 */  regF_rule,
  /*  504 */  _LoadF_memoryRX__rule,
  /*  505 */  regD_rule,
  /*  506 */  regD_rule,
  /*  507 */  _LoadD_memoryRX__rule,
  /*  508 */  regF_rule,
  /*  509 */  regF_rule,
  /*  510 */  regD_rule,
  /*  511 */  regD_rule,
  /*  512 */  regF_rule,
  /*  513 */  regF_rule,
  /*  514 */  _LoadF_memoryRX__rule,
  /*  515 */  regD_rule,
  /*  516 */  regD_rule,
  /*  517 */  _LoadD_memoryRX__rule,
  /*  518 */  regF_rule,
  /*  519 */  regD_rule,
  /*  520 */  _NegF_regF__rule,
  /*  521 */  _NegD_regD__rule,
  /*  522 */  regF_rule,
  /*  523 */  regD_rule,
  /*  524 */  _NegF_regF__rule,
  /*  525 */  _NegD_regD__rule,
  /*  526 */  regF_rule,
  /*  527 */  regD_rule,
  /*  528 */  _NegF_regF__rule,
  /*  529 */  _NegD_regD__rule,
  /*  530 */  regF_rule,
  /*  531 */  regF_rule,
  /*  532 */  regD_rule,
  /*  533 */  regD_rule,
  /*  534 */  regF_rule,
  /*  535 */  regD_rule,
  /*  536 */  _AbsF_regF__rule,
  /*  537 */  _AbsD_regD__rule,
  /*  538 */  regF_rule,
  /*  539 */  regD_rule,
  /*  540 */  regF_rule,
  /*  541 */  regD_rule,
  /*  542 */  memoryRX_rule,
  /*  543 */  memoryRX_rule,
  /*  544 */  iRegI_rule,
  /*  545 */  iRegI_rule,
  /*  546 */  _LoadI_memory__rule,
  /*  547 */  iRegI_rule,
  /*  548 */  iRegI_rule,
  /*  549 */  iRegI_rule,
  /*  550 */  iRegL_rule,
  /*  551 */  iRegL_rule,
  /*  552 */  _LoadL_memory__rule,
  /*  553 */  iRegL_rule,
  /*  554 */  iRegL_rule,
  /*  555 */  iRegL_rule,
  /*  556 */  iRegL_rule,
  /*  557 */  iRegI_rule,
  /*  558 */  iRegI_rule,
  /*  559 */  _LoadI_memory__rule,
  /*  560 */  iRegI_rule,
  /*  561 */  iRegI_rule,
  /*  562 */  iRegL_rule,
  /*  563 */  iRegL_rule,
  /*  564 */  _LoadL_memory__rule,
  /*  565 */  iRegL_rule,
  /*  566 */  iRegI_rule,
  /*  567 */  iRegI_rule,
  /*  568 */  iRegI_rule,
  /*  569 */  _LoadI_memory__rule,
  /*  570 */  iRegI_rule,
  /*  571 */  iRegL_rule,
  /*  572 */  iRegL_rule,
  /*  573 */  _LoadL_memory__rule,
  /*  574 */  iRegL_rule,
  /*  575 */  iRegI_rule,
  /*  576 */  iRegP_N2P_rule,
  /*  577 */  iRegI_rule,
  /*  578 */  iRegI_rule,
  /*  579 */  regD_rule,
  /*  580 */  regF_rule,
  /*  581 */  regD_rule,
  /*  582 */  regF_rule,
  /*  583 */  regD_rule,
  /*  584 */  regF_rule,
  /*  585 */  memoryRX_rule,
  /*  586 */  iRegI_rule,
  /*  587 */  iRegI_rule,
  /*  588 */  iRegI_rule,
  /*  589 */  _ConvI2L_iRegI__rule,
  /*  590 */  _ConvI2L__LoadI_memory___rule,
  /*  591 */  iRegL_rule,
  /*  592 */  _LShiftI_iRegI_immI_16_rule,
  /*  593 */  _LShiftI_iRegI_immI_24_rule,
  /*  594 */  iRegI_rule,
  /*  595 */  regD_rule,
  /*  596 */  iRegL_rule,
  /*  597 */  iRegL_rule,
  /*  598 */  iRegL_rule,
  /*  599 */  iRegL_rule,
  /*  600 */  _RShiftL_iRegL_immI_32_63_rule,
  /*  601 */  cmpOpT_rule,
  /*  602 */  cmpOpT_rule,
  /*  603 */  cmpOpT_rule,
  /*  604 */  cmpOpT_rule,
  /*  605 */  cmpOpT_rule,
  /*  606 */  iRegI_rule,
  /*  607 */  iRegI_rule,
  /*  608 */  iRegI_rule,
  /*  609 */  iRegI_rule,
  /*  610 */  iRegI_rule,
  /*  611 */  iRegI_rule,
  /*  612 */  iRegI_rule,
  /*  613 */  iRegI_rule,
  /*  614 */  iRegI_rule,
  /*  615 */  iRegI_rule,
  /*  616 */  iRegI_rule,
  /*  617 */  iRegI_rule,
  /*  618 */  iRegI_rule,
  /*  619 */  iRegI_rule,
  /*  620 */  iRegI_rule,
  /*  621 */  iRegI_rule,
  /*  622 */  iRegI_rule,
  /*  623 */  iRegL_rule,
  /*  624 */  immI_0_rule,
  /*  625 */  regF_rule,
  /*  626 */  regD_rule,
  /*  627 */  0,
  /*  628 */  0,
  /*  629 */  cmpOp_rule,
  /*  630 */  cmpOp_rule,
  /*  631 */  cmpOp_rule,
  /*  632 */  cmpOp_rule,
  /*  633 */  cmpOpT_rule,
  /*  634 */  cmpOpT_rule,
  /*  635 */  cmpOpT_rule,
  /*  636 */  cmpOpT_rule,
  /*  637 */  cmpOpT_rule,
  /*  638 */  cmpOpT_rule,
  /*  639 */  cmpOpT_rule,
  /*  640 */  cmpOpT_rule,
  /*  641 */  cmpOpT_rule,
  /*  642 */  cmpOpT_rule,
  /*  643 */  cmpOpT_rule,
  /*  644 */  cmpOpT_rule,
  /*  645 */  cmpOpT_rule,
  /*  646 */  cmpOpT_rule,
  /*  647 */  cmpOpT_rule,
  /*  648 */  cmpOpT_rule,
  /*  649 */  cmpOpT_rule,
  /*  650 */  cmpOpT_rule,
  /*  651 */  cmpOpT_rule,
  /*  652 */  cmpOpT_rule,
  /*  653 */  cmpOpT_rule,
  /*  654 */  cmpOpT_rule,
  /*  655 */  cmpOpT_rule,
  /*  656 */  cmpOpT_rule,
  /*  657 */  cmpOpT_rule,
  /*  658 */  cmpOpT_rule,
  /*  659 */  iRegL_rule,
  /*  660 */  0,
  /*  661 */  iRegP_rule,
  /*  662 */  0,
  /*  663 */  0,
  /*  664 */  0,
  /*  665 */  0,
  /*  666 */  0,
  /*  667 */  iRegP_rule,
  /*  668 */  0,
  /*  669 */  iRegP_rule,
  /*  670 */  0,
  /*  671 */  0,
  /*  672 */  0,
  /*  673 */  rarg2RegP_rule,
  /*  674 */  SSlenDW_rule,
  /*  675 */  immL_rule,
  /*  676 */  iRegL_rule,
  /*  677 */  _Binary_iRegP_iRegP_rule,
  /*  678 */  _Binary_iRegP_iRegP_rule,
  /*  679 */  _Binary_iRegP_iRegP_rule,
  /*  680 */  iRegP_rule,
  /*  681 */  iRegP_rule,
  /*  682 */  _Binary_iRegP_rarg2RegI_rule,
  /*  683 */  _Binary_iRegP_rarg2RegI_rule,
  /*  684 */  _Binary_iRegP_rarg2RegI_rule,
  /*  685 */  _Binary_iRegP_rarg2RegI_rule,
  /*  686 */  _Binary_iRegP_iRegI_rule,
  /*  687 */  _Binary_iRegP_iRegI_rule,
  /*  688 */  _Binary_iRegP_iRegI_rule,
  /*  689 */  _Binary_iRegP_iRegI_rule,
  /*  690 */  _Binary_iRegP_iRegI_rule,
  /*  691 */  _Binary_iRegP_rarg2RegI_rule,
  /*  692 */  _Binary_iRegP_rarg2RegI_rule,
  /*  693 */  _Binary_iRegP_rarg2RegI_rule,
  /*  694 */  _Binary_iRegP_rarg2RegI_rule,
  /*  695 */  _Binary_iRegP_rarg2RegI_rule,
  /*  696 */  _Binary_iRegP_rarg2RegI_rule,
  /*  697 */  iRegP_rule,
  /*  698 */  iRegP_rule,
  /*  699 */  iRegP_rule,
  /*  700 */  iRegP_rule,
  /*  701 */  iRegP_rule,
  /*  702 */  iRegP_rule,
  /*  703 */  0,
  /*  704 */  iRegL_rule,
  /*  705 */  iRegI_rule,
  /*  706 */  iRegI_rule,
  /*  707 */  iRegI_rule,
  /*  708 */  regF_rule,
  /*  709 */  regF_rule,
  /*  710 */  memory_rule,
  /*  711 */  memory_rule,
  /*  712 */  iRegI_rule,
  /*  713 */  iRegL_rule,
  /*  714 */  iRegI_rule,
  /*  715 */  iRegL_rule,
  /*  716 */  iRegI_rule,
  /*  717 */  iRegL_rule,
  /*  718 */  iRegI_rule,
  /*  719 */  iRegL_rule,
  // last instruction
  0 // no trailing comma
};

const        int   rightOp[] = {
  /*    0 */  0,
  /*    1 */  0,
  /*    2 */  0,
  /*    3 */  0,
  /*    4 */  0,
  /*    5 */  0,
  /*    6 */  0,
  /*    7 */  0,
  /*    8 */  0,
  /*    9 */  0,
  /*   10 */  0,
  /*   11 */  0,
  /*   12 */  0,
  /*   13 */  0,
  /*   14 */  0,
  /*   15 */  0,
  /*   16 */  0,
  /*   17 */  0,
  /*   18 */  0,
  /*   19 */  0,
  /*   20 */  0,
  /*   21 */  0,
  /*   22 */  0,
  /*   23 */  0,
  /*   24 */  0,
  /*   25 */  0,
  /*   26 */  0,
  /*   27 */  0,
  /*   28 */  0,
  /*   29 */  0,
  /*   30 */  0,
  /*   31 */  0,
  /*   32 */  0,
  /*   33 */  0,
  /*   34 */  0,
  /*   35 */  0,
  /*   36 */  0,
  /*   37 */  0,
  /*   38 */  0,
  /*   39 */  0,
  /*   40 */  0,
  /*   41 */  0,
  /*   42 */  0,
  /*   43 */  0,
  /*   44 */  0,
  /*   45 */  0,
  /*   46 */  0,
  /*   47 */  0,
  /*   48 */  0,
  /*   49 */  0,
  /*   50 */  0,
  /*   51 */  0,
  /*   52 */  0,
  /*   53 */  0,
  /*   54 */  0,
  /*   55 */  0,
  /*   56 */  0,
  /*   57 */  0,
  /*   58 */  0,
  /*   59 */  0,
  /*   60 */  0,
  /*   61 */  0,
  /*   62 */  0,
  /*   63 */  0,
  /*   64 */  0,
  /*   65 */  0,
  /*   66 */  0,
  /*   67 */  0,
  /*   68 */  0,
  /*   69 */  0,
  /*   70 */  0,
  /*   71 */  0,
  /*   72 */  0,
  /*   73 */  0,
  /*   74 */  0,
  /*   75 */  0,
  /*   76 */  0,
  /*   77 */  0,
  /*   78 */  0,
  /*   79 */  0,
  /*   80 */  0,
  /*   81 */  0,
  /*   82 */  0,
  /*   83 */  0,
  /*   84 */  0,
  /*   85 */  0,
  /*   86 */  0,
  /*   87 */  0,
  /*   88 */  0,
  /*   89 */  0,
  /*   90 */  0,
  /*   91 */  0,
  /*   92 */  0,
  /*   93 */  0,
  /*   94 */  0,
  /*   95 */  0,
  /*   96 */  0,
  /*   97 */  0,
  /*   98 */  immL20_rule,
  /*   99 */  immL20_rule,
  /*  100 */  uimmL12_rule,
  /*  101 */  uimmL12_rule,
  /*  102 */  iRegL_rule,
  /*  103 */  immL20_rule,
  /*  104 */  immL20_rule,
  /*  105 */  uimmL12_rule,
  /*  106 */  uimmL12_rule,
  /*  107 */  0,
  /*  108 */  0,
  /*  109 */  0,
  /*  110 */  0,
  /*  111 */  0,
  /*  112 */  0,
  /*  113 */  0,
  /*  114 */  0,
  // last operand
  /*  115 */  0,
  /*  116 */  0,
  /*  117 */  0,
  /*  118 */  0,
  /*  119 */  0,
  /*  120 */  0,
  /*  121 */  0,
  // last operand class
  /*  122 */  0,
  /*  123 */  iRegL_rule,
  /*  124 */  iRegL_rule,
  /*  125 */  0,
  /*  126 */  0,
  /*  127 */  0,
  /*  128 */  0,
  /*  129 */  0,
  /*  130 */  0,
  /*  131 */  0,
  /*  132 */  0,
  /*  133 */  0,
  /*  134 */  iRegN_rule,
  /*  135 */  flagsReg_rule,
  /*  136 */  iRegN_P2N_rule,
  /*  137 */  immN0_rule,
  /*  138 */  iRegI_rule,
  /*  139 */  immI16_rule,
  /*  140 */  iRegP_N2P_rule,
  /*  141 */  immP0_rule,
  /*  142 */  flagsReg_rule,
  /*  143 */  regF_rule,
  /*  144 */  regD_rule,
  /*  145 */  iRegL_rule,
  /*  146 */  immL16_rule,
  /*  147 */  iRegI_rule,
  /*  148 */  iRegL_rule,
  /*  149 */  iRegP_N2P_rule,
  /*  150 */  iRegN_P2N_rule,
  /*  151 */  iRegI_rule,
  /*  152 */  0,
  /*  153 */  immI8_rule,
  /*  154 */  0,
  /*  155 */  0,
  /*  156 */  iRegL_rule,
  /*  157 */  0,
  /*  158 */  immL8_rule,
  /*  159 */  iRegL_rule,
  /*  160 */  0,
  /*  161 */  immL8_rule,
  /*  162 */  0,
  /*  163 */  immI8_rule,
  /*  164 */  immI8_rule,
  /*  165 */  immI8_rule,
  /*  166 */  immI8_rule,
  /*  167 */  0,
  /*  168 */  0,
  /*  169 */  0,
  /*  170 */  0,
  /*  171 */  _LoadF_memoryRX__rule,
  /*  172 */  _LoadD_memoryRX__rule,
  /*  173 */  regF_rule,
  /*  174 */  regD_rule,
  /*  175 */  0,
  /*  176 */  0,
  /*  177 */  immI_16_rule,
  /*  178 */  immI_24_rule,
  /*  179 */  immI_32_63_rule,
  /*  180 */  uimmI16_rule,
  /*  181 */  iRegI_rule,
  /*  182 */  immP0_rule,
  /*  183 */  immN0_rule,
  /*  184 */  0,
  /*  185 */  iRegI_rule,
  /*  186 */  iRegL_rule,
  /*  187 */  iRegP_rule,
  /*  188 */  _DecodeN_iRegN__rule,
  /*  189 */  immI8_rule,
  /*  190 */  uimmI8_rule,
  /*  191 */  immL8_rule,
  /*  192 */  immP8_rule,
  /*  193 */  immP0_rule,
  /*  194 */  0,
  /*  195 */  _DecodeN_immN8__rule,
  /*  196 */  rarg3RegP_rule,
  /*  197 */  iRegP_rule,
  /*  198 */  rarg2RegI_rule,
  /*  199 */  rarg5RegI_rule,
  /*  200 */  iRegI_rule,
  /*  201 */  immI_1_rule,
  /*  202 */  immI16_rule,
  /*  203 */  immI_rule,
  // last internally defined operand
  /*  204 */  0,
  /*  205 */  0,
  /*  206 */  0,
  /*  207 */  0,
  /*  208 */  0,
  /*  209 */  0,
  /*  210 */  0,
  /*  211 */  0,
  /*  212 */  0,
  /*  213 */  0,
  /*  214 */  0,
  /*  215 */  0,
  /*  216 */  0,
  /*  217 */  0,
  /*  218 */  0,
  /*  219 */  0,
  /*  220 */  0,
  /*  221 */  0,
  /*  222 */  0,
  /*  223 */  0,
  /*  224 */  0,
  /*  225 */  0,
  /*  226 */  0,
  /*  227 */  0,
  /*  228 */  0,
  /*  229 */  0,
  /*  230 */  0,
  /*  231 */  0,
  /*  232 */  0,
  /*  233 */  0,
  /*  234 */  0,
  /*  235 */  iRegN_P2N_rule,
  /*  236 */  immN_rule,
  /*  237 */  immNKlass_rule,
  /*  238 */  immN0_rule,
  /*  239 */  0,
  /*  240 */  0,
  /*  241 */  0,
  /*  242 */  0,
  /*  243 */  0,
  /*  244 */  0,
  /*  245 */  0,
  /*  246 */  0,
  /*  247 */  0,
  /*  248 */  0,
  /*  249 */  0,
  /*  250 */  0,
  /*  251 */  iRegI_rule,
  /*  252 */  immI_rule,
  /*  253 */  iRegL_rule,
  /*  254 */  immL_rule,
  /*  255 */  iRegI_rule,
  /*  256 */  immI_rule,
  /*  257 */  iRegL_rule,
  /*  258 */  immL_rule,
  /*  259 */  iRegI_rule,
  /*  260 */  iRegL_rule,
  /*  261 */  0,
  /*  262 */  0,
  /*  263 */  0,
  /*  264 */  0,
  /*  265 */  iRegI_rule,
  /*  266 */  immI_rule,
  /*  267 */  immI16_rule,
  /*  268 */  immI_0_rule,
  /*  269 */  _LoadI_memory__rule,
  /*  270 */  iRegI_rule,
  /*  271 */  uimmI_rule,
  /*  272 */  _LoadI_memory__rule,
  /*  273 */  iRegL_rule,
  /*  274 */  _ConvI2L_iRegI__rule,
  /*  275 */  immL32_rule,
  /*  276 */  immL16_rule,
  /*  277 */  immL_0_rule,
  /*  278 */  immL_0_rule,
  /*  279 */  _LoadL_memory__rule,
  /*  280 */  _ConvI2L__LoadI_memory___rule,
  /*  281 */  iRegL_rule,
  /*  282 */  uimmL32_rule,
  /*  283 */  iRegP_N2P_rule,
  /*  284 */  immP0_rule,
  /*  285 */  immP0_rule,
  /*  286 */  _LoadP_memory__rule,
  /*  287 */  regF_rule,
  /*  288 */  regD_rule,
  /*  289 */  _LoadF_memoryRX__rule,
  /*  290 */  _LoadD_memoryRX__rule,
  /*  291 */  immFpm0_rule,
  /*  292 */  immDpm0_rule,
  /*  293 */  immP0_rule,
  /*  294 */  iRegP_N2P_rule,
  /*  295 */  iRegP_N2P_rule,
  /*  296 */  0,
  /*  297 */  0,
  /*  298 */  0,
  /*  299 */  0,
  /*  300 */  0,
  /*  301 */  0,
  /*  302 */  0,
  /*  303 */  0,
  /*  304 */  0,
  /*  305 */  0,
  /*  306 */  0,
  /*  307 */  0,
  /*  308 */  0,
  /*  309 */  0,
  /*  310 */  0,
  /*  311 */  0,
  /*  312 */  0,
  /*  313 */  0,
  /*  314 */  0,
  /*  315 */  0,
  /*  316 */  0,
  /*  317 */  0,
  /*  318 */  0,
  /*  319 */  immL_FFFFFFFF_rule,
  /*  320 */  0,
  /*  321 */  0,
  /*  322 */  0,
  /*  323 */  0,
  /*  324 */  0,
  /*  325 */  0,
  /*  326 */  0,
  /*  327 */  0,
  /*  328 */  0,
  /*  329 */  iRegI_rule,
  /*  330 */  immI_0_rule,
  /*  331 */  iRegI_rule,
  /*  332 */  iRegI_rule,
  /*  333 */  iRegL_rule,
  /*  334 */  memoryRegP_rule,
  /*  335 */  regF_rule,
  /*  336 */  regD_rule,
  /*  337 */  0,
  /*  338 */  immI8_rule,
  /*  339 */  immI16_rule,
  /*  340 */  immI16_rule,
  /*  341 */  immL16_rule,
  /*  342 */  immP16_rule,
  /*  343 */  iRegL_rule,
  /*  344 */  0,
  /*  345 */  0,
  /*  346 */  0,
  /*  347 */  0,
  /*  348 */  0,
  /*  349 */  0,
  /*  350 */  0,
  /*  351 */  0,
  /*  352 */  iRegL_rule,
  /*  353 */  iRegL_rule,
  /*  354 */  0,
  /*  355 */  0,
  /*  356 */  0,
  /*  357 */  0,
  /*  358 */  0,
  /*  359 */  _Binary_iRegL_iRegN_rule,
  /*  360 */  iRegL_rule,
  /*  361 */  0,
  /*  362 */  0,
  /*  363 */  iRegN_P2N_rule,
  /*  364 */  iRegN_rule,
  /*  365 */  0,
  /*  366 */  0,
  /*  367 */  0,
  /*  368 */  0,
  /*  369 */  0,
  /*  370 */  0,
  /*  371 */  0,
  /*  372 */  0,
  /*  373 */  0,
  /*  374 */  0,
  /*  375 */  0,
  /*  376 */  _Binary_iRegN_iRegN_P2N_rule,
  /*  377 */  _Binary_iRegN_immN0_rule,
  /*  378 */  _Binary_iRegI_iRegI_rule,
  /*  379 */  _Binary_iRegI_immI16_rule,
  /*  380 */  _Binary_iRegP_iRegP_N2P_rule,
  /*  381 */  _Binary_iRegP_immP0_rule,
  /*  382 */  _Binary_regF_regF_rule,
  /*  383 */  _Binary_regD_regD_rule,
  /*  384 */  _Binary_iRegL_iRegL_rule,
  /*  385 */  _Binary_iRegL_immL16_rule,
  /*  386 */  _Binary_rarg5RegI_iRegI_rule,
  /*  387 */  _Binary_rarg5RegL_iRegL_rule,
  /*  388 */  _Binary_rarg5RegP_iRegP_N2P_rule,
  /*  389 */  _Binary_rarg5RegN_iRegN_P2N_rule,
  /*  390 */  immI8_rule,
  /*  391 */  immI16_rule,
  /*  392 */  immI_rule,
  /*  393 */  iRegI_rule,
  /*  394 */  immL8_rule,
  /*  395 */  immL16_rule,
  /*  396 */  immL32_rule,
  /*  397 */  iRegL_rule,
  /*  398 */  iRegI_rule,
  /*  399 */  iRegL_rule,
  /*  400 */  iRegI_rule,
  /*  401 */  iRegL_rule,
  /*  402 */  iRegN_rule,
  /*  403 */  iRegP_rule,
  /*  404 */  iRegI_rule,
  /*  405 */  iRegI_rule,
  /*  406 */  immI16_rule,
  /*  407 */  immI16_rule,
  /*  408 */  immI_rule,
  /*  409 */  uimmI12_rule,
  /*  410 */  immI20_rule,
  /*  411 */  uimmI12_rule,
  /*  412 */  immI20_rule,
  /*  413 */  _LoadI_memory__rule,
  /*  414 */  iRegI_rule,
  /*  415 */  _AddI__LoadI_memoryRSY__immI8_rule,
  /*  416 */  _ConvI2L_iRegI__rule,
  /*  417 */  iRegL_rule,
  /*  418 */  iRegL_rule,
  /*  419 */  iRegL_rule,
  /*  420 */  uimmL12_rule,
  /*  421 */  immL20_rule,
  /*  422 */  immL32_rule,
  /*  423 */  immL16_rule,
  /*  424 */  immL16_rule,
  /*  425 */  _ConvI2L__LoadI_memory___rule,
  /*  426 */  iRegL_rule,
  /*  427 */  _LoadL_memory__rule,
  /*  428 */  iRegL_rule,
  /*  429 */  uimmL12_rule,
  /*  430 */  immL20_rule,
  /*  431 */  _AddL__LoadL_memoryRSY__immL8_rule,
  /*  432 */  iRegL_rule,
  /*  433 */  iRegL_rule,
  /*  434 */  iRegL_rule,
  /*  435 */  uimmL12_rule,
  /*  436 */  immL16_rule,
  /*  437 */  immL16_rule,
  /*  438 */  immL20_rule,
  /*  439 */  immL32_rule,
  /*  440 */  uimmL12_rule,
  /*  441 */  uimmL12_rule,
  /*  442 */  immL20_rule,
  /*  443 */  immL20_rule,
  /*  444 */  _AddP__LoadP_memoryRSY__immL8_rule,
  /*  445 */  iRegI_rule,
  /*  446 */  iRegI_rule,
  /*  447 */  _LoadI_memory__rule,
  /*  448 */  iRegI_rule,
  /*  449 */  iRegL_rule,
  /*  450 */  iRegL_rule,
  /*  451 */  _ConvI2L_iRegI__rule,
  /*  452 */  _ConvI2L__LoadI_memory___rule,
  /*  453 */  _LoadL_memory__rule,
  /*  454 */  iRegI_rule,
  /*  455 */  immI16_rule,
  /*  456 */  immI_rule,
  /*  457 */  _LoadI_memory__rule,
  /*  458 */  iRegI_rule,
  /*  459 */  _ConvI2L_iRegI__rule,
  /*  460 */  iRegL_rule,
  /*  461 */  iRegL_rule,
  /*  462 */  immL16_rule,
  /*  463 */  immL32_rule,
  /*  464 */  _ConvI2L__LoadI_memory___rule,
  /*  465 */  iRegL_rule,
  /*  466 */  _LoadL_memory__rule,
  /*  467 */  iRegL_rule,
  /*  468 */  iRegL_rule,
  /*  469 */  noOdd_iRegI_rule,
  /*  470 */  noOdd_iRegI_rule,
  /*  471 */  immI16_rule,
  /*  472 */  iRegL_rule,
  /*  473 */  iRegL_rule,
  /*  474 */  immL16_rule,
  /*  475 */  noOdd_iRegI_rule,
  /*  476 */  immI16_rule,
  /*  477 */  iRegL_rule,
  /*  478 */  immL16_rule,
  /*  479 */  iRegI_rule,
  /*  480 */  immI_rule,
  /*  481 */  immI_1_rule,
  /*  482 */  iRegI_rule,
  /*  483 */  immI_rule,
  /*  484 */  immI_1_rule,
  /*  485 */  iRegI_rule,
  /*  486 */  immI_rule,
  /*  487 */  iRegI_rule,
  /*  488 */  immI_rule,
  /*  489 */  iRegI_rule,
  /*  490 */  immI_rule,
  /*  491 */  iRegI_rule,
  /*  492 */  immI_rule,
  /*  493 */  immI_rule,
  /*  494 */  _URShiftI_iRegI_immI8_rule,
  /*  495 */  _LShiftI_iRegI_immI8_rule,
  /*  496 */  _URShiftL_iRegL_immI8_rule,
  /*  497 */  _LShiftL_iRegL_immI8_rule,
  /*  498 */  _LShiftI_iRegI_immI8_rule,
  /*  499 */  _URShiftI_iRegI_immI8_rule,
  /*  500 */  _LShiftL_iRegL_immI8_rule,
  /*  501 */  _URShiftL_iRegL_immI8_rule,
  /*  502 */  regF_rule,
  /*  503 */  _LoadF_memoryRX__rule,
  /*  504 */  regF_rule,
  /*  505 */  regD_rule,
  /*  506 */  _LoadD_memoryRX__rule,
  /*  507 */  regD_rule,
  /*  508 */  regF_rule,
  /*  509 */  _LoadF_memoryRX__rule,
  /*  510 */  regD_rule,
  /*  511 */  _LoadD_memoryRX__rule,
  /*  512 */  regF_rule,
  /*  513 */  _LoadF_memoryRX__rule,
  /*  514 */  regF_rule,
  /*  515 */  regD_rule,
  /*  516 */  _LoadD_memoryRX__rule,
  /*  517 */  regD_rule,
  /*  518 */  _Binary_regF_regF_rule,
  /*  519 */  _Binary_regD_regD_rule,
  /*  520 */  _Binary_regF_regF_rule,
  /*  521 */  _Binary_regD_regD_rule,
  /*  522 */  _Binary_regF__LoadF_memoryRX__rule,
  /*  523 */  _Binary_regD__LoadD_memoryRX__rule,
  /*  524 */  _Binary_regF__LoadF_memoryRX__rule,
  /*  525 */  _Binary_regD__LoadD_memoryRX__rule,
  /*  526 */  _Binary__LoadF_memoryRX__regF_rule,
  /*  527 */  _Binary__LoadD_memoryRX__regD_rule,
  /*  528 */  _Binary__LoadF_memoryRX__regF_rule,
  /*  529 */  _Binary__LoadD_memoryRX__regD_rule,
  /*  530 */  regF_rule,
  /*  531 */  _LoadF_memoryRX__rule,
  /*  532 */  regD_rule,
  /*  533 */  _LoadD_memoryRX__rule,
  /*  534 */  0,
  /*  535 */  0,
  /*  536 */  0,
  /*  537 */  0,
  /*  538 */  0,
  /*  539 */  0,
  /*  540 */  0,
  /*  541 */  0,
  /*  542 */  0,
  /*  543 */  0,
  /*  544 */  iRegI_rule,
  /*  545 */  _LoadI_memory__rule,
  /*  546 */  iRegI_rule,
  /*  547 */  uimmI_rule,
  /*  548 */  uimmI_LH1_rule,
  /*  549 */  uimmI_LL1_rule,
  /*  550 */  iRegL_rule,
  /*  551 */  _LoadL_memory__rule,
  /*  552 */  iRegL_rule,
  /*  553 */  uimmL_LL1_rule,
  /*  554 */  uimmL_LH1_rule,
  /*  555 */  uimmL_HL1_rule,
  /*  556 */  uimmL_HH1_rule,
  /*  557 */  iRegI_rule,
  /*  558 */  _LoadI_memory__rule,
  /*  559 */  iRegI_rule,
  /*  560 */  uimmI16_rule,
  /*  561 */  uimmI_rule,
  /*  562 */  iRegL_rule,
  /*  563 */  _LoadL_memory__rule,
  /*  564 */  iRegL_rule,
  /*  565 */  uimmL16_rule,
  /*  566 */  uimmL32_rule,
  /*  567 */  iRegI_rule,
  /*  568 */  _LoadI_memory__rule,
  /*  569 */  iRegI_rule,
  /*  570 */  uimmI_rule,
  /*  571 */  iRegL_rule,
  /*  572 */  _LoadL_memory__rule,
  /*  573 */  iRegL_rule,
  /*  574 */  uimmL32_rule,
  /*  575 */  0,
  /*  576 */  0,
  /*  577 */  iRegI_rule,
  /*  578 */  immI_0_rule,
  /*  579 */  0,
  /*  580 */  0,
  /*  581 */  0,
  /*  582 */  0,
  /*  583 */  0,
  /*  584 */  0,
  /*  585 */  0,
  /*  586 */  0,
  /*  587 */  0,
  /*  588 */  0,
  /*  589 */  immL_32bits_rule,
  /*  590 */  immL_32bits_rule,
  /*  591 */  immL_32bits_rule,
  /*  592 */  immI_16_rule,
  /*  593 */  immI_24_rule,
  /*  594 */  0,
  /*  595 */  0,
  /*  596 */  0,
  /*  597 */  0,
  /*  598 */  0,
  /*  599 */  0,
  /*  600 */  0,
  /*  601 */  _CmpU_iRegI_uimmI16_rule,
  /*  602 */  _CmpU_iRegI_iRegI_rule,
  /*  603 */  _CmpU_iRegI_uimmI16_rule,
  /*  604 */  _CmpP_iRegP_N2P_immP0_rule,
  /*  605 */  _CmpN_iRegN_P2N_immN0_rule,
  /*  606 */  iRegI_rule,
  /*  607 */  iRegI_rule,
  /*  608 */  iRegI_rule,
  /*  609 */  immI_rule,
  /*  610 */  immI_rule,
  /*  611 */  immI16_rule,
  /*  612 */  immI16_rule,
  /*  613 */  immI8_rule,
  /*  614 */  iRegI_rule,
  /*  615 */  iRegI_rule,
  /*  616 */  iRegI_rule,
  /*  617 */  immI_rule,
  /*  618 */  immI_rule,
  /*  619 */  immI16_rule,
  /*  620 */  immI16_rule,
  /*  621 */  immI8_rule,
  /*  622 */  0,
  /*  623 */  0,
  /*  624 */  _AbsI_iRegI__rule,
  /*  625 */  regF_rule,
  /*  626 */  regD_rule,
  /*  627 */  0,
  /*  628 */  0,
  /*  629 */  flagsReg_rule,
  /*  630 */  flagsReg_rule,
  /*  631 */  flagsReg_rule,
  /*  632 */  flagsReg_rule,
  /*  633 */  _CmpI_iRegI_iRegI_rule,
  /*  634 */  _CmpI_iRegI_iRegI_rule,
  /*  635 */  _CmpU_iRegI_iRegI_rule,
  /*  636 */  _CmpL_iRegL_iRegL_rule,
  /*  637 */  _CmpP_iRegP_iRegP_rule,
  /*  638 */  _CmpP__DecodeN_iRegN___DecodeN_iRegN__rule,
  /*  639 */  _CmpI_iRegI_immI8_rule,
  /*  640 */  _CmpI_iRegI_immI8_rule,
  /*  641 */  _CmpU_iRegI_uimmI8_rule,
  /*  642 */  _CmpL_iRegL_immL8_rule,
  /*  643 */  _CmpP_iRegP_immP8_rule,
  /*  644 */  _CmpP__DecodeN_iRegN__immP0_rule,
  /*  645 */  _CmpP__DecodeN_iRegN___DecodeN_immN8__rule,
  /*  646 */  _CmpI_iRegI_iRegI_rule,
  /*  647 */  _CmpI_iRegI_iRegI_rule,
  /*  648 */  _CmpU_iRegI_iRegI_rule,
  /*  649 */  _CmpL_iRegL_iRegL_rule,
  /*  650 */  _CmpP_iRegP_iRegP_rule,
  /*  651 */  _CmpP__DecodeN_iRegN___DecodeN_iRegN__rule,
  /*  652 */  _CmpI_iRegI_immI8_rule,
  /*  653 */  _CmpI_iRegI_immI8_rule,
  /*  654 */  _CmpU_iRegI_uimmI8_rule,
  /*  655 */  _CmpL_iRegL_immL8_rule,
  /*  656 */  _CmpP_iRegP_immP8_rule,
  /*  657 */  _CmpP__DecodeN_iRegN__immP0_rule,
  /*  658 */  _CmpP__DecodeN_iRegN___DecodeN_immN8__rule,
  /*  659 */  iRegL_rule,
  /*  660 */  0,
  /*  661 */  0,
  /*  662 */  0,
  /*  663 */  0,
  /*  664 */  0,
  /*  665 */  0,
  /*  666 */  0,
  /*  667 */  inline_cache_regP_rule,
  /*  668 */  0,
  /*  669 */  rarg1RegP_rule,
  /*  670 */  0,
  /*  671 */  0,
  /*  672 */  0,
  /*  673 */  rarg3RegP_rule,
  /*  674 */  iRegP_N2P_rule,
  /*  675 */  iRegP_N2P_rule,
  /*  676 */  iRegP_N2P_rule,
  /*  677 */  iRegI_rule,
  /*  678 */  uimmI8_rule,
  /*  679 */  immI8_rule,
  /*  680 */  iRegP_rule,
  /*  681 */  iRegP_rule,
  /*  682 */  _Binary_iRegP_rarg5RegI_rule,
  /*  683 */  _Binary_iRegP_rarg5RegI_rule,
  /*  684 */  _Binary_iRegP_rarg5RegI_rule,
  /*  685 */  _Binary_iRegP_rarg5RegI_rule,
  /*  686 */  iRegI_rule,
  /*  687 */  iRegI_rule,
  /*  688 */  _Binary_immP_immI_1_rule,
  /*  689 */  _Binary_immP_immI_1_rule,
  /*  690 */  _Binary_immP_immI_1_rule,
  /*  691 */  _Binary_iRegP_immI16_rule,
  /*  692 */  _Binary_iRegP_immI16_rule,
  /*  693 */  _Binary_iRegP_immI16_rule,
  /*  694 */  _Binary_iRegP_rarg5RegI_rule,
  /*  695 */  _Binary_iRegP_rarg5RegI_rule,
  /*  696 */  _Binary_iRegP_rarg5RegI_rule,
  /*  697 */  _Binary_iRegP_iRegI_rule,
  /*  698 */  _Binary_iRegP_iRegI_rule,
  /*  699 */  _Binary_iRegP_immI_rule,
  /*  700 */  iRegI_rule,
  /*  701 */  _Binary_iRegP_iRegI_rule,
  /*  702 */  _Binary_iRegP_iRegI_rule,
  /*  703 */  0,
  /*  704 */  0,
  /*  705 */  0,
  /*  706 */  0,
  /*  707 */  0,
  /*  708 */  0,
  /*  709 */  0,
  /*  710 */  iRegL_rule,
  /*  711 */  0,
  /*  712 */  0,
  /*  713 */  0,
  /*  714 */  0,
  /*  715 */  0,
  /*  716 */  0,
  /*  717 */  0,
  /*  718 */  0,
  /*  719 */  0,
  // last instruction
  0 // no trailing comma
};

const char        *ruleName[] = {
  /*    0 */  "UNIVERSE",
  /*    1 */  "LABEL",
  /*    2 */  "SREGI",
  /*    3 */  "SREGP",
  /*    4 */  "SREGF",
  /*    5 */  "SREGD",
  /*    6 */  "SREGL",
  /*    7 */  "METHOD",
  /*    8 */  "IMMB_MINUS1",
  /*    9 */  "IMMB_N0M1",
  /*   10 */  "IMMS_MINUS1",
  /*   11 */  "IMMS_N0M1",
  /*   12 */  "IMMI",
  /*   13 */  "IMMI20",
  /*   14 */  "IMMI16",
  /*   15 */  "IMMI8",
  /*   16 */  "IMMI_0",
  /*   17 */  "IMMI_MINUS1",
  /*   18 */  "IMMI_N0M1",
  /*   19 */  "UIMMI",
  /*   20 */  "UIMMI16",
  /*   21 */  "UIMMI12",
  /*   22 */  "UIMMI8",
  /*   23 */  "SSLENDW",
  /*   24 */  "IMMI_1",
  /*   25 */  "IMMI_16",
  /*   26 */  "IMMI_24",
  /*   27 */  "IMMI_32_63",
  /*   28 */  "UIMMI_LL1",
  /*   29 */  "UIMMI_LH1",
  /*   30 */  "IMML",
  /*   31 */  "IMML32",
  /*   32 */  "IMML20",
  /*   33 */  "IMML16",
  /*   34 */  "IMML8",
  /*   35 */  "UIMML32",
  /*   36 */  "UIMML16",
  /*   37 */  "UIMML12",
  /*   38 */  "IMML_FFFFFFFF",
  /*   39 */  "IMML_0",
  /*   40 */  "UIMML_LL1",
  /*   41 */  "UIMML_LH1",
  /*   42 */  "UIMML_HL1",
  /*   43 */  "UIMML_HH1",
  /*   44 */  "IMML_32BITS",
  /*   45 */  "IMMP",
  /*   46 */  "IMMP16",
  /*   47 */  "IMMP8",
  /*   48 */  "IMMP0",
  /*   49 */  "IMMN",
  /*   50 */  "IMMNKLASS",
  /*   51 */  "IMMN8",
  /*   52 */  "IMMN0",
  /*   53 */  "IMMD",
  /*   54 */  "IMMDPM0",
  /*   55 */  "IMMDP0",
  /*   56 */  "IMMF",
  /*   57 */  "IMMFPM0",
  /*   58 */  "IMMFP0",
  /*   59 */  "IREGI",
  /*   60 */  "NOARG_IREGI",
  /*   61 */  "REVENREGI",
  /*   62 */  "RODDREGI",
  /*   63 */  "RARG1REGI",
  /*   64 */  "RARG2REGI",
  /*   65 */  "RARG3REGI",
  /*   66 */  "RARG4REGI",
  /*   67 */  "RARG5REGI",
  /*   68 */  "NOODD_IREGI",
  /*   69 */  "IREGP",
  /*   70 */  "THREADREGP",
  /*   71 */  "NOARG_IREGP",
  /*   72 */  "RARG1REGP",
  /*   73 */  "RARG2REGP",
  /*   74 */  "RARG3REGP",
  /*   75 */  "RARG4REGP",
  /*   76 */  "RARG5REGP",
  /*   77 */  "MEMORYREGP",
  /*   78 */  "REVENREGP",
  /*   79 */  "RODDREGP",
  /*   80 */  "IREGN",
  /*   81 */  "NOARG_IREGN",
  /*   82 */  "RARG1REGN",
  /*   83 */  "RARG2REGN",
  /*   84 */  "RARG3REGN",
  /*   85 */  "RARG4REGN",
  /*   86 */  "RARG5REGN",
  /*   87 */  "IREGL",
  /*   88 */  "REVENREGL",
  /*   89 */  "RODDREGL",
  /*   90 */  "ALLRODDREGL",
  /*   91 */  "RARG1REGL",
  /*   92 */  "RARG5REGL",
  /*   93 */  "FLAGSREG",
  /*   94 */  "REGD",
  /*   95 */  "REGF",
  /*   96 */  "INLINE_CACHE_REGP",
  /*   97 */  "INDIRECT",
  /*   98 */  "INDOFFSET20",
  /*   99 */  "INDOFFSET20NARROW",
  /*  100 */  "INDOFFSET12",
  /*  101 */  "INDOFFSET12NARROW",
  /*  102 */  "INDINDEX",
  /*  103 */  "INDOFFSET20INDEX",
  /*  104 */  "INDOFFSET20INDEXNARROW",
  /*  105 */  "INDOFFSET12INDEX",
  /*  106 */  "INDOFFSET12INDEXNARROW",
  /*  107 */  "STACKSLOTI",
  /*  108 */  "STACKSLOTP",
  /*  109 */  "STACKSLOTF",
  /*  110 */  "STACKSLOTD",
  /*  111 */  "STACKSLOTL",
  /*  112 */  "CMPOPT",
  /*  113 */  "CMPOPF",
  /*  114 */  "CMPOP",
  // last operand
  /*  115 */  "MEMORY",
  /*  116 */  "MEMORYRXY",
  /*  117 */  "MEMORYRX",
  /*  118 */  "MEMORYRSY",
  /*  119 */  "MEMORYRS",
  /*  120 */  "IREGN_P2N",
  /*  121 */  "IREGP_N2P",
  // last operand class
  /*  122 */  "_DecodeN_iRegN_",
  /*  123 */  "_AddP_memoryRegP_iRegL",
  /*  124 */  "_AddP__DecodeN_iRegN__iRegL",
  /*  125 */  "_LoadB_memory_",
  /*  126 */  "_LoadUB_memory_",
  /*  127 */  "_LoadS_memory_",
  /*  128 */  "_LoadUS_memory_",
  /*  129 */  "_LoadI_memory_",
  /*  130 */  "_ConvI2L__LoadI_memory__",
  /*  131 */  "_LoadP_memory_",
  /*  132 */  "_LoadN_memory_",
  /*  133 */  "_LoadNKlass_memory_",
  /*  134 */  "_Binary_iRegL_iRegN",
  /*  135 */  "_Binary_cmpOp_flagsReg",
  /*  136 */  "_Binary_iRegN_iRegN_P2N",
  /*  137 */  "_Binary_iRegN_immN0",
  /*  138 */  "_Binary_iRegI_iRegI",
  /*  139 */  "_Binary_iRegI_immI16",
  /*  140 */  "_Binary_iRegP_iRegP_N2P",
  /*  141 */  "_Binary_iRegP_immP0",
  /*  142 */  "_Binary_cmpOpF_flagsReg",
  /*  143 */  "_Binary_regF_regF",
  /*  144 */  "_Binary_regD_regD",
  /*  145 */  "_Binary_iRegL_iRegL",
  /*  146 */  "_Binary_iRegL_immL16",
  /*  147 */  "_Binary_rarg5RegI_iRegI",
  /*  148 */  "_Binary_rarg5RegL_iRegL",
  /*  149 */  "_Binary_rarg5RegP_iRegP_N2P",
  /*  150 */  "_Binary_rarg5RegN_iRegN_P2N",
  /*  151 */  "_AddI_iRegI_iRegI",
  /*  152 */  "_LoadI_memoryRSY_",
  /*  153 */  "_AddI__LoadI_memoryRSY__immI8",
  /*  154 */  "_ConvI2L_iRegI_",
  /*  155 */  "_LoadL_memory_",
  /*  156 */  "_AddL_iRegL_iRegL",
  /*  157 */  "_LoadL_memoryRSY_",
  /*  158 */  "_AddL__LoadL_memoryRSY__immL8",
  /*  159 */  "_AddP_iRegP_N2P_iRegL",
  /*  160 */  "_LoadP_memoryRSY_",
  /*  161 */  "_AddP__LoadP_memoryRSY__immL8",
  /*  162 */  "_CastP2X_iRegP_N2P_",
  /*  163 */  "_LShiftI_iRegI_immI8",
  /*  164 */  "_URShiftI_iRegI_immI8",
  /*  165 */  "_LShiftL_iRegL_immI8",
  /*  166 */  "_URShiftL_iRegL_immI8",
  /*  167 */  "_LoadF_memoryRX_",
  /*  168 */  "_LoadD_memoryRX_",
  /*  169 */  "_NegF_regF_",
  /*  170 */  "_NegD_regD_",
  /*  171 */  "_Binary_regF__LoadF_memoryRX_",
  /*  172 */  "_Binary_regD__LoadD_memoryRX_",
  /*  173 */  "_Binary__LoadF_memoryRX__regF",
  /*  174 */  "_Binary__LoadD_memoryRX__regD",
  /*  175 */  "_AbsF_regF_",
  /*  176 */  "_AbsD_regD_",
  /*  177 */  "_LShiftI_iRegI_immI_16",
  /*  178 */  "_LShiftI_iRegI_immI_24",
  /*  179 */  "_RShiftL_iRegL_immI_32_63",
  /*  180 */  "_CmpU_iRegI_uimmI16",
  /*  181 */  "_CmpU_iRegI_iRegI",
  /*  182 */  "_CmpP_iRegP_N2P_immP0",
  /*  183 */  "_CmpN_iRegN_P2N_immN0",
  /*  184 */  "_AbsI_iRegI_",
  /*  185 */  "_CmpI_iRegI_iRegI",
  /*  186 */  "_CmpL_iRegL_iRegL",
  /*  187 */  "_CmpP_iRegP_iRegP",
  /*  188 */  "_CmpP__DecodeN_iRegN___DecodeN_iRegN_",
  /*  189 */  "_CmpI_iRegI_immI8",
  /*  190 */  "_CmpU_iRegI_uimmI8",
  /*  191 */  "_CmpL_iRegL_immL8",
  /*  192 */  "_CmpP_iRegP_immP8",
  /*  193 */  "_CmpP__DecodeN_iRegN__immP0",
  /*  194 */  "_DecodeN_immN8_",
  /*  195 */  "_CmpP__DecodeN_iRegN___DecodeN_immN8_",
  /*  196 */  "_PartialSubtypeCheck_rarg2RegP_rarg3RegP",
  /*  197 */  "_Binary_iRegP_iRegP",
  /*  198 */  "_Binary_iRegP_rarg2RegI",
  /*  199 */  "_Binary_iRegP_rarg5RegI",
  /*  200 */  "_Binary_iRegP_iRegI",
  /*  201 */  "_Binary_immP_immI_1",
  /*  202 */  "_Binary_iRegP_immI16",
  /*  203 */  "_Binary_iRegP_immI",
  // last internally defined operand
  /*  204 */  "regI_to_stkI",
  /*  205 */  "regL_to_stkL",
  /*  206 */  "regP_to_stkP",
  /*  207 */  "regF_to_stkF",
  /*  208 */  "regD_to_stkD",
  /*  209 */  "stfSSD",
  /*  210 */  "stfSSF",
  /*  211 */  "stkI_to_regI",
  /*  212 */  "stkL_to_regL",
  /*  213 */  "stkP_to_regP",
  /*  214 */  "stkF_to_regF",
  /*  215 */  "stkD_to_regD",
  /*  216 */  "loadConI",
  /*  217 */  "loadConI16",
  /*  218 */  "loadConI_0",
  /*  219 */  "loadConUI16",
  /*  220 */  "loadConL_pcrelTOC",
  /*  221 */  "loadConL32",
  /*  222 */  "loadConL16",
  /*  223 */  "loadConL_0",
  /*  224 */  "loadConP_pcrelTOC",
  /*  225 */  "loadConP0",
  /*  226 */  "loadConF_dynTOC",
  /*  227 */  "loadConD_dynTOC",
  /*  228 */  "loadConF0",
  /*  229 */  "loadConD0",
  /*  230 */  "loadConN",
  /*  231 */  "loadConN0",
  /*  232 */  "loadConNKlass",
  /*  233 */  "castP2X_loadP",
  /*  234 */  "loadBase",
  /*  235 */  "compN_iRegN",
  /*  236 */  "compN_iRegN_immN",
  /*  237 */  "compNKlass_iRegN_immN",
  /*  238 */  "compN_iRegN_immN0",
  /*  239 */  "roundDouble_nop",
  /*  240 */  "roundFloat_nop",
  /*  241 */  "castX2P",
  /*  242 */  "castP2X",
  /*  243 */  "tlsLoadP",
  /*  244 */  "checkCastPP",
  /*  245 */  "castPP",
  /*  246 */  "castII",
  /*  247 */  "castLL",
  /*  248 */  "castFF",
  /*  249 */  "castDD",
  /*  250 */  "castVV",
  /*  251 */  "overflowAddI_reg_reg",
  /*  252 */  "overflowAddI_reg_imm",
  /*  253 */  "overflowAddL_reg_reg",
  /*  254 */  "overflowAddL_reg_imm",
  /*  255 */  "overflowSubI_reg_reg",
  /*  256 */  "overflowSubI_reg_imm",
  /*  257 */  "overflowSubL_reg_reg",
  /*  258 */  "overflowSubL_reg_imm",
  /*  259 */  "overflowNegI_rReg",
  /*  260 */  "overflowNegL_rReg",
  /*  261 */  "MoveF2I_stack_reg",
  /*  262 */  "MoveI2F_stack_reg",
  /*  263 */  "MoveD2L_stack_reg",
  /*  264 */  "MoveL2D_stack_reg",
  /*  265 */  "compI_reg_reg",
  /*  266 */  "compI_reg_imm",
  /*  267 */  "compI_reg_imm16",
  /*  268 */  "compI_reg_imm0",
  /*  269 */  "compI_reg_mem",
  /*  270 */  "compU_reg_reg",
  /*  271 */  "compU_reg_uimm",
  /*  272 */  "compU_reg_mem",
  /*  273 */  "compL_reg_reg",
  /*  274 */  "compL_reg_regI",
  /*  275 */  "compL_reg_imm32",
  /*  276 */  "compL_reg_imm16",
  /*  277 */  "compL_reg_imm0",
  /*  278 */  "compL_conv_reg_imm0",
  /*  279 */  "compL_reg_mem",
  /*  280 */  "compL_reg_memI",
  /*  281 */  "compUL_reg_reg",
  /*  282 */  "compUL_reg_imm32",
  /*  283 */  "compP_reg_reg",
  /*  284 */  "compP_reg_imm0",
  /*  285 */  "compP_decode_reg_imm0",
  /*  286 */  "compP_reg_mem",
  /*  287 */  "cmpF_cc",
  /*  288 */  "cmpD_cc",
  /*  289 */  "cmpF_cc_mem",
  /*  290 */  "cmpD_cc_mem",
  /*  291 */  "cmpF0_cc",
  /*  292 */  "cmpD0_cc",
  /*  293 */  "partialSubtypeCheck_vs_zero",
  /*  294 */  "cmpFastLock",
  /*  295 */  "cmpFastUnlock",
  /*  296 */  "expand_LoadLogical_I2L",
  /*  297 */  "Repl8B_imm",
  /*  298 */  "Repl8B_imm0",
  /*  299 */  "Repl8B_immm1",
  /*  300 */  "Repl4S_imm",
  /*  301 */  "Repl4S_imm0",
  /*  302 */  "Repl4S_immm1",
  /*  303 */  "Repl2I_imm",
  /*  304 */  "Repl2I_imm0",
  /*  305 */  "Repl2I_immm1",
  /*  306 */  "Repl2F_imm",
  /*  307 */  "Repl2F_imm0",
  /*  308 */  "reinterpret",
  /*  309 */  "loadB",
  /*  310 */  "loadB2L",
  /*  311 */  "loadUB",
  /*  312 */  "loadUB2L",
  /*  313 */  "loadS",
  /*  314 */  "loadS2L",
  /*  315 */  "loadUS",
  /*  316 */  "loadUS2L",
  /*  317 */  "loadI",
  /*  318 */  "loadI2L",
  /*  319 */  "loadUI2L",
  /*  320 */  "loadRange",
  /*  321 */  "loadL",
  /*  322 */  "loadL_unaligned",
  /*  323 */  "loadP",
  /*  324 */  "loadKlass",
  /*  325 */  "loadTOC",
  /*  326 */  "loadF",
  /*  327 */  "loadD",
  /*  328 */  "loadD_unaligned",
  /*  329 */  "storeB",
  /*  330 */  "storeCM",
  /*  331 */  "storeC",
  /*  332 */  "storeI",
  /*  333 */  "storeL",
  /*  334 */  "storeP",
  /*  335 */  "storeF",
  /*  336 */  "storeD",
  /*  337 */  "prefetchAlloc",
  /*  338 */  "memInitB",
  /*  339 */  "memInitC",
  /*  340 */  "memInitI",
  /*  341 */  "memInitL",
  /*  342 */  "memInitP",
  /*  343 */  "negL_reg_reg",
  /*  344 */  "loadN",
  /*  345 */  "loadNKlass",
  /*  346 */  "decodeLoadN",
  /*  347 */  "decodeLoadNKlass",
  /*  348 */  "decodeLoadConNKlass",
  /*  349 */  "decodeN",
  /*  350 */  "decodeKlass",
  /*  351 */  "decodeN_NN",
  /*  352 */  "decodeN_base",
  /*  353 */  "decodeN_NN_base",
  /*  354 */  "decodeN_Ex",
  /*  355 */  "decodeN_NN_Ex",
  /*  356 */  "encodeP",
  /*  357 */  "encodeKlass",
  /*  358 */  "encodeP_NN",
  /*  359 */  "encodeP_base",
  /*  360 */  "encodeP_NN_base",
  /*  361 */  "encodeP_Ex",
  /*  362 */  "encodeP_NN_Ex",
  /*  363 */  "storeN",
  /*  364 */  "storeNKlass",
  /*  365 */  "membar_acquire",
  /*  366 */  "membar_acquire_0",
  /*  367 */  "membar_acquire_lock",
  /*  368 */  "membar_release",
  /*  369 */  "membar_release_0",
  /*  370 */  "membar_release_lock",
  /*  371 */  "membar_volatile",
  /*  372 */  "unnecessary_membar_volatile",
  /*  373 */  "membar_CPUOrder",
  /*  374 */  "membar_storestore",
  /*  375 */  "membar_storestore_0",
  /*  376 */  "cmovN_reg",
  /*  377 */  "cmovN_imm",
  /*  378 */  "cmovI_reg",
  /*  379 */  "cmovI_imm",
  /*  380 */  "cmovP_reg",
  /*  381 */  "cmovP_imm",
  /*  382 */  "cmovF_reg",
  /*  383 */  "cmovD_reg",
  /*  384 */  "cmovL_reg",
  /*  385 */  "cmovL_imm",
  /*  386 */  "compareAndSwapI_bool",
  /*  387 */  "compareAndSwapL_bool",
  /*  388 */  "compareAndSwapP_bool",
  /*  389 */  "compareAndSwapN_bool",
  /*  390 */  "addI_mem_imm8_atomic_no_res",
  /*  391 */  "addI_mem_imm16_atomic",
  /*  392 */  "addI_mem_imm32_atomic",
  /*  393 */  "addI_mem_reg_atomic",
  /*  394 */  "addL_mem_imm8_atomic_no_res",
  /*  395 */  "addL_mem_imm16_atomic",
  /*  396 */  "addL_mem_imm32_atomic",
  /*  397 */  "addL_mem_reg_atomic",
  /*  398 */  "addI_mem_reg_atomic_z196",
  /*  399 */  "addL_mem_reg_atomic_z196",
  /*  400 */  "xchgI_reg_mem",
  /*  401 */  "xchgL_reg_mem",
  /*  402 */  "xchgN_reg_mem",
  /*  403 */  "xchgP_reg_mem",
  /*  404 */  "addI_reg_reg_CISC",
  /*  405 */  "addI_reg_reg_RISC",
  /*  406 */  "addI_reg_imm16_CISC",
  /*  407 */  "addI_reg_imm16_RISC",
  /*  408 */  "addI_reg_imm32",
  /*  409 */  "addI_reg_imm12",
  /*  410 */  "addI_reg_imm20",
  /*  411 */  "addI_reg_reg_imm12",
  /*  412 */  "addI_reg_reg_imm20",
  /*  413 */  "addI_Reg_mem",
  /*  414 */  "addI_Reg_mem_0",
  /*  415 */  "addI_mem_imm",
  /*  416 */  "addL_reg_regI",
  /*  417 */  "addL_reg_regI_0",
  /*  418 */  "addL_reg_reg_CISC",
  /*  419 */  "addL_reg_reg_RISC",
  /*  420 */  "addL_reg_imm12",
  /*  421 */  "addL_reg_imm20",
  /*  422 */  "addL_reg_imm32",
  /*  423 */  "addL_reg_imm16_CISC",
  /*  424 */  "addL_reg_imm16_RISC",
  /*  425 */  "addL_Reg_memI",
  /*  426 */  "addL_Reg_memI_0",
  /*  427 */  "addL_Reg_mem",
  /*  428 */  "addL_Reg_mem_0",
  /*  429 */  "addL_reg_reg_imm12",
  /*  430 */  "addL_reg_reg_imm20",
  /*  431 */  "addL_mem_imm",
  /*  432 */  "addP_reg_reg_LA",
  /*  433 */  "addP_reg_reg_CISC",
  /*  434 */  "addP_reg_reg_RISC",
  /*  435 */  "addP_reg_imm12",
  /*  436 */  "addP_reg_imm16_CISC",
  /*  437 */  "addP_reg_imm16_RISC",
  /*  438 */  "addP_reg_imm20",
  /*  439 */  "addP_reg_imm32",
  /*  440 */  "addP_reg_reg_imm12",
  /*  441 */  "addP_regN_reg_imm12",
  /*  442 */  "addP_reg_reg_imm20",
  /*  443 */  "addP_regN_reg_imm20",
  /*  444 */  "addP_mem_imm",
  /*  445 */  "subI_reg_reg_CISC",
  /*  446 */  "subI_reg_reg_RISC",
  /*  447 */  "subI_Reg_mem",
  /*  448 */  "subI_zero_reg",
  /*  449 */  "subL_reg_reg_CISC",
  /*  450 */  "subL_reg_reg_RISC",
  /*  451 */  "subL_reg_regI_CISC",
  /*  452 */  "subL_Reg_memI",
  /*  453 */  "subL_Reg_mem",
  /*  454 */  "mulI_reg_reg",
  /*  455 */  "mulI_reg_imm16",
  /*  456 */  "mulI_reg_imm32",
  /*  457 */  "mulI_Reg_mem",
  /*  458 */  "mulI_Reg_mem_0",
  /*  459 */  "mulL_reg_regI",
  /*  460 */  "mulL_reg_regI_0",
  /*  461 */  "mulL_reg_reg",
  /*  462 */  "mulL_reg_imm16",
  /*  463 */  "mulL_reg_imm32",
  /*  464 */  "mulL_Reg_memI",
  /*  465 */  "mulL_Reg_memI_0",
  /*  466 */  "mulL_Reg_mem",
  /*  467 */  "mulL_Reg_mem_0",
  /*  468 */  "mulHiL_reg_reg",
  /*  469 */  "divModI_reg_divmod",
  /*  470 */  "divI_reg_reg",
  /*  471 */  "divI_reg_imm16",
  /*  472 */  "divModL_reg_divmod",
  /*  473 */  "divL_reg_reg",
  /*  474 */  "divL_reg_imm16",
  /*  475 */  "modI_reg_reg",
  /*  476 */  "modI_reg_imm16",
  /*  477 */  "modL_reg_reg",
  /*  478 */  "modL_reg_imm16",
  /*  479 */  "sllI_reg_reg",
  /*  480 */  "sllI_reg_imm",
  /*  481 */  "sllI_reg_imm_1",
  /*  482 */  "sllL_reg_reg",
  /*  483 */  "sllL_reg_imm",
  /*  484 */  "sllL_reg_imm_1",
  /*  485 */  "sraI_reg_reg",
  /*  486 */  "sraI_reg_imm",
  /*  487 */  "sraL_reg_reg",
  /*  488 */  "sraL_reg_imm",
  /*  489 */  "srlI_reg_reg",
  /*  490 */  "srlI_reg_imm",
  /*  491 */  "srlL_reg_reg",
  /*  492 */  "srlL_reg_imm",
  /*  493 */  "srlP_reg_imm",
  /*  494 */  "rotlI_reg_immI8",
  /*  495 */  "rotlI_reg_immI8_0",
  /*  496 */  "rotlL_reg_immI8",
  /*  497 */  "rotlL_reg_immI8_0",
  /*  498 */  "rotrI_reg_immI8",
  /*  499 */  "rotrI_reg_immI8_0",
  /*  500 */  "rotrL_reg_immI8",
  /*  501 */  "rotrL_reg_immI8_0",
  /*  502 */  "addF_reg_reg",
  /*  503 */  "addF_reg_mem",
  /*  504 */  "addF_reg_mem_0",
  /*  505 */  "addD_reg_reg",
  /*  506 */  "addD_reg_mem",
  /*  507 */  "addD_reg_mem_0",
  /*  508 */  "subF_reg_reg",
  /*  509 */  "subF_reg_mem",
  /*  510 */  "subD_reg_reg",
  /*  511 */  "subD_reg_mem",
  /*  512 */  "mulF_reg_reg",
  /*  513 */  "mulF_reg_mem",
  /*  514 */  "mulF_reg_mem_0",
  /*  515 */  "mulD_reg_reg",
  /*  516 */  "mulD_reg_mem",
  /*  517 */  "mulD_reg_mem_0",
  /*  518 */  "maddF_reg_reg",
  /*  519 */  "maddD_reg_reg",
  /*  520 */  "msubF_reg_reg",
  /*  521 */  "msubD_reg_reg",
  /*  522 */  "maddF_reg_mem",
  /*  523 */  "maddD_reg_mem",
  /*  524 */  "msubF_reg_mem",
  /*  525 */  "msubD_reg_mem",
  /*  526 */  "maddF_mem_reg",
  /*  527 */  "maddD_mem_reg",
  /*  528 */  "msubF_mem_reg",
  /*  529 */  "msubD_mem_reg",
  /*  530 */  "divF_reg_reg",
  /*  531 */  "divF_reg_mem",
  /*  532 */  "divD_reg_reg",
  /*  533 */  "divD_reg_mem",
  /*  534 */  "absF_reg",
  /*  535 */  "absD_reg",
  /*  536 */  "nabsF_reg",
  /*  537 */  "nabsD_reg",
  /*  538 */  "negF_reg",
  /*  539 */  "negD_reg",
  /*  540 */  "sqrtF_reg",
  /*  541 */  "sqrtD_reg",
  /*  542 */  "sqrtF_mem",
  /*  543 */  "sqrtD_mem",
  /*  544 */  "andI_reg_reg",
  /*  545 */  "andI_Reg_mem",
  /*  546 */  "andI_Reg_mem_0",
  /*  547 */  "andI_reg_uimm32",
  /*  548 */  "andI_reg_uimmI_LH1",
  /*  549 */  "andI_reg_uimmI_LL1",
  /*  550 */  "andL_reg_reg",
  /*  551 */  "andL_Reg_mem",
  /*  552 */  "andL_Reg_mem_0",
  /*  553 */  "andL_reg_uimmL_LL1",
  /*  554 */  "andL_reg_uimmL_LH1",
  /*  555 */  "andL_reg_uimmL_HL1",
  /*  556 */  "andL_reg_uimmL_HH1",
  /*  557 */  "orI_reg_reg",
  /*  558 */  "orI_Reg_mem",
  /*  559 */  "orI_Reg_mem_0",
  /*  560 */  "orI_reg_uimm16",
  /*  561 */  "orI_reg_uimm32",
  /*  562 */  "orL_reg_reg",
  /*  563 */  "orL_Reg_mem",
  /*  564 */  "orL_Reg_mem_0",
  /*  565 */  "orL_reg_uimm16",
  /*  566 */  "orL_reg_uimm32",
  /*  567 */  "xorI_reg_reg",
  /*  568 */  "xorI_Reg_mem",
  /*  569 */  "xorI_Reg_mem_0",
  /*  570 */  "xorI_reg_uimm32",
  /*  571 */  "xorL_reg_reg",
  /*  572 */  "xorL_Reg_mem",
  /*  573 */  "xorL_Reg_mem_0",
  /*  574 */  "xorL_reg_uimm32",
  /*  575 */  "convI2B",
  /*  576 */  "convP2B",
  /*  577 */  "cmpLTMask_reg_reg",
  /*  578 */  "cmpLTMask_reg_zero",
  /*  579 */  "convD2F_reg",
  /*  580 */  "convF2I_reg",
  /*  581 */  "convD2I_reg",
  /*  582 */  "convF2L_reg",
  /*  583 */  "convD2L_reg",
  /*  584 */  "convF2D_reg",
  /*  585 */  "convF2D_mem",
  /*  586 */  "convI2D_reg",
  /*  587 */  "convI2F_ireg",
  /*  588 */  "convI2L_reg",
  /*  589 */  "convI2L_reg_zex",
  /*  590 */  "convI2L_mem_zex",
  /*  591 */  "zeroExtend_long",
  /*  592 */  "rShiftI16_lShiftI16_reg",
  /*  593 */  "rShiftI24_lShiftI24_reg",
  /*  594 */  "MoveI2F_reg_stack",
  /*  595 */  "MoveD2L_reg_stack",
  /*  596 */  "MoveL2D_reg_stack",
  /*  597 */  "convL2F_reg",
  /*  598 */  "convL2D_reg",
  /*  599 */  "convL2I_reg",
  /*  600 */  "shrL_reg_imm6_L2I",
  /*  601 */  "rangeCheck_iReg_uimmI16",
  /*  602 */  "rangeCheck_iReg_iReg",
  /*  603 */  "rangeCheck_uimmI16_iReg",
  /*  604 */  "zeroCheckP_iReg_imm0",
  /*  605 */  "zeroCheckN_iReg_imm0",
  /*  606 */  "z196_minI_reg_reg",
  /*  607 */  "z10_minI_reg_reg",
  /*  608 */  "minI_reg_reg",
  /*  609 */  "z196_minI_reg_imm32",
  /*  610 */  "minI_reg_imm32",
  /*  611 */  "z196_minI_reg_imm16",
  /*  612 */  "minI_reg_imm16",
  /*  613 */  "z10_minI_reg_imm8",
  /*  614 */  "z196_maxI_reg_reg",
  /*  615 */  "z10_maxI_reg_reg",
  /*  616 */  "maxI_reg_reg",
  /*  617 */  "z196_maxI_reg_imm32",
  /*  618 */  "maxI_reg_imm32",
  /*  619 */  "z196_maxI_reg_imm16",
  /*  620 */  "maxI_reg_imm16",
  /*  621 */  "z10_maxI_reg_imm8",
  /*  622 */  "absI_reg",
  /*  623 */  "absL_reg",
  /*  624 */  "negabsI_reg",
  /*  625 */  "cmpF_reg",
  /*  626 */  "cmpD_reg",
  /*  627 */  "branch",
  /*  628 */  "branchFar",
  /*  629 */  "branchCon",
  /*  630 */  "branchConFar",
  /*  631 */  "branchLoopEnd",
  /*  632 */  "branchLoopEndFar",
  /*  633 */  "testAndBranchLoopEnd_Reg",
  /*  634 */  "cmpb_RegI",
  /*  635 */  "cmpbU_RegI",
  /*  636 */  "cmpb_RegL",
  /*  637 */  "cmpb_RegPP",
  /*  638 */  "cmpb_RegNN",
  /*  639 */  "testAndBranchLoopEnd_Imm",
  /*  640 */  "cmpb_RegI_imm",
  /*  641 */  "cmpbU_RegI_imm",
  /*  642 */  "cmpb_RegL_imm",
  /*  643 */  "cmpb_RegP_immP",
  /*  644 */  "cmpb_RegN_immP0",
  /*  645 */  "cmpb_RegN_imm",
  /*  646 */  "testAndBranchLoopEnd_RegFar",
  /*  647 */  "cmpb_RegI_Far",
  /*  648 */  "cmpbU_RegI_Far",
  /*  649 */  "cmpb_RegL_Far",
  /*  650 */  "cmpb_RegPP_Far",
  /*  651 */  "cmpb_RegNN_Far",
  /*  652 */  "testAndBranchLoopEnd_ImmFar",
  /*  653 */  "cmpb_RegI_imm_Far",
  /*  654 */  "cmpbU_RegI_imm_Far",
  /*  655 */  "cmpb_RegL_imm_Far",
  /*  656 */  "cmpb_RegP_immP_Far",
  /*  657 */  "cmpb_RegN_immP0_Far",
  /*  658 */  "cmpb_RegN_immN_Far",
  /*  659 */  "cmpL3_reg_reg",
  /*  660 */  "safePoint",
  /*  661 */  "safePoint_poll",
  /*  662 */  "CallStaticJavaDirect_dynTOC",
  /*  663 */  "CallDynamicJavaDirect_dynTOC",
  /*  664 */  "CallRuntimeDirect",
  /*  665 */  "CallLeafDirect",
  /*  666 */  "CallLeafNoFPDirect",
  /*  667 */  "TailCalljmpInd",
  /*  668 */  "Ret",
  /*  669 */  "tailjmpInd",
  /*  670 */  "CreateException",
  /*  671 */  "RethrowException",
  /*  672 */  "ShouldNotReachHere",
  /*  673 */  "partialSubtypeCheck",
  /*  674 */  "inlineCallClearArrayConst",
  /*  675 */  "inlineCallClearArrayConstBig",
  /*  676 */  "inlineCallClearArray",
  /*  677 */  "string_equalsL",
  /*  678 */  "string_equals_imm",
  /*  679 */  "string_equalsC_imm",
  /*  680 */  "array_equalsB",
  /*  681 */  "array_equalsC",
  /*  682 */  "string_compareL",
  /*  683 */  "string_compareU",
  /*  684 */  "string_compareLU",
  /*  685 */  "string_compareUL",
  /*  686 */  "indexOfChar_U",
  /*  687 */  "indexOfChar_L",
  /*  688 */  "indexOf_imm1_U",
  /*  689 */  "indexOf_imm1_L",
  /*  690 */  "indexOf_imm1_UL",
  /*  691 */  "indexOf_imm_U",
  /*  692 */  "indexOf_imm_L",
  /*  693 */  "indexOf_imm_UL",
  /*  694 */  "indexOf_U",
  /*  695 */  "indexOf_L",
  /*  696 */  "indexOf_UL",
  /*  697 */  "string_compress",
  /*  698 */  "string_inflate",
  /*  699 */  "string_inflate_const",
  /*  700 */  "count_positives",
  /*  701 */  "encode_iso_array",
  /*  702 */  "encode_ascii_array",
  /*  703 */  "expand_storeF",
  /*  704 */  "expand_Repl2I_reg",
  /*  705 */  "Repl8B_reg_risbg",
  /*  706 */  "Repl4S_reg_risbg",
  /*  707 */  "Repl2I_reg_risbg",
  /*  708 */  "Repl2F_reg_indirect",
  /*  709 */  "Repl2F_reg_direct",
  /*  710 */  "storeA8B",
  /*  711 */  "loadV8",
  /*  712 */  "bytes_reverse_int",
  /*  713 */  "bytes_reverse_long",
  /*  714 */  "countLeadingZerosI",
  /*  715 */  "countLeadingZerosL",
  /*  716 */  "countTrailingZerosI",
  /*  717 */  "countTrailingZerosL",
  /*  718 */  "popCountI",
  /*  719 */  "popCountL",
  // last instruction
  "invalid rule name" // no trailing comma
};

const        bool  swallowed[] = {
  /*    0 */  false,
  /*    1 */  false,
  /*    2 */  false,
  /*    3 */  false,
  /*    4 */  false,
  /*    5 */  false,
  /*    6 */  false,
  /*    7 */  false,
  /*    8 */  true,
  /*    9 */  true,
  /*   10 */  true,
  /*   11 */  true,
  /*   12 */  true,
  /*   13 */  true,
  /*   14 */  true,
  /*   15 */  true,
  /*   16 */  true,
  /*   17 */  true,
  /*   18 */  true,
  /*   19 */  true,
  /*   20 */  true,
  /*   21 */  true,
  /*   22 */  true,
  /*   23 */  true,
  /*   24 */  true,
  /*   25 */  true,
  /*   26 */  true,
  /*   27 */  true,
  /*   28 */  true,
  /*   29 */  true,
  /*   30 */  true,
  /*   31 */  true,
  /*   32 */  true,
  /*   33 */  true,
  /*   34 */  true,
  /*   35 */  true,
  /*   36 */  true,
  /*   37 */  true,
  /*   38 */  true,
  /*   39 */  true,
  /*   40 */  true,
  /*   41 */  true,
  /*   42 */  true,
  /*   43 */  true,
  /*   44 */  true,
  /*   45 */  true,
  /*   46 */  true,
  /*   47 */  true,
  /*   48 */  true,
  /*   49 */  true,
  /*   50 */  true,
  /*   51 */  true,
  /*   52 */  true,
  /*   53 */  true,
  /*   54 */  true,
  /*   55 */  true,
  /*   56 */  true,
  /*   57 */  true,
  /*   58 */  true,
  /*   59 */  false,
  /*   60 */  false,
  /*   61 */  false,
  /*   62 */  false,
  /*   63 */  false,
  /*   64 */  false,
  /*   65 */  false,
  /*   66 */  false,
  /*   67 */  false,
  /*   68 */  false,
  /*   69 */  false,
  /*   70 */  false,
  /*   71 */  false,
  /*   72 */  false,
  /*   73 */  false,
  /*   74 */  false,
  /*   75 */  false,
  /*   76 */  false,
  /*   77 */  false,
  /*   78 */  false,
  /*   79 */  false,
  /*   80 */  false,
  /*   81 */  false,
  /*   82 */  false,
  /*   83 */  false,
  /*   84 */  false,
  /*   85 */  false,
  /*   86 */  false,
  /*   87 */  false,
  /*   88 */  false,
  /*   89 */  false,
  /*   90 */  false,
  /*   91 */  false,
  /*   92 */  false,
  /*   93 */  false,
  /*   94 */  false,
  /*   95 */  false,
  /*   96 */  false,
  /*   97 */  false,
  /*   98 */  false,
  /*   99 */  false,
  /*  100 */  false,
  /*  101 */  false,
  /*  102 */  false,
  /*  103 */  false,
  /*  104 */  false,
  /*  105 */  false,
  /*  106 */  false,
  /*  107 */  false,
  /*  108 */  false,
  /*  109 */  false,
  /*  110 */  false,
  /*  111 */  false,
  /*  112 */  true,
  /*  113 */  true,
  /*  114 */  true,
  // last operand
  /*  115 */  false,
  /*  116 */  false,
  /*  117 */  false,
  /*  118 */  false,
  /*  119 */  false,
  /*  120 */  false,
  /*  121 */  false,
  // last operand class
  /*  122 */  false,
  /*  123 */  false,
  /*  124 */  false,
  /*  125 */  false,
  /*  126 */  false,
  /*  127 */  false,
  /*  128 */  false,
  /*  129 */  false,
  /*  130 */  false,
  /*  131 */  false,
  /*  132 */  false,
  /*  133 */  false,
  /*  134 */  false,
  /*  135 */  false,
  /*  136 */  false,
  /*  137 */  false,
  /*  138 */  false,
  /*  139 */  false,
  /*  140 */  false,
  /*  141 */  false,
  /*  142 */  false,
  /*  143 */  false,
  /*  144 */  false,
  /*  145 */  false,
  /*  146 */  false,
  /*  147 */  false,
  /*  148 */  false,
  /*  149 */  false,
  /*  150 */  false,
  /*  151 */  false,
  /*  152 */  false,
  /*  153 */  false,
  /*  154 */  false,
  /*  155 */  false,
  /*  156 */  false,
  /*  157 */  false,
  /*  158 */  false,
  /*  159 */  false,
  /*  160 */  false,
  /*  161 */  false,
  /*  162 */  false,
  /*  163 */  false,
  /*  164 */  false,
  /*  165 */  false,
  /*  166 */  false,
  /*  167 */  false,
  /*  168 */  false,
  /*  169 */  false,
  /*  170 */  false,
  /*  171 */  false,
  /*  172 */  false,
  /*  173 */  false,
  /*  174 */  false,
  /*  175 */  false,
  /*  176 */  false,
  /*  177 */  false,
  /*  178 */  false,
  /*  179 */  false,
  /*  180 */  false,
  /*  181 */  false,
  /*  182 */  false,
  /*  183 */  false,
  /*  184 */  false,
  /*  185 */  false,
  /*  186 */  false,
  /*  187 */  false,
  /*  188 */  false,
  /*  189 */  false,
  /*  190 */  false,
  /*  191 */  false,
  /*  192 */  false,
  /*  193 */  false,
  /*  194 */  false,
  /*  195 */  false,
  /*  196 */  false,
  /*  197 */  false,
  /*  198 */  false,
  /*  199 */  false,
  /*  200 */  false,
  /*  201 */  false,
  /*  202 */  false,
  /*  203 */  false,
  // last internally defined operand
  /*  204 */  false,
  /*  205 */  false,
  /*  206 */  false,
  /*  207 */  false,
  /*  208 */  false,
  /*  209 */  false,
  /*  210 */  false,
  /*  211 */  false,
  /*  212 */  false,
  /*  213 */  false,
  /*  214 */  false,
  /*  215 */  false,
  /*  216 */  false,
  /*  217 */  false,
  /*  218 */  false,
  /*  219 */  false,
  /*  220 */  false,
  /*  221 */  false,
  /*  222 */  false,
  /*  223 */  false,
  /*  224 */  false,
  /*  225 */  false,
  /*  226 */  false,
  /*  227 */  false,
  /*  228 */  false,
  /*  229 */  false,
  /*  230 */  false,
  /*  231 */  false,
  /*  232 */  false,
  /*  233 */  false,
  /*  234 */  false,
  /*  235 */  false,
  /*  236 */  false,
  /*  237 */  false,
  /*  238 */  false,
  /*  239 */  false,
  /*  240 */  false,
  /*  241 */  false,
  /*  242 */  false,
  /*  243 */  false,
  /*  244 */  false,
  /*  245 */  false,
  /*  246 */  false,
  /*  247 */  false,
  /*  248 */  false,
  /*  249 */  false,
  /*  250 */  false,
  /*  251 */  false,
  /*  252 */  false,
  /*  253 */  false,
  /*  254 */  false,
  /*  255 */  false,
  /*  256 */  false,
  /*  257 */  false,
  /*  258 */  false,
  /*  259 */  false,
  /*  260 */  false,
  /*  261 */  false,
  /*  262 */  false,
  /*  263 */  false,
  /*  264 */  false,
  /*  265 */  false,
  /*  266 */  false,
  /*  267 */  false,
  /*  268 */  false,
  /*  269 */  false,
  /*  270 */  false,
  /*  271 */  false,
  /*  272 */  false,
  /*  273 */  false,
  /*  274 */  false,
  /*  275 */  false,
  /*  276 */  false,
  /*  277 */  false,
  /*  278 */  false,
  /*  279 */  false,
  /*  280 */  false,
  /*  281 */  false,
  /*  282 */  false,
  /*  283 */  false,
  /*  284 */  false,
  /*  285 */  false,
  /*  286 */  false,
  /*  287 */  false,
  /*  288 */  false,
  /*  289 */  false,
  /*  290 */  false,
  /*  291 */  false,
  /*  292 */  false,
  /*  293 */  false,
  /*  294 */  false,
  /*  295 */  false,
  /*  296 */  false,
  /*  297 */  false,
  /*  298 */  false,
  /*  299 */  false,
  /*  300 */  false,
  /*  301 */  false,
  /*  302 */  false,
  /*  303 */  false,
  /*  304 */  false,
  /*  305 */  false,
  /*  306 */  false,
  /*  307 */  false,
  /*  308 */  false,
  /*  309 */  false,
  /*  310 */  false,
  /*  311 */  false,
  /*  312 */  false,
  /*  313 */  false,
  /*  314 */  false,
  /*  315 */  false,
  /*  316 */  false,
  /*  317 */  false,
  /*  318 */  false,
  /*  319 */  false,
  /*  320 */  false,
  /*  321 */  false,
  /*  322 */  false,
  /*  323 */  false,
  /*  324 */  false,
  /*  325 */  false,
  /*  326 */  false,
  /*  327 */  false,
  /*  328 */  false,
  /*  329 */  false,
  /*  330 */  false,
  /*  331 */  false,
  /*  332 */  false,
  /*  333 */  false,
  /*  334 */  false,
  /*  335 */  false,
  /*  336 */  false,
  /*  337 */  false,
  /*  338 */  false,
  /*  339 */  false,
  /*  340 */  false,
  /*  341 */  false,
  /*  342 */  false,
  /*  343 */  false,
  /*  344 */  false,
  /*  345 */  false,
  /*  346 */  false,
  /*  347 */  false,
  /*  348 */  false,
  /*  349 */  false,
  /*  350 */  false,
  /*  351 */  false,
  /*  352 */  false,
  /*  353 */  false,
  /*  354 */  false,
  /*  355 */  false,
  /*  356 */  false,
  /*  357 */  false,
  /*  358 */  false,
  /*  359 */  false,
  /*  360 */  false,
  /*  361 */  false,
  /*  362 */  false,
  /*  363 */  false,
  /*  364 */  false,
  /*  365 */  false,
  /*  366 */  false,
  /*  367 */  false,
  /*  368 */  false,
  /*  369 */  false,
  /*  370 */  false,
  /*  371 */  false,
  /*  372 */  false,
  /*  373 */  false,
  /*  374 */  false,
  /*  375 */  false,
  /*  376 */  false,
  /*  377 */  false,
  /*  378 */  false,
  /*  379 */  false,
  /*  380 */  false,
  /*  381 */  false,
  /*  382 */  false,
  /*  383 */  false,
  /*  384 */  false,
  /*  385 */  false,
  /*  386 */  false,
  /*  387 */  false,
  /*  388 */  false,
  /*  389 */  false,
  /*  390 */  false,
  /*  391 */  false,
  /*  392 */  false,
  /*  393 */  false,
  /*  394 */  false,
  /*  395 */  false,
  /*  396 */  false,
  /*  397 */  false,
  /*  398 */  false,
  /*  399 */  false,
  /*  400 */  false,
  /*  401 */  false,
  /*  402 */  false,
  /*  403 */  false,
  /*  404 */  false,
  /*  405 */  false,
  /*  406 */  false,
  /*  407 */  false,
  /*  408 */  false,
  /*  409 */  false,
  /*  410 */  false,
  /*  411 */  false,
  /*  412 */  false,
  /*  413 */  false,
  /*  414 */  false,
  /*  415 */  false,
  /*  416 */  false,
  /*  417 */  false,
  /*  418 */  false,
  /*  419 */  false,
  /*  420 */  false,
  /*  421 */  false,
  /*  422 */  false,
  /*  423 */  false,
  /*  424 */  false,
  /*  425 */  false,
  /*  426 */  false,
  /*  427 */  false,
  /*  428 */  false,
  /*  429 */  false,
  /*  430 */  false,
  /*  431 */  false,
  /*  432 */  false,
  /*  433 */  false,
  /*  434 */  false,
  /*  435 */  false,
  /*  436 */  false,
  /*  437 */  false,
  /*  438 */  false,
  /*  439 */  false,
  /*  440 */  false,
  /*  441 */  false,
  /*  442 */  false,
  /*  443 */  false,
  /*  444 */  false,
  /*  445 */  false,
  /*  446 */  false,
  /*  447 */  false,
  /*  448 */  false,
  /*  449 */  false,
  /*  450 */  false,
  /*  451 */  false,
  /*  452 */  false,
  /*  453 */  false,
  /*  454 */  false,
  /*  455 */  false,
  /*  456 */  false,
  /*  457 */  false,
  /*  458 */  false,
  /*  459 */  false,
  /*  460 */  false,
  /*  461 */  false,
  /*  462 */  false,
  /*  463 */  false,
  /*  464 */  false,
  /*  465 */  false,
  /*  466 */  false,
  /*  467 */  false,
  /*  468 */  false,
  /*  469 */  false,
  /*  470 */  false,
  /*  471 */  false,
  /*  472 */  false,
  /*  473 */  false,
  /*  474 */  false,
  /*  475 */  false,
  /*  476 */  false,
  /*  477 */  false,
  /*  478 */  false,
  /*  479 */  false,
  /*  480 */  false,
  /*  481 */  false,
  /*  482 */  false,
  /*  483 */  false,
  /*  484 */  false,
  /*  485 */  false,
  /*  486 */  false,
  /*  487 */  false,
  /*  488 */  false,
  /*  489 */  false,
  /*  490 */  false,
  /*  491 */  false,
  /*  492 */  false,
  /*  493 */  false,
  /*  494 */  false,
  /*  495 */  false,
  /*  496 */  false,
  /*  497 */  false,
  /*  498 */  false,
  /*  499 */  false,
  /*  500 */  false,
  /*  501 */  false,
  /*  502 */  false,
  /*  503 */  false,
  /*  504 */  false,
  /*  505 */  false,
  /*  506 */  false,
  /*  507 */  false,
  /*  508 */  false,
  /*  509 */  false,
  /*  510 */  false,
  /*  511 */  false,
  /*  512 */  false,
  /*  513 */  false,
  /*  514 */  false,
  /*  515 */  false,
  /*  516 */  false,
  /*  517 */  false,
  /*  518 */  false,
  /*  519 */  false,
  /*  520 */  false,
  /*  521 */  false,
  /*  522 */  false,
  /*  523 */  false,
  /*  524 */  false,
  /*  525 */  false,
  /*  526 */  false,
  /*  527 */  false,
  /*  528 */  false,
  /*  529 */  false,
  /*  530 */  false,
  /*  531 */  false,
  /*  532 */  false,
  /*  533 */  false,
  /*  534 */  false,
  /*  535 */  false,
  /*  536 */  false,
  /*  537 */  false,
  /*  538 */  false,
  /*  539 */  false,
  /*  540 */  false,
  /*  541 */  false,
  /*  542 */  false,
  /*  543 */  false,
  /*  544 */  false,
  /*  545 */  false,
  /*  546 */  false,
  /*  547 */  false,
  /*  548 */  false,
  /*  549 */  false,
  /*  550 */  false,
  /*  551 */  false,
  /*  552 */  false,
  /*  553 */  false,
  /*  554 */  false,
  /*  555 */  false,
  /*  556 */  false,
  /*  557 */  false,
  /*  558 */  false,
  /*  559 */  false,
  /*  560 */  false,
  /*  561 */  false,
  /*  562 */  false,
  /*  563 */  false,
  /*  564 */  false,
  /*  565 */  false,
  /*  566 */  false,
  /*  567 */  false,
  /*  568 */  false,
  /*  569 */  false,
  /*  570 */  false,
  /*  571 */  false,
  /*  572 */  false,
  /*  573 */  false,
  /*  574 */  false,
  /*  575 */  false,
  /*  576 */  false,
  /*  577 */  false,
  /*  578 */  false,
  /*  579 */  false,
  /*  580 */  false,
  /*  581 */  false,
  /*  582 */  false,
  /*  583 */  false,
  /*  584 */  false,
  /*  585 */  false,
  /*  586 */  false,
  /*  587 */  false,
  /*  588 */  false,
  /*  589 */  false,
  /*  590 */  false,
  /*  591 */  false,
  /*  592 */  false,
  /*  593 */  false,
  /*  594 */  false,
  /*  595 */  false,
  /*  596 */  false,
  /*  597 */  false,
  /*  598 */  false,
  /*  599 */  false,
  /*  600 */  false,
  /*  601 */  false,
  /*  602 */  false,
  /*  603 */  false,
  /*  604 */  false,
  /*  605 */  false,
  /*  606 */  false,
  /*  607 */  false,
  /*  608 */  false,
  /*  609 */  false,
  /*  610 */  false,
  /*  611 */  false,
  /*  612 */  false,
  /*  613 */  false,
  /*  614 */  false,
  /*  615 */  false,
  /*  616 */  false,
  /*  617 */  false,
  /*  618 */  false,
  /*  619 */  false,
  /*  620 */  false,
  /*  621 */  false,
  /*  622 */  false,
  /*  623 */  false,
  /*  624 */  false,
  /*  625 */  false,
  /*  626 */  false,
  /*  627 */  false,
  /*  628 */  false,
  /*  629 */  false,
  /*  630 */  false,
  /*  631 */  false,
  /*  632 */  false,
  /*  633 */  false,
  /*  634 */  false,
  /*  635 */  false,
  /*  636 */  false,
  /*  637 */  false,
  /*  638 */  false,
  /*  639 */  false,
  /*  640 */  false,
  /*  641 */  false,
  /*  642 */  false,
  /*  643 */  false,
  /*  644 */  false,
  /*  645 */  false,
  /*  646 */  false,
  /*  647 */  false,
  /*  648 */  false,
  /*  649 */  false,
  /*  650 */  false,
  /*  651 */  false,
  /*  652 */  false,
  /*  653 */  false,
  /*  654 */  false,
  /*  655 */  false,
  /*  656 */  false,
  /*  657 */  false,
  /*  658 */  false,
  /*  659 */  false,
  /*  660 */  false,
  /*  661 */  false,
  /*  662 */  false,
  /*  663 */  false,
  /*  664 */  false,
  /*  665 */  false,
  /*  666 */  false,
  /*  667 */  false,
  /*  668 */  false,
  /*  669 */  false,
  /*  670 */  false,
  /*  671 */  false,
  /*  672 */  false,
  /*  673 */  false,
  /*  674 */  false,
  /*  675 */  false,
  /*  676 */  false,
  /*  677 */  false,
  /*  678 */  false,
  /*  679 */  false,
  /*  680 */  false,
  /*  681 */  false,
  /*  682 */  false,
  /*  683 */  false,
  /*  684 */  false,
  /*  685 */  false,
  /*  686 */  false,
  /*  687 */  false,
  /*  688 */  false,
  /*  689 */  false,
  /*  690 */  false,
  /*  691 */  false,
  /*  692 */  false,
  /*  693 */  false,
  /*  694 */  false,
  /*  695 */  false,
  /*  696 */  false,
  /*  697 */  false,
  /*  698 */  false,
  /*  699 */  false,
  /*  700 */  false,
  /*  701 */  false,
  /*  702 */  false,
  /*  703 */  false,
  /*  704 */  false,
  /*  705 */  false,
  /*  706 */  false,
  /*  707 */  false,
  /*  708 */  false,
  /*  709 */  false,
  /*  710 */  false,
  /*  711 */  false,
  /*  712 */  false,
  /*  713 */  false,
  /*  714 */  false,
  /*  715 */  false,
  /*  716 */  false,
  /*  717 */  false,
  /*  718 */  false,
  /*  719 */  false,
  // last instruction
  false // no trailing comma
};

// Mapping from machine-independent opcode to boolean
const        char must_clone[] = {
  0, // Node: 0
  0, // Set: 1
  0, // RegN: 2
  0, // RegI: 3
  0, // RegP: 4
  0, // RegF: 5
  0, // RegD: 6
  0, // RegL: 7
  0, // VecA: 8
  0, // VecS: 9
  0, // VecD: 10
  0, // VecX: 11
  0, // VecY: 12
  0, // VecZ: 13
  0, // RegVectMask: 14
  0, // RegFlags: 15
  0, // _last_machine_leaf: 16
  0, // AbsD: 17
  0, // AbsF: 18
  0, // AbsI: 19
  0, // AbsL: 20
  0, // AddD: 21
  0, // AddF: 22
  0, // AddI: 23
  0, // AddL: 24
  0, // AddP: 25
  0, // Allocate: 26
  0, // AllocateArray: 27
  0, // AndI: 28
  0, // AndL: 29
  0, // ArrayCopy: 30
  0, // AryEq: 31
  0, // AtanD: 32
  1, // Binary: 33
  0, // Blackhole: 34
  1, // Bool: 35
  0, // BoxLock: 36
  0, // ReverseBytesI: 37
  0, // ReverseBytesL: 38
  0, // ReverseBytesUS: 39
  0, // ReverseBytesS: 40
  0, // ReverseBytesV: 41
  0, // CProj: 42
  0, // CacheWB: 43
  0, // CacheWBPreSync: 44
  0, // CacheWBPostSync: 45
  0, // CallDynamicJava: 46
  0, // CallJava: 47
  0, // CallLeaf: 48
  0, // CallLeafNoFP: 49
  0, // CallLeafVector: 50
  0, // CallRuntime: 51
  0, // CallStaticJava: 52
  0, // CastDD: 53
  0, // CastFF: 54
  0, // CastII: 55
  0, // CastLL: 56
  0, // CastVV: 57
  0, // CastX2P: 58
  0, // CastP2X: 59
  0, // CastPP: 60
  0, // Catch: 61
  0, // CatchProj: 62
  0, // CheckCastPP: 63
  0, // ClearArray: 64
  0, // CompressBits: 65
  0, // ExpandBits: 66
  0, // CompressBitsV: 67
  0, // ExpandBitsV: 68
  0, // ConstraintCast: 69
  0, // CMoveD: 70
  0, // CMoveF: 71
  0, // CMoveI: 72
  0, // CMoveL: 73
  0, // CMoveP: 74
  0, // CMoveN: 75
  1, // CmpN: 76
  1, // CmpD: 77
  0, // CmpD3: 78
  1, // CmpF: 79
  0, // CmpF3: 80
  1, // CmpI: 81
  1, // CmpL: 82
  0, // CmpL3: 83
  0, // CmpLTMask: 84
  1, // CmpP: 85
  1, // CmpU: 86
  0, // CmpU3: 87
  1, // CmpUL: 88
  0, // CmpUL3: 89
  0, // CompareAndSwapB: 90
  0, // CompareAndSwapS: 91
  0, // CompareAndSwapI: 92
  0, // CompareAndSwapL: 93
  0, // CompareAndSwapP: 94
  0, // CompareAndSwapN: 95
  0, // WeakCompareAndSwapB: 96
  0, // WeakCompareAndSwapS: 97
  0, // WeakCompareAndSwapI: 98
  0, // WeakCompareAndSwapL: 99
  0, // WeakCompareAndSwapP: 100
  0, // WeakCompareAndSwapN: 101
  0, // CompareAndExchangeB: 102
  0, // CompareAndExchangeS: 103
  0, // CompareAndExchangeI: 104
  0, // CompareAndExchangeL: 105
  0, // CompareAndExchangeP: 106
  0, // CompareAndExchangeN: 107
  0, // GetAndAddB: 108
  0, // GetAndAddS: 109
  0, // GetAndAddI: 110
  0, // GetAndAddL: 111
  0, // GetAndSetB: 112
  0, // GetAndSetS: 113
  0, // GetAndSetI: 114
  0, // GetAndSetL: 115
  0, // GetAndSetP: 116
  0, // GetAndSetN: 117
  0, // Con: 118
  0, // ConN: 119
  0, // ConNKlass: 120
  0, // ConD: 121
  0, // ConF: 122
  0, // ConI: 123
  0, // ConL: 124
  0, // ConP: 125
  0, // Conv2B: 126
  0, // ConvD2F: 127
  0, // ConvD2I: 128
  0, // ConvD2L: 129
  0, // ConvF2D: 130
  0, // ConvF2I: 131
  0, // ConvF2L: 132
  0, // ConvI2D: 133
  0, // ConvI2F: 134
  0, // ConvI2L: 135
  0, // ConvL2D: 136
  0, // ConvL2F: 137
  0, // ConvL2I: 138
  0, // ConvF2HF: 139
  0, // ConvHF2F: 140
  0, // CountedLoop: 141
  0, // CountedLoopEnd: 142
  0, // OuterStripMinedLoop: 143
  0, // OuterStripMinedLoopEnd: 144
  0, // LongCountedLoop: 145
  0, // LongCountedLoopEnd: 146
  0, // CountLeadingZerosI: 147
  0, // CountLeadingZerosL: 148
  0, // CountLeadingZerosV: 149
  0, // CountTrailingZerosI: 150
  0, // CountTrailingZerosL: 151
  0, // CountTrailingZerosV: 152
  0, // CreateEx: 153
  0, // DecodeN: 154
  0, // DecodeNKlass: 155
  0, // DivD: 156
  0, // DivF: 157
  0, // DivI: 158
  0, // DivL: 159
  0, // UDivI: 160
  0, // UDivL: 161
  0, // DivMod: 162
  0, // DivModI: 163
  0, // DivModL: 164
  0, // UDivModI: 165
  0, // UDivModL: 166
  0, // EncodeISOArray: 167
  0, // EncodeP: 168
  0, // EncodePKlass: 169
  1, // FastLock: 170
  1, // FastUnlock: 171
  0, // FmaD: 172
  0, // FmaF: 173
  0, // Goto: 174
  0, // Halt: 175
  0, // CountPositives: 176
  0, // If: 177
  0, // RangeCheck: 178
  0, // IfFalse: 179
  0, // IfTrue: 180
  0, // Initialize: 181
  0, // JProj: 182
  0, // Jump: 183
  0, // JumpProj: 184
  0, // LShiftI: 185
  0, // LShiftL: 186
  0, // LoadB: 187
  0, // LoadUB: 188
  0, // LoadUS: 189
  0, // LoadD: 190
  0, // LoadD_unaligned: 191
  0, // LoadF: 192
  0, // LoadI: 193
  0, // LoadKlass: 194
  0, // LoadNKlass: 195
  0, // LoadL: 196
  0, // LoadL_unaligned: 197
  0, // LoadP: 198
  0, // LoadN: 199
  0, // LoadRange: 200
  0, // LoadS: 201
  0, // Lock: 202
  0, // Loop: 203
  0, // LoopLimit: 204
  0, // Mach: 205
  0, // MachNullCheck: 206
  0, // MachProj: 207
  0, // MulAddS2I: 208
  0, // MaxI: 209
  0, // MaxL: 210
  0, // MaxD: 211
  0, // MaxF: 212
  0, // MemBarAcquire: 213
  0, // LoadFence: 214
  0, // MemBarAcquireLock: 215
  0, // MemBarCPUOrder: 216
  0, // MemBarRelease: 217
  0, // StoreFence: 218
  0, // StoreStoreFence: 219
  0, // MemBarReleaseLock: 220
  0, // MemBarVolatile: 221
  0, // MemBarStoreStore: 222
  0, // MergeMem: 223
  0, // MinI: 224
  0, // MinL: 225
  0, // MinF: 226
  0, // MinD: 227
  0, // ModD: 228
  0, // ModF: 229
  0, // ModI: 230
  0, // ModL: 231
  0, // UModI: 232
  0, // UModL: 233
  0, // MoveI2F: 234
  0, // MoveF2I: 235
  0, // MoveL2D: 236
  0, // MoveD2L: 237
  0, // IsInfiniteF: 238
  0, // IsFiniteF: 239
  0, // IsInfiniteD: 240
  0, // IsFiniteD: 241
  0, // MulD: 242
  0, // MulF: 243
  0, // MulHiL: 244
  0, // UMulHiL: 245
  0, // MulI: 246
  0, // MulL: 247
  0, // Multi: 248
  0, // NegI: 249
  0, // NegL: 250
  0, // NegD: 251
  0, // NegF: 252
  0, // NeverBranch: 253
  0, // OnSpinWait: 254
  0, // Opaque1: 255
  0, // OpaqueLoopInit: 256
  0, // OpaqueLoopStride: 257
  0, // OpaqueZeroTripGuard: 258
  0, // Opaque3: 259
  0, // Opaque4: 260
  0, // OpaqueInitializedAssertionPredicate: 261
  0, // ProfileBoolean: 262
  0, // OrI: 263
  0, // OrL: 264
  1, // OverflowAddI: 265
  1, // OverflowSubI: 266
  1, // OverflowMulI: 267
  1, // OverflowAddL: 268
  1, // OverflowSubL: 269
  1, // OverflowMulL: 270
  0, // PCTable: 271
  0, // Parm: 272
  0, // ParsePredicate: 273
  0, // PartialSubtypeCheck: 274
  0, // SubTypeCheck: 275
  0, // Phi: 276
  0, // PopCountI: 277
  0, // PopCountL: 278
  0, // PopCountVI: 279
  0, // PopCountVL: 280
  0, // PopulateIndex: 281
  0, // PrefetchAllocation: 282
  0, // Proj: 283
  0, // RShiftI: 284
  0, // RShiftL: 285
  0, // Region: 286
  0, // Rethrow: 287
  0, // Return: 288
  0, // ReverseI: 289
  0, // ReverseL: 290
  0, // ReverseV: 291
  0, // Root: 292
  0, // RoundDouble: 293
  0, // RoundDoubleMode: 294
  0, // RoundDoubleModeV: 295
  0, // RoundFloat: 296
  0, // RotateLeft: 297
  0, // RotateLeftV: 298
  0, // RotateRight: 299
  0, // RotateRightV: 300
  0, // SafePoint: 301
  0, // SafePointScalarObject: 302
  0, // SafePointScalarMerge: 303
  0, // ShenandoahCompareAndExchangeP: 304
  0, // ShenandoahCompareAndExchangeN: 305
  0, // ShenandoahCompareAndSwapN: 306
  0, // ShenandoahCompareAndSwapP: 307
  0, // ShenandoahWeakCompareAndSwapN: 308
  0, // ShenandoahWeakCompareAndSwapP: 309
  0, // ShenandoahIUBarrier: 310
  0, // ShenandoahLoadReferenceBarrier: 311
  0, // SCMemProj: 312
  0, // CopySignD: 313
  0, // CopySignF: 314
  0, // SignumD: 315
  0, // SignumF: 316
  0, // SignumVF: 317
  0, // SignumVD: 318
  0, // SqrtD: 319
  0, // SqrtF: 320
  0, // RoundF: 321
  0, // RoundD: 322
  0, // Start: 323
  0, // StartOSR: 324
  0, // StoreB: 325
  0, // StoreC: 326
  0, // StoreCM: 327
  0, // StoreD: 328
  0, // StoreF: 329
  0, // StoreI: 330
  0, // StoreL: 331
  0, // StoreP: 332
  0, // StoreN: 333
  0, // StoreNKlass: 334
  0, // StrComp: 335
  0, // StrCompressedCopy: 336
  0, // StrEquals: 337
  0, // StrIndexOf: 338
  0, // StrIndexOfChar: 339
  0, // StrInflatedCopy: 340
  0, // SubD: 341
  0, // SubF: 342
  0, // SubI: 343
  0, // SubL: 344
  0, // TailCall: 345
  0, // TailJump: 346
  0, // MacroLogicV: 347
  0, // ThreadLocal: 348
  0, // Unlock: 349
  0, // URShiftB: 350
  0, // URShiftS: 351
  0, // URShiftI: 352
  0, // URShiftL: 353
  0, // XorI: 354
  0, // XorL: 355
  0, // Vector: 356
  0, // AddVB: 357
  0, // AddVS: 358
  0, // AddVI: 359
  0, // AddReductionVI: 360
  0, // AddVL: 361
  0, // AddReductionVL: 362
  0, // AddVF: 363
  0, // AddReductionVF: 364
  0, // AddVD: 365
  0, // AddReductionVD: 366
  0, // SubVB: 367
  0, // SubVS: 368
  0, // SubVI: 369
  0, // SubVL: 370
  0, // SubVF: 371
  0, // SubVD: 372
  0, // MulVB: 373
  0, // MulVS: 374
  0, // MulVI: 375
  0, // MulReductionVI: 376
  0, // MulVL: 377
  0, // MulReductionVL: 378
  0, // MulVF: 379
  0, // MulReductionVF: 380
  0, // MulVD: 381
  0, // MulReductionVD: 382
  0, // MulAddVS2VI: 383
  0, // FmaVD: 384
  0, // FmaVF: 385
  0, // DivVF: 386
  0, // DivVD: 387
  0, // AbsVB: 388
  0, // AbsVS: 389
  0, // AbsVI: 390
  0, // AbsVL: 391
  0, // AbsVF: 392
  0, // AbsVD: 393
  0, // NegVI: 394
  0, // NegVL: 395
  0, // NegVF: 396
  0, // NegVD: 397
  0, // SqrtVD: 398
  0, // SqrtVF: 399
  0, // LShiftCntV: 400
  0, // RShiftCntV: 401
  0, // LShiftVB: 402
  0, // LShiftVS: 403
  0, // LShiftVI: 404
  0, // LShiftVL: 405
  0, // RShiftVB: 406
  0, // RShiftVS: 407
  0, // RShiftVI: 408
  0, // RShiftVL: 409
  0, // URShiftVB: 410
  0, // URShiftVS: 411
  0, // URShiftVI: 412
  0, // URShiftVL: 413
  0, // AndV: 414
  0, // AndReductionV: 415
  0, // OrV: 416
  0, // OrReductionV: 417
  0, // XorV: 418
  0, // XorReductionV: 419
  0, // MinV: 420
  0, // MaxV: 421
  0, // MinReductionV: 422
  0, // MaxReductionV: 423
  0, // CompressV: 424
  0, // CompressM: 425
  0, // ExpandV: 426
  0, // LoadVector: 427
  0, // LoadVectorGather: 428
  0, // LoadVectorGatherMasked: 429
  0, // StoreVector: 430
  0, // StoreVectorScatter: 431
  0, // StoreVectorScatterMasked: 432
  0, // LoadVectorMasked: 433
  0, // StoreVectorMasked: 434
  0, // VerifyVectorAlignment: 435
  0, // VectorCmpMasked: 436
  0, // VectorMaskGen: 437
  0, // VectorMaskOp: 438
  0, // VectorMaskTrueCount: 439
  0, // VectorMaskFirstTrue: 440
  0, // VectorMaskLastTrue: 441
  0, // VectorMaskToLong: 442
  0, // VectorLongToMask: 443
  0, // Pack: 444
  0, // PackB: 445
  0, // PackS: 446
  0, // PackI: 447
  0, // PackL: 448
  0, // PackF: 449
  0, // PackD: 450
  0, // Pack2L: 451
  0, // Pack2D: 452
  0, // Replicate: 453
  0, // RoundVF: 454
  0, // RoundVD: 455
  0, // Extract: 456
  0, // ExtractB: 457
  0, // ExtractUB: 458
  0, // ExtractC: 459
  0, // ExtractS: 460
  0, // ExtractI: 461
  0, // ExtractL: 462
  0, // ExtractF: 463
  0, // ExtractD: 464
  0, // Digit: 465
  0, // LowerCase: 466
  0, // UpperCase: 467
  0, // Whitespace: 468
  0, // VectorBox: 469
  0, // VectorBoxAllocate: 470
  0, // VectorUnbox: 471
  0, // VectorMaskWrapper: 472
  0, // VectorMaskCmp: 473
  0, // VectorMaskCast: 474
  1, // VectorTest: 475
  0, // VectorBlend: 476
  0, // VectorRearrange: 477
  0, // VectorLoadMask: 478
  0, // VectorLoadShuffle: 479
  0, // VectorLoadConst: 480
  0, // VectorStoreMask: 481
  0, // VectorReinterpret: 482
  0, // VectorCast: 483
  0, // VectorCastB2X: 484
  0, // VectorCastS2X: 485
  0, // VectorCastI2X: 486
  0, // VectorCastL2X: 487
  0, // VectorCastF2X: 488
  0, // VectorCastD2X: 489
  0, // VectorCastF2HF: 490
  0, // VectorCastHF2F: 491
  0, // VectorUCastB2X: 492
  0, // VectorUCastS2X: 493
  0, // VectorUCastI2X: 494
  0, // VectorizedHashCode: 495
  0, // VectorInsert: 496
  0, // MaskAll: 497
  0, // AndVMask: 498
  0, // OrVMask: 499
  0 // no trailing comma // XorVMask: 500
};
//  The following instructions can cisc-spill
//  addI_reg_reg_CISC can cisc-spill operand 2 to addI_Reg_mem
//  addL_reg_regI can cisc-spill operand 2 to addL_Reg_memI
//  addL_reg_regI_0 can cisc-spill operand 1 to addL_Reg_memI_0
//  addL_reg_reg_CISC can cisc-spill operand 2 to addL_Reg_mem
//  subI_reg_reg_CISC can cisc-spill operand 2 to subI_Reg_mem
//  subL_reg_reg_CISC can cisc-spill operand 2 to subL_Reg_mem
//  subL_reg_regI_CISC can cisc-spill operand 2 to subL_Reg_memI
//  mulI_reg_reg can cisc-spill operand 2 to mulI_Reg_mem
//  mulL_reg_regI can cisc-spill operand 2 to mulL_Reg_memI
//  mulL_reg_regI_0 can cisc-spill operand 1 to mulL_Reg_memI_0
//  mulL_reg_reg can cisc-spill operand 2 to mulL_Reg_mem
//  addF_reg_reg can cisc-spill operand 2 to addF_reg_mem
//  addD_reg_reg can cisc-spill operand 2 to addD_reg_mem
//  subF_reg_reg can cisc-spill operand 2 to subF_reg_mem
//  subD_reg_reg can cisc-spill operand 2 to subD_reg_mem
//  mulF_reg_reg can cisc-spill operand 2 to mulF_reg_mem
//  mulD_reg_reg can cisc-spill operand 2 to mulD_reg_mem
//  maddF_reg_reg can cisc-spill operand 3 to maddF_reg_mem
//  maddD_reg_reg can cisc-spill operand 3 to maddD_reg_mem
//  msubF_reg_reg can cisc-spill operand 3 to msubF_reg_mem
//  msubD_reg_reg can cisc-spill operand 3 to msubD_reg_mem
//  divF_reg_reg can cisc-spill operand 2 to divF_reg_mem
//  divD_reg_reg can cisc-spill operand 2 to divD_reg_mem
//  sqrtF_reg can cisc-spill operand 1 to sqrtF_mem
//  sqrtD_reg can cisc-spill operand 1 to sqrtD_mem
//  andI_reg_reg can cisc-spill operand 2 to andI_Reg_mem
//  andL_reg_reg can cisc-spill operand 2 to andL_Reg_mem
//  orI_reg_reg can cisc-spill operand 2 to orI_Reg_mem
//  orL_reg_reg can cisc-spill operand 2 to orL_Reg_mem
//  xorI_reg_reg can cisc-spill operand 2 to xorI_Reg_mem
//  xorL_reg_reg can cisc-spill operand 2 to xorL_Reg_mem
//  convF2D_reg can cisc-spill operand 1 to convF2D_mem
//  convI2L_reg can cisc-spill operand 1 to loadI2L
//  convI2L_reg_zex can cisc-spill operand 1 to convI2L_mem_zex
//  compI_reg_reg can cisc-spill operand 2 to compI_reg_mem
//  compU_reg_reg can cisc-spill operand 2 to compU_reg_mem
//  compL_reg_reg can cisc-spill operand 2 to compL_reg_mem
//  compL_reg_regI can cisc-spill operand 2 to compL_reg_memI
//  cmpF_cc can cisc-spill operand 2 to cmpF_cc_mem
//  cmpD_cc can cisc-spill operand 2 to cmpD_cc_mem



// An array of character pointers to machine register names.
const char *Matcher::regName[REG_COUNT] = {
  "Z_R13",
  "Z_R13_H",
  "Z_R12",
  "Z_R12_H",
  "Z_R11",
  "Z_R11_H",
  "Z_R10",
  "Z_R10_H",
  "Z_R9",
  "Z_R9_H",
  "Z_R8",
  "Z_R8_H",
  "Z_R7",
  "Z_R7_H",
  "Z_R1",
  "Z_R1_H",
  "Z_R0",
  "Z_R0_H",
  "Z_R6",
  "Z_R6_H",
  "Z_R5",
  "Z_R5_H",
  "Z_R4",
  "Z_R4_H",
  "Z_R3",
  "Z_R3_H",
  "Z_R2",
  "Z_R2_H",
  "Z_R14",
  "Z_R14_H",
  "Z_R15",
  "Z_R15_H",
  "Z_F15",
  "Z_F15_H",
  "Z_F14",
  "Z_F14_H",
  "Z_F13",
  "Z_F13_H",
  "Z_F12",
  "Z_F12_H",
  "Z_F11",
  "Z_F11_H",
  "Z_F10",
  "Z_F10_H",
  "Z_F9",
  "Z_F9_H",
  "Z_F8",
  "Z_F8_H",
  "Z_F7",
  "Z_F7_H",
  "Z_F5",
  "Z_F5_H",
  "Z_F3",
  "Z_F3_H",
  "Z_F1",
  "Z_F1_H",
  "Z_F6",
  "Z_F6_H",
  "Z_F4",
  "Z_F4_H",
  "Z_F2",
  "Z_F2_H",
  "Z_F0",
  "Z_F0_H",
  "Z_CR" // no trailing comma
};

// An array of character pointers to machine register names.
const VMReg OptoReg::opto2vm[REG_COUNT] = {
	Z_R13->as_VMReg(),
	Z_R13->as_VMReg()->next(),
	Z_R12->as_VMReg(),
	Z_R12->as_VMReg()->next(),
	Z_R11->as_VMReg(),
	Z_R11->as_VMReg()->next(),
	Z_R10->as_VMReg(),
	Z_R10->as_VMReg()->next(),
	Z_R9->as_VMReg(),
	Z_R9->as_VMReg()->next(),
	Z_R8->as_VMReg(),
	Z_R8->as_VMReg()->next(),
	Z_R7->as_VMReg(),
	Z_R7->as_VMReg()->next(),
	Z_R1->as_VMReg(),
	Z_R1->as_VMReg()->next(),
	Z_R0->as_VMReg(),
	Z_R0->as_VMReg()->next(),
	Z_R6->as_VMReg(),
	Z_R6->as_VMReg()->next(),
	Z_R5->as_VMReg(),
	Z_R5->as_VMReg()->next(),
	Z_R4->as_VMReg(),
	Z_R4->as_VMReg()->next(),
	Z_R3->as_VMReg(),
	Z_R3->as_VMReg()->next(),
	Z_R2->as_VMReg(),
	Z_R2->as_VMReg()->next(),
	Z_R14->as_VMReg(),
	Z_R14->as_VMReg()->next(),
	Z_R15->as_VMReg(),
	Z_R15->as_VMReg()->next(),
	Z_F15->as_VMReg(),
	Z_F15->as_VMReg()->next(),
	Z_F14->as_VMReg(),
	Z_F14->as_VMReg()->next(),
	Z_F13->as_VMReg(),
	Z_F13->as_VMReg()->next(),
	Z_F12->as_VMReg(),
	Z_F12->as_VMReg()->next(),
	Z_F11->as_VMReg(),
	Z_F11->as_VMReg()->next(),
	Z_F10->as_VMReg(),
	Z_F10->as_VMReg()->next(),
	Z_F9->as_VMReg(),
	Z_F9->as_VMReg()->next(),
	Z_F8->as_VMReg(),
	Z_F8->as_VMReg()->next(),
	Z_F7->as_VMReg(),
	Z_F7->as_VMReg()->next(),
	Z_F5->as_VMReg(),
	Z_F5->as_VMReg()->next(),
	Z_F3->as_VMReg(),
	Z_F3->as_VMReg()->next(),
	Z_F1->as_VMReg(),
	Z_F1->as_VMReg()->next(),
	Z_F6->as_VMReg(),
	Z_F6->as_VMReg()->next(),
	Z_F4->as_VMReg(),
	Z_F4->as_VMReg()->next(),
	Z_F2->as_VMReg(),
	Z_F2->as_VMReg()->next(),
	Z_F0->as_VMReg(),
	Z_F0->as_VMReg()->next(),
	Z_CR->as_VMReg() // no trailing comma
	};

 OptoReg::Name OptoReg::vm2opto[ConcreteRegisterImpl::number_of_registers];

// An array of the machine register encode values
const unsigned char Matcher::_regEncode[REG_COUNT] = {
  (unsigned char)'\xD',  // Z_R13
  (unsigned char)'\x63',  // Z_R13_H
  (unsigned char)'\xC',  // Z_R12
  (unsigned char)'\x63',  // Z_R12_H
  (unsigned char)'\xB',  // Z_R11
  (unsigned char)'\x63',  // Z_R11_H
  (unsigned char)'\xA',  // Z_R10
  (unsigned char)'\x63',  // Z_R10_H
  (unsigned char)'\x9',  // Z_R9
  (unsigned char)'\x63',  // Z_R9_H
  (unsigned char)'\x8',  // Z_R8
  (unsigned char)'\x63',  // Z_R8_H
  (unsigned char)'\x7',  // Z_R7
  (unsigned char)'\x63',  // Z_R7_H
  (unsigned char)'\x1',  // Z_R1
  (unsigned char)'\x63',  // Z_R1_H
  (unsigned char)'\x0',  // Z_R0
  (unsigned char)'\x63',  // Z_R0_H
  (unsigned char)'\x6',  // Z_R6
  (unsigned char)'\x63',  // Z_R6_H
  (unsigned char)'\x5',  // Z_R5
  (unsigned char)'\x63',  // Z_R5_H
  (unsigned char)'\x4',  // Z_R4
  (unsigned char)'\x63',  // Z_R4_H
  (unsigned char)'\x3',  // Z_R3
  (unsigned char)'\x63',  // Z_R3_H
  (unsigned char)'\x2',  // Z_R2
  (unsigned char)'\x63',  // Z_R2_H
  (unsigned char)'\xE',  // Z_R14
  (unsigned char)'\x63',  // Z_R14_H
  (unsigned char)'\xF',  // Z_R15
  (unsigned char)'\x63',  // Z_R15_H
  (unsigned char)'\xF',  // Z_F15
  (unsigned char)'\x63',  // Z_F15_H
  (unsigned char)'\xE',  // Z_F14
  (unsigned char)'\x63',  // Z_F14_H
  (unsigned char)'\xD',  // Z_F13
  (unsigned char)'\x63',  // Z_F13_H
  (unsigned char)'\xC',  // Z_F12
  (unsigned char)'\x63',  // Z_F12_H
  (unsigned char)'\xB',  // Z_F11
  (unsigned char)'\x63',  // Z_F11_H
  (unsigned char)'\xA',  // Z_F10
  (unsigned char)'\x63',  // Z_F10_H
  (unsigned char)'\x9',  // Z_F9
  (unsigned char)'\x63',  // Z_F9_H
  (unsigned char)'\x8',  // Z_F8
  (unsigned char)'\x63',  // Z_F8_H
  (unsigned char)'\x7',  // Z_F7
  (unsigned char)'\x63',  // Z_F7_H
  (unsigned char)'\x5',  // Z_F5
  (unsigned char)'\x63',  // Z_F5_H
  (unsigned char)'\x3',  // Z_F3
  (unsigned char)'\x63',  // Z_F3_H
  (unsigned char)'\x1',  // Z_F1
  (unsigned char)'\x63',  // Z_F1_H
  (unsigned char)'\x6',  // Z_F6
  (unsigned char)'\x63',  // Z_F6_H
  (unsigned char)'\x4',  // Z_F4
  (unsigned char)'\x63',  // Z_F4_H
  (unsigned char)'\x2',  // Z_F2
  (unsigned char)'\x63',  // Z_F2_H
  (unsigned char)'\x0',  // Z_F0
  (unsigned char)'\x63',  // Z_F0_H
  (unsigned char)'\x0' // no trailing comma  // Z_CR
};


//------------------Define classes derived from MachOper---------------------
MachOper  *labelOper::clone() const {
  return  new labelOper(_label, _block_num);
}
uint labelOper::opcode() const { return LABEL; }

const RegMask *sRegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *sRegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *sRegFOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *sRegDOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *sRegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

MachOper  *methodOper::clone() const {
  return  new methodOper(_method);
}
uint methodOper::opcode() const { return METHOD; }

const RegMask *iRegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &Z_INT_REG_mask();
}

const RegMask *noArg_iRegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &Z_NO_ARG_INT_REG_mask();
}

const RegMask *revenRegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &Z_RARG3_INT_REG_mask();
}

const RegMask *roddRegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &Z_RARG4_INT_REG_mask();
}

const RegMask *rarg1RegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &Z_RARG1_INT_REG_mask();
}

const RegMask *rarg2RegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &Z_RARG2_INT_REG_mask();
}

const RegMask *rarg3RegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &Z_RARG3_INT_REG_mask();
}

const RegMask *rarg4RegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &Z_RARG4_INT_REG_mask();
}

const RegMask *rarg5RegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &Z_RARG5_INT_REG_mask();
}

const RegMask *noOdd_iRegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &Z_NO_ODD_INT_REG_mask();
}

const RegMask *iRegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &Z_PTR_REG_mask();
}

const RegMask *threadRegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &Z_THREAD_PTR_REG_mask();
}

const RegMask *noArg_iRegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &Z_NO_ARG_PTR_REG_mask();
}

const RegMask *rarg1RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &Z_RARG1_PTR_REG_mask();
}

const RegMask *rarg2RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &Z_RARG2_PTR_REG_mask();
}

const RegMask *rarg3RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &Z_RARG3_PTR_REG_mask();
}

const RegMask *rarg4RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &Z_RARG4_PTR_REG_mask();
}

const RegMask *rarg5RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &Z_RARG5_PTR_REG_mask();
}

const RegMask *memoryRegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &Z_MEMORY_PTR_REG_mask();
}

const RegMask *revenRegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &Z_RARG3_PTR_REG_mask();
}

const RegMask *roddRegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &Z_RARG4_PTR_REG_mask();
}

const RegMask *iRegNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &Z_INT_REG_mask();
}

const RegMask *noArg_iRegNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &Z_NO_ARG_INT_REG_mask();
}

const RegMask *rarg1RegNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &Z_RARG1_INT_REG_mask();
}

const RegMask *rarg2RegNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &Z_RARG2_INT_REG_mask();
}

const RegMask *rarg3RegNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &Z_RARG3_INT_REG_mask();
}

const RegMask *rarg4RegNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &Z_RARG4_INT_REG_mask();
}

const RegMask *rarg5RegNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &Z_RARG5_PTRN_REG_mask();
}

const RegMask *iRegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &Z_LONG_REG_mask();
}

const RegMask *revenRegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &Z_RARG3_LONG_REG_mask();
}

const RegMask *roddRegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &Z_RARG4_LONG_REG_mask();
}

const RegMask *allRoddRegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &Z_LONG_ODD_REG_mask();
}

const RegMask *rarg1RegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &Z_RARG1_LONG_REG_mask();
}

const RegMask *rarg5RegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &Z_RARG5_LONG_REG_mask();
}

const RegMask *flagsRegOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &Z_CONDITION_REG_mask();
}

const RegMask *regDOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &Z_DBL_REG_mask();
}

const RegMask *regFOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &Z_FLT_REG_mask();
}

const RegMask *inline_cache_regPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &Z_R9_REGP_mask();
}

const RegMask *indirectOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &Z_MEMORY_PTR_REG_mask();
}

const RegMask *indOffset20Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &Z_MEMORY_PTR_REG_mask();
}

const RegMask *indOffset20NarrowOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &Z_INT_REG_mask();
}

const RegMask *indOffset12Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &Z_MEMORY_PTR_REG_mask();
}

const RegMask *indOffset12NarrowOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &Z_INT_REG_mask();
}

const RegMask *indIndexOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &Z_MEMORY_PTR_REG_mask();
  case 1: return &Z_LONG_REG_mask();
  }
  ShouldNotReachHere();
  return nullptr;
}

const RegMask *indOffset20indexOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &Z_MEMORY_PTR_REG_mask();
  case 1: return &Z_LONG_REG_mask();
  }
  ShouldNotReachHere();
  return nullptr;
}

const RegMask *indOffset20indexNarrowOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &Z_INT_REG_mask();
  case 1: return &Z_LONG_REG_mask();
  }
  ShouldNotReachHere();
  return nullptr;
}

const RegMask *indOffset12indexOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &Z_MEMORY_PTR_REG_mask();
  case 1: return &Z_LONG_REG_mask();
  }
  ShouldNotReachHere();
  return nullptr;
}

const RegMask *indOffset12indexNarrowOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &Z_INT_REG_mask();
  case 1: return &Z_LONG_REG_mask();
  }
  ShouldNotReachHere();
  return nullptr;
}

const RegMask *stackSlotIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *stackSlotPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *stackSlotFOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *stackSlotDOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *stackSlotLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

//------------------Define members for classes derived from MachNode----------

void addI_reg_reg_CISCNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_Z_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *addI_reg_reg_CISCNode::cisc_version(int offset) {
  addI_Reg_memNode *node = new addI_Reg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset12Oper(offset));

  return node;
}


void addL_reg_regINode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_Z_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *addL_reg_regINode::cisc_version(int offset) {
  addL_Reg_memINode *node = new addL_Reg_memINode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset12Oper(offset));

  return node;
}


void addL_reg_regI_0Node::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_Z_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *addL_reg_regI_0Node::cisc_version(int offset) {
  addL_Reg_memI_0Node *node = new addL_Reg_memI_0Node();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset12Oper(offset));

  return node;
}


void addL_reg_reg_CISCNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_Z_LONG_REG_mask();
}

// Build CISC version of this instruction
MachNode *addL_reg_reg_CISCNode::cisc_version(int offset) {
  addL_Reg_memNode *node = new addL_Reg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset12Oper(offset));

  return node;
}


void subI_reg_reg_CISCNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_Z_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *subI_reg_reg_CISCNode::cisc_version(int offset) {
  subI_Reg_memNode *node = new subI_Reg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset12Oper(offset));

  return node;
}


void subL_reg_reg_CISCNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_Z_LONG_REG_mask();
}

// Build CISC version of this instruction
MachNode *subL_reg_reg_CISCNode::cisc_version(int offset) {
  subL_Reg_memNode *node = new subL_Reg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset12Oper(offset));

  return node;
}


void subL_reg_regI_CISCNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_Z_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *subL_reg_regI_CISCNode::cisc_version(int offset) {
  subL_Reg_memINode *node = new subL_Reg_memINode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset12Oper(offset));

  return node;
}


void mulI_reg_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_Z_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *mulI_reg_regNode::cisc_version(int offset) {
  mulI_Reg_memNode *node = new mulI_Reg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset12Oper(offset));

  return node;
}


void mulL_reg_regINode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_Z_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *mulL_reg_regINode::cisc_version(int offset) {
  mulL_Reg_memINode *node = new mulL_Reg_memINode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset12Oper(offset));

  return node;
}


void mulL_reg_regI_0Node::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_Z_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *mulL_reg_regI_0Node::cisc_version(int offset) {
  mulL_Reg_memI_0Node *node = new mulL_Reg_memI_0Node();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset12Oper(offset));

  return node;
}


void mulL_reg_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_Z_LONG_REG_mask();
}

// Build CISC version of this instruction
MachNode *mulL_reg_regNode::cisc_version(int offset) {
  mulL_Reg_memNode *node = new mulL_Reg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset12Oper(offset));

  return node;
}


void addF_reg_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_Z_FLT_REG_mask();
}

// Build CISC version of this instruction
MachNode *addF_reg_regNode::cisc_version(int offset) {
  addF_reg_memNode *node = new addF_reg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset12Oper(offset));

  return node;
}


void addD_reg_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_Z_DBL_REG_mask();
}

// Build CISC version of this instruction
MachNode *addD_reg_regNode::cisc_version(int offset) {
  addD_reg_memNode *node = new addD_reg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset12Oper(offset));

  return node;
}


void subF_reg_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_Z_FLT_REG_mask();
}

// Build CISC version of this instruction
MachNode *subF_reg_regNode::cisc_version(int offset) {
  subF_reg_memNode *node = new subF_reg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset12Oper(offset));

  return node;
}


void subD_reg_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_Z_DBL_REG_mask();
}

// Build CISC version of this instruction
MachNode *subD_reg_regNode::cisc_version(int offset) {
  subD_reg_memNode *node = new subD_reg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset12Oper(offset));

  return node;
}


void mulF_reg_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_Z_FLT_REG_mask();
}

// Build CISC version of this instruction
MachNode *mulF_reg_regNode::cisc_version(int offset) {
  mulF_reg_memNode *node = new mulF_reg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset12Oper(offset));

  return node;
}


void mulD_reg_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_Z_DBL_REG_mask();
}

// Build CISC version of this instruction
MachNode *mulD_reg_regNode::cisc_version(int offset) {
  mulD_reg_memNode *node = new mulD_reg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset12Oper(offset));

  return node;
}


void maddF_reg_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_Z_FLT_REG_mask();
}

// Build CISC version of this instruction
MachNode *maddF_reg_regNode::cisc_version(int offset) {
  maddF_reg_memNode *node = new maddF_reg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset12Oper(offset));

  return node;
}


void maddD_reg_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_Z_DBL_REG_mask();
}

// Build CISC version of this instruction
MachNode *maddD_reg_regNode::cisc_version(int offset) {
  maddD_reg_memNode *node = new maddD_reg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset12Oper(offset));

  return node;
}


void msubF_reg_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_Z_FLT_REG_mask();
}

// Build CISC version of this instruction
MachNode *msubF_reg_regNode::cisc_version(int offset) {
  msubF_reg_memNode *node = new msubF_reg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset12Oper(offset));

  return node;
}


void msubD_reg_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_Z_DBL_REG_mask();
}

// Build CISC version of this instruction
MachNode *msubD_reg_regNode::cisc_version(int offset) {
  msubD_reg_memNode *node = new msubD_reg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset12Oper(offset));

  return node;
}


void divF_reg_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_Z_FLT_REG_mask();
}

// Build CISC version of this instruction
MachNode *divF_reg_regNode::cisc_version(int offset) {
  divF_reg_memNode *node = new divF_reg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset12Oper(offset));

  return node;
}


void divD_reg_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_Z_DBL_REG_mask();
}

// Build CISC version of this instruction
MachNode *divD_reg_regNode::cisc_version(int offset) {
  divD_reg_memNode *node = new divD_reg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset12Oper(offset));

  return node;
}


void sqrtF_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_Z_FLT_REG_mask();
}

// Build CISC version of this instruction
MachNode *sqrtF_regNode::cisc_version(int offset) {
  sqrtF_memNode *node = new sqrtF_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset12Oper(offset));

  return node;
}


void sqrtD_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_Z_DBL_REG_mask();
}

// Build CISC version of this instruction
MachNode *sqrtD_regNode::cisc_version(int offset) {
  sqrtD_memNode *node = new sqrtD_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset12Oper(offset));

  return node;
}


void andI_reg_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_Z_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *andI_reg_regNode::cisc_version(int offset) {
  andI_Reg_memNode *node = new andI_Reg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset12Oper(offset));

  return node;
}


void andL_reg_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_Z_LONG_REG_mask();
}

// Build CISC version of this instruction
MachNode *andL_reg_regNode::cisc_version(int offset) {
  andL_Reg_memNode *node = new andL_Reg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset12Oper(offset));

  return node;
}


void orI_reg_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_Z_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *orI_reg_regNode::cisc_version(int offset) {
  orI_Reg_memNode *node = new orI_Reg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset12Oper(offset));

  return node;
}


void orL_reg_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_Z_LONG_REG_mask();
}

// Build CISC version of this instruction
MachNode *orL_reg_regNode::cisc_version(int offset) {
  orL_Reg_memNode *node = new orL_Reg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset12Oper(offset));

  return node;
}


void xorI_reg_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_Z_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *xorI_reg_regNode::cisc_version(int offset) {
  xorI_Reg_memNode *node = new xorI_Reg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset12Oper(offset));

  return node;
}


void xorL_reg_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_Z_LONG_REG_mask();
}

// Build CISC version of this instruction
MachNode *xorL_reg_regNode::cisc_version(int offset) {
  xorL_Reg_memNode *node = new xorL_Reg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset12Oper(offset));

  return node;
}


void convF2D_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_Z_FLT_REG_mask();
}

// Build CISC version of this instruction
MachNode *convF2D_regNode::cisc_version(int offset) {
  convF2D_memNode *node = new convF2D_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset12Oper(offset));

  return node;
}


void convI2L_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_Z_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *convI2L_regNode::cisc_version(int offset) {
  loadI2LNode *node = new loadI2LNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset12Oper(offset));

  return node;
}


void convI2L_reg_zexNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_Z_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *convI2L_reg_zexNode::cisc_version(int offset) {
  convI2L_mem_zexNode *node = new convI2L_mem_zexNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset12Oper(offset));

  return node;
}

// Build short branch version of this instruction
MachNode *rangeCheck_iReg_iRegNode::short_branch_version() {
  cmpbU_RegINode *node = new cmpbU_RegINode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  return node;
}


void compI_reg_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_Z_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *compI_reg_regNode::cisc_version(int offset) {
  compI_reg_memNode *node = new compI_reg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset12Oper(offset));

  return node;
}


void compU_reg_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_Z_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *compU_reg_regNode::cisc_version(int offset) {
  compU_reg_memNode *node = new compU_reg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset12Oper(offset));

  return node;
}


void compL_reg_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_Z_LONG_REG_mask();
}

// Build CISC version of this instruction
MachNode *compL_reg_regNode::cisc_version(int offset) {
  compL_reg_memNode *node = new compL_reg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset12Oper(offset));

  return node;
}


void compL_reg_regINode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_Z_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *compL_reg_regINode::cisc_version(int offset) {
  compL_reg_memINode *node = new compL_reg_memINode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset12Oper(offset));

  return node;
}


void cmpF_ccNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_Z_FLT_REG_mask();
}

// Build CISC version of this instruction
MachNode *cmpF_ccNode::cisc_version(int offset) {
  cmpF_cc_memNode *node = new cmpF_cc_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset12Oper(offset));

  return node;
}


void cmpD_ccNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_Z_DBL_REG_mask();
}

// Build CISC version of this instruction
MachNode *cmpD_ccNode::cisc_version(int offset) {
  cmpD_cc_memNode *node = new cmpD_cc_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset12Oper(offset));

  return node;
}

// Build short branch version of this instruction
MachNode *branchFarNode::short_branch_version() {
  branchNode *node = new branchNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  return node;
}

// Build short branch version of this instruction
MachNode *branchConFarNode::short_branch_version() {
  branchConNode *node = new branchConNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  return node;
}

// Build short branch version of this instruction
MachNode *branchLoopEndFarNode::short_branch_version() {
  branchLoopEndNode *node = new branchLoopEndNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  return node;
}

// Build short branch version of this instruction
MachNode *testAndBranchLoopEnd_RegFarNode::short_branch_version() {
  testAndBranchLoopEnd_RegNode *node = new testAndBranchLoopEnd_RegNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  return node;
}

// Build short branch version of this instruction
MachNode *cmpb_RegI_FarNode::short_branch_version() {
  cmpb_RegINode *node = new cmpb_RegINode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  return node;
}

// Build short branch version of this instruction
MachNode *cmpbU_RegI_FarNode::short_branch_version() {
  cmpbU_RegINode *node = new cmpbU_RegINode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  return node;
}

// Build short branch version of this instruction
MachNode *cmpb_RegL_FarNode::short_branch_version() {
  cmpb_RegLNode *node = new cmpb_RegLNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  return node;
}

// Build short branch version of this instruction
MachNode *cmpb_RegPP_FarNode::short_branch_version() {
  cmpb_RegPPNode *node = new cmpb_RegPPNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  return node;
}

// Build short branch version of this instruction
MachNode *cmpb_RegNN_FarNode::short_branch_version() {
  cmpb_RegNNNode *node = new cmpb_RegNNNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  return node;
}

// Build short branch version of this instruction
MachNode *testAndBranchLoopEnd_ImmFarNode::short_branch_version() {
  testAndBranchLoopEnd_ImmNode *node = new testAndBranchLoopEnd_ImmNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  return node;
}

// Build short branch version of this instruction
MachNode *cmpb_RegI_imm_FarNode::short_branch_version() {
  cmpb_RegI_immNode *node = new cmpb_RegI_immNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  return node;
}

// Build short branch version of this instruction
MachNode *cmpbU_RegI_imm_FarNode::short_branch_version() {
  cmpbU_RegI_immNode *node = new cmpbU_RegI_immNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  return node;
}

// Build short branch version of this instruction
MachNode *cmpb_RegL_imm_FarNode::short_branch_version() {
  cmpb_RegL_immNode *node = new cmpb_RegL_immNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  return node;
}

// Build short branch version of this instruction
MachNode *cmpb_RegP_immP_FarNode::short_branch_version() {
  cmpb_RegP_immPNode *node = new cmpb_RegP_immPNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  return node;
}

// Build short branch version of this instruction
MachNode *cmpb_RegN_immP0_FarNode::short_branch_version() {
  cmpb_RegN_immP0Node *node = new cmpb_RegN_immP0Node();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  return node;
}

// Build short branch version of this instruction
MachNode *cmpb_RegN_immN_FarNode::short_branch_version() {
  cmpb_RegN_immNode *node = new cmpb_RegN_immNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  return node;
}

void rangeCheck_iReg_uimmI16Node::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void rangeCheck_iReg_uimmI16Node::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void rangeCheck_iReg_iRegNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void rangeCheck_iReg_iRegNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void rangeCheck_uimmI16_iRegNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void rangeCheck_uimmI16_iRegNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void zeroCheckP_iReg_imm0Node::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void zeroCheckP_iReg_imm0Node::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void zeroCheckN_iReg_imm0Node::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void zeroCheckN_iReg_imm0Node::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(1));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(1));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchFarNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(1));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchFarNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(1));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchConNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchConNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchConFarNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchConFarNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchLoopEndNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchLoopEndNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void branchLoopEndFarNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void branchLoopEndFarNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void testAndBranchLoopEnd_RegNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void testAndBranchLoopEnd_RegNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpb_RegINode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpb_RegINode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpbU_RegINode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpbU_RegINode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpb_RegLNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpb_RegLNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpb_RegPPNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpb_RegPPNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpb_RegNNNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpb_RegNNNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void testAndBranchLoopEnd_ImmNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void testAndBranchLoopEnd_ImmNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpb_RegI_immNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpb_RegI_immNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpbU_RegI_immNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpbU_RegI_immNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpb_RegL_immNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpb_RegL_immNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpb_RegP_immPNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpb_RegP_immPNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpb_RegN_immP0Node::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpb_RegN_immP0Node::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpb_RegN_immNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpb_RegN_immNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void testAndBranchLoopEnd_RegFarNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void testAndBranchLoopEnd_RegFarNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpb_RegI_FarNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpb_RegI_FarNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpbU_RegI_FarNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpbU_RegI_FarNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpb_RegL_FarNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpb_RegL_FarNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpb_RegPP_FarNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpb_RegPP_FarNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpb_RegNN_FarNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpb_RegNN_FarNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void testAndBranchLoopEnd_ImmFarNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void testAndBranchLoopEnd_ImmFarNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpb_RegI_imm_FarNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpb_RegI_imm_FarNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpbU_RegI_imm_FarNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpbU_RegI_imm_FarNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpb_RegL_imm_FarNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpb_RegL_imm_FarNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpb_RegP_immP_FarNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpb_RegP_immP_FarNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpb_RegN_immP0_FarNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpb_RegN_immP0_FarNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void cmpb_RegN_immN_FarNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void cmpb_RegN_immN_FarNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(4));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void CallStaticJavaDirect_dynTOCNode::method_set( intptr_t method ) {
  ((methodOper*)opnd_array(1))->_method = method;
}

void CallDynamicJavaDirect_dynTOCNode::method_set( intptr_t method ) {
  ((methodOper*)opnd_array(1))->_method = method;
}

void CallRuntimeDirectNode::method_set( intptr_t method ) {
  ((methodOper*)opnd_array(1))->_method = method;
}

void CallLeafDirectNode::method_set( intptr_t method ) {
  ((methodOper*)opnd_array(1))->_method = method;
}

void CallLeafNoFPDirectNode::method_set( intptr_t method ) {
  ((methodOper*)opnd_array(1))->_method = method;
}

int loadBNode::reloc() const {
  return 1;
}

int loadB2LNode::reloc() const {
  return 1;
}

int loadUBNode::reloc() const {
  return 1;
}

int loadUB2LNode::reloc() const {
  return 1;
}

int loadSNode::reloc() const {
  return 1;
}

int loadS2LNode::reloc() const {
  return 1;
}

int loadUSNode::reloc() const {
  return 1;
}

int loadUS2LNode::reloc() const {
  return 1;
}

int loadINode::reloc() const {
  return 1;
}

int loadI2LNode::reloc() const {
  return 1;
}

int loadUI2LNode::reloc() const {
  return 1;
}

int loadRangeNode::reloc() const {
  return 1;
}

int loadLNode::reloc() const {
  return 1;
}

int loadL_unalignedNode::reloc() const {
  return 1;
}

int loadPNode::reloc() const {
  return 1;
}

int castP2X_loadPNode::reloc() const {
  return 1;
}

int loadKlassNode::reloc() const {
  return 1;
}

int loadFNode::reloc() const {
  return 1;
}

int loadDNode::reloc() const {
  return 1;
}

int loadD_unalignedNode::reloc() const {
  return 1;
}

int loadConP_pcrelTOCNode::reloc() const {
  return 1;
}

int loadConP0Node::reloc() const {
  return 1;
}

int loadConF_dynTOCNode::reloc() const {
  return 2;
}

int loadConD_dynTOCNode::reloc() const {
  return 2;
}

int loadConF0Node::reloc() const {
  return 2;
}

int loadConD0Node::reloc() const {
  return 2;
}

int storeBNode::reloc() const {
  return 2;
}

int storeCMNode::reloc() const {
  return 2;
}

int storeCNode::reloc() const {
  return 2;
}

int storeINode::reloc() const {
  return 2;
}

int storeLNode::reloc() const {
  return 2;
}

int storePNode::reloc() const {
  return 2;
}

int storeFNode::reloc() const {
  return 2;
}

int storeDNode::reloc() const {
  return 2;
}

int prefetchAllocNode::reloc() const {
  return 1;
}

int memInitBNode::reloc() const {
  return 2;
}

int memInitCNode::reloc() const {
  return 2;
}

int memInitINode::reloc() const {
  return 2;
}

int memInitLNode::reloc() const {
  return 2;
}

int memInitPNode::reloc() const {
  return 3;
}

int loadNNode::reloc() const {
  return 1;
}

int loadNKlassNode::reloc() const {
  return 1;
}

int decodeLoadNNode::reloc() const {
  return 1;
}

int decodeLoadNKlassNode::reloc() const {
  return 1;
}

int storeNNode::reloc() const {
  return 3;
}

int storeNKlassNode::reloc() const {
  return 2;
}

int compN_iRegNNode::reloc() const {
  return 2;
}

int compN_iRegN_immNNode::reloc() const {
  return 1;
}

int compN_iRegN_immN0Node::reloc() const {
  return 1;
}

int castP2XNode::reloc() const {
  return 1;
}

int cmovN_regNode::reloc() const {
  return 1;
}

int cmovP_regNode::reloc() const {
  return 1;
}

int cmovP_immNode::reloc() const {
  return 1;
}

int compareAndSwapP_boolNode::reloc() const {
  return 1;
}

int compareAndSwapN_boolNode::reloc() const {
  return 1;
}

int addI_mem_imm8_atomic_no_resNode::reloc() const {
  return 1;
}

int addI_mem_imm16_atomicNode::reloc() const {
  return 1;
}

int addI_mem_imm32_atomicNode::reloc() const {
  return 1;
}

int addI_mem_reg_atomicNode::reloc() const {
  return 1;
}

int addL_mem_imm8_atomic_no_resNode::reloc() const {
  return 1;
}

int addL_mem_imm16_atomicNode::reloc() const {
  return 1;
}

int addL_mem_imm32_atomicNode::reloc() const {
  return 1;
}

int addL_mem_reg_atomicNode::reloc() const {
  return 1;
}

int addI_mem_reg_atomic_z196Node::reloc() const {
  return 1;
}

int addL_mem_reg_atomic_z196Node::reloc() const {
  return 1;
}

int xchgI_reg_memNode::reloc() const {
  return 1;
}

int xchgL_reg_memNode::reloc() const {
  return 1;
}

int xchgN_reg_memNode::reloc() const {
  return 1;
}

int xchgP_reg_memNode::reloc() const {
  return 1;
}

int addI_Reg_memNode::reloc() const {
  return 1;
}

int addI_Reg_mem_0Node::reloc() const {
  return 1;
}

int addI_mem_immNode::reloc() const {
  return 3;
}

int addL_Reg_memINode::reloc() const {
  return 1;
}

int addL_Reg_memI_0Node::reloc() const {
  return 1;
}

int addL_Reg_memNode::reloc() const {
  return 1;
}

int addL_Reg_mem_0Node::reloc() const {
  return 1;
}

int addL_mem_immNode::reloc() const {
  return 3;
}

int addP_reg_reg_LANode::reloc() const {
  return 1;
}

int addP_reg_reg_RISCNode::reloc() const {
  return 1;
}

int addP_reg_imm12Node::reloc() const {
  return 1;
}

int addP_reg_imm16_RISCNode::reloc() const {
  return 1;
}

int addP_regN_reg_imm12Node::reloc() const {
  return 1;
}

int addP_regN_reg_imm20Node::reloc() const {
  return 1;
}

int addP_mem_immNode::reloc() const {
  return 3;
}

int subI_Reg_memNode::reloc() const {
  return 1;
}

int subL_Reg_memINode::reloc() const {
  return 1;
}

int subL_Reg_memNode::reloc() const {
  return 1;
}

int mulI_Reg_memNode::reloc() const {
  return 1;
}

int mulI_Reg_mem_0Node::reloc() const {
  return 1;
}

int mulL_Reg_memINode::reloc() const {
  return 1;
}

int mulL_Reg_memI_0Node::reloc() const {
  return 1;
}

int mulL_Reg_memNode::reloc() const {
  return 1;
}

int mulL_Reg_mem_0Node::reloc() const {
  return 1;
}

int srlP_reg_immNode::reloc() const {
  return 1;
}

int addF_reg_memNode::reloc() const {
  return 1;
}

int addF_reg_mem_0Node::reloc() const {
  return 1;
}

int addD_reg_memNode::reloc() const {
  return 1;
}

int addD_reg_mem_0Node::reloc() const {
  return 1;
}

int subF_reg_memNode::reloc() const {
  return 1;
}

int subD_reg_memNode::reloc() const {
  return 1;
}

int mulF_reg_memNode::reloc() const {
  return 1;
}

int mulF_reg_mem_0Node::reloc() const {
  return 1;
}

int mulD_reg_memNode::reloc() const {
  return 1;
}

int mulD_reg_mem_0Node::reloc() const {
  return 1;
}

int maddF_reg_memNode::reloc() const {
  return 1;
}

int maddD_reg_memNode::reloc() const {
  return 1;
}

int msubF_reg_memNode::reloc() const {
  return 1;
}

int msubD_reg_memNode::reloc() const {
  return 1;
}

int maddF_mem_regNode::reloc() const {
  return 1;
}

int maddD_mem_regNode::reloc() const {
  return 1;
}

int msubF_mem_regNode::reloc() const {
  return 1;
}

int msubD_mem_regNode::reloc() const {
  return 1;
}

int divF_reg_memNode::reloc() const {
  return 1;
}

int divD_reg_memNode::reloc() const {
  return 1;
}

int sqrtF_memNode::reloc() const {
  return 1;
}

int sqrtD_memNode::reloc() const {
  return 1;
}

int andI_Reg_memNode::reloc() const {
  return 1;
}

int andI_Reg_mem_0Node::reloc() const {
  return 1;
}

int andL_Reg_memNode::reloc() const {
  return 1;
}

int andL_Reg_mem_0Node::reloc() const {
  return 1;
}

int orI_Reg_memNode::reloc() const {
  return 1;
}

int orI_Reg_mem_0Node::reloc() const {
  return 1;
}

int orL_Reg_memNode::reloc() const {
  return 1;
}

int orL_Reg_mem_0Node::reloc() const {
  return 1;
}

int xorI_Reg_memNode::reloc() const {
  return 1;
}

int xorI_Reg_mem_0Node::reloc() const {
  return 1;
}

int xorL_Reg_memNode::reloc() const {
  return 1;
}

int xorL_Reg_mem_0Node::reloc() const {
  return 1;
}

int convP2BNode::reloc() const {
  return 1;
}

int convF2D_memNode::reloc() const {
  return 1;
}

int convI2L_mem_zexNode::reloc() const {
  return 1;
}

int zeroCheckP_iReg_imm0Node::reloc() const {
  return 2;
}

int zeroCheckN_iReg_imm0Node::reloc() const {
  return 1;
}

int compI_reg_memNode::reloc() const {
  return 1;
}

int compU_reg_memNode::reloc() const {
  return 1;
}

int compL_reg_memNode::reloc() const {
  return 1;
}

int compL_reg_memINode::reloc() const {
  return 1;
}

int compP_reg_regNode::reloc() const {
  return 2;
}

int compP_reg_imm0Node::reloc() const {
  return 2;
}

int compP_decode_reg_imm0Node::reloc() const {
  return 1;
}

int compP_reg_memNode::reloc() const {
  return 1;
}

int cmpF_cc_memNode::reloc() const {
  return 1;
}

int cmpD_cc_memNode::reloc() const {
  return 1;
}

int cmpF0_ccNode::reloc() const {
  return 1;
}

int cmpD0_ccNode::reloc() const {
  return 1;
}

int cmpb_RegP_immPNode::reloc() const {
  return 1;
}

int cmpb_RegN_immP0Node::reloc() const {
  return 1;
}

int cmpb_RegP_immP_FarNode::reloc() const {
  return 1;
}

int cmpb_RegN_immP0_FarNode::reloc() const {
  return 1;
}

int safePointNode::reloc() const {
  return 1;
}

int safePoint_pollNode::reloc() const {
  return 1;
}

int CallStaticJavaDirect_dynTOCNode::reloc() const {
  return 1;
}

int CallDynamicJavaDirect_dynTOCNode::reloc() const {
  return 1;
}

int CallRuntimeDirectNode::reloc() const {
  return 1;
}

int CallLeafDirectNode::reloc() const {
  return 1;
}

int CallLeafNoFPDirectNode::reloc() const {
  return 1;
}

int TailCalljmpIndNode::reloc() const {
  return 1;
}

int RetNode::reloc() const {
  return 1;
}

int tailjmpIndNode::reloc() const {
  return 1;
}

int RethrowExceptionNode::reloc() const {
  return 1;
}

int partialSubtypeCheck_vs_zeroNode::reloc() const {
  return 1;
}

int cmpFastLockNode::reloc() const {
  return 2;
}

int cmpFastUnlockNode::reloc() const {
  return 2;
}

int inlineCallClearArrayConstNode::reloc() const {
  return 1;
}

int inlineCallClearArrayConstBigNode::reloc() const {
  return 1;
}

int inlineCallClearArrayNode::reloc() const {
  return 1;
}

int indexOf_imm1_UNode::reloc() const {
  return 1;
}

int indexOf_imm1_LNode::reloc() const {
  return 1;
}

int indexOf_imm1_ULNode::reloc() const {
  return 1;
}

int Repl2F_immNode::reloc() const {
  return 1;
}

int Repl2F_imm0Node::reloc() const {
  return 1;
}

int storeA8BNode::reloc() const {
  return 2;
}

int loadV8Node::reloc() const {
  return 1;
}


void stkI_to_regINode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1837 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Ridx = as_Register(opnd_array(1)->index(ra_,this,idx1));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.
    if ((L_ZOPC /*primary()*/) > (1L<<32)) {
      z_emit_inst(masm, (L_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, 48) |
                  Assembler::simm20(opnd_array(1)->disp(ra_,this,idx1)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 48));
    } else {
      z_emit_inst(masm, (L_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, 32) |
                  Assembler::uimm12(opnd_array(1)->disp(ra_,this,idx1), 20, 32) |
                  Assembler::reg(Ridx, 12, 32) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 32));
    }
  
#line 8033 "ad_s390.cpp"
  }
}

void regI_to_stkINode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1837 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Ridx = as_Register(opnd_array(0)->index(ra_,this,idx0));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.
    if ((ST_ZOPC /*primary()*/) > (1L<<32)) {
      z_emit_inst(masm, (ST_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src */, 8, 48) |
                  Assembler::simm20(opnd_array(0)->disp(ra_,this,0)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(0)->base(ra_,this,idx0)), 16, 48));
    } else {
      z_emit_inst(masm, (ST_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src */, 8, 32) |
                  Assembler::uimm12(opnd_array(0)->disp(ra_,this,0), 20, 32) |
                  Assembler::reg(Ridx, 12, 32) |
                  Assembler::regz(reg_to_register_object(opnd_array(0)->base(ra_,this,idx0)), 16, 32));
    }
  
#line 8061 "ad_s390.cpp"
  }
}

void stkL_to_regLNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1837 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Ridx = as_Register(opnd_array(1)->index(ra_,this,idx1));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.
    if ((LG_ZOPC /*primary()*/) > (1L<<32)) {
      z_emit_inst(masm, (LG_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, 48) |
                  Assembler::simm20(opnd_array(1)->disp(ra_,this,idx1)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 48));
    } else {
      z_emit_inst(masm, (LG_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, 32) |
                  Assembler::uimm12(opnd_array(1)->disp(ra_,this,idx1), 20, 32) |
                  Assembler::reg(Ridx, 12, 32) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 32));
    }
  
#line 8089 "ad_s390.cpp"
  }
}

void regL_to_stkLNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1837 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Ridx = as_Register(opnd_array(0)->index(ra_,this,idx0));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.
    if ((STG_ZOPC /*primary()*/) > (1L<<32)) {
      z_emit_inst(masm, (STG_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src */, 8, 48) |
                  Assembler::simm20(opnd_array(0)->disp(ra_,this,0)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(0)->base(ra_,this,idx0)), 16, 48));
    } else {
      z_emit_inst(masm, (STG_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src */, 8, 32) |
                  Assembler::uimm12(opnd_array(0)->disp(ra_,this,0), 20, 32) |
                  Assembler::reg(Ridx, 12, 32) |
                  Assembler::regz(reg_to_register_object(opnd_array(0)->base(ra_,this,idx0)), 16, 32));
    }
  
#line 8117 "ad_s390.cpp"
  }
}

uint regL_to_stkLNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void stkP_to_regPNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1837 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Ridx = as_Register(opnd_array(1)->index(ra_,this,idx1));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.
    if ((LG_ZOPC /*primary()*/) > (1L<<32)) {
      z_emit_inst(masm, (LG_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, 48) |
                  Assembler::simm20(opnd_array(1)->disp(ra_,this,idx1)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 48));
    } else {
      z_emit_inst(masm, (LG_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, 32) |
                  Assembler::uimm12(opnd_array(1)->disp(ra_,this,idx1), 20, 32) |
                  Assembler::reg(Ridx, 12, 32) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 32));
    }
  
#line 8150 "ad_s390.cpp"
  }
}

void regP_to_stkPNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1837 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Ridx = as_Register(opnd_array(0)->index(ra_,this,idx0));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.
    if ((STG_ZOPC /*primary()*/) > (1L<<32)) {
      z_emit_inst(masm, (STG_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src */, 8, 48) |
                  Assembler::simm20(opnd_array(0)->disp(ra_,this,0)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(0)->base(ra_,this,idx0)), 16, 48));
    } else {
      z_emit_inst(masm, (STG_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src */, 8, 32) |
                  Assembler::uimm12(opnd_array(0)->disp(ra_,this,0), 20, 32) |
                  Assembler::reg(Ridx, 12, 32) |
                  Assembler::regz(reg_to_register_object(opnd_array(0)->base(ra_,this,idx0)), 16, 32));
    }
  
#line 8178 "ad_s390.cpp"
  }
}

void stkF_to_regFNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1837 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Ridx = as_Register(opnd_array(1)->index(ra_,this,idx1));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.
    if ((LE_ZOPC /*primary()*/) > (1L<<32)) {
      z_emit_inst(masm, (LE_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, 48) |
                  Assembler::simm20(opnd_array(1)->disp(ra_,this,idx1)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 48));
    } else {
      z_emit_inst(masm, (LE_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, 32) |
                  Assembler::uimm12(opnd_array(1)->disp(ra_,this,idx1), 20, 32) |
                  Assembler::reg(Ridx, 12, 32) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 32));
    }
  
#line 8206 "ad_s390.cpp"
  }
}

uint stkF_to_regFNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void regF_to_stkFNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1837 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Ridx = as_Register(opnd_array(0)->index(ra_,this,idx0));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.
    if ((STE_ZOPC /*primary()*/) > (1L<<32)) {
      z_emit_inst(masm, (STE_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src */, 8, 48) |
                  Assembler::simm20(opnd_array(0)->disp(ra_,this,0)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(0)->base(ra_,this,idx0)), 16, 48));
    } else {
      z_emit_inst(masm, (STE_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src */, 8, 32) |
                  Assembler::uimm12(opnd_array(0)->disp(ra_,this,0), 20, 32) |
                  Assembler::reg(Ridx, 12, 32) |
                  Assembler::regz(reg_to_register_object(opnd_array(0)->base(ra_,this,idx0)), 16, 32));
    }
  
#line 8239 "ad_s390.cpp"
  }
}

uint regF_to_stkFNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void stkD_to_regDNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1837 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Ridx = as_Register(opnd_array(1)->index(ra_,this,idx1));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.
    if ((LD_ZOPC /*primary()*/) > (1L<<32)) {
      z_emit_inst(masm, (LD_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, 48) |
                  Assembler::simm20(opnd_array(1)->disp(ra_,this,idx1)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 48));
    } else {
      z_emit_inst(masm, (LD_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, 32) |
                  Assembler::uimm12(opnd_array(1)->disp(ra_,this,idx1), 20, 32) |
                  Assembler::reg(Ridx, 12, 32) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 32));
    }
  
#line 8272 "ad_s390.cpp"
  }
}

void regD_to_stkDNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1837 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Ridx = as_Register(opnd_array(0)->index(ra_,this,idx0));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.
    if ((STD_ZOPC /*primary()*/) > (1L<<32)) {
      z_emit_inst(masm, (STD_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src */, 8, 48) |
                  Assembler::simm20(opnd_array(0)->disp(ra_,this,0)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(0)->base(ra_,this,idx0)), 16, 48));
    } else {
      z_emit_inst(masm, (STD_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src */, 8, 32) |
                  Assembler::uimm12(opnd_array(0)->disp(ra_,this,0), 20, 32) |
                  Assembler::reg(Ridx, 12, 32) |
                  Assembler::regz(reg_to_register_object(opnd_array(0)->base(ra_,this,idx0)), 16, 32));
    }
  
#line 8300 "ad_s390.cpp"
  }
}

uint regD_to_stkDNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void loadBNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1855 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int isize = (LB_ZOPC /*secondary()*/) > 1L << 32 ? 48 : 32;
    Register Ridx = as_Register(opnd_array(1)->index(ra_,this,idx1));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.

    if (Displacement::is_shortDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (LB_ZOPC /*secondary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, isize) |
                  Assembler::uimm12(opnd_array(1)->disp(ra_,this,idx1), 20, isize) |
                  Assembler::reg(Ridx, 12, isize) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    } else if (Displacement::is_validDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (LB_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, 48) |
                  Assembler::simm20(opnd_array(1)->disp(ra_,this,idx1)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 48));
    } else {
        __ load_const_optimized(Z_R1_scratch, opnd_array(1)->disp(ra_,this,idx1));
        if (Ridx != Z_R0) { __ z_agr(Z_R1_scratch, Ridx); }
        z_emit_inst(masm, (LB_ZOPC /*secondary()*/) |
                    Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, isize) |
                    Assembler::uimm12(0, 20, isize) |
                    Assembler::reg(Z_R1_scratch, 12, isize) |
                    Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    }
  
#line 8343 "ad_s390.cpp"
  }
}

uint loadBNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= Z_DISP3_SIZE, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : Z_DISP3_SIZE);
}

void loadB2LNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1855 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int isize = (LGB_ZOPC /*secondary()*/) > 1L << 32 ? 48 : 32;
    Register Ridx = as_Register(opnd_array(1)->index(ra_,this,idx1));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.

    if (Displacement::is_shortDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (LGB_ZOPC /*secondary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, isize) |
                  Assembler::uimm12(opnd_array(1)->disp(ra_,this,idx1), 20, isize) |
                  Assembler::reg(Ridx, 12, isize) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    } else if (Displacement::is_validDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (LGB_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, 48) |
                  Assembler::simm20(opnd_array(1)->disp(ra_,this,idx1)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 48));
    } else {
        __ load_const_optimized(Z_R1_scratch, opnd_array(1)->disp(ra_,this,idx1));
        if (Ridx != Z_R0) { __ z_agr(Z_R1_scratch, Ridx); }
        z_emit_inst(masm, (LGB_ZOPC /*secondary()*/) |
                    Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, isize) |
                    Assembler::uimm12(0, 20, isize) |
                    Assembler::reg(Z_R1_scratch, 12, isize) |
                    Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    }
  
#line 8386 "ad_s390.cpp"
  }
}

uint loadB2LNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= Z_DISP3_SIZE, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : Z_DISP3_SIZE);
}

void loadUBNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1855 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int isize = (LLGC_ZOPC /*secondary()*/) > 1L << 32 ? 48 : 32;
    Register Ridx = as_Register(opnd_array(1)->index(ra_,this,idx1));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.

    if (Displacement::is_shortDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (LLGC_ZOPC /*secondary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, isize) |
                  Assembler::uimm12(opnd_array(1)->disp(ra_,this,idx1), 20, isize) |
                  Assembler::reg(Ridx, 12, isize) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    } else if (Displacement::is_validDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (LLGC_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, 48) |
                  Assembler::simm20(opnd_array(1)->disp(ra_,this,idx1)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 48));
    } else {
        __ load_const_optimized(Z_R1_scratch, opnd_array(1)->disp(ra_,this,idx1));
        if (Ridx != Z_R0) { __ z_agr(Z_R1_scratch, Ridx); }
        z_emit_inst(masm, (LLGC_ZOPC /*secondary()*/) |
                    Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, isize) |
                    Assembler::uimm12(0, 20, isize) |
                    Assembler::reg(Z_R1_scratch, 12, isize) |
                    Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    }
  
#line 8429 "ad_s390.cpp"
  }
}

uint loadUBNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= Z_DISP3_SIZE, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : Z_DISP3_SIZE);
}

void loadUB2LNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1855 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int isize = (LLGC_ZOPC /*secondary()*/) > 1L << 32 ? 48 : 32;
    Register Ridx = as_Register(opnd_array(1)->index(ra_,this,idx1));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.

    if (Displacement::is_shortDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (LLGC_ZOPC /*secondary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, isize) |
                  Assembler::uimm12(opnd_array(1)->disp(ra_,this,idx1), 20, isize) |
                  Assembler::reg(Ridx, 12, isize) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    } else if (Displacement::is_validDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (LLGC_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, 48) |
                  Assembler::simm20(opnd_array(1)->disp(ra_,this,idx1)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 48));
    } else {
        __ load_const_optimized(Z_R1_scratch, opnd_array(1)->disp(ra_,this,idx1));
        if (Ridx != Z_R0) { __ z_agr(Z_R1_scratch, Ridx); }
        z_emit_inst(masm, (LLGC_ZOPC /*secondary()*/) |
                    Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, isize) |
                    Assembler::uimm12(0, 20, isize) |
                    Assembler::reg(Z_R1_scratch, 12, isize) |
                    Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    }
  
#line 8472 "ad_s390.cpp"
  }
}

uint loadUB2LNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= Z_DISP3_SIZE, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : Z_DISP3_SIZE);
}

void loadSNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1855 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int isize = (LH_ZOPC /*secondary()*/) > 1L << 32 ? 48 : 32;
    Register Ridx = as_Register(opnd_array(1)->index(ra_,this,idx1));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.

    if (Displacement::is_shortDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (LH_ZOPC /*secondary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, isize) |
                  Assembler::uimm12(opnd_array(1)->disp(ra_,this,idx1), 20, isize) |
                  Assembler::reg(Ridx, 12, isize) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    } else if (Displacement::is_validDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (LHY_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, 48) |
                  Assembler::simm20(opnd_array(1)->disp(ra_,this,idx1)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 48));
    } else {
        __ load_const_optimized(Z_R1_scratch, opnd_array(1)->disp(ra_,this,idx1));
        if (Ridx != Z_R0) { __ z_agr(Z_R1_scratch, Ridx); }
        z_emit_inst(masm, (LH_ZOPC /*secondary()*/) |
                    Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, isize) |
                    Assembler::uimm12(0, 20, isize) |
                    Assembler::reg(Z_R1_scratch, 12, isize) |
                    Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    }
  
#line 8515 "ad_s390.cpp"
  }
}

uint loadSNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= Z_DISP_SIZE, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : Z_DISP_SIZE);
}

void loadS2LNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1855 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int isize = (LGH_ZOPC /*secondary()*/) > 1L << 32 ? 48 : 32;
    Register Ridx = as_Register(opnd_array(1)->index(ra_,this,idx1));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.

    if (Displacement::is_shortDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (LGH_ZOPC /*secondary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, isize) |
                  Assembler::uimm12(opnd_array(1)->disp(ra_,this,idx1), 20, isize) |
                  Assembler::reg(Ridx, 12, isize) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    } else if (Displacement::is_validDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (LGH_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, 48) |
                  Assembler::simm20(opnd_array(1)->disp(ra_,this,idx1)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 48));
    } else {
        __ load_const_optimized(Z_R1_scratch, opnd_array(1)->disp(ra_,this,idx1));
        if (Ridx != Z_R0) { __ z_agr(Z_R1_scratch, Ridx); }
        z_emit_inst(masm, (LGH_ZOPC /*secondary()*/) |
                    Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, isize) |
                    Assembler::uimm12(0, 20, isize) |
                    Assembler::reg(Z_R1_scratch, 12, isize) |
                    Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    }
  
#line 8558 "ad_s390.cpp"
  }
}

uint loadS2LNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= Z_DISP3_SIZE, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : Z_DISP3_SIZE);
}

void loadUSNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1855 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int isize = (LLGH_ZOPC /*secondary()*/) > 1L << 32 ? 48 : 32;
    Register Ridx = as_Register(opnd_array(1)->index(ra_,this,idx1));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.

    if (Displacement::is_shortDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (LLGH_ZOPC /*secondary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, isize) |
                  Assembler::uimm12(opnd_array(1)->disp(ra_,this,idx1), 20, isize) |
                  Assembler::reg(Ridx, 12, isize) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    } else if (Displacement::is_validDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (LLGH_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, 48) |
                  Assembler::simm20(opnd_array(1)->disp(ra_,this,idx1)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 48));
    } else {
        __ load_const_optimized(Z_R1_scratch, opnd_array(1)->disp(ra_,this,idx1));
        if (Ridx != Z_R0) { __ z_agr(Z_R1_scratch, Ridx); }
        z_emit_inst(masm, (LLGH_ZOPC /*secondary()*/) |
                    Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, isize) |
                    Assembler::uimm12(0, 20, isize) |
                    Assembler::reg(Z_R1_scratch, 12, isize) |
                    Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    }
  
#line 8601 "ad_s390.cpp"
  }
}

uint loadUSNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= Z_DISP3_SIZE, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : Z_DISP3_SIZE);
}

void loadUS2LNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1855 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int isize = (LLGH_ZOPC /*secondary()*/) > 1L << 32 ? 48 : 32;
    Register Ridx = as_Register(opnd_array(1)->index(ra_,this,idx1));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.

    if (Displacement::is_shortDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (LLGH_ZOPC /*secondary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, isize) |
                  Assembler::uimm12(opnd_array(1)->disp(ra_,this,idx1), 20, isize) |
                  Assembler::reg(Ridx, 12, isize) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    } else if (Displacement::is_validDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (LLGH_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, 48) |
                  Assembler::simm20(opnd_array(1)->disp(ra_,this,idx1)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 48));
    } else {
        __ load_const_optimized(Z_R1_scratch, opnd_array(1)->disp(ra_,this,idx1));
        if (Ridx != Z_R0) { __ z_agr(Z_R1_scratch, Ridx); }
        z_emit_inst(masm, (LLGH_ZOPC /*secondary()*/) |
                    Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, isize) |
                    Assembler::uimm12(0, 20, isize) |
                    Assembler::reg(Z_R1_scratch, 12, isize) |
                    Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    }
  
#line 8644 "ad_s390.cpp"
  }
}

uint loadUS2LNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= Z_DISP3_SIZE, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : Z_DISP3_SIZE);
}

void loadINode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1855 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int isize = (L_ZOPC /*secondary()*/) > 1L << 32 ? 48 : 32;
    Register Ridx = as_Register(opnd_array(1)->index(ra_,this,idx1));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.

    if (Displacement::is_shortDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (L_ZOPC /*secondary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, isize) |
                  Assembler::uimm12(opnd_array(1)->disp(ra_,this,idx1), 20, isize) |
                  Assembler::reg(Ridx, 12, isize) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    } else if (Displacement::is_validDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (LY_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, 48) |
                  Assembler::simm20(opnd_array(1)->disp(ra_,this,idx1)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 48));
    } else {
        __ load_const_optimized(Z_R1_scratch, opnd_array(1)->disp(ra_,this,idx1));
        if (Ridx != Z_R0) { __ z_agr(Z_R1_scratch, Ridx); }
        z_emit_inst(masm, (L_ZOPC /*secondary()*/) |
                    Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, isize) |
                    Assembler::uimm12(0, 20, isize) |
                    Assembler::reg(Z_R1_scratch, 12, isize) |
                    Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    }
  
#line 8687 "ad_s390.cpp"
  }
}

uint loadINode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= Z_DISP_SIZE, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : Z_DISP_SIZE);
}

void loadI2LNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1855 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int isize = (LGF_ZOPC /*secondary()*/) > 1L << 32 ? 48 : 32;
    Register Ridx = as_Register(opnd_array(1)->index(ra_,this,idx1));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.

    if (Displacement::is_shortDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (LGF_ZOPC /*secondary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, isize) |
                  Assembler::uimm12(opnd_array(1)->disp(ra_,this,idx1), 20, isize) |
                  Assembler::reg(Ridx, 12, isize) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    } else if (Displacement::is_validDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (LGF_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, 48) |
                  Assembler::simm20(opnd_array(1)->disp(ra_,this,idx1)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 48));
    } else {
        __ load_const_optimized(Z_R1_scratch, opnd_array(1)->disp(ra_,this,idx1));
        if (Ridx != Z_R0) { __ z_agr(Z_R1_scratch, Ridx); }
        z_emit_inst(masm, (LGF_ZOPC /*secondary()*/) |
                    Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, isize) |
                    Assembler::uimm12(0, 20, isize) |
                    Assembler::reg(Z_R1_scratch, 12, isize) |
                    Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    }
  
#line 8730 "ad_s390.cpp"
  }
}

uint loadI2LNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= Z_DISP3_SIZE, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : Z_DISP3_SIZE);
}

void loadUI2LNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {

#line 1855 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int isize = (LLGF_ZOPC /*secondary()*/) > 1L << 32 ? 48 : 32;
    Register Ridx = as_Register(opnd_array(1)->index(ra_,this,idx1));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.

    if (Displacement::is_shortDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (LLGF_ZOPC /*secondary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, isize) |
                  Assembler::uimm12(opnd_array(1)->disp(ra_,this,idx1), 20, isize) |
                  Assembler::reg(Ridx, 12, isize) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    } else if (Displacement::is_validDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (LLGF_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, 48) |
                  Assembler::simm20(opnd_array(1)->disp(ra_,this,idx1)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 48));
    } else {
        __ load_const_optimized(Z_R1_scratch, opnd_array(1)->disp(ra_,this,idx1));
        if (Ridx != Z_R0) { __ z_agr(Z_R1_scratch, Ridx); }
        z_emit_inst(masm, (LLGF_ZOPC /*secondary()*/) |
                    Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, isize) |
                    Assembler::uimm12(0, 20, isize) |
                    Assembler::reg(Z_R1_scratch, 12, isize) |
                    Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    }
  
#line 8774 "ad_s390.cpp"
  }
}

uint loadUI2LNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= Z_DISP3_SIZE, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : Z_DISP3_SIZE);
}

void loadRangeNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1855 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int isize = (L_ZOPC /*secondary()*/) > 1L << 32 ? 48 : 32;
    Register Ridx = as_Register(opnd_array(1)->index(ra_,this,idx1));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.

    if (Displacement::is_shortDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (L_ZOPC /*secondary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, isize) |
                  Assembler::uimm12(opnd_array(1)->disp(ra_,this,idx1), 20, isize) |
                  Assembler::reg(Ridx, 12, isize) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    } else if (Displacement::is_validDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (LY_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, 48) |
                  Assembler::simm20(opnd_array(1)->disp(ra_,this,idx1)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 48));
    } else {
        __ load_const_optimized(Z_R1_scratch, opnd_array(1)->disp(ra_,this,idx1));
        if (Ridx != Z_R0) { __ z_agr(Z_R1_scratch, Ridx); }
        z_emit_inst(masm, (L_ZOPC /*secondary()*/) |
                    Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, isize) |
                    Assembler::uimm12(0, 20, isize) |
                    Assembler::reg(Z_R1_scratch, 12, isize) |
                    Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    }
  
#line 8817 "ad_s390.cpp"
  }
}

uint loadRangeNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= Z_DISP_SIZE, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : Z_DISP_SIZE);
}

void loadLNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1855 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int isize = (LG_ZOPC /*secondary()*/) > 1L << 32 ? 48 : 32;
    Register Ridx = as_Register(opnd_array(1)->index(ra_,this,idx1));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.

    if (Displacement::is_shortDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (LG_ZOPC /*secondary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, isize) |
                  Assembler::uimm12(opnd_array(1)->disp(ra_,this,idx1), 20, isize) |
                  Assembler::reg(Ridx, 12, isize) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    } else if (Displacement::is_validDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (LG_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, 48) |
                  Assembler::simm20(opnd_array(1)->disp(ra_,this,idx1)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 48));
    } else {
        __ load_const_optimized(Z_R1_scratch, opnd_array(1)->disp(ra_,this,idx1));
        if (Ridx != Z_R0) { __ z_agr(Z_R1_scratch, Ridx); }
        z_emit_inst(masm, (LG_ZOPC /*secondary()*/) |
                    Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, isize) |
                    Assembler::uimm12(0, 20, isize) |
                    Assembler::reg(Z_R1_scratch, 12, isize) |
                    Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    }
  
#line 8860 "ad_s390.cpp"
  }
}

uint loadLNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= Z_DISP3_SIZE, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : Z_DISP3_SIZE);
}

void loadL_unalignedNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1855 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int isize = (LG_ZOPC /*secondary()*/) > 1L << 32 ? 48 : 32;
    Register Ridx = as_Register(opnd_array(1)->index(ra_,this,idx1));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.

    if (Displacement::is_shortDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (LG_ZOPC /*secondary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, isize) |
                  Assembler::uimm12(opnd_array(1)->disp(ra_,this,idx1), 20, isize) |
                  Assembler::reg(Ridx, 12, isize) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    } else if (Displacement::is_validDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (LG_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, 48) |
                  Assembler::simm20(opnd_array(1)->disp(ra_,this,idx1)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 48));
    } else {
        __ load_const_optimized(Z_R1_scratch, opnd_array(1)->disp(ra_,this,idx1));
        if (Ridx != Z_R0) { __ z_agr(Z_R1_scratch, Ridx); }
        z_emit_inst(masm, (LG_ZOPC /*secondary()*/) |
                    Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, isize) |
                    Assembler::uimm12(0, 20, isize) |
                    Assembler::reg(Z_R1_scratch, 12, isize) |
                    Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    }
  
#line 8903 "ad_s390.cpp"
  }
}

uint loadL_unalignedNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= Z_DISP3_SIZE, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : Z_DISP3_SIZE);
}

void loadPNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1855 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int isize = (LG_ZOPC /*secondary()*/) > 1L << 32 ? 48 : 32;
    Register Ridx = as_Register(opnd_array(1)->index(ra_,this,idx1));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.

    if (Displacement::is_shortDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (LG_ZOPC /*secondary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, isize) |
                  Assembler::uimm12(opnd_array(1)->disp(ra_,this,idx1), 20, isize) |
                  Assembler::reg(Ridx, 12, isize) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    } else if (Displacement::is_validDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (LG_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, 48) |
                  Assembler::simm20(opnd_array(1)->disp(ra_,this,idx1)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 48));
    } else {
        __ load_const_optimized(Z_R1_scratch, opnd_array(1)->disp(ra_,this,idx1));
        if (Ridx != Z_R0) { __ z_agr(Z_R1_scratch, Ridx); }
        z_emit_inst(masm, (LG_ZOPC /*secondary()*/) |
                    Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, isize) |
                    Assembler::uimm12(0, 20, isize) |
                    Assembler::reg(Z_R1_scratch, 12, isize) |
                    Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    }
  
#line 8946 "ad_s390.cpp"
  }
}

uint loadPNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= Z_DISP3_SIZE, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : Z_DISP3_SIZE);
}

void castP2X_loadPNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1855 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int isize = (LG_ZOPC /*secondary()*/) > 1L << 32 ? 48 : 32;
    Register Ridx = as_Register(opnd_array(1)->index(ra_,this,idx1));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.

    if (Displacement::is_shortDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (LG_ZOPC /*secondary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, isize) |
                  Assembler::uimm12(opnd_array(1)->disp(ra_,this,idx1), 20, isize) |
                  Assembler::reg(Ridx, 12, isize) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    } else if (Displacement::is_validDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (LG_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, 48) |
                  Assembler::simm20(opnd_array(1)->disp(ra_,this,idx1)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 48));
    } else {
        __ load_const_optimized(Z_R1_scratch, opnd_array(1)->disp(ra_,this,idx1));
        if (Ridx != Z_R0) { __ z_agr(Z_R1_scratch, Ridx); }
        z_emit_inst(masm, (LG_ZOPC /*secondary()*/) |
                    Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, isize) |
                    Assembler::uimm12(0, 20, isize) |
                    Assembler::reg(Z_R1_scratch, 12, isize) |
                    Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    }
  
#line 8989 "ad_s390.cpp"
  }
}

uint castP2X_loadPNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= Z_DISP3_SIZE, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : Z_DISP3_SIZE);
}

void loadKlassNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1855 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int isize = (LG_ZOPC /*secondary()*/) > 1L << 32 ? 48 : 32;
    Register Ridx = as_Register(opnd_array(1)->index(ra_,this,idx1));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.

    if (Displacement::is_shortDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (LG_ZOPC /*secondary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, isize) |
                  Assembler::uimm12(opnd_array(1)->disp(ra_,this,idx1), 20, isize) |
                  Assembler::reg(Ridx, 12, isize) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    } else if (Displacement::is_validDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (LG_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, 48) |
                  Assembler::simm20(opnd_array(1)->disp(ra_,this,idx1)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 48));
    } else {
        __ load_const_optimized(Z_R1_scratch, opnd_array(1)->disp(ra_,this,idx1));
        if (Ridx != Z_R0) { __ z_agr(Z_R1_scratch, Ridx); }
        z_emit_inst(masm, (LG_ZOPC /*secondary()*/) |
                    Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, isize) |
                    Assembler::uimm12(0, 20, isize) |
                    Assembler::reg(Z_R1_scratch, 12, isize) |
                    Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    }
  
#line 9032 "ad_s390.cpp"
  }
}

uint loadKlassNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= Z_DISP3_SIZE, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : Z_DISP3_SIZE);
}

void loadTOCNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {

#line 3949 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"
__ load_toc(opnd_array(0)->as_Register(ra_,this)/* dst */); 
#line 9049 "ad_s390.cpp"
  }
}

void loadFNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1855 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int isize = (LE_ZOPC /*secondary()*/) > 1L << 32 ? 48 : 32;
    Register Ridx = as_Register(opnd_array(1)->index(ra_,this,idx1));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.

    if (Displacement::is_shortDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (LE_ZOPC /*secondary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, isize) |
                  Assembler::uimm12(opnd_array(1)->disp(ra_,this,idx1), 20, isize) |
                  Assembler::reg(Ridx, 12, isize) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    } else if (Displacement::is_validDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (LEY_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, 48) |
                  Assembler::simm20(opnd_array(1)->disp(ra_,this,idx1)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 48));
    } else {
        __ load_const_optimized(Z_R1_scratch, opnd_array(1)->disp(ra_,this,idx1));
        if (Ridx != Z_R0) { __ z_agr(Z_R1_scratch, Ridx); }
        z_emit_inst(masm, (LE_ZOPC /*secondary()*/) |
                    Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, isize) |
                    Assembler::uimm12(0, 20, isize) |
                    Assembler::reg(Z_R1_scratch, 12, isize) |
                    Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    }
  
#line 9087 "ad_s390.cpp"
  }
}

uint loadFNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= Z_DISP_SIZE, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : Z_DISP_SIZE);
}

void loadDNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1855 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int isize = (LD_ZOPC /*secondary()*/) > 1L << 32 ? 48 : 32;
    Register Ridx = as_Register(opnd_array(1)->index(ra_,this,idx1));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.

    if (Displacement::is_shortDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (LD_ZOPC /*secondary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, isize) |
                  Assembler::uimm12(opnd_array(1)->disp(ra_,this,idx1), 20, isize) |
                  Assembler::reg(Ridx, 12, isize) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    } else if (Displacement::is_validDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (LDY_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, 48) |
                  Assembler::simm20(opnd_array(1)->disp(ra_,this,idx1)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 48));
    } else {
        __ load_const_optimized(Z_R1_scratch, opnd_array(1)->disp(ra_,this,idx1));
        if (Ridx != Z_R0) { __ z_agr(Z_R1_scratch, Ridx); }
        z_emit_inst(masm, (LD_ZOPC /*secondary()*/) |
                    Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, isize) |
                    Assembler::uimm12(0, 20, isize) |
                    Assembler::reg(Z_R1_scratch, 12, isize) |
                    Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    }
  
#line 9130 "ad_s390.cpp"
  }
}

uint loadDNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= Z_DISP_SIZE, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : Z_DISP_SIZE);
}

void loadD_unalignedNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1855 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int isize = (LD_ZOPC /*secondary()*/) > 1L << 32 ? 48 : 32;
    Register Ridx = as_Register(opnd_array(1)->index(ra_,this,idx1));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.

    if (Displacement::is_shortDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (LD_ZOPC /*secondary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, isize) |
                  Assembler::uimm12(opnd_array(1)->disp(ra_,this,idx1), 20, isize) |
                  Assembler::reg(Ridx, 12, isize) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    } else if (Displacement::is_validDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (LDY_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, 48) |
                  Assembler::simm20(opnd_array(1)->disp(ra_,this,idx1)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 48));
    } else {
        __ load_const_optimized(Z_R1_scratch, opnd_array(1)->disp(ra_,this,idx1));
        if (Ridx != Z_R0) { __ z_agr(Z_R1_scratch, Ridx); }
        z_emit_inst(masm, (LD_ZOPC /*secondary()*/) |
                    Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, isize) |
                    Assembler::uimm12(0, 20, isize) |
                    Assembler::reg(Z_R1_scratch, 12, isize) |
                    Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    }
  
#line 9173 "ad_s390.cpp"
  }
}

uint loadD_unalignedNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= Z_DISP_SIZE, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : Z_DISP_SIZE);
}

void loadConINode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 4000 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"
__ z_lgfi(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->constant()); 
#line 9190 "ad_s390.cpp"
  }
}

uint loadConINode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void loadConI16Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 4009 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"
__ z_lghi(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->constant()); 
#line 9207 "ad_s390.cpp"
  }
}

uint loadConI16Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void loadConI_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1700 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((XGR_ZOPC /*primary()*/) >> 30) & 0x03) == 2, "Instruction format error");
    z_emit32(masm, (XGR_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */,24,32) |
             Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */,28,32));
  
#line 9229 "ad_s390.cpp"
  }
}

uint loadConI_0Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void loadConUI16Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1722 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((LLILL_ZOPC /*primary()*/)>>30) & 0x03) == 2, "Instruction format error");
    z_emit32(masm, (LLILL_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */,8,32) |
             Assembler::uimm16(opnd_array(1)->constant(),16,32));
  
#line 9251 "ad_s390.cpp"
  }
}

void loadConL_pcrelTOCNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 4039 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    address long_address = __ long_constant(opnd_array(1)->constantL());
    if (long_address == nullptr) {
      Compile::current()->env()->record_out_of_memory_failure();
      return;
    }
    __ load_long_pcrelative(opnd_array(0)->as_Register(ra_,this)/* dst */, long_address);
  
#line 9270 "ad_s390.cpp"
  }
}

uint loadConL_pcrelTOCNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void loadConL32Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 4055 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"
__ z_lgfi(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->constantL()); 
#line 9287 "ad_s390.cpp"
  }
}

uint loadConL32Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void loadConL16Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 4064 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"
__ z_lghi(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->constantL()); 
#line 9304 "ad_s390.cpp"
  }
}

uint loadConL16Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void loadConL_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1700 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((XGR_ZOPC /*primary()*/) >> 30) & 0x03) == 2, "Instruction format error");
    z_emit32(masm, (XGR_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */,24,32) |
             Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */,28,32));
  
#line 9326 "ad_s390.cpp"
  }
}

void loadConP_pcrelTOCNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 4085 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    relocInfo::relocType constant_reloc = opnd_array(1)->constant_reloc();
    if (constant_reloc == relocInfo::oop_type) {
      AddressLiteral a = __ allocate_oop_address((jobject)opnd_array(1)->constant());
      bool success = __ load_oop_from_toc(opnd_array(0)->as_Register(ra_,this)/* dst */, a);
      if (!success) {
        Compile::current()->env()->record_out_of_memory_failure();
        return;
      }
    } else if (constant_reloc == relocInfo::metadata_type) {
      AddressLiteral a = __ constant_metadata_address((Metadata *)opnd_array(1)->constant());
      address const_toc_addr = __ address_constant((address)a.value(), RelocationHolder::none);
      if (const_toc_addr == nullptr) {
        Compile::current()->env()->record_out_of_memory_failure();
        return;
      }
      __ load_long_pcrelative(opnd_array(0)->as_Register(ra_,this)/* dst */, const_toc_addr);
    } else {          // Non-oop pointers, e.g. card mark base, heap top.
      address long_address = __ long_constant((jlong)opnd_array(1)->constant());
      if (long_address == nullptr) {
        Compile::current()->env()->record_out_of_memory_failure();
        return;
      }
      __ load_long_pcrelative(opnd_array(0)->as_Register(ra_,this)/* dst */, long_address);
    }
  
#line 9363 "ad_s390.cpp"
  }
}

uint loadConP_pcrelTOCNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void loadConP0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1700 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((XGR_ZOPC /*primary()*/) >> 30) & 0x03) == 2, "Instruction format error");
    z_emit32(masm, (XGR_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */,24,32) |
             Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */,28,32));
  
#line 9385 "ad_s390.cpp"
  }
}

uint loadConP0Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void loadConF_dynTOCNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 4140 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    __ load_float_largeoffset(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, constant_offset(), as_Register(ra_->get_encode(in(mach_constant_base_node_input()))), Z_R1_scratch);
  
#line 9404 "ad_s390.cpp"
  }
}

void loadConF_dynTOCNode::eval_constant(Compile* C) {
  {

#line 4141 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"
    _constant = C->output()->constant_table().add(this, opnd_array(1));
#line 9413 "ad_s390.cpp"
  }
}
uint loadConF_dynTOCNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void loadConD_dynTOCNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 4159 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    __ load_double_largeoffset(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, constant_offset(), as_Register(ra_->get_encode(in(mach_constant_base_node_input()))), Z_R1_scratch);
  
#line 9431 "ad_s390.cpp"
  }
}

void loadConD_dynTOCNode::eval_constant(Compile* C) {
  {

#line 4160 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"
    _constant = C->output()->constant_table().add(this, opnd_array(1));
#line 9440 "ad_s390.cpp"
  }
}
uint loadConD_dynTOCNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void loadConF0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1700 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((LZER_ZOPC /*primary()*/) >> 30) & 0x03) == 2, "Instruction format error");
    z_emit32(masm, (LZER_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */,24,32) |
             Assembler::reg((Z_F0_enc),28,32));
  
#line 9461 "ad_s390.cpp"
  }
}

uint loadConF0Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void loadConD0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1700 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((LZDR_ZOPC /*primary()*/) >> 30) & 0x03) == 2, "Instruction format error");
    z_emit32(masm, (LZDR_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */,24,32) |
             Assembler::reg((Z_F0_enc),28,32));
  
#line 9483 "ad_s390.cpp"
  }
}

uint loadConD0Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void storeBNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1855 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int isize = (STC_ZOPC /*secondary()*/) > 1L << 32 ? 48 : 32;
    Register Ridx = as_Register(opnd_array(1)->index(ra_,this,idx1));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.

    if (Displacement::is_shortDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (STC_ZOPC /*secondary()*/) |
                  Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* src */, 8, isize) |
                  Assembler::uimm12(opnd_array(1)->disp(ra_,this,idx1), 20, isize) |
                  Assembler::reg(Ridx, 12, isize) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    } else if (Displacement::is_validDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (STCY_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* src */, 8, 48) |
                  Assembler::simm20(opnd_array(1)->disp(ra_,this,idx1)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 48));
    } else {
        __ load_const_optimized(Z_R1_scratch, opnd_array(1)->disp(ra_,this,idx1));
        if (Ridx != Z_R0) { __ z_agr(Z_R1_scratch, Ridx); }
        z_emit_inst(masm, (STC_ZOPC /*secondary()*/) |
                    Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* src */, 8, isize) |
                    Assembler::uimm12(0, 20, isize) |
                    Assembler::reg(Z_R1_scratch, 12, isize) |
                    Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    }
  
#line 9527 "ad_s390.cpp"
  }
}

uint storeBNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= Z_DISP_SIZE, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : Z_DISP_SIZE);
}

void storeCMNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 4210 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    guarantee(as_Register(opnd_array(1)->index(ra_,this,idx1))!= Z_R0, "content will not be used.");
    if (as_Register(opnd_array(1)->index(ra_,this,idx1))!= noreg) {
      // Can't use clear_mem --> load const zero and store character.
      __ load_const_optimized(Z_R0_scratch, (long)0);
      if (Immediate::is_uimm12(opnd_array(1)->disp(ra_,this,idx1))) {
        __ z_stc(Z_R0_scratch, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
      } else {
        __ z_stcy(Z_R0_scratch, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
      }
    } else {
      __ clear_mem(Address(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc())), 1);
    }
  
#line 9558 "ad_s390.cpp"
  }
}

void storeCNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1855 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int isize = (STH_ZOPC /*secondary()*/) > 1L << 32 ? 48 : 32;
    Register Ridx = as_Register(opnd_array(1)->index(ra_,this,idx1));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.

    if (Displacement::is_shortDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (STH_ZOPC /*secondary()*/) |
                  Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* src */, 8, isize) |
                  Assembler::uimm12(opnd_array(1)->disp(ra_,this,idx1), 20, isize) |
                  Assembler::reg(Ridx, 12, isize) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    } else if (Displacement::is_validDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (STHY_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* src */, 8, 48) |
                  Assembler::simm20(opnd_array(1)->disp(ra_,this,idx1)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 48));
    } else {
        __ load_const_optimized(Z_R1_scratch, opnd_array(1)->disp(ra_,this,idx1));
        if (Ridx != Z_R0) { __ z_agr(Z_R1_scratch, Ridx); }
        z_emit_inst(masm, (STH_ZOPC /*secondary()*/) |
                    Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* src */, 8, isize) |
                    Assembler::uimm12(0, 20, isize) |
                    Assembler::reg(Z_R1_scratch, 12, isize) |
                    Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    }
  
#line 9597 "ad_s390.cpp"
  }
}

uint storeCNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= Z_DISP_SIZE, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : Z_DISP_SIZE);
}

void storeINode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1855 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int isize = (ST_ZOPC /*secondary()*/) > 1L << 32 ? 48 : 32;
    Register Ridx = as_Register(opnd_array(1)->index(ra_,this,idx1));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.

    if (Displacement::is_shortDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (ST_ZOPC /*secondary()*/) |
                  Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* src */, 8, isize) |
                  Assembler::uimm12(opnd_array(1)->disp(ra_,this,idx1), 20, isize) |
                  Assembler::reg(Ridx, 12, isize) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    } else if (Displacement::is_validDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (STY_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* src */, 8, 48) |
                  Assembler::simm20(opnd_array(1)->disp(ra_,this,idx1)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 48));
    } else {
        __ load_const_optimized(Z_R1_scratch, opnd_array(1)->disp(ra_,this,idx1));
        if (Ridx != Z_R0) { __ z_agr(Z_R1_scratch, Ridx); }
        z_emit_inst(masm, (ST_ZOPC /*secondary()*/) |
                    Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* src */, 8, isize) |
                    Assembler::uimm12(0, 20, isize) |
                    Assembler::reg(Z_R1_scratch, 12, isize) |
                    Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    }
  
#line 9641 "ad_s390.cpp"
  }
}

uint storeINode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= Z_DISP_SIZE, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : Z_DISP_SIZE);
}

void storeLNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1855 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int isize = (STG_ZOPC /*secondary()*/) > 1L << 32 ? 48 : 32;
    Register Ridx = as_Register(opnd_array(1)->index(ra_,this,idx1));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.

    if (Displacement::is_shortDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (STG_ZOPC /*secondary()*/) |
                  Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* src */, 8, isize) |
                  Assembler::uimm12(opnd_array(1)->disp(ra_,this,idx1), 20, isize) |
                  Assembler::reg(Ridx, 12, isize) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    } else if (Displacement::is_validDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (STG_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* src */, 8, 48) |
                  Assembler::simm20(opnd_array(1)->disp(ra_,this,idx1)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 48));
    } else {
        __ load_const_optimized(Z_R1_scratch, opnd_array(1)->disp(ra_,this,idx1));
        if (Ridx != Z_R0) { __ z_agr(Z_R1_scratch, Ridx); }
        z_emit_inst(masm, (STG_ZOPC /*secondary()*/) |
                    Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* src */, 8, isize) |
                    Assembler::uimm12(0, 20, isize) |
                    Assembler::reg(Z_R1_scratch, 12, isize) |
                    Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    }
  
#line 9685 "ad_s390.cpp"
  }
}

uint storeLNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= Z_DISP3_SIZE, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : Z_DISP3_SIZE);
}

void storePNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1855 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int isize = (STG_ZOPC /*secondary()*/) > 1L << 32 ? 48 : 32;
    Register Ridx = as_Register(opnd_array(1)->index(ra_,this,idx1));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.

    if (Displacement::is_shortDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (STG_ZOPC /*secondary()*/) |
                  Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* src */, 8, isize) |
                  Assembler::uimm12(opnd_array(1)->disp(ra_,this,idx1), 20, isize) |
                  Assembler::reg(Ridx, 12, isize) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    } else if (Displacement::is_validDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (STG_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* src */, 8, 48) |
                  Assembler::simm20(opnd_array(1)->disp(ra_,this,idx1)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 48));
    } else {
        __ load_const_optimized(Z_R1_scratch, opnd_array(1)->disp(ra_,this,idx1));
        if (Ridx != Z_R0) { __ z_agr(Z_R1_scratch, Ridx); }
        z_emit_inst(masm, (STG_ZOPC /*secondary()*/) |
                    Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* src */, 8, isize) |
                    Assembler::uimm12(0, 20, isize) |
                    Assembler::reg(Z_R1_scratch, 12, isize) |
                    Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    }
  
#line 9729 "ad_s390.cpp"
  }
}

uint storePNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= Z_DISP3_SIZE, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : Z_DISP3_SIZE);
}

void storeFNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1855 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int isize = (STE_ZOPC /*secondary()*/) > 1L << 32 ? 48 : 32;
    Register Ridx = as_Register(opnd_array(1)->index(ra_,this,idx1));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.

    if (Displacement::is_shortDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (STE_ZOPC /*secondary()*/) |
                  Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* src */, 8, isize) |
                  Assembler::uimm12(opnd_array(1)->disp(ra_,this,idx1), 20, isize) |
                  Assembler::reg(Ridx, 12, isize) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    } else if (Displacement::is_validDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (STEY_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* src */, 8, 48) |
                  Assembler::simm20(opnd_array(1)->disp(ra_,this,idx1)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 48));
    } else {
        __ load_const_optimized(Z_R1_scratch, opnd_array(1)->disp(ra_,this,idx1));
        if (Ridx != Z_R0) { __ z_agr(Z_R1_scratch, Ridx); }
        z_emit_inst(masm, (STE_ZOPC /*secondary()*/) |
                    Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* src */, 8, isize) |
                    Assembler::uimm12(0, 20, isize) |
                    Assembler::reg(Z_R1_scratch, 12, isize) |
                    Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    }
  
#line 9773 "ad_s390.cpp"
  }
}

uint storeFNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= Z_DISP_SIZE, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : Z_DISP_SIZE);
}

void storeDNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1855 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int isize = (STD_ZOPC /*secondary()*/) > 1L << 32 ? 48 : 32;
    Register Ridx = as_Register(opnd_array(1)->index(ra_,this,idx1));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.

    if (Displacement::is_shortDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (STD_ZOPC /*secondary()*/) |
                  Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* src */, 8, isize) |
                  Assembler::uimm12(opnd_array(1)->disp(ra_,this,idx1), 20, isize) |
                  Assembler::reg(Ridx, 12, isize) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    } else if (Displacement::is_validDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (STDY_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* src */, 8, 48) |
                  Assembler::simm20(opnd_array(1)->disp(ra_,this,idx1)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 48));
    } else {
        __ load_const_optimized(Z_R1_scratch, opnd_array(1)->disp(ra_,this,idx1));
        if (Ridx != Z_R0) { __ z_agr(Z_R1_scratch, Ridx); }
        z_emit_inst(masm, (STD_ZOPC /*secondary()*/) |
                    Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* src */, 8, isize) |
                    Assembler::uimm12(0, 20, isize) |
                    Assembler::reg(Z_R1_scratch, 12, isize) |
                    Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    }
  
#line 9817 "ad_s390.cpp"
  }
}

uint storeDNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= Z_DISP_SIZE, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : Z_DISP_SIZE);
}

void prefetchAllocNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// 
  {

#line 4314 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"
__ z_pfd(0x02, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc())); 
#line 9834 "ad_s390.cpp"
  }
}

void memInitBNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 4326 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    if (Immediate::is_uimm12((long)opnd_array(1)->disp(ra_,this,idx1))) {
      __ z_mvi(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->constant());
    } else {
      __ z_mviy(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->constant());
    }
  
#line 9853 "ad_s390.cpp"
  }
}

void memInitCNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1811 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    z_emit_inst(masm, (MVHHI_ZOPC /*primary()*/) |
                Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)),16,48) |
                Assembler::uimm12(opnd_array(1)->disp(ra_,this,idx1),20,48) |
                Assembler::simm16(opnd_array(2)->constant(),32,48));
  
#line 9871 "ad_s390.cpp"
  }
}

uint memInitCNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void memInitINode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1811 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    z_emit_inst(masm, (MVHI_ZOPC /*primary()*/) |
                Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)),16,48) |
                Assembler::uimm12(opnd_array(1)->disp(ra_,this,idx1),20,48) |
                Assembler::simm16(opnd_array(2)->constant(),32,48));
  
#line 9894 "ad_s390.cpp"
  }
}

uint memInitINode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void memInitLNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1811 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    z_emit_inst(masm, (MVGHI_ZOPC /*primary()*/) |
                Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)),16,48) |
                Assembler::uimm12(opnd_array(1)->disp(ra_,this,idx1),20,48) |
                Assembler::simm16(opnd_array(2)->constantL(),32,48));
  
#line 9917 "ad_s390.cpp"
  }
}

uint memInitLNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void memInitPNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1811 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    z_emit_inst(masm, (MVGHI_ZOPC /*primary()*/) |
                Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)),16,48) |
                Assembler::uimm12(opnd_array(1)->disp(ra_,this,idx1),20,48) |
                Assembler::simm16(opnd_array(2)->constant(),32,48));
  
#line 9940 "ad_s390.cpp"
  }
}

uint memInitPNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void negL_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 4393 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"
__ z_lcgr(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(2)->as_Register(ra_,this,idx2)/* src */); 
#line 9958 "ad_s390.cpp"
  }
}

uint negL_reg_regNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void loadNNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1855 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int isize = (LLGF_ZOPC /*secondary()*/) > 1L << 32 ? 48 : 32;
    Register Ridx = as_Register(opnd_array(1)->index(ra_,this,idx1));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.

    if (Displacement::is_shortDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (LLGF_ZOPC /*secondary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, isize) |
                  Assembler::uimm12(opnd_array(1)->disp(ra_,this,idx1), 20, isize) |
                  Assembler::reg(Ridx, 12, isize) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    } else if (Displacement::is_validDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (LLGF_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, 48) |
                  Assembler::simm20(opnd_array(1)->disp(ra_,this,idx1)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 48));
    } else {
        __ load_const_optimized(Z_R1_scratch, opnd_array(1)->disp(ra_,this,idx1));
        if (Ridx != Z_R0) { __ z_agr(Z_R1_scratch, Ridx); }
        z_emit_inst(masm, (LLGF_ZOPC /*secondary()*/) |
                    Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, isize) |
                    Assembler::uimm12(0, 20, isize) |
                    Assembler::reg(Z_R1_scratch, 12, isize) |
                    Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    }
  
#line 10001 "ad_s390.cpp"
  }
}

uint loadNNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= Z_DISP3_SIZE, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : Z_DISP3_SIZE);
}

void loadNKlassNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1855 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int isize = (LLGF_ZOPC /*secondary()*/) > 1L << 32 ? 48 : 32;
    Register Ridx = as_Register(opnd_array(1)->index(ra_,this,idx1));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.

    if (Displacement::is_shortDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (LLGF_ZOPC /*secondary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, isize) |
                  Assembler::uimm12(opnd_array(1)->disp(ra_,this,idx1), 20, isize) |
                  Assembler::reg(Ridx, 12, isize) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    } else if (Displacement::is_validDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (LLGF_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, 48) |
                  Assembler::simm20(opnd_array(1)->disp(ra_,this,idx1)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 48));
    } else {
        __ load_const_optimized(Z_R1_scratch, opnd_array(1)->disp(ra_,this,idx1));
        if (Ridx != Z_R0) { __ z_agr(Z_R1_scratch, Ridx); }
        z_emit_inst(masm, (LLGF_ZOPC /*secondary()*/) |
                    Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, isize) |
                    Assembler::uimm12(0, 20, isize) |
                    Assembler::reg(Z_R1_scratch, 12, isize) |
                    Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    }
  
#line 10044 "ad_s390.cpp"
  }
}

uint loadNKlassNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= Z_DISP3_SIZE, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : Z_DISP3_SIZE);
}

void loadConNNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 4428 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    AddressLiteral cOop = __ constant_oop_address((jobject)opnd_array(1)->constant());
    __ relocate(cOop.rspec(), 1);
    __ load_narrow_oop(opnd_array(0)->as_Register(ra_,this)/* dst */, (narrowOop)cOop.value());
  
#line 10065 "ad_s390.cpp"
  }
}

uint loadConNNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void loadConN0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1700 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((XGR_ZOPC /*primary()*/) >> 30) & 0x03) == 2, "Instruction format error");
    z_emit32(masm, (XGR_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */,24,32) |
             Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */,28,32));
  
#line 10087 "ad_s390.cpp"
  }
}

uint loadConN0Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void loadConNKlassNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 4452 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    AddressLiteral NKlass = __ constant_metadata_address((Metadata*)opnd_array(1)->constant());
    __ relocate(NKlass.rspec(), 1);
    __ load_narrow_klass(opnd_array(0)->as_Register(ra_,this)/* dst */, (Klass*)NKlass.value());
  
#line 10108 "ad_s390.cpp"
  }
}

uint loadConNKlassNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void decodeLoadNNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1855 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int isize = (LLGF_ZOPC /*secondary()*/) > 1L << 32 ? 48 : 32;
    Register Ridx = as_Register(opnd_array(1)->index(ra_,this,idx1));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.

    if (Displacement::is_shortDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (LLGF_ZOPC /*secondary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, isize) |
                  Assembler::uimm12(opnd_array(1)->disp(ra_,this,idx1), 20, isize) |
                  Assembler::reg(Ridx, 12, isize) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    } else if (Displacement::is_validDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (LLGF_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, 48) |
                  Assembler::simm20(opnd_array(1)->disp(ra_,this,idx1)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 48));
    } else {
        __ load_const_optimized(Z_R1_scratch, opnd_array(1)->disp(ra_,this,idx1));
        if (Ridx != Z_R0) { __ z_agr(Z_R1_scratch, Ridx); }
        z_emit_inst(masm, (LLGF_ZOPC /*secondary()*/) |
                    Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, isize) |
                    Assembler::uimm12(0, 20, isize) |
                    Assembler::reg(Z_R1_scratch, 12, isize) |
                    Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    }
  
#line 10151 "ad_s390.cpp"
  }
}

uint decodeLoadNNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= Z_DISP3_SIZE, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : Z_DISP3_SIZE);
}

void decodeLoadNKlassNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1855 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int isize = (LLGF_ZOPC /*secondary()*/) > 1L << 32 ? 48 : 32;
    Register Ridx = as_Register(opnd_array(1)->index(ra_,this,idx1));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.

    if (Displacement::is_shortDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (LLGF_ZOPC /*secondary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, isize) |
                  Assembler::uimm12(opnd_array(1)->disp(ra_,this,idx1), 20, isize) |
                  Assembler::reg(Ridx, 12, isize) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    } else if (Displacement::is_validDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (LLGF_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, 48) |
                  Assembler::simm20(opnd_array(1)->disp(ra_,this,idx1)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 48));
    } else {
        __ load_const_optimized(Z_R1_scratch, opnd_array(1)->disp(ra_,this,idx1));
        if (Ridx != Z_R0) { __ z_agr(Z_R1_scratch, Ridx); }
        z_emit_inst(masm, (LLGF_ZOPC /*secondary()*/) |
                    Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, isize) |
                    Assembler::uimm12(0, 20, isize) |
                    Assembler::reg(Z_R1_scratch, 12, isize) |
                    Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    }
  
#line 10194 "ad_s390.cpp"
  }
}

uint decodeLoadNKlassNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= Z_DISP3_SIZE, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : Z_DISP3_SIZE);
}

void decodeLoadConNKlassNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 4490 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    AddressLiteral NKlass = __ constant_metadata_address((Metadata*)opnd_array(1)->constant());
    __ relocate(NKlass.rspec(), 1);
    __ load_const(opnd_array(0)->as_Register(ra_,this)/* dst */, (Klass*)NKlass.value());
  
#line 10215 "ad_s390.cpp"
  }
}

uint decodeLoadConNKlassNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 12, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 12);
}

void decodeNNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 4508 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"
__ oop_decoder(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, true); 
#line 10232 "ad_s390.cpp"
  }
}

void decodeKlassNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 4518 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"
__ decode_klass_not_null(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */); 
#line 10244 "ad_s390.cpp"
  }
}

void decodeN_NNNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 4532 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"
__ oop_decoder(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, false); 
#line 10256 "ad_s390.cpp"
  }
}

void loadBaseNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// baseImm
  {

#line 4540 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"
__ get_oop_base(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->constantL()); 
#line 10268 "ad_s390.cpp"
  }
}

void decodeN_baseNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// base
  {

#line 4555 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

      __ oop_decoder(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, true, opnd_array(2)->as_Register(ra_,this,idx2)/* base */,
                     (jlong)MacroAssembler::get_oop_base_pow2_offset((uint64_t)(intptr_t)CompressedOops::base()));
    
#line 10284 "ad_s390.cpp"
  }
}

void decodeN_NN_baseNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// base
  {

#line 4569 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

      __ oop_decoder(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, false, opnd_array(2)->as_Register(ra_,this,idx2)/* base */,
                     (jlong)MacroAssembler::get_oop_base_pow2_offset((uint64_t)(intptr_t)CompressedOops::base()));
    
#line 10300 "ad_s390.cpp"
  }
}

void encodePNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 4619 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"
__ oop_encoder(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, true, Z_R1_scratch, -1, all_outs_are_Stores(this)); 
#line 10312 "ad_s390.cpp"
  }
}

void encodeKlassNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 4628 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"
__ encode_klass_not_null(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */); 
#line 10324 "ad_s390.cpp"
  }
}

void encodeP_NNNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 4642 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"
__ oop_encoder(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, false, Z_R1_scratch, -1, all_outs_are_Stores(this)); 
#line 10336 "ad_s390.cpp"
  }
}

void encodeP_baseNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// base
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {

#line 4654 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

      jlong offset = -(jlong)MacroAssembler::get_oop_base_pow2_offset
        (((uint64_t)(intptr_t)CompressedOops::base()) >> CompressedOops::shift());
      __ oop_encoder(opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, true, opnd_array(2)->as_Register(ra_,this,idx2)/* base */, offset);
    
#line 10354 "ad_s390.cpp"
  }
}

void encodeP_NN_baseNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// base
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// pow2_offset
  {

#line 4670 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"
__ oop_encoder(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, false, opnd_array(2)->as_Register(ra_,this,idx2)/* base */, opnd_array(3)->constantL()); 
#line 10368 "ad_s390.cpp"
  }
}

void storeNNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1855 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int isize = (ST_ZOPC /*secondary()*/) > 1L << 32 ? 48 : 32;
    Register Ridx = as_Register(opnd_array(1)->index(ra_,this,idx1));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.

    if (Displacement::is_shortDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (ST_ZOPC /*secondary()*/) |
                  Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* src */, 8, isize) |
                  Assembler::uimm12(opnd_array(1)->disp(ra_,this,idx1), 20, isize) |
                  Assembler::reg(Ridx, 12, isize) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    } else if (Displacement::is_validDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (STY_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* src */, 8, 48) |
                  Assembler::simm20(opnd_array(1)->disp(ra_,this,idx1)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 48));
    } else {
        __ load_const_optimized(Z_R1_scratch, opnd_array(1)->disp(ra_,this,idx1));
        if (Ridx != Z_R0) { __ z_agr(Z_R1_scratch, Ridx); }
        z_emit_inst(masm, (ST_ZOPC /*secondary()*/) |
                    Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* src */, 8, isize) |
                    Assembler::uimm12(0, 20, isize) |
                    Assembler::reg(Z_R1_scratch, 12, isize) |
                    Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    }
  
#line 10407 "ad_s390.cpp"
  }
}

uint storeNNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= Z_DISP_SIZE, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : Z_DISP_SIZE);
}

void storeNKlassNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1855 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int isize = (ST_ZOPC /*secondary()*/) > 1L << 32 ? 48 : 32;
    Register Ridx = as_Register(opnd_array(1)->index(ra_,this,idx1));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.

    if (Displacement::is_shortDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (ST_ZOPC /*secondary()*/) |
                  Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* src */, 8, isize) |
                  Assembler::uimm12(opnd_array(1)->disp(ra_,this,idx1), 20, isize) |
                  Assembler::reg(Ridx, 12, isize) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    } else if (Displacement::is_validDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (STY_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* src */, 8, 48) |
                  Assembler::simm20(opnd_array(1)->disp(ra_,this,idx1)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 48));
    } else {
        __ load_const_optimized(Z_R1_scratch, opnd_array(1)->disp(ra_,this,idx1));
        if (Ridx != Z_R0) { __ z_agr(Z_R1_scratch, Ridx); }
        z_emit_inst(masm, (ST_ZOPC /*secondary()*/) |
                    Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* src */, 8, isize) |
                    Assembler::uimm12(0, 20, isize) |
                    Assembler::reg(Z_R1_scratch, 12, isize) |
                    Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    }
  
#line 10451 "ad_s390.cpp"
  }
}

uint storeNKlassNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= Z_DISP_SIZE, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : Z_DISP_SIZE);
}

void compN_iRegNNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 1692 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((CLR_ZOPC /*primary()*/) >> 14) & 0x03) == 0, "Instruction format error");
    assert( ((CLR_ZOPC /*primary()*/) >> 16)         == 0, "Instruction format error");
    z_emit16(masm, (CLR_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src1 */,8,16) |
             Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* src2 */,12,16));
  
#line 10475 "ad_s390.cpp"
  }
}

uint compN_iRegNNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 2, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 2);
}

void compN_iRegN_immNNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 4756 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    AddressLiteral cOop = __ constant_oop_address((jobject)opnd_array(2)->constant());
    __ relocate(cOop.rspec(), 1);
    __ compare_immediate_narrow_oop(opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, (narrowOop)cOop.value());
  
#line 10497 "ad_s390.cpp"
  }
}

uint compN_iRegN_immNNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void compNKlass_iRegN_immNNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 4769 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    AddressLiteral NKlass = __ constant_metadata_address((Metadata*)opnd_array(2)->constant());
    __ relocate(NKlass.rspec(), 1);
    __ compare_immediate_narrow_klass(opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, (Klass*)NKlass.value());
  
#line 10519 "ad_s390.cpp"
  }
}

uint compNKlass_iRegN_immNNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void compN_iRegN_immN0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 1692 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((LTR_ZOPC /*primary()*/) >> 14) & 0x03) == 0, "Instruction format error");
    assert( ((LTR_ZOPC /*primary()*/) >> 16)         == 0, "Instruction format error");
    z_emit16(masm, (LTR_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src1 */,8,16) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src1 */,12,16));
  
#line 10543 "ad_s390.cpp"
  }
}

uint compN_iRegN_immN0Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 2, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 2);
}

void membar_acquireNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {

#line 4798 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"
__ z_acquire(); 
#line 10560 "ad_s390.cpp"
  }
}

uint membar_acquireNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void membar_acquire_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {

#line 4798 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"
__ z_acquire(); 
#line 10577 "ad_s390.cpp"
  }
}

uint membar_acquire_0Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void membar_acquire_lockNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  // User did not define which encode class to use.
}

uint membar_acquire_lockNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void membar_releaseNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {

#line 4817 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"
__ z_release(); 
#line 10606 "ad_s390.cpp"
  }
}

uint membar_releaseNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void membar_release_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {

#line 4817 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"
__ z_release(); 
#line 10623 "ad_s390.cpp"
  }
}

uint membar_release_0Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void membar_release_lockNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  // User did not define which encode class to use.
}

uint membar_release_lockNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void membar_volatileNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {

#line 4835 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"
__ z_fence(); 
#line 10652 "ad_s390.cpp"
  }
}

uint membar_volatileNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 2, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 2);
}

void unnecessary_membar_volatileNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  // User did not define which encode class to use.
}

uint unnecessary_membar_volatileNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void membar_CPUOrderNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  // User did not define which encode class to use.
}

void membar_storestoreNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  // User did not define which encode class to use.
}

uint membar_storestoreNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void membar_storestore_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  // User did not define which encode class to use.
}

uint membar_storestore_0Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void roundDouble_nopNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  // User did not define which encode class to use.
}

void roundFloat_nopNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  // User did not define which encode class to use.
}

void castX2PNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 4893 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"
__ lgr_if_needed(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */); 
#line 10726 "ad_s390.cpp"
  }
}

void castP2XNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 4902 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"
__ lgr_if_needed(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */); 
#line 10738 "ad_s390.cpp"
  }
}

void stfSSDNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1837 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Ridx = as_Register(opnd_array(0)->index(ra_,this,idx0));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.
    if ((STD_ZOPC /*primary()*/) > (1L<<32)) {
      z_emit_inst(masm, (STD_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src */, 8, 48) |
                  Assembler::simm20(opnd_array(0)->disp(ra_,this,0)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(0)->base(ra_,this,idx0)), 16, 48));
    } else {
      z_emit_inst(masm, (STD_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src */, 8, 32) |
                  Assembler::uimm12(opnd_array(0)->disp(ra_,this,0), 20, 32) |
                  Assembler::reg(Ridx, 12, 32) |
                  Assembler::regz(reg_to_register_object(opnd_array(0)->base(ra_,this,idx0)), 16, 32));
    }
  
#line 10766 "ad_s390.cpp"
  }
}

void stfSSFNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1837 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Ridx = as_Register(opnd_array(0)->index(ra_,this,idx0));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.
    if ((STE_ZOPC /*primary()*/) > (1L<<32)) {
      z_emit_inst(masm, (STE_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src */, 8, 48) |
                  Assembler::simm20(opnd_array(0)->disp(ra_,this,0)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(0)->base(ra_,this,idx0)), 16, 48));
    } else {
      z_emit_inst(masm, (STE_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src */, 8, 32) |
                  Assembler::uimm12(opnd_array(0)->disp(ra_,this,0), 20, 32) |
                  Assembler::reg(Ridx, 12, 32) |
                  Assembler::regz(reg_to_register_object(opnd_array(0)->base(ra_,this,idx0)), 16, 32));
    }
  
#line 10794 "ad_s390.cpp"
  }
}

void cmovN_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {

#line 2141 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Rdst = reg_to_register_object(opnd_array(3)->reg(ra_,this,idx3)/* dst */);
    Register Rsrc = reg_to_register_object(opnd_array(4)->reg(ra_,this,idx4)/* src */);

    // Don't emit code if operands are identical (same register).
    if (Rsrc != Rdst) {
      Assembler::branch_condition cc = (Assembler::branch_condition)opnd_array(1)->ccode();

      if (VM_Version::has_LoadStoreConditional()) {
        __ z_locgr(Rdst, Rsrc, cc);
      } else {
        // Branch if not (cmp cr).
        Label done;
        __ z_brc(Assembler::inverse_condition(cc), done);
        __ z_lgr(Rdst, Rsrc); // Used for int and long+ptr.
        __ bind(done);
      }
    }
  
#line 10827 "ad_s390.cpp"
  }
}

void cmovN_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {

#line 2161 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Rdst = reg_to_register_object(opnd_array(3)->reg(ra_,this,idx3)/* dst */);
    int      Csrc = opnd_array(4)->constant();
    Assembler::branch_condition cc = (Assembler::branch_condition)opnd_array(1)->ccode();
    Label done;
    // Branch if not (cmp cr).
    __ z_brc(Assembler::inverse_condition(cc), done);
    if (Csrc == 0) {
      // Don't set CC.
      __ clear_reg(Rdst, true, false);  // Use for int, long & ptr.
    } else {
      __ z_lghi(Rdst, Csrc); // Use for int, long & ptr.
    }
    __ bind(done);
  
#line 10856 "ad_s390.cpp"
  }
}

void cmovI_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {

#line 2141 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Rdst = reg_to_register_object(opnd_array(3)->reg(ra_,this,idx3)/* dst */);
    Register Rsrc = reg_to_register_object(opnd_array(4)->reg(ra_,this,idx4)/* src */);

    // Don't emit code if operands are identical (same register).
    if (Rsrc != Rdst) {
      Assembler::branch_condition cc = (Assembler::branch_condition)opnd_array(1)->ccode();

      if (VM_Version::has_LoadStoreConditional()) {
        __ z_locgr(Rdst, Rsrc, cc);
      } else {
        // Branch if not (cmp cr).
        Label done;
        __ z_brc(Assembler::inverse_condition(cc), done);
        __ z_lgr(Rdst, Rsrc); // Used for int and long+ptr.
        __ bind(done);
      }
    }
  
#line 10889 "ad_s390.cpp"
  }
}

void cmovI_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {

#line 2161 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Rdst = reg_to_register_object(opnd_array(3)->reg(ra_,this,idx3)/* dst */);
    int      Csrc = opnd_array(4)->constant();
    Assembler::branch_condition cc = (Assembler::branch_condition)opnd_array(1)->ccode();
    Label done;
    // Branch if not (cmp cr).
    __ z_brc(Assembler::inverse_condition(cc), done);
    if (Csrc == 0) {
      // Don't set CC.
      __ clear_reg(Rdst, true, false);  // Use for int, long & ptr.
    } else {
      __ z_lghi(Rdst, Csrc); // Use for int, long & ptr.
    }
    __ bind(done);
  
#line 10918 "ad_s390.cpp"
  }
}

void cmovP_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {

#line 2141 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Rdst = reg_to_register_object(opnd_array(3)->reg(ra_,this,idx3)/* dst */);
    Register Rsrc = reg_to_register_object(opnd_array(4)->reg(ra_,this,idx4)/* src */);

    // Don't emit code if operands are identical (same register).
    if (Rsrc != Rdst) {
      Assembler::branch_condition cc = (Assembler::branch_condition)opnd_array(1)->ccode();

      if (VM_Version::has_LoadStoreConditional()) {
        __ z_locgr(Rdst, Rsrc, cc);
      } else {
        // Branch if not (cmp cr).
        Label done;
        __ z_brc(Assembler::inverse_condition(cc), done);
        __ z_lgr(Rdst, Rsrc); // Used for int and long+ptr.
        __ bind(done);
      }
    }
  
#line 10951 "ad_s390.cpp"
  }
}

void cmovP_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {

#line 2161 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Rdst = reg_to_register_object(opnd_array(3)->reg(ra_,this,idx3)/* dst */);
    int      Csrc = opnd_array(4)->constant();
    Assembler::branch_condition cc = (Assembler::branch_condition)opnd_array(1)->ccode();
    Label done;
    // Branch if not (cmp cr).
    __ z_brc(Assembler::inverse_condition(cc), done);
    if (Csrc == 0) {
      // Don't set CC.
      __ clear_reg(Rdst, true, false);  // Use for int, long & ptr.
    } else {
      __ z_lghi(Rdst, Csrc); // Use for int, long & ptr.
    }
    __ bind(done);
  
#line 10980 "ad_s390.cpp"
  }
}

void cmovF_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {

#line 4989 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    // Don't emit code if operands are identical (same register).
    if (opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */!= opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* src */) {
      Label done;
      __ z_brc(Assembler::inverse_float_condition((Assembler::branch_condition)opnd_array(1)->ccode()), done);
      __ z_ler(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* src */);
      __ bind(done);
    }
  
#line 11003 "ad_s390.cpp"
  }
}

void cmovD_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {

#line 5006 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    // Don't emit code if operands are identical (same register).
    if (opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */!= opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* src */) {
      Label done;
      __ z_brc(Assembler::inverse_float_condition((Assembler::branch_condition)opnd_array(1)->ccode()), done);
      __ z_ldr(opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_FloatRegister(ra_,this,idx4)/* src */);
      __ bind(done);
    }
  
#line 11026 "ad_s390.cpp"
  }
}

void cmovL_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {

#line 2141 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Rdst = reg_to_register_object(opnd_array(3)->reg(ra_,this,idx3)/* dst */);
    Register Rsrc = reg_to_register_object(opnd_array(4)->reg(ra_,this,idx4)/* src */);

    // Don't emit code if operands are identical (same register).
    if (Rsrc != Rdst) {
      Assembler::branch_condition cc = (Assembler::branch_condition)opnd_array(1)->ccode();

      if (VM_Version::has_LoadStoreConditional()) {
        __ z_locgr(Rdst, Rsrc, cc);
      } else {
        // Branch if not (cmp cr).
        Label done;
        __ z_brc(Assembler::inverse_condition(cc), done);
        __ z_lgr(Rdst, Rsrc); // Used for int and long+ptr.
        __ bind(done);
      }
    }
  
#line 11059 "ad_s390.cpp"
  }
}

void cmovL_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {

#line 2161 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Rdst = reg_to_register_object(opnd_array(3)->reg(ra_,this,idx3)/* dst */);
    int      Csrc = opnd_array(4)->constantL();
    Assembler::branch_condition cc = (Assembler::branch_condition)opnd_array(1)->ccode();
    Label done;
    // Branch if not (cmp cr).
    __ z_brc(Assembler::inverse_condition(cc), done);
    if (Csrc == 0) {
      // Don't set CC.
      __ clear_reg(Rdst, true, false);  // Use for int, long & ptr.
    } else {
      __ z_lghi(Rdst, Csrc); // Use for int, long & ptr.
    }
    __ bind(done);
  
#line 11088 "ad_s390.cpp"
  }
}

void tlsLoadPNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  // User did not define which encode class to use.
}

uint tlsLoadPNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void checkCastPPNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  // User did not define which encode class to use.
}

uint checkCastPPNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void castPPNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  // User did not define which encode class to use.
}

uint castPPNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void castIINode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  // User did not define which encode class to use.
}

uint castIINode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void castLLNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  // User did not define which encode class to use.
}

uint castLLNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void castFFNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  // User did not define which encode class to use.
}

uint castFFNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void castDDNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  // User did not define which encode class to use.
}

uint castDDNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void castVVNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  // User did not define which encode class to use.
}

uint castVVNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void compareAndSwapI_boolNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem_ptr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 2193 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Rcomp = reg_to_register_object(opnd_array(2)->reg(ra_,this,idx2)/* oldval */);
    Register Rnew  = reg_to_register_object(opnd_array(3)->reg(ra_,this,idx3)/* newval */);
    Register Raddr = reg_to_register_object(opnd_array(1)->reg(ra_,this,idx1)/* mem_ptr */);

    __ z_cs(Rcomp, Rnew, 0, Raddr);
  
#line 11204 "ad_s390.cpp"
  }
  {

#line 2177 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Rres = reg_to_register_object(opnd_array(0)->reg(ra_,this)/* res */);

    if (VM_Version::has_LoadStoreConditional()) {
      __ load_const_optimized(Z_R0_scratch, 0L); // false (failed)
      __ load_const_optimized(Rres, 1L);         // true  (succeed)
      __ z_locgr(Rres, Z_R0_scratch, Assembler::bcondNotEqual);
    } else {
      Label done;
      __ load_const_optimized(Rres, 0L); // false (failed)
      __ z_brne(done);                   // Assume true to be the common case.
      __ load_const_optimized(Rres, 1L); // true  (succeed)
      __ bind(done);
    }
  
#line 11224 "ad_s390.cpp"
  }
}

uint compareAndSwapI_boolNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 16, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 16);
}

void compareAndSwapL_boolNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem_ptr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 2201 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Rcomp = reg_to_register_object(opnd_array(2)->reg(ra_,this,idx2)/* oldval */);
    Register Rnew  = reg_to_register_object(opnd_array(3)->reg(ra_,this,idx3)/* newval */);
    Register Raddr = reg_to_register_object(opnd_array(1)->reg(ra_,this,idx1)/* mem_ptr */);

    __ z_csg(Rcomp, Rnew, 0, Raddr);
  
#line 11249 "ad_s390.cpp"
  }
  {

#line 2177 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Rres = reg_to_register_object(opnd_array(0)->reg(ra_,this)/* res */);

    if (VM_Version::has_LoadStoreConditional()) {
      __ load_const_optimized(Z_R0_scratch, 0L); // false (failed)
      __ load_const_optimized(Rres, 1L);         // true  (succeed)
      __ z_locgr(Rres, Z_R0_scratch, Assembler::bcondNotEqual);
    } else {
      Label done;
      __ load_const_optimized(Rres, 0L); // false (failed)
      __ z_brne(done);                   // Assume true to be the common case.
      __ load_const_optimized(Rres, 1L); // true  (succeed)
      __ bind(done);
    }
  
#line 11269 "ad_s390.cpp"
  }
}

uint compareAndSwapL_boolNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 18, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 18);
}

void compareAndSwapP_boolNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem_ptr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 2201 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Rcomp = reg_to_register_object(opnd_array(2)->reg(ra_,this,idx2)/* oldval */);
    Register Rnew  = reg_to_register_object(opnd_array(3)->reg(ra_,this,idx3)/* newval */);
    Register Raddr = reg_to_register_object(opnd_array(1)->reg(ra_,this,idx1)/* mem_ptr */);

    __ z_csg(Rcomp, Rnew, 0, Raddr);
  
#line 11294 "ad_s390.cpp"
  }
  {

#line 2177 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Rres = reg_to_register_object(opnd_array(0)->reg(ra_,this)/* res */);

    if (VM_Version::has_LoadStoreConditional()) {
      __ load_const_optimized(Z_R0_scratch, 0L); // false (failed)
      __ load_const_optimized(Rres, 1L);         // true  (succeed)
      __ z_locgr(Rres, Z_R0_scratch, Assembler::bcondNotEqual);
    } else {
      Label done;
      __ load_const_optimized(Rres, 0L); // false (failed)
      __ z_brne(done);                   // Assume true to be the common case.
      __ load_const_optimized(Rres, 1L); // true  (succeed)
      __ bind(done);
    }
  
#line 11314 "ad_s390.cpp"
  }
}

uint compareAndSwapP_boolNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 18, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 18);
}

void compareAndSwapN_boolNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem_ptr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 2193 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Rcomp = reg_to_register_object(opnd_array(2)->reg(ra_,this,idx2)/* oldval */);
    Register Rnew  = reg_to_register_object(opnd_array(3)->reg(ra_,this,idx3)/* newval */);
    Register Raddr = reg_to_register_object(opnd_array(1)->reg(ra_,this,idx1)/* mem_ptr */);

    __ z_cs(Rcomp, Rnew, 0, Raddr);
  
#line 11339 "ad_s390.cpp"
  }
  {

#line 2177 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Rres = reg_to_register_object(opnd_array(0)->reg(ra_,this)/* res */);

    if (VM_Version::has_LoadStoreConditional()) {
      __ load_const_optimized(Z_R0_scratch, 0L); // false (failed)
      __ load_const_optimized(Rres, 1L);         // true  (succeed)
      __ z_locgr(Rres, Z_R0_scratch, Assembler::bcondNotEqual);
    } else {
      Label done;
      __ load_const_optimized(Rres, 0L); // false (failed)
      __ z_brne(done);                   // Assume true to be the common case.
      __ load_const_optimized(Rres, 1L); // true  (succeed)
      __ bind(done);
    }
  
#line 11359 "ad_s390.cpp"
  }
}

uint compareAndSwapN_boolNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 16, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 16);
}

void addI_mem_imm8_atomic_no_resNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1799 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int      disp = opnd_array(1)->disp(ra_,this,idx1);
    Register base = reg_to_register_object(opnd_array(1)->base(ra_,this,idx1));
    int      con  = opnd_array(2)->constant();

    assert(VM_Version::has_MemWithImmALUOps(), "unsupported CPU");
    z_emit_inst(masm, (ASI_ZOPC /*primary()*/) |
                Assembler::regz(base,16,48) |
                Assembler::simm20(disp) |
                Assembler::simm8(con,8,48));
  
#line 11387 "ad_s390.cpp"
  }
}

uint addI_mem_imm8_atomic_no_resNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void addI_mem_imm16_atomicNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {

#line 5183 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Rdst = opnd_array(3)->as_Register(ra_,this,idx3)/* dst */;
    Register Rtmp = opnd_array(4)->as_Register(ra_,this,idx4)/* tmp */;
    int      Isrc = opnd_array(2)->constant();
    Label    retry;

    // Iterate until update with incremented value succeeds.
    __ z_lgf(Rdst, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));    // current contents
    __ bind(retry);
      // Calculate incremented value.
      if (VM_Version::has_DistinctOpnds()) {
        __ z_ahik(Rtmp, Rdst, Isrc);
      } else {
        __ z_lr(Rtmp, Rdst);
        __ z_ahi(Rtmp, Isrc);
      }
      // Swap into memory location.
      __ z_csy(Rdst, Rtmp, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc())); // Try to store new value.
    __ z_brne(retry);                      // Yikes, concurrent update, need to retry.
  
#line 11426 "ad_s390.cpp"
  }
}

void addI_mem_imm32_atomicNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {

#line 5218 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Rdst = opnd_array(3)->as_Register(ra_,this,idx3)/* dst */;
    Register Rtmp = opnd_array(4)->as_Register(ra_,this,idx4)/* tmp */;
    int      Isrc = opnd_array(2)->constant();
    Label    retry;

    // Iterate until update with incremented value succeeds.
    __ z_lgf(Rdst, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));    // current contents
    __ bind(retry);
      // Calculate incremented value.
      __ z_lr(Rtmp, Rdst);
      __ z_afi(Rtmp, Isrc);
      // Swap into memory location.
      __ z_csy(Rdst, Rtmp, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc())); // Try to store new value.
    __ z_brne(retry);                      // Yikes, concurrent update, need to retry.
  
#line 11456 "ad_s390.cpp"
  }
}

void addI_mem_reg_atomicNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {

#line 5248 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Rsrc = opnd_array(2)->as_Register(ra_,this,idx2)/* src */;
    Register Rdst = opnd_array(3)->as_Register(ra_,this,idx3)/* dst */;
    Register Rtmp = opnd_array(4)->as_Register(ra_,this,idx4)/* tmp */;
    Label    retry;

    // Iterate until update with incremented value succeeds.
    __ z_lgf(Rdst, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));  // current contents
    __ bind(retry);
      // Calculate incremented value.
      if (VM_Version::has_DistinctOpnds()) {
        __ z_ark(Rtmp, Rdst, Rsrc);
      } else {
        __ z_lr(Rtmp, Rdst);
        __ z_ar(Rtmp, Rsrc);
      }
      __ z_csy(Rdst, Rtmp, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc())); // Try to store new value.
    __ z_brne(retry);                      // Yikes, concurrent update, need to retry.
  
#line 11489 "ad_s390.cpp"
  }
}

void addL_mem_imm8_atomic_no_resNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1799 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int      disp = opnd_array(1)->disp(ra_,this,idx1);
    Register base = reg_to_register_object(opnd_array(1)->base(ra_,this,idx1));
    int      con  = opnd_array(2)->constantL();

    assert(VM_Version::has_MemWithImmALUOps(), "unsupported CPU");
    z_emit_inst(masm, (AGSI_ZOPC /*primary()*/) |
                Assembler::regz(base,16,48) |
                Assembler::simm20(disp) |
                Assembler::simm8(con,8,48));
  
#line 11512 "ad_s390.cpp"
  }
}

uint addL_mem_imm8_atomic_no_resNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void addL_mem_imm16_atomicNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {

#line 5303 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Rdst = opnd_array(3)->as_Register(ra_,this,idx3)/* dst */;
    Register Rtmp = opnd_array(4)->as_Register(ra_,this,idx4)/* tmp */;
    int      Isrc = opnd_array(2)->constantL();
    Label    retry;

    // Iterate until update with incremented value succeeds.
    __ z_lg(Rdst, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));  // current contents
    __ bind(retry);
      // Calculate incremented value.
      if (VM_Version::has_DistinctOpnds()) {
        __ z_aghik(Rtmp, Rdst, Isrc);
      } else {
        __ z_lgr(Rtmp, Rdst);
        __ z_aghi(Rtmp, Isrc);
      }
      __ z_csg(Rdst, Rtmp, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc())); // Try to store new value.
    __ z_brne(retry);                      // Yikes, concurrent update, need to retry.
  
#line 11550 "ad_s390.cpp"
  }
}

void addL_mem_imm32_atomicNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {

#line 5337 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Rdst = opnd_array(3)->as_Register(ra_,this,idx3)/* dst */;
    Register Rtmp = opnd_array(4)->as_Register(ra_,this,idx4)/* tmp */;
    int      Isrc = opnd_array(2)->constantL();
    Label    retry;

    // Iterate until update with incremented value succeeds.
    __ z_lg(Rdst, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));  // current contents
    __ bind(retry);
      // Calculate incremented value.
      __ z_lgr(Rtmp, Rdst);
      __ z_agfi(Rtmp, Isrc);
      __ z_csg(Rdst, Rtmp, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc())); // Try to store new value.
    __ z_brne(retry);                      // Yikes, concurrent update, need to retry.
  
#line 11579 "ad_s390.cpp"
  }
}

void addL_mem_reg_atomicNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {

#line 5366 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Rsrc = opnd_array(2)->as_Register(ra_,this,idx2)/* src */;
    Register Rdst = opnd_array(3)->as_Register(ra_,this,idx3)/* dst */;
    Register Rtmp = opnd_array(4)->as_Register(ra_,this,idx4)/* tmp */;
    Label    retry;

    // Iterate until update with incremented value succeeds.
    __ z_lg(Rdst, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));  // current contents
    __ bind(retry);
      // Calculate incremented value.
      if (VM_Version::has_DistinctOpnds()) {
        __ z_agrk(Rtmp, Rdst, Rsrc);
      } else {
        __ z_lgr(Rtmp, Rdst);
        __ z_agr(Rtmp, Rsrc);
      }
      __ z_csg(Rdst, Rtmp, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc())); // Try to store new value.
    __ z_brne(retry);                      // Yikes, concurrent update, need to retry.
  
#line 11612 "ad_s390.cpp"
  }
}

void addI_mem_reg_atomic_z196Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 5395 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"
__ z_laa(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(2)->as_Register(ra_,this,idx2)/* src */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc())); 
#line 11625 "ad_s390.cpp"
  }
}

uint addI_mem_reg_atomic_z196Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void addL_mem_reg_atomic_z196Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 5406 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"
__ z_laag(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(2)->as_Register(ra_,this,idx2)/* src */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc())); 
#line 11643 "ad_s390.cpp"
  }
}

uint addL_mem_reg_atomic_z196Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void xchgI_reg_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {

#line 2209 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Rdst = reg_to_register_object(opnd_array(2)->reg(ra_,this,idx2)/* dst */);
    Register Rtmp = reg_to_register_object(opnd_array(3)->reg(ra_,this,idx3)/* tmp */);
    guarantee(Rdst != Rtmp, "Fix match rule to use TEMP_DEF");
    Label    retry;

    // Iterate until swap succeeds.
    __ z_llgf(Rtmp, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));  // current contents
    __ bind(retry);
      // Calculate incremented value.
      __ z_csy(Rtmp, Rdst, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc())); // Try to store new value.
      __ z_brne(retry);                    // Yikes, concurrent update, need to retry.
    __ z_lgr(Rdst, Rtmp);                  // Exchanged value from memory is return value.
  
#line 11675 "ad_s390.cpp"
  }
}

void xchgL_reg_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {

#line 2224 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Rdst = reg_to_register_object(opnd_array(2)->reg(ra_,this,idx2)/* dst */);
    Register Rtmp = reg_to_register_object(opnd_array(3)->reg(ra_,this,idx3)/* tmp */);
    guarantee(Rdst != Rtmp, "Fix match rule to use TEMP_DEF");
    Label    retry;

    // Iterate until swap succeeds.
    __ z_lg(Rtmp, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));  // current contents
    __ bind(retry);
      // Calculate incremented value.
      __ z_csg(Rtmp, Rdst, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc())); // Try to store new value.
      __ z_brne(retry);                    // Yikes, concurrent update, need to retry.
    __ z_lgr(Rdst, Rtmp);                  // Exchanged value from memory is return value.
  
#line 11702 "ad_s390.cpp"
  }
}

void xchgN_reg_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {

#line 2209 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Rdst = reg_to_register_object(opnd_array(2)->reg(ra_,this,idx2)/* dst */);
    Register Rtmp = reg_to_register_object(opnd_array(3)->reg(ra_,this,idx3)/* tmp */);
    guarantee(Rdst != Rtmp, "Fix match rule to use TEMP_DEF");
    Label    retry;

    // Iterate until swap succeeds.
    __ z_llgf(Rtmp, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));  // current contents
    __ bind(retry);
      // Calculate incremented value.
      __ z_csy(Rtmp, Rdst, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc())); // Try to store new value.
      __ z_brne(retry);                    // Yikes, concurrent update, need to retry.
    __ z_lgr(Rdst, Rtmp);                  // Exchanged value from memory is return value.
  
#line 11729 "ad_s390.cpp"
  }
}

void xchgP_reg_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {

#line 2224 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Rdst = reg_to_register_object(opnd_array(2)->reg(ra_,this,idx2)/* dst */);
    Register Rtmp = reg_to_register_object(opnd_array(3)->reg(ra_,this,idx3)/* tmp */);
    guarantee(Rdst != Rtmp, "Fix match rule to use TEMP_DEF");
    Label    retry;

    // Iterate until swap succeeds.
    __ z_lg(Rtmp, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));  // current contents
    __ bind(retry);
      // Calculate incremented value.
      __ z_csg(Rtmp, Rdst, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc())); // Try to store new value.
      __ z_brne(retry);                    // Yikes, concurrent update, need to retry.
    __ z_lgr(Rdst, Rtmp);                  // Exchanged value from memory is return value.
  
#line 11756 "ad_s390.cpp"
  }
}

void addI_reg_reg_CISCNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1692 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((AR_ZOPC /*primary()*/) >> 14) & 0x03) == 0, "Instruction format error");
    assert( ((AR_ZOPC /*primary()*/) >> 16)         == 0, "Instruction format error");
    z_emit16(masm, (AR_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */,8,16) |
             Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* src */,12,16));
  
#line 11775 "ad_s390.cpp"
  }
}

void addI_reg_reg_RISCNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 1707 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((ARK_ZOPC /*primary()*/) >> 30) & 0x03) == 2, "Instruction format error");
    z_emit32(masm, (ARK_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */,24,32) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src1 */,28,32) |
             Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* src2 */,16,32));
  
#line 11794 "ad_s390.cpp"
  }
}

uint addI_reg_reg_RISCNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void addI_reg_imm16_CISCNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {

#line 1715 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((AHI_ZOPC /*primary()*/)>>30) & 0x03) == 2, "Instruction format error");
    z_emit32(masm, (AHI_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */,8,32) |
             Assembler::simm16(opnd_array(2)->constant(),16,32));
  
#line 11817 "ad_s390.cpp"
  }
}

void addI_reg_imm16_RISCNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {

#line 1729 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((AHIK_ZOPC /*primary()*/)>>46) & 0x03) == 3, "Instruction format error");
    z_emit48(masm, (AHIK_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */,8,48) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src */,12,48) |
             Assembler::simm16(opnd_array(2)->constant(),16,48));
  
#line 11836 "ad_s390.cpp"
  }
}

void addI_reg_imm32Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1737 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((AFI_ZOPC /*primary()*/)>>46) & 0x03) == 3, "Instruction format error");
    z_emit48(masm, (AFI_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */,8,48) |
             Assembler::simm32(opnd_array(2)->constant(),16,48));
  
#line 11854 "ad_s390.cpp"
  }
}

uint addI_reg_imm32Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void addI_reg_imm12Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {

#line 1775 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((LA_ZOPC /*primary()*/)>>30) & 0x03) == 1, "Instruction format error");
    z_emit32(masm, (LA_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */,8,32) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src */,16,32) |
             Assembler::uimm12(opnd_array(2)->constant(),20,32));
  
#line 11878 "ad_s390.cpp"
  }
}

uint addI_reg_imm12Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void addI_reg_imm20Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {

#line 1791 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    z_emit48(masm, (LAY_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */,8,48) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src */,16,48) |
             Assembler::simm20(opnd_array(2)->constant()));
  
#line 11901 "ad_s390.cpp"
  }
}

uint addI_reg_imm20Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void addI_reg_reg_imm12Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// con
  {

#line 1766 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((LA_ZOPC /*primary()*/)>>30) & 0x03) == 1, "Instruction format error");
    z_emit32(masm, (LA_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */,8,32) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src1 */,12,32) |
             Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* src2 */,16,32) |
             Assembler::uimm12(opnd_array(3)->constant(),20,32));
  
#line 11927 "ad_s390.cpp"
  }
}

uint addI_reg_reg_imm12Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void addI_reg_reg_imm20Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// con
  {

#line 1783 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    z_emit48(masm, (LAY_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */,8,48) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src1 */,12,48) |
             Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* src2 */,16,48) |
             Assembler::simm20(opnd_array(3)->constant()));
  
#line 11952 "ad_s390.cpp"
  }
}

uint addI_reg_reg_imm20Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void addI_Reg_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1855 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int isize = (A_ZOPC /*secondary()*/) > 1L << 32 ? 48 : 32;
    Register Ridx = as_Register(opnd_array(2)->index(ra_,this,idx2));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.

    if (Displacement::is_shortDisp((long)opnd_array(2)->disp(ra_,this,idx2))) {
      z_emit_inst(masm, (A_ZOPC /*secondary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */, 8, isize) |
                  Assembler::uimm12(opnd_array(2)->disp(ra_,this,idx2), 20, isize) |
                  Assembler::reg(Ridx, 12, isize) |
                  Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, isize));
    } else if (Displacement::is_validDisp((long)opnd_array(2)->disp(ra_,this,idx2))) {
      z_emit_inst(masm, (AY_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */, 8, 48) |
                  Assembler::simm20(opnd_array(2)->disp(ra_,this,idx2)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, 48));
    } else {
        __ load_const_optimized(Z_R1_scratch, opnd_array(2)->disp(ra_,this,idx2));
        if (Ridx != Z_R0) { __ z_agr(Z_R1_scratch, Ridx); }
        z_emit_inst(masm, (A_ZOPC /*secondary()*/) |
                    Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */, 8, isize) |
                    Assembler::uimm12(0, 20, isize) |
                    Assembler::reg(Z_R1_scratch, 12, isize) |
                    Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, isize));
    }
  
#line 11996 "ad_s390.cpp"
  }
}

void addI_Reg_mem_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {

#line 1855 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int isize = (A_ZOPC /*secondary()*/) > 1L << 32 ? 48 : 32;
    Register Ridx = as_Register(opnd_array(1)->index(ra_,this,idx1));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.

    if (Displacement::is_shortDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (A_ZOPC /*secondary()*/) |
                  Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* dst */, 8, isize) |
                  Assembler::uimm12(opnd_array(1)->disp(ra_,this,idx1), 20, isize) |
                  Assembler::reg(Ridx, 12, isize) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    } else if (Displacement::is_validDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (AY_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* dst */, 8, 48) |
                  Assembler::simm20(opnd_array(1)->disp(ra_,this,idx1)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 48));
    } else {
        __ load_const_optimized(Z_R1_scratch, opnd_array(1)->disp(ra_,this,idx1));
        if (Ridx != Z_R0) { __ z_agr(Z_R1_scratch, Ridx); }
        z_emit_inst(masm, (A_ZOPC /*secondary()*/) |
                    Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* dst */, 8, isize) |
                    Assembler::uimm12(0, 20, isize) |
                    Assembler::reg(Z_R1_scratch, 12, isize) |
                    Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    }
  
#line 12035 "ad_s390.cpp"
  }
}

void addI_mem_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1799 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int      disp = opnd_array(1)->disp(ra_,this,idx1);
    Register base = reg_to_register_object(opnd_array(1)->base(ra_,this,idx1));
    int      con  = opnd_array(2)->constant();

    assert(VM_Version::has_MemWithImmALUOps(), "unsupported CPU");
    z_emit_inst(masm, (ASI_ZOPC /*primary()*/) |
                Assembler::regz(base,16,48) |
                Assembler::simm20(disp) |
                Assembler::simm8(con,8,48));
  
#line 12058 "ad_s390.cpp"
  }
}

uint addI_mem_immNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void addL_reg_regINode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1700 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((AGFR_ZOPC /*primary()*/) >> 30) & 0x03) == 2, "Instruction format error");
    z_emit32(masm, (AGFR_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */,24,32) |
             Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* src */,28,32));
  
#line 12081 "ad_s390.cpp"
  }
}

uint addL_reg_regINode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void addL_reg_regI_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {

#line 1700 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((AGFR_ZOPC /*primary()*/) >> 30) & 0x03) == 2, "Instruction format error");
    z_emit32(masm, (AGFR_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* dst */,24,32) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src */,28,32));
  
#line 12104 "ad_s390.cpp"
  }
}

uint addL_reg_regI_0Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void addL_reg_reg_CISCNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1700 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((AGR_ZOPC /*primary()*/) >> 30) & 0x03) == 2, "Instruction format error");
    z_emit32(masm, (AGR_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */,24,32) |
             Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* src */,28,32));
  
#line 12127 "ad_s390.cpp"
  }
}

void addL_reg_reg_RISCNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 1707 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((AGRK_ZOPC /*primary()*/) >> 30) & 0x03) == 2, "Instruction format error");
    z_emit32(masm, (AGRK_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */,24,32) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src1 */,28,32) |
             Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* src2 */,16,32));
  
#line 12146 "ad_s390.cpp"
  }
}

uint addL_reg_reg_RISCNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void addL_reg_imm12Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {

#line 1775 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((LA_ZOPC /*primary()*/)>>30) & 0x03) == 1, "Instruction format error");
    z_emit32(masm, (LA_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */,8,32) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src */,16,32) |
             Assembler::uimm12(opnd_array(2)->constantL(),20,32));
  
#line 12170 "ad_s390.cpp"
  }
}

uint addL_reg_imm12Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void addL_reg_imm20Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {

#line 1791 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    z_emit48(masm, (LAY_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */,8,48) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src */,16,48) |
             Assembler::simm20(opnd_array(2)->constantL()));
  
#line 12193 "ad_s390.cpp"
  }
}

uint addL_reg_imm20Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void addL_reg_imm32Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {

#line 1737 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((AGFI_ZOPC /*primary()*/)>>46) & 0x03) == 3, "Instruction format error");
    z_emit48(masm, (AGFI_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */,8,48) |
             Assembler::simm32(opnd_array(2)->constantL(),16,48));
  
#line 12216 "ad_s390.cpp"
  }
}

uint addL_reg_imm32Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void addL_reg_imm16_CISCNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {

#line 1715 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((AGHI_ZOPC /*primary()*/)>>30) & 0x03) == 2, "Instruction format error");
    z_emit32(masm, (AGHI_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */,8,32) |
             Assembler::simm16(opnd_array(2)->constantL(),16,32));
  
#line 12239 "ad_s390.cpp"
  }
}

void addL_reg_imm16_RISCNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {

#line 1729 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((AGHIK_ZOPC /*primary()*/)>>46) & 0x03) == 3, "Instruction format error");
    z_emit48(masm, (AGHIK_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */,8,48) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src */,12,48) |
             Assembler::simm16(opnd_array(2)->constantL(),16,48));
  
#line 12258 "ad_s390.cpp"
  }
}

uint addL_reg_imm16_RISCNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void addL_Reg_memINode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1855 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int isize = (AGF_ZOPC /*secondary()*/) > 1L << 32 ? 48 : 32;
    Register Ridx = as_Register(opnd_array(2)->index(ra_,this,idx2));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.

    if (Displacement::is_shortDisp((long)opnd_array(2)->disp(ra_,this,idx2))) {
      z_emit_inst(masm, (AGF_ZOPC /*secondary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */, 8, isize) |
                  Assembler::uimm12(opnd_array(2)->disp(ra_,this,idx2), 20, isize) |
                  Assembler::reg(Ridx, 12, isize) |
                  Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, isize));
    } else if (Displacement::is_validDisp((long)opnd_array(2)->disp(ra_,this,idx2))) {
      z_emit_inst(masm, (AGF_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */, 8, 48) |
                  Assembler::simm20(opnd_array(2)->disp(ra_,this,idx2)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, 48));
    } else {
        __ load_const_optimized(Z_R1_scratch, opnd_array(2)->disp(ra_,this,idx2));
        if (Ridx != Z_R0) { __ z_agr(Z_R1_scratch, Ridx); }
        z_emit_inst(masm, (AGF_ZOPC /*secondary()*/) |
                    Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */, 8, isize) |
                    Assembler::uimm12(0, 20, isize) |
                    Assembler::reg(Z_R1_scratch, 12, isize) |
                    Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, isize));
    }
  
#line 12302 "ad_s390.cpp"
  }
}

uint addL_Reg_memINode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= Z_DISP3_SIZE, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : Z_DISP3_SIZE);
}

void addL_Reg_memI_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {

#line 1855 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int isize = (AGF_ZOPC /*secondary()*/) > 1L << 32 ? 48 : 32;
    Register Ridx = as_Register(opnd_array(1)->index(ra_,this,idx1));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.

    if (Displacement::is_shortDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (AGF_ZOPC /*secondary()*/) |
                  Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* dst */, 8, isize) |
                  Assembler::uimm12(opnd_array(1)->disp(ra_,this,idx1), 20, isize) |
                  Assembler::reg(Ridx, 12, isize) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    } else if (Displacement::is_validDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (AGF_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* dst */, 8, 48) |
                  Assembler::simm20(opnd_array(1)->disp(ra_,this,idx1)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 48));
    } else {
        __ load_const_optimized(Z_R1_scratch, opnd_array(1)->disp(ra_,this,idx1));
        if (Ridx != Z_R0) { __ z_agr(Z_R1_scratch, Ridx); }
        z_emit_inst(masm, (AGF_ZOPC /*secondary()*/) |
                    Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* dst */, 8, isize) |
                    Assembler::uimm12(0, 20, isize) |
                    Assembler::reg(Z_R1_scratch, 12, isize) |
                    Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    }
  
#line 12346 "ad_s390.cpp"
  }
}

uint addL_Reg_memI_0Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= Z_DISP3_SIZE, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : Z_DISP3_SIZE);
}

void addL_Reg_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1855 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int isize = (AG_ZOPC /*secondary()*/) > 1L << 32 ? 48 : 32;
    Register Ridx = as_Register(opnd_array(2)->index(ra_,this,idx2));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.

    if (Displacement::is_shortDisp((long)opnd_array(2)->disp(ra_,this,idx2))) {
      z_emit_inst(masm, (AG_ZOPC /*secondary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */, 8, isize) |
                  Assembler::uimm12(opnd_array(2)->disp(ra_,this,idx2), 20, isize) |
                  Assembler::reg(Ridx, 12, isize) |
                  Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, isize));
    } else if (Displacement::is_validDisp((long)opnd_array(2)->disp(ra_,this,idx2))) {
      z_emit_inst(masm, (AG_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */, 8, 48) |
                  Assembler::simm20(opnd_array(2)->disp(ra_,this,idx2)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, 48));
    } else {
        __ load_const_optimized(Z_R1_scratch, opnd_array(2)->disp(ra_,this,idx2));
        if (Ridx != Z_R0) { __ z_agr(Z_R1_scratch, Ridx); }
        z_emit_inst(masm, (AG_ZOPC /*secondary()*/) |
                    Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */, 8, isize) |
                    Assembler::uimm12(0, 20, isize) |
                    Assembler::reg(Z_R1_scratch, 12, isize) |
                    Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, isize));
    }
  
#line 12390 "ad_s390.cpp"
  }
}

uint addL_Reg_memNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= Z_DISP3_SIZE, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : Z_DISP3_SIZE);
}

void addL_Reg_mem_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {

#line 1855 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int isize = (AG_ZOPC /*secondary()*/) > 1L << 32 ? 48 : 32;
    Register Ridx = as_Register(opnd_array(1)->index(ra_,this,idx1));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.

    if (Displacement::is_shortDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (AG_ZOPC /*secondary()*/) |
                  Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* dst */, 8, isize) |
                  Assembler::uimm12(opnd_array(1)->disp(ra_,this,idx1), 20, isize) |
                  Assembler::reg(Ridx, 12, isize) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    } else if (Displacement::is_validDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (AG_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* dst */, 8, 48) |
                  Assembler::simm20(opnd_array(1)->disp(ra_,this,idx1)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 48));
    } else {
        __ load_const_optimized(Z_R1_scratch, opnd_array(1)->disp(ra_,this,idx1));
        if (Ridx != Z_R0) { __ z_agr(Z_R1_scratch, Ridx); }
        z_emit_inst(masm, (AG_ZOPC /*secondary()*/) |
                    Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* dst */, 8, isize) |
                    Assembler::uimm12(0, 20, isize) |
                    Assembler::reg(Z_R1_scratch, 12, isize) |
                    Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    }
  
#line 12434 "ad_s390.cpp"
  }
}

uint addL_Reg_mem_0Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= Z_DISP3_SIZE, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : Z_DISP3_SIZE);
}

void addL_reg_reg_imm12Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// con
  {

#line 1766 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((LA_ZOPC /*primary()*/)>>30) & 0x03) == 1, "Instruction format error");
    z_emit32(masm, (LA_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */,8,32) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src1 */,12,32) |
             Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* src2 */,16,32) |
             Assembler::uimm12(opnd_array(3)->constantL(),20,32));
  
#line 12460 "ad_s390.cpp"
  }
}

uint addL_reg_reg_imm12Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void addL_reg_reg_imm20Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// con
  {

#line 1783 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    z_emit48(masm, (LAY_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */,8,48) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src1 */,12,48) |
             Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* src2 */,16,48) |
             Assembler::simm20(opnd_array(3)->constantL()));
  
#line 12485 "ad_s390.cpp"
  }
}

uint addL_reg_reg_imm20Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void addL_mem_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1799 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int      disp = opnd_array(1)->disp(ra_,this,idx1);
    Register base = reg_to_register_object(opnd_array(1)->base(ra_,this,idx1));
    int      con  = opnd_array(2)->constantL();

    assert(VM_Version::has_MemWithImmALUOps(), "unsupported CPU");
    z_emit_inst(masm, (AGSI_ZOPC /*primary()*/) |
                Assembler::regz(base,16,48) |
                Assembler::simm20(disp) |
                Assembler::simm8(con,8,48));
  
#line 12513 "ad_s390.cpp"
  }
}

uint addL_mem_immNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void addP_reg_reg_LANode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 1766 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((LA_ZOPC /*primary()*/)>>30) & 0x03) == 1, "Instruction format error");
    z_emit32(masm, (LA_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */,8,32) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src1 */,12,32) |
             Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* src2 */,16,32) |
             Assembler::uimm12((0x0),20,32));
  
#line 12538 "ad_s390.cpp"
  }
}

uint addP_reg_reg_LANode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void addP_reg_reg_CISCNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1700 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((ALGR_ZOPC /*primary()*/) >> 30) & 0x03) == 2, "Instruction format error");
    z_emit32(masm, (ALGR_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */,24,32) |
             Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* src */,28,32));
  
#line 12561 "ad_s390.cpp"
  }
}

void addP_reg_reg_RISCNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 1707 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((ALGRK_ZOPC /*primary()*/) >> 30) & 0x03) == 2, "Instruction format error");
    z_emit32(masm, (ALGRK_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */,24,32) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src1 */,28,32) |
             Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* src2 */,16,32));
  
#line 12580 "ad_s390.cpp"
  }
}

void addP_reg_imm12Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {

#line 1775 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((LA_ZOPC /*primary()*/)>>30) & 0x03) == 1, "Instruction format error");
    z_emit32(masm, (LA_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */,8,32) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src */,16,32) |
             Assembler::uimm12(opnd_array(2)->constantL(),20,32));
  
#line 12599 "ad_s390.cpp"
  }
}

uint addP_reg_imm12Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void addP_reg_imm16_CISCNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1715 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((AGHI_ZOPC /*primary()*/)>>30) & 0x03) == 2, "Instruction format error");
    z_emit32(masm, (AGHI_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */,8,32) |
             Assembler::simm16(opnd_array(2)->constantL(),16,32));
  
#line 12622 "ad_s390.cpp"
  }
}

void addP_reg_imm16_RISCNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {

#line 1729 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((ALGHSIK_ZOPC /*primary()*/)>>46) & 0x03) == 3, "Instruction format error");
    z_emit48(masm, (ALGHSIK_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */,8,48) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src */,12,48) |
             Assembler::simm16(opnd_array(2)->constantL(),16,48));
  
#line 12641 "ad_s390.cpp"
  }
}

void addP_reg_imm20Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {

#line 1791 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    z_emit48(masm, (LAY_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */,8,48) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src */,16,48) |
             Assembler::simm20(opnd_array(2)->constantL()));
  
#line 12659 "ad_s390.cpp"
  }
}

uint addP_reg_imm20Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void addP_reg_imm32Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1737 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((AGFI_ZOPC /*primary()*/)>>46) & 0x03) == 3, "Instruction format error");
    z_emit48(masm, (AGFI_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */,8,48) |
             Assembler::simm32(opnd_array(2)->constantL(),16,48));
  
#line 12682 "ad_s390.cpp"
  }
}

void addP_reg_reg_imm12Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// con
  {

#line 1766 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((LA_ZOPC /*primary()*/)>>30) & 0x03) == 1, "Instruction format error");
    z_emit32(masm, (LA_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */,8,32) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src1 */,12,32) |
             Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* src2 */,16,32) |
             Assembler::uimm12(opnd_array(3)->constantL(),20,32));
  
#line 12703 "ad_s390.cpp"
  }
}

uint addP_reg_reg_imm12Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void addP_regN_reg_imm12Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// con
  {

#line 1766 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((LA_ZOPC /*primary()*/)>>30) & 0x03) == 1, "Instruction format error");
    z_emit32(masm, (LA_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */,8,32) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src1 */,12,32) |
             Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* src2 */,16,32) |
             Assembler::uimm12(opnd_array(3)->constantL(),20,32));
  
#line 12729 "ad_s390.cpp"
  }
}

uint addP_regN_reg_imm12Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void addP_reg_reg_imm20Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// con
  {

#line 1783 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    z_emit48(masm, (LAY_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */,8,48) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src1 */,12,48) |
             Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* src2 */,16,48) |
             Assembler::simm20(opnd_array(3)->constantL()));
  
#line 12754 "ad_s390.cpp"
  }
}

void addP_regN_reg_imm20Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// con
  {

#line 1783 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    z_emit48(masm, (LAY_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */,8,48) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src1 */,12,48) |
             Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* src2 */,16,48) |
             Assembler::simm20(opnd_array(3)->constantL()));
  
#line 12774 "ad_s390.cpp"
  }
}

void addP_mem_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1799 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int      disp = opnd_array(1)->disp(ra_,this,idx1);
    Register base = reg_to_register_object(opnd_array(1)->base(ra_,this,idx1));
    int      con  = opnd_array(2)->constantL();

    assert(VM_Version::has_MemWithImmALUOps(), "unsupported CPU");
    z_emit_inst(masm, (AGSI_ZOPC /*primary()*/) |
                Assembler::regz(base,16,48) |
                Assembler::simm20(disp) |
                Assembler::simm8(con,8,48));
  
#line 12797 "ad_s390.cpp"
  }
}

uint addP_mem_immNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void subI_reg_reg_CISCNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1692 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((SR_ZOPC /*primary()*/) >> 14) & 0x03) == 0, "Instruction format error");
    assert( ((SR_ZOPC /*primary()*/) >> 16)         == 0, "Instruction format error");
    z_emit16(masm, (SR_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */,8,16) |
             Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* src */,12,16));
  
#line 12821 "ad_s390.cpp"
  }
}

void subI_reg_reg_RISCNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 1707 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((SRK_ZOPC /*primary()*/) >> 30) & 0x03) == 2, "Instruction format error");
    z_emit32(masm, (SRK_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */,24,32) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src1 */,28,32) |
             Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* src2 */,16,32));
  
#line 12840 "ad_s390.cpp"
  }
}

uint subI_reg_reg_RISCNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void subI_Reg_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1855 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int isize = (S_ZOPC /*secondary()*/) > 1L << 32 ? 48 : 32;
    Register Ridx = as_Register(opnd_array(2)->index(ra_,this,idx2));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.

    if (Displacement::is_shortDisp((long)opnd_array(2)->disp(ra_,this,idx2))) {
      z_emit_inst(masm, (S_ZOPC /*secondary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */, 8, isize) |
                  Assembler::uimm12(opnd_array(2)->disp(ra_,this,idx2), 20, isize) |
                  Assembler::reg(Ridx, 12, isize) |
                  Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, isize));
    } else if (Displacement::is_validDisp((long)opnd_array(2)->disp(ra_,this,idx2))) {
      z_emit_inst(masm, (SY_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */, 8, 48) |
                  Assembler::simm20(opnd_array(2)->disp(ra_,this,idx2)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, 48));
    } else {
        __ load_const_optimized(Z_R1_scratch, opnd_array(2)->disp(ra_,this,idx2));
        if (Ridx != Z_R0) { __ z_agr(Z_R1_scratch, Ridx); }
        z_emit_inst(masm, (S_ZOPC /*secondary()*/) |
                    Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */, 8, isize) |
                    Assembler::uimm12(0, 20, isize) |
                    Assembler::reg(Z_R1_scratch, 12, isize) |
                    Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, isize));
    }
  
#line 12884 "ad_s390.cpp"
  }
}

void subI_zero_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 5961 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"
__ z_lcr(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(2)->as_Register(ra_,this,idx2)/* src */); 
#line 12897 "ad_s390.cpp"
  }
}

uint subI_zero_regNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 2, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 2);
}

void subL_reg_reg_CISCNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1700 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((SGR_ZOPC /*primary()*/) >> 30) & 0x03) == 2, "Instruction format error");
    z_emit32(masm, (SGR_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */,24,32) |
             Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* src */,28,32));
  
#line 12920 "ad_s390.cpp"
  }
}

void subL_reg_reg_RISCNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 1707 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((SGRK_ZOPC /*primary()*/) >> 30) & 0x03) == 2, "Instruction format error");
    z_emit32(masm, (SGRK_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */,24,32) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src1 */,28,32) |
             Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* src2 */,16,32));
  
#line 12939 "ad_s390.cpp"
  }
}

uint subL_reg_reg_RISCNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void subL_reg_regI_CISCNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1700 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((SGFR_ZOPC /*primary()*/) >> 30) & 0x03) == 2, "Instruction format error");
    z_emit32(masm, (SGFR_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */,24,32) |
             Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* src */,28,32));
  
#line 12962 "ad_s390.cpp"
  }
}

uint subL_reg_regI_CISCNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void subL_Reg_memINode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1855 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int isize = (SGF_ZOPC /*secondary()*/) > 1L << 32 ? 48 : 32;
    Register Ridx = as_Register(opnd_array(2)->index(ra_,this,idx2));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.

    if (Displacement::is_shortDisp((long)opnd_array(2)->disp(ra_,this,idx2))) {
      z_emit_inst(masm, (SGF_ZOPC /*secondary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */, 8, isize) |
                  Assembler::uimm12(opnd_array(2)->disp(ra_,this,idx2), 20, isize) |
                  Assembler::reg(Ridx, 12, isize) |
                  Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, isize));
    } else if (Displacement::is_validDisp((long)opnd_array(2)->disp(ra_,this,idx2))) {
      z_emit_inst(masm, (SGF_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */, 8, 48) |
                  Assembler::simm20(opnd_array(2)->disp(ra_,this,idx2)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, 48));
    } else {
        __ load_const_optimized(Z_R1_scratch, opnd_array(2)->disp(ra_,this,idx2));
        if (Ridx != Z_R0) { __ z_agr(Z_R1_scratch, Ridx); }
        z_emit_inst(masm, (SGF_ZOPC /*secondary()*/) |
                    Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */, 8, isize) |
                    Assembler::uimm12(0, 20, isize) |
                    Assembler::reg(Z_R1_scratch, 12, isize) |
                    Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, isize));
    }
  
#line 13006 "ad_s390.cpp"
  }
}

uint subL_Reg_memINode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= Z_DISP3_SIZE, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : Z_DISP3_SIZE);
}

void subL_Reg_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1855 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int isize = (SG_ZOPC /*secondary()*/) > 1L << 32 ? 48 : 32;
    Register Ridx = as_Register(opnd_array(2)->index(ra_,this,idx2));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.

    if (Displacement::is_shortDisp((long)opnd_array(2)->disp(ra_,this,idx2))) {
      z_emit_inst(masm, (SG_ZOPC /*secondary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */, 8, isize) |
                  Assembler::uimm12(opnd_array(2)->disp(ra_,this,idx2), 20, isize) |
                  Assembler::reg(Ridx, 12, isize) |
                  Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, isize));
    } else if (Displacement::is_validDisp((long)opnd_array(2)->disp(ra_,this,idx2))) {
      z_emit_inst(masm, (SG_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */, 8, 48) |
                  Assembler::simm20(opnd_array(2)->disp(ra_,this,idx2)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, 48));
    } else {
        __ load_const_optimized(Z_R1_scratch, opnd_array(2)->disp(ra_,this,idx2));
        if (Ridx != Z_R0) { __ z_agr(Z_R1_scratch, Ridx); }
        z_emit_inst(masm, (SG_ZOPC /*secondary()*/) |
                    Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */, 8, isize) |
                    Assembler::uimm12(0, 20, isize) |
                    Assembler::reg(Z_R1_scratch, 12, isize) |
                    Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, isize));
    }
  
#line 13050 "ad_s390.cpp"
  }
}

uint subL_Reg_memNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= Z_DISP3_SIZE, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : Z_DISP3_SIZE);
}

void mulI_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1700 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((MSR_ZOPC /*primary()*/) >> 30) & 0x03) == 2, "Instruction format error");
    z_emit32(masm, (MSR_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */,24,32) |
             Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* src */,28,32));
  
#line 13073 "ad_s390.cpp"
  }
}

uint mulI_reg_regNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void mulI_reg_imm16Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {

#line 1715 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((MHI_ZOPC /*primary()*/)>>30) & 0x03) == 2, "Instruction format error");
    z_emit32(masm, (MHI_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */,8,32) |
             Assembler::simm16(opnd_array(2)->constant(),16,32));
  
#line 13096 "ad_s390.cpp"
  }
}

void mulI_reg_imm32Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {

#line 1737 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((MSFI_ZOPC /*primary()*/)>>46) & 0x03) == 3, "Instruction format error");
    z_emit48(masm, (MSFI_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */,8,48) |
             Assembler::simm32(opnd_array(2)->constant(),16,48));
  
#line 13114 "ad_s390.cpp"
  }
}

uint mulI_reg_imm32Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void mulI_Reg_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1855 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int isize = (MS_ZOPC /*secondary()*/) > 1L << 32 ? 48 : 32;
    Register Ridx = as_Register(opnd_array(2)->index(ra_,this,idx2));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.

    if (Displacement::is_shortDisp((long)opnd_array(2)->disp(ra_,this,idx2))) {
      z_emit_inst(masm, (MS_ZOPC /*secondary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */, 8, isize) |
                  Assembler::uimm12(opnd_array(2)->disp(ra_,this,idx2), 20, isize) |
                  Assembler::reg(Ridx, 12, isize) |
                  Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, isize));
    } else if (Displacement::is_validDisp((long)opnd_array(2)->disp(ra_,this,idx2))) {
      z_emit_inst(masm, (MSY_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */, 8, 48) |
                  Assembler::simm20(opnd_array(2)->disp(ra_,this,idx2)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, 48));
    } else {
        __ load_const_optimized(Z_R1_scratch, opnd_array(2)->disp(ra_,this,idx2));
        if (Ridx != Z_R0) { __ z_agr(Z_R1_scratch, Ridx); }
        z_emit_inst(masm, (MS_ZOPC /*secondary()*/) |
                    Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */, 8, isize) |
                    Assembler::uimm12(0, 20, isize) |
                    Assembler::reg(Z_R1_scratch, 12, isize) |
                    Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, isize));
    }
  
#line 13158 "ad_s390.cpp"
  }
}

void mulI_Reg_mem_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {

#line 1855 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int isize = (MS_ZOPC /*secondary()*/) > 1L << 32 ? 48 : 32;
    Register Ridx = as_Register(opnd_array(1)->index(ra_,this,idx1));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.

    if (Displacement::is_shortDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (MS_ZOPC /*secondary()*/) |
                  Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* dst */, 8, isize) |
                  Assembler::uimm12(opnd_array(1)->disp(ra_,this,idx1), 20, isize) |
                  Assembler::reg(Ridx, 12, isize) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    } else if (Displacement::is_validDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (MSY_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* dst */, 8, 48) |
                  Assembler::simm20(opnd_array(1)->disp(ra_,this,idx1)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 48));
    } else {
        __ load_const_optimized(Z_R1_scratch, opnd_array(1)->disp(ra_,this,idx1));
        if (Ridx != Z_R0) { __ z_agr(Z_R1_scratch, Ridx); }
        z_emit_inst(masm, (MS_ZOPC /*secondary()*/) |
                    Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* dst */, 8, isize) |
                    Assembler::uimm12(0, 20, isize) |
                    Assembler::reg(Z_R1_scratch, 12, isize) |
                    Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    }
  
#line 13197 "ad_s390.cpp"
  }
}

void mulL_reg_regINode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1700 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((MSGFR_ZOPC /*primary()*/) >> 30) & 0x03) == 2, "Instruction format error");
    z_emit32(masm, (MSGFR_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */,24,32) |
             Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* src */,28,32));
  
#line 13215 "ad_s390.cpp"
  }
}

void mulL_reg_regI_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {

#line 1700 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((MSGFR_ZOPC /*primary()*/) >> 30) & 0x03) == 2, "Instruction format error");
    z_emit32(masm, (MSGFR_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* dst */,24,32) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src */,28,32));
  
#line 13233 "ad_s390.cpp"
  }
}

void mulL_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1700 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((MSGR_ZOPC /*primary()*/) >> 30) & 0x03) == 2, "Instruction format error");
    z_emit32(masm, (MSGR_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */,24,32) |
             Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* src */,28,32));
  
#line 13251 "ad_s390.cpp"
  }
}

uint mulL_reg_regNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void mulL_reg_imm16Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1715 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((MGHI_ZOPC /*primary()*/)>>30) & 0x03) == 2, "Instruction format error");
    z_emit32(masm, (MGHI_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */,8,32) |
             Assembler::simm16(opnd_array(2)->constantL(),16,32));
  
#line 13274 "ad_s390.cpp"
  }
}

void mulL_reg_imm32Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {

#line 1737 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((MSGFI_ZOPC /*primary()*/)>>46) & 0x03) == 3, "Instruction format error");
    z_emit48(masm, (MSGFI_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */,8,48) |
             Assembler::simm32(opnd_array(2)->constantL(),16,48));
  
#line 13292 "ad_s390.cpp"
  }
}

uint mulL_reg_imm32Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void mulL_Reg_memINode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1855 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int isize = (MSGF_ZOPC /*secondary()*/) > 1L << 32 ? 48 : 32;
    Register Ridx = as_Register(opnd_array(2)->index(ra_,this,idx2));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.

    if (Displacement::is_shortDisp((long)opnd_array(2)->disp(ra_,this,idx2))) {
      z_emit_inst(masm, (MSGF_ZOPC /*secondary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */, 8, isize) |
                  Assembler::uimm12(opnd_array(2)->disp(ra_,this,idx2), 20, isize) |
                  Assembler::reg(Ridx, 12, isize) |
                  Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, isize));
    } else if (Displacement::is_validDisp((long)opnd_array(2)->disp(ra_,this,idx2))) {
      z_emit_inst(masm, (MSGF_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */, 8, 48) |
                  Assembler::simm20(opnd_array(2)->disp(ra_,this,idx2)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, 48));
    } else {
        __ load_const_optimized(Z_R1_scratch, opnd_array(2)->disp(ra_,this,idx2));
        if (Ridx != Z_R0) { __ z_agr(Z_R1_scratch, Ridx); }
        z_emit_inst(masm, (MSGF_ZOPC /*secondary()*/) |
                    Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */, 8, isize) |
                    Assembler::uimm12(0, 20, isize) |
                    Assembler::reg(Z_R1_scratch, 12, isize) |
                    Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, isize));
    }
  
#line 13336 "ad_s390.cpp"
  }
}

uint mulL_Reg_memINode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= Z_DISP3_SIZE, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : Z_DISP3_SIZE);
}

void mulL_Reg_memI_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {

#line 1855 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int isize = (MSGF_ZOPC /*secondary()*/) > 1L << 32 ? 48 : 32;
    Register Ridx = as_Register(opnd_array(1)->index(ra_,this,idx1));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.

    if (Displacement::is_shortDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (MSGF_ZOPC /*secondary()*/) |
                  Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* dst */, 8, isize) |
                  Assembler::uimm12(opnd_array(1)->disp(ra_,this,idx1), 20, isize) |
                  Assembler::reg(Ridx, 12, isize) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    } else if (Displacement::is_validDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (MSGF_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* dst */, 8, 48) |
                  Assembler::simm20(opnd_array(1)->disp(ra_,this,idx1)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 48));
    } else {
        __ load_const_optimized(Z_R1_scratch, opnd_array(1)->disp(ra_,this,idx1));
        if (Ridx != Z_R0) { __ z_agr(Z_R1_scratch, Ridx); }
        z_emit_inst(masm, (MSGF_ZOPC /*secondary()*/) |
                    Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* dst */, 8, isize) |
                    Assembler::uimm12(0, 20, isize) |
                    Assembler::reg(Z_R1_scratch, 12, isize) |
                    Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    }
  
#line 13380 "ad_s390.cpp"
  }
}

uint mulL_Reg_memI_0Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= Z_DISP3_SIZE, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : Z_DISP3_SIZE);
}

void mulL_Reg_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1855 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int isize = (MSG_ZOPC /*secondary()*/) > 1L << 32 ? 48 : 32;
    Register Ridx = as_Register(opnd_array(2)->index(ra_,this,idx2));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.

    if (Displacement::is_shortDisp((long)opnd_array(2)->disp(ra_,this,idx2))) {
      z_emit_inst(masm, (MSG_ZOPC /*secondary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */, 8, isize) |
                  Assembler::uimm12(opnd_array(2)->disp(ra_,this,idx2), 20, isize) |
                  Assembler::reg(Ridx, 12, isize) |
                  Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, isize));
    } else if (Displacement::is_validDisp((long)opnd_array(2)->disp(ra_,this,idx2))) {
      z_emit_inst(masm, (MSG_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */, 8, 48) |
                  Assembler::simm20(opnd_array(2)->disp(ra_,this,idx2)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, 48));
    } else {
        __ load_const_optimized(Z_R1_scratch, opnd_array(2)->disp(ra_,this,idx2));
        if (Ridx != Z_R0) { __ z_agr(Z_R1_scratch, Ridx); }
        z_emit_inst(masm, (MSG_ZOPC /*secondary()*/) |
                    Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */, 8, isize) |
                    Assembler::uimm12(0, 20, isize) |
                    Assembler::reg(Z_R1_scratch, 12, isize) |
                    Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, isize));
    }
  
#line 13424 "ad_s390.cpp"
  }
}

uint mulL_Reg_memNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= Z_DISP3_SIZE, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : Z_DISP3_SIZE);
}

void mulL_Reg_mem_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {

#line 1855 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int isize = (MSG_ZOPC /*secondary()*/) > 1L << 32 ? 48 : 32;
    Register Ridx = as_Register(opnd_array(1)->index(ra_,this,idx1));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.

    if (Displacement::is_shortDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (MSG_ZOPC /*secondary()*/) |
                  Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* dst */, 8, isize) |
                  Assembler::uimm12(opnd_array(1)->disp(ra_,this,idx1), 20, isize) |
                  Assembler::reg(Ridx, 12, isize) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    } else if (Displacement::is_validDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (MSG_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* dst */, 8, 48) |
                  Assembler::simm20(opnd_array(1)->disp(ra_,this,idx1)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 48));
    } else {
        __ load_const_optimized(Z_R1_scratch, opnd_array(1)->disp(ra_,this,idx1));
        if (Ridx != Z_R0) { __ z_agr(Z_R1_scratch, Ridx); }
        z_emit_inst(masm, (MSG_ZOPC /*secondary()*/) |
                    Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* dst */, 8, isize) |
                    Assembler::uimm12(0, 20, isize) |
                    Assembler::reg(Z_R1_scratch, 12, isize) |
                    Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    }
  
#line 13468 "ad_s390.cpp"
  }
}

uint mulL_Reg_mem_0Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= Z_DISP3_SIZE, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : Z_DISP3_SIZE);
}

void mulHiL_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// Rsrc1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// Rsrc2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// Rdst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// Rtmp1
  {

#line 6140 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register dst  = opnd_array(3)->as_Register(ra_,this,idx3)/* Rdst */;
    Register src1 = opnd_array(1)->as_Register(ra_,this,idx1)/* Rsrc1 */;
    Register src2 = opnd_array(2)->as_Register(ra_,this,idx2)/* Rsrc2 */;
    Register tmp1 = opnd_array(4)->as_Register(ra_,this,idx4)/* Rtmp1 */;
    Register tmp2 = opnd_array(3)->as_Register(ra_,this,idx3)/* Rdst */;
    // z/Architecture has only unsigned multiply (64 * 64 -> 128).
    // implementing mulhs(a,b) = mulhu(a,b) – (a & (b>>63)) – (b & (a>>63))
    __ z_srag(tmp2, src1, 63);  // a>>63
    __ z_srag(tmp1, src2, 63);  // b>>63
    __ z_ngr(tmp2, src2);       // b & (a>>63)
    __ z_ngr(tmp1, src1);       // a & (b>>63)
    __ z_agr(tmp1, tmp2);       // ((a & (b>>63)) + (b & (a>>63)))
    __ z_mlgr(dst, src2);       // tricky: 128-bit product is written to even/odd pair (dst,src1),
                                //         multiplicand is taken from oddReg (src1), multiplier in src2.
    __ z_sgr(dst, tmp1);
  
#line 13504 "ad_s390.cpp"
  }
}

void divModI_reg_divmodNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst2
  {

#line 6169 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register d1s1 = opnd_array(1)->as_Register(ra_,this,idx1)/* dst1src1 */;
    Register d2   = as_Register(Z_R4_enc);
    Register s2   = opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */;

    assert_different_registers(d1s1, s2);

    Label do_div, done_div;
    if (VM_Version::has_CompareBranch()) {
      __ z_cij(s2, -1, Assembler::bcondNotEqual, do_div);
    } else {
      __ z_chi(s2, -1);
      __ z_brne(do_div);
    }
    __ z_lcr(d1s1, d1s1);
    __ clear_reg(d2, false, false);
    __ z_bru(done_div);
    __ bind(do_div);
    __ z_lgfr(d1s1, d1s1);
    __ z_dsgfr(d2, s2);
    __ bind(done_div);
  
#line 13538 "ad_s390.cpp"
  }
}

uint divModI_reg_divmodNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= (VM_Version::has_CompareBranch() ? 24 : 26), "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : (VM_Version::has_CompareBranch() ? 24 : 26));
}

void divI_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 6202 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register a = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    Register b = opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */;
    Register t = opnd_array(0)->as_Register(ra_,this)/* dst */;

    assert_different_registers(t, b);

    Label do_div, done_div;
    if (VM_Version::has_CompareBranch()) {
      __ z_cij(b, -1, Assembler::bcondNotEqual, do_div);
    } else {
      __ z_chi(b, -1);
      __ z_brne(do_div);
    }
    __ z_lcr(t, a);
    __ z_bru(done_div);
    __ bind(do_div);
    __ z_lgfr(t, a);
    __ z_dsgfr(t->predecessor()/* t is odd part of a register pair. */, b);
    __ bind(done_div);
  
#line 13576 "ad_s390.cpp"
  }
}

uint divI_reg_regNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= (VM_Version::has_CompareBranch() ? 20 : 22), "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : (VM_Version::has_CompareBranch() ? 20 : 22));
}

void divI_reg_imm16Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 6233 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    // No sign extension of Rdividend needed here.
    if (opnd_array(2)->constant()!= -1) {
      __ z_lghi(Z_R0_scratch, opnd_array(2)->constant());
      __ z_lgfr(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */);
      __ z_dsgfr(opnd_array(0)->as_Register(ra_,this)/* dst */->predecessor()/* Dst is odd part of a register pair. */, Z_R0_scratch);
    } else {
      __ z_lcr(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */);
    }
  
#line 13603 "ad_s390.cpp"
  }
}

void divModL_reg_divmodNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst2
  {

#line 6253 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register d1s1 = opnd_array(1)->as_Register(ra_,this,idx1)/* dst1src1 */;
    Register d2   = as_Register(Z_R4_enc);
    Register s2   = opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */;

    Label do_div, done_div;
    if (VM_Version::has_CompareBranch()) {
      __ z_cgij(s2, -1, Assembler::bcondNotEqual, do_div);
    } else {
      __ z_cghi(s2, -1);
      __ z_brne(do_div);
    }
    __ z_lcgr(d1s1, d1s1);
    // indicate unused result
    (void) __ clear_reg(d2, true, false);
    __ z_bru(done_div);
    __ bind(do_div);
    __ z_dsgr(d2, s2);
    __ bind(done_div);
  
#line 13635 "ad_s390.cpp"
  }
}

uint divModL_reg_divmodNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= (VM_Version::has_CompareBranch() ? 22 : 24), "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : (VM_Version::has_CompareBranch() ? 22 : 24));
}

void divL_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 6283 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register b = opnd_array(2)->as_Register(ra_,this,idx2)/* src */;
    Register t = opnd_array(1)->as_Register(ra_,this,idx1)/* dst */;

    Label done_div;
    __ z_lcgr(t, t);    // Does no harm. divisor is in other register.
    if (VM_Version::has_CompareBranch()) {
      __ z_cgij(b, -1, Assembler::bcondEqual, done_div);
    } else {
      __ z_cghi(b, -1);
      __ z_bre(done_div);
    }
    __ z_lcgr(t, t);    // Restore sign.
    __ z_dsgr(t->predecessor()/* t is odd part of a register pair. */, b);
    __ bind(done_div);
  
#line 13668 "ad_s390.cpp"
  }
}

uint divL_reg_regNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= (VM_Version::has_CompareBranch() ? 18 : 20), "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : (VM_Version::has_CompareBranch() ? 18 : 20));
}

void divL_reg_imm16Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 6309 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    if (opnd_array(2)->constantL()!= -1) {
      __ z_lghi(Z_R0_scratch, opnd_array(2)->constantL());
      __ lgr_if_needed(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */);
      __ z_dsgr(opnd_array(0)->as_Register(ra_,this)/* dst */->predecessor()/* Dst is odd part of a register pair. */, Z_R0_scratch);
    } else {
      __ z_lcgr(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */);
    }
  
#line 13694 "ad_s390.cpp"
  }
}

void modI_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 6331 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register a = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    Register b = opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */;
    Register t = opnd_array(0)->as_Register(ra_,this)/* dst */;
    assert_different_registers(t->successor(), b);

    Label do_div, done_div;

    if ((t->encoding() != b->encoding()) && (t->encoding() != a->encoding())) {
      (void) __ clear_reg(t, true, false);  // Does no harm. Operands are in other regs.
      if (VM_Version::has_CompareBranch()) {
        __ z_cij(b, -1, Assembler::bcondEqual, done_div);
      } else {
        __ z_chi(b, -1);
        __ z_bre(done_div);
      }
      __ z_lgfr(t->successor(), a);
      __ z_dsgfr(t/* t is even part of a register pair. */, b);
    } else {
      if (VM_Version::has_CompareBranch()) {
        __ z_cij(b, -1, Assembler::bcondNotEqual, do_div);
      } else {
        __ z_chi(b, -1);
        __ z_brne(do_div);
      }
      __ clear_reg(t, true, false);
      __ z_bru(done_div);
      __ bind(do_div);
      __ z_lgfr(t->successor(), a);
      __ z_dsgfr(t/* t is even part of a register pair. */, b);
    }
    __ bind(done_div);
  
#line 13739 "ad_s390.cpp"
  }
}

void modI_reg_imm16Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 6374 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert_different_registers(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */);
    assert_different_registers(opnd_array(0)->as_Register(ra_,this)/* dst */->successor(), opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */);
    int divisor = opnd_array(2)->constant();

    if (divisor != -1) {
      __ z_lghi(Z_R0_scratch, divisor);
      __ z_lgfr(opnd_array(0)->as_Register(ra_,this)/* dst */->successor(), opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */);
      __ z_dsgfr(opnd_array(0)->as_Register(ra_,this)/* dst */, Z_R0_scratch); // Instruction kills tmp.
    } else {
      __ clear_reg(opnd_array(0)->as_Register(ra_,this)/* dst */, true, false);
    }
  
#line 13764 "ad_s390.cpp"
  }
}

void modL_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 6397 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register a = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    Register b = opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */;
    Register t = opnd_array(0)->as_Register(ra_,this)/* dst */;
    assert(t->successor() == a, "(t,a) is an even-odd pair" );

    Label do_div, done_div;
    if (t->encoding() != b->encoding()) {
      (void) __ clear_reg(t, true, false); // Does no harm. Dividend is in successor.
      if (VM_Version::has_CompareBranch()) {
        __ z_cgij(b, -1, Assembler::bcondEqual, done_div);
      } else {
        __ z_cghi(b, -1);
        __ z_bre(done_div);
      }
      __ z_dsgr(t, b);
    } else {
      if (VM_Version::has_CompareBranch()) {
        __ z_cgij(b, -1, Assembler::bcondNotEqual, do_div);
      } else {
        __ z_cghi(b, -1);
        __ z_brne(do_div);
      }
      __ clear_reg(t, true, false);
      __ z_bru(done_div);
      __ bind(do_div);
      __ z_dsgr(t, b);
    }
    __ bind(done_div);
  
#line 13806 "ad_s390.cpp"
  }
}

void modL_reg_imm16Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 6437 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int divisor = opnd_array(2)->constantL();
    if (divisor != -1) {
      __ z_lghi(Z_R0_scratch, divisor);
      __ z_lgr(opnd_array(0)->as_Register(ra_,this)/* dst */->successor(), opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */);
      __ z_dsgr(opnd_array(0)->as_Register(ra_,this)/* dst */, Z_R0_scratch);  // Instruction kills tmp.
    } else {
      __ clear_reg(opnd_array(0)->as_Register(ra_,this)/* dst */, true, false);
    }
  
#line 13828 "ad_s390.cpp"
  }
}

void sllI_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// nbits
  {

#line 6461 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    __ z_lgr(Z_R1_scratch, opnd_array(2)->as_Register(ra_,this,idx2)/* nbits */);
    __ z_nill(Z_R1_scratch, BitsPerJavaInteger-1);
    __ z_sllg(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, 0, Z_R1_scratch);
  
#line 13845 "ad_s390.cpp"
  }
}

uint sllI_reg_regNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 14, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 14);
}

void sllI_reg_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// nbits
  {

#line 6475 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int Nbit = opnd_array(2)->constant();
    assert((Nbit & (BitsPerJavaInteger - 1)) == Nbit, "Check shift mask in ideal graph");
    __ z_sllg(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, Nbit & (BitsPerJavaInteger - 1), Z_R0);
  
#line 13867 "ad_s390.cpp"
  }
}

uint sllI_reg_immNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void sllI_reg_imm_1Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// nbits
  {

#line 6490 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"
__ z_la(opnd_array(0)->as_Register(ra_,this)/* dst */, 0, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */); 
#line 13885 "ad_s390.cpp"
  }
}

uint sllI_reg_imm_1Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void sllL_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// nbits
  {

#line 1758 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    z_emit48(masm, (SLLG_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */,8,48) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src1 */,12,48) |
             Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* nbits */,16,48) |
             Assembler::simm20(0));
  
#line 13909 "ad_s390.cpp"
  }
}

uint sllL_reg_regNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void sllL_reg_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// nbits
  {

#line 1751 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    z_emit48(masm, (SLLG_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */,8,48) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src1 */,12,48) |
             Assembler::simm20(opnd_array(2)->constant()));
  
#line 13932 "ad_s390.cpp"
  }
}

uint sllL_reg_immNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void sllL_reg_imm_1Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// nbits
  {

#line 6521 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"
__ z_la(opnd_array(0)->as_Register(ra_,this)/* dst */, 0, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */); 
#line 13950 "ad_s390.cpp"
  }
}

uint sllL_reg_imm_1Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void sraI_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 6534 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    __ z_lgr(Z_R1_scratch, opnd_array(2)->as_Register(ra_,this,idx2)/* src */);
    __ z_nill(Z_R1_scratch, BitsPerJavaInteger-1);
    __ z_sra(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, 0, Z_R1_scratch);
  
#line 13972 "ad_s390.cpp"
  }
}

uint sraI_reg_regNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 12, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 12);
}

void sraI_reg_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 6549 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int Nbit = opnd_array(2)->constant();
    assert((Nbit & (BitsPerJavaInteger - 1)) == Nbit, "Check shift mask in ideal graph");
    __ z_sra(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, Nbit & (BitsPerJavaInteger - 1), Z_R0);
  
#line 13994 "ad_s390.cpp"
  }
}

uint sraI_reg_immNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void sraL_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 1758 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    z_emit48(masm, (SRAG_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */,8,48) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src1 */,12,48) |
             Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* src2 */,16,48) |
             Assembler::simm20(0));
  
#line 14018 "ad_s390.cpp"
  }
}

uint sraL_reg_regNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void sraL_reg_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 1751 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    z_emit48(masm, (SRAG_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */,8,48) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src1 */,12,48) |
             Assembler::simm20(opnd_array(2)->constant()));
  
#line 14041 "ad_s390.cpp"
  }
}

uint sraL_reg_immNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void srlI_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 6588 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    __ z_lgr(Z_R1_scratch, opnd_array(2)->as_Register(ra_,this,idx2)/* src */);
    __ z_nill(Z_R1_scratch, BitsPerJavaInteger-1);
    __ z_srl(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, 0, Z_R1_scratch);
  
#line 14063 "ad_s390.cpp"
  }
}

uint srlI_reg_regNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 12, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 12);
}

void srlI_reg_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 6602 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int Nbit = opnd_array(2)->constant();
    assert((Nbit & (BitsPerJavaInteger - 1)) == Nbit, "Check shift mask in ideal graph");
    __ z_srl(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, Nbit & (BitsPerJavaInteger - 1), Z_R0);
  
#line 14085 "ad_s390.cpp"
  }
}

uint srlI_reg_immNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void srlL_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 1758 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    z_emit48(masm, (SRLG_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */,8,48) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src1 */,12,48) |
             Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* src2 */,16,48) |
             Assembler::simm20(0));
  
#line 14109 "ad_s390.cpp"
  }
}

uint srlL_reg_regNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void srlL_reg_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 1751 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    z_emit48(masm, (SRLG_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */,8,48) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src1 */,12,48) |
             Assembler::simm20(opnd_array(2)->constant()));
  
#line 14132 "ad_s390.cpp"
  }
}

uint srlL_reg_immNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void srlP_reg_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 1751 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    z_emit48(masm, (SRLG_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */,8,48) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src1 */,12,48) |
             Assembler::simm20(opnd_array(2)->constant()));
  
#line 14155 "ad_s390.cpp"
  }
}

uint srlP_reg_immNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void rotlI_reg_immI8Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift
  {

#line 1751 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    z_emit48(masm, (RLL_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */,8,48) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src */,12,48) |
             Assembler::simm20(opnd_array(2)->constant()));
  
#line 14179 "ad_s390.cpp"
  }
}

uint rotlI_reg_immI8Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void rotlI_reg_immI8_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// rshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  {

#line 1751 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    z_emit48(masm, (RLL_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */,8,48) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src */,12,48) |
             Assembler::simm20(opnd_array(3)->constant()));
  
#line 14203 "ad_s390.cpp"
  }
}

uint rotlI_reg_immI8_0Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void rotlL_reg_immI8Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift
  {

#line 1751 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    z_emit48(masm, (RLLG_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */,8,48) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src */,12,48) |
             Assembler::simm20(opnd_array(2)->constant()));
  
#line 14227 "ad_s390.cpp"
  }
}

uint rotlL_reg_immI8Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void rotlL_reg_immI8_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// rshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  {

#line 1751 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    z_emit48(masm, (RLLG_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */,8,48) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src */,12,48) |
             Assembler::simm20(opnd_array(3)->constant()));
  
#line 14251 "ad_s390.cpp"
  }
}

uint rotlL_reg_immI8_0Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void rotrI_reg_immI8Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// rshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  {

#line 1751 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    z_emit48(masm, (RLL_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */,8,48) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src */,12,48) |
             Assembler::simm20(opnd_array(2)->constant()));
  
#line 14275 "ad_s390.cpp"
  }
}

void rotrI_reg_immI8_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift
  {

#line 1751 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    z_emit48(masm, (RLL_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */,8,48) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src */,12,48) |
             Assembler::simm20(opnd_array(3)->constant()));
  
#line 14294 "ad_s390.cpp"
  }
}

void rotrL_reg_immI8Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// rshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// lshift
  {

#line 1751 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    z_emit48(masm, (RLLG_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */,8,48) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src */,12,48) |
             Assembler::simm20(opnd_array(2)->constant()));
  
#line 14313 "ad_s390.cpp"
  }
}

void rotrL_reg_immI8_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lshift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rshift
  {

#line 1751 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    z_emit48(masm, (RLLG_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */,8,48) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src */,12,48) |
             Assembler::simm20(opnd_array(3)->constant()));
  
#line 14332 "ad_s390.cpp"
  }
}

void overflowAddI_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 6694 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    __ z_lr(Z_R0_scratch, opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */);
    __ z_ar(Z_R0_scratch, opnd_array(2)->as_Register(ra_,this,idx2)/* op2 */);
  
#line 14348 "ad_s390.cpp"
  }
}

void overflowAddI_reg_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 6706 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    __ load_const_optimized(Z_R0_scratch, opnd_array(2)->constant());
    __ z_ar(Z_R0_scratch, opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */);
  
#line 14364 "ad_s390.cpp"
  }
}

void overflowAddL_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 6718 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    __ z_lgr(Z_R0_scratch, opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */);
    __ z_agr(Z_R0_scratch, opnd_array(2)->as_Register(ra_,this,idx2)/* op2 */);
  
#line 14380 "ad_s390.cpp"
  }
}

void overflowAddL_reg_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 6730 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    __ load_const_optimized(Z_R0_scratch, opnd_array(2)->constantL());
    __ z_agr(Z_R0_scratch, opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */);
  
#line 14396 "ad_s390.cpp"
  }
}

void overflowSubI_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 6742 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    __ z_lr(Z_R0_scratch, opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */);
    __ z_sr(Z_R0_scratch, opnd_array(2)->as_Register(ra_,this,idx2)/* op2 */);
  
#line 14412 "ad_s390.cpp"
  }
}

void overflowSubI_reg_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 6754 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    __ load_const_optimized(Z_R1_scratch, opnd_array(2)->constant());
    __ z_lr(Z_R0_scratch, opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */);
    __ z_sr(Z_R0_scratch, Z_R1_scratch);
  
#line 14429 "ad_s390.cpp"
  }
}

void overflowSubL_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 6767 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    __ z_lgr(Z_R0_scratch, opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */);
    __ z_sgr(Z_R0_scratch, opnd_array(2)->as_Register(ra_,this,idx2)/* op2 */);
  
#line 14445 "ad_s390.cpp"
  }
}

void overflowSubL_reg_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 6779 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    __ load_const_optimized(Z_R1_scratch, opnd_array(2)->constantL());
    __ z_lgr(Z_R0_scratch, opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */);
    __ z_sgr(Z_R0_scratch, Z_R1_scratch);
  
#line 14462 "ad_s390.cpp"
  }
}

void overflowNegI_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 6791 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    __ clear_reg(Z_R0_scratch, false, false);
    __ z_sr(Z_R0_scratch, opnd_array(2)->as_Register(ra_,this,idx2)/* op2 */);
  
#line 14478 "ad_s390.cpp"
  }
}

void overflowNegL_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 6802 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    __ clear_reg(Z_R0_scratch, true, false);
    __ z_sgr(Z_R0_scratch, opnd_array(2)->as_Register(ra_,this,idx2)/* op2 */);
  
#line 14494 "ad_s390.cpp"
  }
}

void addF_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1700 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((AEBR_ZOPC /*primary()*/) >> 30) & 0x03) == 2, "Instruction format error");
    z_emit32(masm, (AEBR_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */,24,32) |
             Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* src */,28,32));
  
#line 14512 "ad_s390.cpp"
  }
}

uint addF_reg_regNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void addF_reg_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1819 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Ridx = as_Register(opnd_array(2)->index(ra_,this,idx2));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.
    if ((AEB_ZOPC /*primary()*/) > (1L << 32)) {
      z_emit_inst(masm, (AEB_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */, 8, 48) |
                  Assembler::uimm12(opnd_array(2)->disp(ra_,this,idx2), 20, 48) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, 48));
    } else {
      z_emit_inst(masm, (AEB_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */, 8, 32) |
                  Assembler::uimm12(opnd_array(2)->disp(ra_,this,idx2), 20, 32) |
                  Assembler::reg(Ridx, 12, 32) |
                  Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, 32));
    }
  
#line 14546 "ad_s390.cpp"
  }
}

uint addF_reg_memNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void addF_reg_mem_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {

#line 1819 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Ridx = as_Register(opnd_array(1)->index(ra_,this,idx1));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.
    if ((AEB_ZOPC /*primary()*/) > (1L << 32)) {
      z_emit_inst(masm, (AEB_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* dst */, 8, 48) |
                  Assembler::uimm12(opnd_array(1)->disp(ra_,this,idx1), 20, 48) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 48));
    } else {
      z_emit_inst(masm, (AEB_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* dst */, 8, 32) |
                  Assembler::uimm12(opnd_array(1)->disp(ra_,this,idx1), 20, 32) |
                  Assembler::reg(Ridx, 12, 32) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 32));
    }
  
#line 14580 "ad_s390.cpp"
  }
}

uint addF_reg_mem_0Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void addD_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1700 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((ADBR_ZOPC /*primary()*/) >> 30) & 0x03) == 2, "Instruction format error");
    z_emit32(masm, (ADBR_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */,24,32) |
             Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* src */,28,32));
  
#line 14603 "ad_s390.cpp"
  }
}

uint addD_reg_regNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void addD_reg_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1819 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Ridx = as_Register(opnd_array(2)->index(ra_,this,idx2));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.
    if ((ADB_ZOPC /*primary()*/) > (1L << 32)) {
      z_emit_inst(masm, (ADB_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */, 8, 48) |
                  Assembler::uimm12(opnd_array(2)->disp(ra_,this,idx2), 20, 48) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, 48));
    } else {
      z_emit_inst(masm, (ADB_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */, 8, 32) |
                  Assembler::uimm12(opnd_array(2)->disp(ra_,this,idx2), 20, 32) |
                  Assembler::reg(Ridx, 12, 32) |
                  Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, 32));
    }
  
#line 14637 "ad_s390.cpp"
  }
}

uint addD_reg_memNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void addD_reg_mem_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {

#line 1819 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Ridx = as_Register(opnd_array(1)->index(ra_,this,idx1));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.
    if ((ADB_ZOPC /*primary()*/) > (1L << 32)) {
      z_emit_inst(masm, (ADB_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* dst */, 8, 48) |
                  Assembler::uimm12(opnd_array(1)->disp(ra_,this,idx1), 20, 48) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 48));
    } else {
      z_emit_inst(masm, (ADB_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* dst */, 8, 32) |
                  Assembler::uimm12(opnd_array(1)->disp(ra_,this,idx1), 20, 32) |
                  Assembler::reg(Ridx, 12, 32) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 32));
    }
  
#line 14671 "ad_s390.cpp"
  }
}

uint addD_reg_mem_0Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void subF_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1700 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((SEBR_ZOPC /*primary()*/) >> 30) & 0x03) == 2, "Instruction format error");
    z_emit32(masm, (SEBR_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */,24,32) |
             Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* src */,28,32));
  
#line 14694 "ad_s390.cpp"
  }
}

uint subF_reg_regNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void subF_reg_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1819 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Ridx = as_Register(opnd_array(2)->index(ra_,this,idx2));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.
    if ((SEB_ZOPC /*primary()*/) > (1L << 32)) {
      z_emit_inst(masm, (SEB_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */, 8, 48) |
                  Assembler::uimm12(opnd_array(2)->disp(ra_,this,idx2), 20, 48) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, 48));
    } else {
      z_emit_inst(masm, (SEB_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */, 8, 32) |
                  Assembler::uimm12(opnd_array(2)->disp(ra_,this,idx2), 20, 32) |
                  Assembler::reg(Ridx, 12, 32) |
                  Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, 32));
    }
  
#line 14728 "ad_s390.cpp"
  }
}

uint subF_reg_memNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void subD_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1700 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((SDBR_ZOPC /*primary()*/) >> 30) & 0x03) == 2, "Instruction format error");
    z_emit32(masm, (SDBR_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */,24,32) |
             Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* src */,28,32));
  
#line 14751 "ad_s390.cpp"
  }
}

uint subD_reg_regNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void subD_reg_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1819 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Ridx = as_Register(opnd_array(2)->index(ra_,this,idx2));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.
    if ((SDB_ZOPC /*primary()*/) > (1L << 32)) {
      z_emit_inst(masm, (SDB_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */, 8, 48) |
                  Assembler::uimm12(opnd_array(2)->disp(ra_,this,idx2), 20, 48) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, 48));
    } else {
      z_emit_inst(masm, (SDB_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */, 8, 32) |
                  Assembler::uimm12(opnd_array(2)->disp(ra_,this,idx2), 20, 32) |
                  Assembler::reg(Ridx, 12, 32) |
                  Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, 32));
    }
  
#line 14785 "ad_s390.cpp"
  }
}

uint subD_reg_memNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void mulF_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1700 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((MEEBR_ZOPC /*primary()*/) >> 30) & 0x03) == 2, "Instruction format error");
    z_emit32(masm, (MEEBR_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */,24,32) |
             Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* src */,28,32));
  
#line 14808 "ad_s390.cpp"
  }
}

uint mulF_reg_regNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void mulF_reg_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1819 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Ridx = as_Register(opnd_array(2)->index(ra_,this,idx2));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.
    if ((MEEB_ZOPC /*primary()*/) > (1L << 32)) {
      z_emit_inst(masm, (MEEB_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */, 8, 48) |
                  Assembler::uimm12(opnd_array(2)->disp(ra_,this,idx2), 20, 48) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, 48));
    } else {
      z_emit_inst(masm, (MEEB_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */, 8, 32) |
                  Assembler::uimm12(opnd_array(2)->disp(ra_,this,idx2), 20, 32) |
                  Assembler::reg(Ridx, 12, 32) |
                  Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, 32));
    }
  
#line 14842 "ad_s390.cpp"
  }
}

uint mulF_reg_memNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void mulF_reg_mem_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {

#line 1819 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Ridx = as_Register(opnd_array(1)->index(ra_,this,idx1));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.
    if ((MEEB_ZOPC /*primary()*/) > (1L << 32)) {
      z_emit_inst(masm, (MEEB_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* dst */, 8, 48) |
                  Assembler::uimm12(opnd_array(1)->disp(ra_,this,idx1), 20, 48) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 48));
    } else {
      z_emit_inst(masm, (MEEB_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* dst */, 8, 32) |
                  Assembler::uimm12(opnd_array(1)->disp(ra_,this,idx1), 20, 32) |
                  Assembler::reg(Ridx, 12, 32) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 32));
    }
  
#line 14876 "ad_s390.cpp"
  }
}

uint mulF_reg_mem_0Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void mulD_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1700 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((MDBR_ZOPC /*primary()*/) >> 30) & 0x03) == 2, "Instruction format error");
    z_emit32(masm, (MDBR_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */,24,32) |
             Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* src */,28,32));
  
#line 14899 "ad_s390.cpp"
  }
}

uint mulD_reg_regNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void mulD_reg_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1819 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Ridx = as_Register(opnd_array(2)->index(ra_,this,idx2));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.
    if ((MDB_ZOPC /*primary()*/) > (1L << 32)) {
      z_emit_inst(masm, (MDB_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */, 8, 48) |
                  Assembler::uimm12(opnd_array(2)->disp(ra_,this,idx2), 20, 48) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, 48));
    } else {
      z_emit_inst(masm, (MDB_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */, 8, 32) |
                  Assembler::uimm12(opnd_array(2)->disp(ra_,this,idx2), 20, 32) |
                  Assembler::reg(Ridx, 12, 32) |
                  Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, 32));
    }
  
#line 14933 "ad_s390.cpp"
  }
}

uint mulD_reg_memNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void mulD_reg_mem_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {

#line 1819 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Ridx = as_Register(opnd_array(1)->index(ra_,this,idx1));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.
    if ((MDB_ZOPC /*primary()*/) > (1L << 32)) {
      z_emit_inst(masm, (MDB_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* dst */, 8, 48) |
                  Assembler::uimm12(opnd_array(1)->disp(ra_,this,idx1), 20, 48) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 48));
    } else {
      z_emit_inst(masm, (MDB_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* dst */, 8, 32) |
                  Assembler::uimm12(opnd_array(1)->disp(ra_,this,idx1), 20, 32) |
                  Assembler::reg(Ridx, 12, 32) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 32));
    }
  
#line 14967 "ad_s390.cpp"
  }
}

uint mulD_reg_mem_0Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void maddF_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {

#line 6967 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert(UseFMA, "Needs FMA instructions support.");
    __ z_maebr(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */);
  
#line 14989 "ad_s390.cpp"
  }
}

uint maddF_reg_regNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void maddD_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {

#line 6981 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert(UseFMA, "Needs FMA instructions support.");
    __ z_madbr(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */);
  
#line 15011 "ad_s390.cpp"
  }
}

uint maddD_reg_regNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void msubF_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {

#line 6995 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert(UseFMA, "Needs FMA instructions support.");
    __ z_msebr(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */);
  
#line 15033 "ad_s390.cpp"
  }
}

uint msubF_reg_regNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void msubD_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {

#line 7009 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert(UseFMA, "Needs FMA instructions support.");
    __ z_msdbr(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src1 */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */);
  
#line 15055 "ad_s390.cpp"
  }
}

uint msubD_reg_regNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void maddF_reg_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {

#line 7023 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert(UseFMA, "Needs FMA instructions support.");
    __ z_maeb(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src1 */,
              Address(reg_to_register_object(opnd_array(3)->base(ra_,this,idx3)), as_Register(opnd_array(3)->index(ra_,this,idx3)), opnd_array(3)->disp(ra_,this,idx3)));
  
#line 15078 "ad_s390.cpp"
  }
}

uint maddF_reg_memNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void maddD_reg_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {

#line 7038 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert(UseFMA, "Needs FMA instructions support.");
    __ z_madb(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src1 */,
              Address(reg_to_register_object(opnd_array(3)->base(ra_,this,idx3)), as_Register(opnd_array(3)->index(ra_,this,idx3)), opnd_array(3)->disp(ra_,this,idx3)));
  
#line 15101 "ad_s390.cpp"
  }
}

uint maddD_reg_memNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void msubF_reg_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {

#line 7053 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert(UseFMA, "Needs FMA instructions support.");
    __ z_mseb(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src1 */,
              Address(reg_to_register_object(opnd_array(3)->base(ra_,this,idx3)), as_Register(opnd_array(3)->index(ra_,this,idx3)), opnd_array(3)->disp(ra_,this,idx3)));
  
#line 15124 "ad_s390.cpp"
  }
}

uint msubF_reg_memNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void msubD_reg_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {

#line 7068 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert(UseFMA, "Needs FMA instructions support.");
    __ z_msdb(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src1 */,
              Address(reg_to_register_object(opnd_array(3)->base(ra_,this,idx3)), as_Register(opnd_array(3)->index(ra_,this,idx3)), opnd_array(3)->disp(ra_,this,idx3)));
  
#line 15147 "ad_s390.cpp"
  }
}

uint msubD_reg_memNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void maddF_mem_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {

#line 7083 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert(UseFMA, "Needs FMA instructions support.");
    __ z_maeb(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */,
              Address(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), as_Register(opnd_array(2)->index(ra_,this,idx2)), opnd_array(2)->disp(ra_,this,idx2)));
  
#line 15170 "ad_s390.cpp"
  }
}

uint maddF_mem_regNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void maddD_mem_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {

#line 7098 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert(UseFMA, "Needs FMA instructions support.");
    __ z_madb(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */,
              Address(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), as_Register(opnd_array(2)->index(ra_,this,idx2)), opnd_array(2)->disp(ra_,this,idx2)));
  
#line 15193 "ad_s390.cpp"
  }
}

uint maddD_mem_regNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void msubF_mem_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {

#line 7113 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert(UseFMA, "Needs FMA instructions support.");
    __ z_mseb(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */,
              Address(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), as_Register(opnd_array(2)->index(ra_,this,idx2)), opnd_array(2)->disp(ra_,this,idx2)));
  
#line 15216 "ad_s390.cpp"
  }
}

uint msubF_mem_regNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void msubD_mem_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {

#line 7128 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert(UseFMA, "Needs FMA instructions support.");
    __ z_msdb(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* dst */, opnd_array(3)->as_FloatRegister(ra_,this,idx3)/* src2 */,
              Address(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), as_Register(opnd_array(2)->index(ra_,this,idx2)), opnd_array(2)->disp(ra_,this,idx2)));
  
#line 15239 "ad_s390.cpp"
  }
}

uint msubD_mem_regNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void divF_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1700 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((DEBR_ZOPC /*primary()*/) >> 30) & 0x03) == 2, "Instruction format error");
    z_emit32(masm, (DEBR_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */,24,32) |
             Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* src */,28,32));
  
#line 15262 "ad_s390.cpp"
  }
}

uint divF_reg_regNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void divF_reg_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1819 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Ridx = as_Register(opnd_array(2)->index(ra_,this,idx2));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.
    if ((DEB_ZOPC /*primary()*/) > (1L << 32)) {
      z_emit_inst(masm, (DEB_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */, 8, 48) |
                  Assembler::uimm12(opnd_array(2)->disp(ra_,this,idx2), 20, 48) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, 48));
    } else {
      z_emit_inst(masm, (DEB_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */, 8, 32) |
                  Assembler::uimm12(opnd_array(2)->disp(ra_,this,idx2), 20, 32) |
                  Assembler::reg(Ridx, 12, 32) |
                  Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, 32));
    }
  
#line 15296 "ad_s390.cpp"
  }
}

uint divF_reg_memNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void divD_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1700 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((DDBR_ZOPC /*primary()*/) >> 30) & 0x03) == 2, "Instruction format error");
    z_emit32(masm, (DDBR_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */,24,32) |
             Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* src */,28,32));
  
#line 15319 "ad_s390.cpp"
  }
}

uint divD_reg_regNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void divD_reg_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1819 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Ridx = as_Register(opnd_array(2)->index(ra_,this,idx2));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.
    if ((DDB_ZOPC /*primary()*/) > (1L << 32)) {
      z_emit_inst(masm, (DDB_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */, 8, 48) |
                  Assembler::uimm12(opnd_array(2)->disp(ra_,this,idx2), 20, 48) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, 48));
    } else {
      z_emit_inst(masm, (DDB_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */, 8, 32) |
                  Assembler::uimm12(opnd_array(2)->disp(ra_,this,idx2), 20, 32) |
                  Assembler::reg(Ridx, 12, 32) |
                  Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, 32));
    }
  
#line 15353 "ad_s390.cpp"
  }
}

uint divD_reg_memNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void absF_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1700 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((LPEBR_ZOPC /*primary()*/) >> 30) & 0x03) == 2, "Instruction format error");
    z_emit32(masm, (LPEBR_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */,24,32) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src */,28,32));
  
#line 15375 "ad_s390.cpp"
  }
}

uint absF_regNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void absD_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1700 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((LPDBR_ZOPC /*primary()*/) >> 30) & 0x03) == 2, "Instruction format error");
    z_emit32(masm, (LPDBR_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */,24,32) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src */,28,32));
  
#line 15397 "ad_s390.cpp"
  }
}

uint absD_regNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void nabsF_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1700 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((LNEBR_ZOPC /*primary()*/) >> 30) & 0x03) == 2, "Instruction format error");
    z_emit32(masm, (LNEBR_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */,24,32) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src */,28,32));
  
#line 15419 "ad_s390.cpp"
  }
}

uint nabsF_regNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void nabsD_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1700 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((LNDBR_ZOPC /*primary()*/) >> 30) & 0x03) == 2, "Instruction format error");
    z_emit32(masm, (LNDBR_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */,24,32) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src */,28,32));
  
#line 15441 "ad_s390.cpp"
  }
}

uint nabsD_regNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void negF_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 7239 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"
__ z_lcebr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */); 
#line 15458 "ad_s390.cpp"
  }
}

uint negF_regNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void negD_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 7248 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"
__ z_lcdbr(opnd_array(0)->as_FloatRegister(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */); 
#line 15475 "ad_s390.cpp"
  }
}

uint negD_regNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void sqrtF_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1700 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((SQEBR_ZOPC /*primary()*/) >> 30) & 0x03) == 2, "Instruction format error");
    z_emit32(masm, (SQEBR_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */,24,32) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src */,28,32));
  
#line 15497 "ad_s390.cpp"
  }
}

uint sqrtF_regNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void sqrtD_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1700 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((SQDBR_ZOPC /*primary()*/) >> 30) & 0x03) == 2, "Instruction format error");
    z_emit32(masm, (SQDBR_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */,24,32) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src */,28,32));
  
#line 15519 "ad_s390.cpp"
  }
}

uint sqrtD_regNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void sqrtF_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1819 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Ridx = as_Register(opnd_array(1)->index(ra_,this,idx1));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.
    if ((SQEB_ZOPC /*primary()*/) > (1L << 32)) {
      z_emit_inst(masm, (SQEB_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, 48) |
                  Assembler::uimm12(opnd_array(1)->disp(ra_,this,idx1), 20, 48) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 48));
    } else {
      z_emit_inst(masm, (SQEB_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, 32) |
                  Assembler::uimm12(opnd_array(1)->disp(ra_,this,idx1), 20, 32) |
                  Assembler::reg(Ridx, 12, 32) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 32));
    }
  
#line 15552 "ad_s390.cpp"
  }
}

uint sqrtF_memNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void sqrtD_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1819 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Ridx = as_Register(opnd_array(1)->index(ra_,this,idx1));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.
    if ((SQDB_ZOPC /*primary()*/) > (1L << 32)) {
      z_emit_inst(masm, (SQDB_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, 48) |
                  Assembler::uimm12(opnd_array(1)->disp(ra_,this,idx1), 20, 48) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 48));
    } else {
      z_emit_inst(masm, (SQDB_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, 32) |
                  Assembler::uimm12(opnd_array(1)->disp(ra_,this,idx1), 20, 32) |
                  Assembler::reg(Ridx, 12, 32) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 32));
    }
  
#line 15585 "ad_s390.cpp"
  }
}

void andI_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1692 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((NR_ZOPC /*primary()*/) >> 14) & 0x03) == 0, "Instruction format error");
    assert( ((NR_ZOPC /*primary()*/) >> 16)         == 0, "Instruction format error");
    z_emit16(masm, (NR_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */,8,16) |
             Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* src */,12,16));
  
#line 15604 "ad_s390.cpp"
  }
}

uint andI_reg_regNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 2, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 2);
}

void andI_Reg_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1855 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int isize = (N_ZOPC /*secondary()*/) > 1L << 32 ? 48 : 32;
    Register Ridx = as_Register(opnd_array(2)->index(ra_,this,idx2));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.

    if (Displacement::is_shortDisp((long)opnd_array(2)->disp(ra_,this,idx2))) {
      z_emit_inst(masm, (N_ZOPC /*secondary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */, 8, isize) |
                  Assembler::uimm12(opnd_array(2)->disp(ra_,this,idx2), 20, isize) |
                  Assembler::reg(Ridx, 12, isize) |
                  Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, isize));
    } else if (Displacement::is_validDisp((long)opnd_array(2)->disp(ra_,this,idx2))) {
      z_emit_inst(masm, (NY_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */, 8, 48) |
                  Assembler::simm20(opnd_array(2)->disp(ra_,this,idx2)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, 48));
    } else {
        __ load_const_optimized(Z_R1_scratch, opnd_array(2)->disp(ra_,this,idx2));
        if (Ridx != Z_R0) { __ z_agr(Z_R1_scratch, Ridx); }
        z_emit_inst(masm, (N_ZOPC /*secondary()*/) |
                    Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */, 8, isize) |
                    Assembler::uimm12(0, 20, isize) |
                    Assembler::reg(Z_R1_scratch, 12, isize) |
                    Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, isize));
    }
  
#line 15648 "ad_s390.cpp"
  }
}

void andI_Reg_mem_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {

#line 1855 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int isize = (N_ZOPC /*secondary()*/) > 1L << 32 ? 48 : 32;
    Register Ridx = as_Register(opnd_array(1)->index(ra_,this,idx1));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.

    if (Displacement::is_shortDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (N_ZOPC /*secondary()*/) |
                  Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* dst */, 8, isize) |
                  Assembler::uimm12(opnd_array(1)->disp(ra_,this,idx1), 20, isize) |
                  Assembler::reg(Ridx, 12, isize) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    } else if (Displacement::is_validDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (NY_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* dst */, 8, 48) |
                  Assembler::simm20(opnd_array(1)->disp(ra_,this,idx1)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 48));
    } else {
        __ load_const_optimized(Z_R1_scratch, opnd_array(1)->disp(ra_,this,idx1));
        if (Ridx != Z_R0) { __ z_agr(Z_R1_scratch, Ridx); }
        z_emit_inst(masm, (N_ZOPC /*secondary()*/) |
                    Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* dst */, 8, isize) |
                    Assembler::uimm12(0, 20, isize) |
                    Assembler::reg(Z_R1_scratch, 12, isize) |
                    Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    }
  
#line 15687 "ad_s390.cpp"
  }
}

void andI_reg_uimm32Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1744 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((NILF_ZOPC /*primary()*/)>>46) & 0x03) == 3, "Instruction format error");
    z_emit48(masm, (NILF_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */,8,48) |
             Assembler::uimm32(opnd_array(2)->constant(),16,48));
  
#line 15705 "ad_s390.cpp"
  }
}

uint andI_reg_uimm32Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void andI_reg_uimmI_LH1Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 7343 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"
__ z_nilh(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, (opnd_array(2)->constant()>> 16) & 0xFFFF); 
#line 15723 "ad_s390.cpp"
  }
}

uint andI_reg_uimmI_LH1Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void andI_reg_uimmI_LL1Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 7353 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"
__ z_nill(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, opnd_array(2)->constant()& 0xFFFF); 
#line 15741 "ad_s390.cpp"
  }
}

uint andI_reg_uimmI_LL1Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void andL_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1700 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((NGR_ZOPC /*primary()*/) >> 30) & 0x03) == 2, "Instruction format error");
    z_emit32(masm, (NGR_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */,24,32) |
             Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* src */,28,32));
  
#line 15764 "ad_s390.cpp"
  }
}

uint andL_reg_regNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void andL_Reg_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1855 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int isize = (NG_ZOPC /*secondary()*/) > 1L << 32 ? 48 : 32;
    Register Ridx = as_Register(opnd_array(2)->index(ra_,this,idx2));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.

    if (Displacement::is_shortDisp((long)opnd_array(2)->disp(ra_,this,idx2))) {
      z_emit_inst(masm, (NG_ZOPC /*secondary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */, 8, isize) |
                  Assembler::uimm12(opnd_array(2)->disp(ra_,this,idx2), 20, isize) |
                  Assembler::reg(Ridx, 12, isize) |
                  Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, isize));
    } else if (Displacement::is_validDisp((long)opnd_array(2)->disp(ra_,this,idx2))) {
      z_emit_inst(masm, (NG_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */, 8, 48) |
                  Assembler::simm20(opnd_array(2)->disp(ra_,this,idx2)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, 48));
    } else {
        __ load_const_optimized(Z_R1_scratch, opnd_array(2)->disp(ra_,this,idx2));
        if (Ridx != Z_R0) { __ z_agr(Z_R1_scratch, Ridx); }
        z_emit_inst(masm, (NG_ZOPC /*secondary()*/) |
                    Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */, 8, isize) |
                    Assembler::uimm12(0, 20, isize) |
                    Assembler::reg(Z_R1_scratch, 12, isize) |
                    Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, isize));
    }
  
#line 15808 "ad_s390.cpp"
  }
}

uint andL_Reg_memNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= Z_DISP3_SIZE, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : Z_DISP3_SIZE);
}

void andL_Reg_mem_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {

#line 1855 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int isize = (NG_ZOPC /*secondary()*/) > 1L << 32 ? 48 : 32;
    Register Ridx = as_Register(opnd_array(1)->index(ra_,this,idx1));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.

    if (Displacement::is_shortDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (NG_ZOPC /*secondary()*/) |
                  Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* dst */, 8, isize) |
                  Assembler::uimm12(opnd_array(1)->disp(ra_,this,idx1), 20, isize) |
                  Assembler::reg(Ridx, 12, isize) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    } else if (Displacement::is_validDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (NG_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* dst */, 8, 48) |
                  Assembler::simm20(opnd_array(1)->disp(ra_,this,idx1)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 48));
    } else {
        __ load_const_optimized(Z_R1_scratch, opnd_array(1)->disp(ra_,this,idx1));
        if (Ridx != Z_R0) { __ z_agr(Z_R1_scratch, Ridx); }
        z_emit_inst(masm, (NG_ZOPC /*secondary()*/) |
                    Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* dst */, 8, isize) |
                    Assembler::uimm12(0, 20, isize) |
                    Assembler::reg(Z_R1_scratch, 12, isize) |
                    Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    }
  
#line 15852 "ad_s390.cpp"
  }
}

uint andL_Reg_mem_0Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= Z_DISP3_SIZE, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : Z_DISP3_SIZE);
}

void andL_reg_uimmL_LL1Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 7386 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"
__ z_nill(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, opnd_array(2)->constantL()& 0xFFFF); 
#line 15870 "ad_s390.cpp"
  }
}

uint andL_reg_uimmL_LL1Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void andL_reg_uimmL_LH1Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 7396 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"
__ z_nilh(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, (opnd_array(2)->constantL()>> 16) & 0xFFFF); 
#line 15888 "ad_s390.cpp"
  }
}

uint andL_reg_uimmL_LH1Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void andL_reg_uimmL_HL1Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 7406 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"
__ z_nihl(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, (opnd_array(2)->constantL()>> 32) & 0xFFFF); 
#line 15906 "ad_s390.cpp"
  }
}

uint andL_reg_uimmL_HL1Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void andL_reg_uimmL_HH1Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 7416 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"
__ z_nihh(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, (opnd_array(2)->constantL()>> 48) & 0xFFFF); 
#line 15924 "ad_s390.cpp"
  }
}

uint andL_reg_uimmL_HH1Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void orI_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1692 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((OR_ZOPC /*primary()*/) >> 14) & 0x03) == 0, "Instruction format error");
    assert( ((OR_ZOPC /*primary()*/) >> 16)         == 0, "Instruction format error");
    z_emit16(masm, (OR_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */,8,16) |
             Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* src */,12,16));
  
#line 15948 "ad_s390.cpp"
  }
}

uint orI_reg_regNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 2, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 2);
}

void orI_Reg_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1855 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int isize = (O_ZOPC /*secondary()*/) > 1L << 32 ? 48 : 32;
    Register Ridx = as_Register(opnd_array(2)->index(ra_,this,idx2));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.

    if (Displacement::is_shortDisp((long)opnd_array(2)->disp(ra_,this,idx2))) {
      z_emit_inst(masm, (O_ZOPC /*secondary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */, 8, isize) |
                  Assembler::uimm12(opnd_array(2)->disp(ra_,this,idx2), 20, isize) |
                  Assembler::reg(Ridx, 12, isize) |
                  Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, isize));
    } else if (Displacement::is_validDisp((long)opnd_array(2)->disp(ra_,this,idx2))) {
      z_emit_inst(masm, (OY_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */, 8, 48) |
                  Assembler::simm20(opnd_array(2)->disp(ra_,this,idx2)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, 48));
    } else {
        __ load_const_optimized(Z_R1_scratch, opnd_array(2)->disp(ra_,this,idx2));
        if (Ridx != Z_R0) { __ z_agr(Z_R1_scratch, Ridx); }
        z_emit_inst(masm, (O_ZOPC /*secondary()*/) |
                    Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */, 8, isize) |
                    Assembler::uimm12(0, 20, isize) |
                    Assembler::reg(Z_R1_scratch, 12, isize) |
                    Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, isize));
    }
  
#line 15992 "ad_s390.cpp"
  }
}

void orI_Reg_mem_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {

#line 1855 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int isize = (O_ZOPC /*secondary()*/) > 1L << 32 ? 48 : 32;
    Register Ridx = as_Register(opnd_array(1)->index(ra_,this,idx1));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.

    if (Displacement::is_shortDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (O_ZOPC /*secondary()*/) |
                  Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* dst */, 8, isize) |
                  Assembler::uimm12(opnd_array(1)->disp(ra_,this,idx1), 20, isize) |
                  Assembler::reg(Ridx, 12, isize) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    } else if (Displacement::is_validDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (OY_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* dst */, 8, 48) |
                  Assembler::simm20(opnd_array(1)->disp(ra_,this,idx1)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 48));
    } else {
        __ load_const_optimized(Z_R1_scratch, opnd_array(1)->disp(ra_,this,idx1));
        if (Ridx != Z_R0) { __ z_agr(Z_R1_scratch, Ridx); }
        z_emit_inst(masm, (O_ZOPC /*secondary()*/) |
                    Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* dst */, 8, isize) |
                    Assembler::uimm12(0, 20, isize) |
                    Assembler::reg(Z_R1_scratch, 12, isize) |
                    Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    }
  
#line 16031 "ad_s390.cpp"
  }
}

void orI_reg_uimm16Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {

#line 1722 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((OILL_ZOPC /*primary()*/)>>30) & 0x03) == 2, "Instruction format error");
    z_emit32(masm, (OILL_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */,8,32) |
             Assembler::uimm16(opnd_array(2)->constant(),16,32));
  
#line 16049 "ad_s390.cpp"
  }
}

uint orI_reg_uimm16Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void orI_reg_uimm32Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {

#line 1744 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((OILF_ZOPC /*primary()*/)>>46) & 0x03) == 3, "Instruction format error");
    z_emit48(masm, (OILF_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */,8,48) |
             Assembler::uimm32(opnd_array(2)->constant(),16,48));
  
#line 16072 "ad_s390.cpp"
  }
}

uint orI_reg_uimm32Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void orL_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1700 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((OGR_ZOPC /*primary()*/) >> 30) & 0x03) == 2, "Instruction format error");
    z_emit32(masm, (OGR_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */,24,32) |
             Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* src */,28,32));
  
#line 16095 "ad_s390.cpp"
  }
}

uint orL_reg_regNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void orL_Reg_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1855 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int isize = (OG_ZOPC /*secondary()*/) > 1L << 32 ? 48 : 32;
    Register Ridx = as_Register(opnd_array(2)->index(ra_,this,idx2));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.

    if (Displacement::is_shortDisp((long)opnd_array(2)->disp(ra_,this,idx2))) {
      z_emit_inst(masm, (OG_ZOPC /*secondary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */, 8, isize) |
                  Assembler::uimm12(opnd_array(2)->disp(ra_,this,idx2), 20, isize) |
                  Assembler::reg(Ridx, 12, isize) |
                  Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, isize));
    } else if (Displacement::is_validDisp((long)opnd_array(2)->disp(ra_,this,idx2))) {
      z_emit_inst(masm, (OG_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */, 8, 48) |
                  Assembler::simm20(opnd_array(2)->disp(ra_,this,idx2)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, 48));
    } else {
        __ load_const_optimized(Z_R1_scratch, opnd_array(2)->disp(ra_,this,idx2));
        if (Ridx != Z_R0) { __ z_agr(Z_R1_scratch, Ridx); }
        z_emit_inst(masm, (OG_ZOPC /*secondary()*/) |
                    Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */, 8, isize) |
                    Assembler::uimm12(0, 20, isize) |
                    Assembler::reg(Z_R1_scratch, 12, isize) |
                    Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, isize));
    }
  
#line 16139 "ad_s390.cpp"
  }
}

uint orL_Reg_memNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= Z_DISP3_SIZE, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : Z_DISP3_SIZE);
}

void orL_Reg_mem_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {

#line 1855 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int isize = (OG_ZOPC /*secondary()*/) > 1L << 32 ? 48 : 32;
    Register Ridx = as_Register(opnd_array(1)->index(ra_,this,idx1));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.

    if (Displacement::is_shortDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (OG_ZOPC /*secondary()*/) |
                  Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* dst */, 8, isize) |
                  Assembler::uimm12(opnd_array(1)->disp(ra_,this,idx1), 20, isize) |
                  Assembler::reg(Ridx, 12, isize) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    } else if (Displacement::is_validDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (OG_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* dst */, 8, 48) |
                  Assembler::simm20(opnd_array(1)->disp(ra_,this,idx1)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 48));
    } else {
        __ load_const_optimized(Z_R1_scratch, opnd_array(1)->disp(ra_,this,idx1));
        if (Ridx != Z_R0) { __ z_agr(Z_R1_scratch, Ridx); }
        z_emit_inst(masm, (OG_ZOPC /*secondary()*/) |
                    Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* dst */, 8, isize) |
                    Assembler::uimm12(0, 20, isize) |
                    Assembler::reg(Z_R1_scratch, 12, isize) |
                    Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    }
  
#line 16183 "ad_s390.cpp"
  }
}

uint orL_Reg_mem_0Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= Z_DISP3_SIZE, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : Z_DISP3_SIZE);
}

void orL_reg_uimm16Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {

#line 1722 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((OILL_ZOPC /*primary()*/)>>30) & 0x03) == 2, "Instruction format error");
    z_emit32(masm, (OILL_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */,8,32) |
             Assembler::uimm16(opnd_array(2)->constantL(),16,32));
  
#line 16206 "ad_s390.cpp"
  }
}

uint orL_reg_uimm16Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void orL_reg_uimm32Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {

#line 1744 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((OILF_ZOPC /*primary()*/)>>46) & 0x03) == 3, "Instruction format error");
    z_emit48(masm, (OILF_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */,8,48) |
             Assembler::uimm32(opnd_array(2)->constantL(),16,48));
  
#line 16229 "ad_s390.cpp"
  }
}

void xorI_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1692 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((XR_ZOPC /*primary()*/) >> 14) & 0x03) == 0, "Instruction format error");
    assert( ((XR_ZOPC /*primary()*/) >> 16)         == 0, "Instruction format error");
    z_emit16(masm, (XR_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */,8,16) |
             Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* src */,12,16));
  
#line 16248 "ad_s390.cpp"
  }
}

uint xorI_reg_regNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 2, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 2);
}

void xorI_Reg_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1855 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int isize = (X_ZOPC /*secondary()*/) > 1L << 32 ? 48 : 32;
    Register Ridx = as_Register(opnd_array(2)->index(ra_,this,idx2));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.

    if (Displacement::is_shortDisp((long)opnd_array(2)->disp(ra_,this,idx2))) {
      z_emit_inst(masm, (X_ZOPC /*secondary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */, 8, isize) |
                  Assembler::uimm12(opnd_array(2)->disp(ra_,this,idx2), 20, isize) |
                  Assembler::reg(Ridx, 12, isize) |
                  Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, isize));
    } else if (Displacement::is_validDisp((long)opnd_array(2)->disp(ra_,this,idx2))) {
      z_emit_inst(masm, (XY_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */, 8, 48) |
                  Assembler::simm20(opnd_array(2)->disp(ra_,this,idx2)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, 48));
    } else {
        __ load_const_optimized(Z_R1_scratch, opnd_array(2)->disp(ra_,this,idx2));
        if (Ridx != Z_R0) { __ z_agr(Z_R1_scratch, Ridx); }
        z_emit_inst(masm, (X_ZOPC /*secondary()*/) |
                    Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */, 8, isize) |
                    Assembler::uimm12(0, 20, isize) |
                    Assembler::reg(Z_R1_scratch, 12, isize) |
                    Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, isize));
    }
  
#line 16292 "ad_s390.cpp"
  }
}

void xorI_Reg_mem_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {

#line 1855 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int isize = (X_ZOPC /*secondary()*/) > 1L << 32 ? 48 : 32;
    Register Ridx = as_Register(opnd_array(1)->index(ra_,this,idx1));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.

    if (Displacement::is_shortDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (X_ZOPC /*secondary()*/) |
                  Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* dst */, 8, isize) |
                  Assembler::uimm12(opnd_array(1)->disp(ra_,this,idx1), 20, isize) |
                  Assembler::reg(Ridx, 12, isize) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    } else if (Displacement::is_validDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (XY_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* dst */, 8, 48) |
                  Assembler::simm20(opnd_array(1)->disp(ra_,this,idx1)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 48));
    } else {
        __ load_const_optimized(Z_R1_scratch, opnd_array(1)->disp(ra_,this,idx1));
        if (Ridx != Z_R0) { __ z_agr(Z_R1_scratch, Ridx); }
        z_emit_inst(masm, (X_ZOPC /*secondary()*/) |
                    Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* dst */, 8, isize) |
                    Assembler::uimm12(0, 20, isize) |
                    Assembler::reg(Z_R1_scratch, 12, isize) |
                    Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    }
  
#line 16331 "ad_s390.cpp"
  }
}

void xorI_reg_uimm32Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1744 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((XILF_ZOPC /*primary()*/)>>46) & 0x03) == 3, "Instruction format error");
    z_emit48(masm, (XILF_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */,8,48) |
             Assembler::uimm32(opnd_array(2)->constant(),16,48));
  
#line 16349 "ad_s390.cpp"
  }
}

uint xorI_reg_uimm32Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void xorL_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1700 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((XGR_ZOPC /*primary()*/) >> 30) & 0x03) == 2, "Instruction format error");
    z_emit32(masm, (XGR_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */,24,32) |
             Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* src */,28,32));
  
#line 16372 "ad_s390.cpp"
  }
}

uint xorL_reg_regNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void xorL_Reg_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1855 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int isize = (XG_ZOPC /*secondary()*/) > 1L << 32 ? 48 : 32;
    Register Ridx = as_Register(opnd_array(2)->index(ra_,this,idx2));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.

    if (Displacement::is_shortDisp((long)opnd_array(2)->disp(ra_,this,idx2))) {
      z_emit_inst(masm, (XG_ZOPC /*secondary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */, 8, isize) |
                  Assembler::uimm12(opnd_array(2)->disp(ra_,this,idx2), 20, isize) |
                  Assembler::reg(Ridx, 12, isize) |
                  Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, isize));
    } else if (Displacement::is_validDisp((long)opnd_array(2)->disp(ra_,this,idx2))) {
      z_emit_inst(masm, (XG_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */, 8, 48) |
                  Assembler::simm20(opnd_array(2)->disp(ra_,this,idx2)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, 48));
    } else {
        __ load_const_optimized(Z_R1_scratch, opnd_array(2)->disp(ra_,this,idx2));
        if (Ridx != Z_R0) { __ z_agr(Z_R1_scratch, Ridx); }
        z_emit_inst(masm, (XG_ZOPC /*secondary()*/) |
                    Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */, 8, isize) |
                    Assembler::uimm12(0, 20, isize) |
                    Assembler::reg(Z_R1_scratch, 12, isize) |
                    Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, isize));
    }
  
#line 16416 "ad_s390.cpp"
  }
}

uint xorL_Reg_memNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= Z_DISP3_SIZE, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : Z_DISP3_SIZE);
}

void xorL_Reg_mem_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {

#line 1855 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int isize = (XG_ZOPC /*secondary()*/) > 1L << 32 ? 48 : 32;
    Register Ridx = as_Register(opnd_array(1)->index(ra_,this,idx1));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.

    if (Displacement::is_shortDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (XG_ZOPC /*secondary()*/) |
                  Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* dst */, 8, isize) |
                  Assembler::uimm12(opnd_array(1)->disp(ra_,this,idx1), 20, isize) |
                  Assembler::reg(Ridx, 12, isize) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    } else if (Displacement::is_validDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (XG_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* dst */, 8, 48) |
                  Assembler::simm20(opnd_array(1)->disp(ra_,this,idx1)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 48));
    } else {
        __ load_const_optimized(Z_R1_scratch, opnd_array(1)->disp(ra_,this,idx1));
        if (Ridx != Z_R0) { __ z_agr(Z_R1_scratch, Ridx); }
        z_emit_inst(masm, (XG_ZOPC /*secondary()*/) |
                    Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* dst */, 8, isize) |
                    Assembler::uimm12(0, 20, isize) |
                    Assembler::reg(Z_R1_scratch, 12, isize) |
                    Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    }
  
#line 16460 "ad_s390.cpp"
  }
}

uint xorL_Reg_mem_0Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= Z_DISP3_SIZE, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : Z_DISP3_SIZE);
}

void xorL_reg_uimm32Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {

#line 1744 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((XILF_ZOPC /*primary()*/)>>46) & 0x03) == 3, "Instruction format error");
    z_emit48(masm, (XILF_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */,8,48) |
             Assembler::uimm32(opnd_array(2)->constantL(),16,48));
  
#line 16483 "ad_s390.cpp"
  }
}

uint xorL_reg_uimm32Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void convI2BNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 7593 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    __ z_lnr(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);  // Rdst := -|Rsrc|, i.e. Rdst == 0 <=> Rsrc == 0
    __ z_srl(opnd_array(0)->as_Register(ra_,this)/* dst */, 31);              // Rdst := sign(Rdest)
  
#line 16503 "ad_s390.cpp"
  }
}

uint convI2BNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void convP2BNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 7606 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    __ z_lngr(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);     // Rdst := -|Rsrc| i.e. Rdst == 0 <=> Rsrc == 0
    __ z_srlg(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(0)->as_Register(ra_,this)/* dst */, 63); // Rdst := sign(Rdest)
  
#line 16523 "ad_s390.cpp"
  }
}

uint convP2BNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 10, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 10);
}

void cmpLTMask_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 7619 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    // Avoid signed 32 bit overflow: Do sign extend and sub 64 bit.
    __ z_lgfr(Z_R0_scratch, opnd_array(2)->as_Register(ra_,this,idx2)/* src */);
    __ z_lgfr(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* dst */);
    __ z_sgr(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, Z_R0_scratch);
    __ z_srag(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, 63);
  
#line 16547 "ad_s390.cpp"
  }
}

uint cmpLTMask_reg_regNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 18, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 18);
}

void cmpLTMask_reg_zeroNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 7635 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"
__ z_sra(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, 31); 
#line 16565 "ad_s390.cpp"
  }
}

uint cmpLTMask_reg_zeroNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void convD2F_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1700 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((LEDBR_ZOPC /*primary()*/) >> 30) & 0x03) == 2, "Instruction format error");
    z_emit32(masm, (LEDBR_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */,24,32) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src */,28,32));
  
#line 16587 "ad_s390.cpp"
  }
}

uint convD2F_regNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void convF2I_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 7659 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Label done;
    __ clear_reg(opnd_array(0)->as_Register(ra_,this)/* dst */, false, false);  // Initialize with result for unordered: 0.
    __ z_cebr(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);   // Round.
    __ z_brno(done);                             // Result is zero if unordered argument.
    __ z_cfebr(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, Assembler::to_zero);
    __ bind(done);
  
#line 16611 "ad_s390.cpp"
  }
}

uint convF2I_regNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 16, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 16);
}

void convD2I_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 7676 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Label done;
    __ clear_reg(opnd_array(0)->as_Register(ra_,this)/* dst */, false, false);  // Initialize with result for unordered: 0.
    __ z_cdbr(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);   // Round.
    __ z_brno(done);                             // Result is zero if unordered argument.
    __ z_cfdbr(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, Assembler::to_zero);
    __ bind(done);
  
#line 16635 "ad_s390.cpp"
  }
}

uint convD2I_regNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 16, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 16);
}

void convF2L_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 7693 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Label done;
    __ clear_reg(opnd_array(0)->as_Register(ra_,this)/* dst */, true, false);  // Initialize with result for unordered: 0.
    __ z_cebr(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);   // Round.
    __ z_brno(done);                             // Result is zero if unordered argument.
    __ z_cgebr(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, Assembler::to_zero);
    __ bind(done);
  
#line 16659 "ad_s390.cpp"
  }
}

uint convF2L_regNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 16, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 16);
}

void convD2L_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 7710 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Label done;
    __ clear_reg(opnd_array(0)->as_Register(ra_,this)/* dst */, true, false);  // Initialize with result for unordered: 0.
    __ z_cdbr(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);   // Round.
    __ z_brno(done);                             // Result is zero if unordered argument.
    __ z_cgdbr(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */, Assembler::to_zero);
    __ bind(done);
  
#line 16683 "ad_s390.cpp"
  }
}

uint convD2L_regNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 16, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 16);
}

void convF2D_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1700 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((LDEBR_ZOPC /*primary()*/) >> 30) & 0x03) == 2, "Instruction format error");
    z_emit32(masm, (LDEBR_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */,24,32) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src */,28,32));
  
#line 16705 "ad_s390.cpp"
  }
}

uint convF2D_regNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void convF2D_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1819 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Ridx = as_Register(opnd_array(1)->index(ra_,this,idx1));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.
    if ((LDEB_ZOPC /*primary()*/) > (1L << 32)) {
      z_emit_inst(masm, (LDEB_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, 48) |
                  Assembler::uimm12(opnd_array(1)->disp(ra_,this,idx1), 20, 48) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 48));
    } else {
      z_emit_inst(masm, (LDEB_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, 32) |
                  Assembler::uimm12(opnd_array(1)->disp(ra_,this,idx1), 20, 32) |
                  Assembler::reg(Ridx, 12, 32) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 32));
    }
  
#line 16738 "ad_s390.cpp"
  }
}

uint convF2D_memNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void convI2D_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1700 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((CDFBR_ZOPC /*primary()*/) >> 30) & 0x03) == 2, "Instruction format error");
    z_emit32(masm, (CDFBR_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */,24,32) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src */,28,32));
  
#line 16760 "ad_s390.cpp"
  }
}

uint convI2D_regNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void convI2F_iregNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1700 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((CEFBR_ZOPC /*primary()*/) >> 30) & 0x03) == 2, "Instruction format error");
    z_emit32(masm, (CEFBR_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */,24,32) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src */,28,32));
  
#line 16782 "ad_s390.cpp"
  }
}

uint convI2F_iregNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void convI2L_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1700 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((LGFR_ZOPC /*primary()*/) >> 30) & 0x03) == 2, "Instruction format error");
    z_emit32(masm, (LGFR_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */,24,32) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src */,28,32));
  
#line 16804 "ad_s390.cpp"
  }
}

uint convI2L_regNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void convI2L_reg_zexNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {

#line 7778 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"
__ z_llgfr(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */); 
#line 16822 "ad_s390.cpp"
  }
}

uint convI2L_reg_zexNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void convI2L_mem_zexNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {

#line 1855 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int isize = (LLGF_ZOPC /*secondary()*/) > 1L << 32 ? 48 : 32;
    Register Ridx = as_Register(opnd_array(1)->index(ra_,this,idx1));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.

    if (Displacement::is_shortDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (LLGF_ZOPC /*secondary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, isize) |
                  Assembler::uimm12(opnd_array(1)->disp(ra_,this,idx1), 20, isize) |
                  Assembler::reg(Ridx, 12, isize) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    } else if (Displacement::is_validDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (LLGF_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, 48) |
                  Assembler::simm20(opnd_array(1)->disp(ra_,this,idx1)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 48));
    } else {
        __ load_const_optimized(Z_R1_scratch, opnd_array(1)->disp(ra_,this,idx1));
        if (Ridx != Z_R0) { __ z_agr(Z_R1_scratch, Ridx); }
        z_emit_inst(masm, (LLGF_ZOPC /*secondary()*/) |
                    Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, isize) |
                    Assembler::uimm12(0, 20, isize) |
                    Assembler::reg(Z_R1_scratch, 12, isize) |
                    Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    }
  
#line 16866 "ad_s390.cpp"
  }
}

void zeroExtend_longNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {

#line 7798 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"
__ z_llgfr(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */); 
#line 16879 "ad_s390.cpp"
  }
}

uint zeroExtend_longNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void rShiftI16_lShiftI16_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// amount
  {

#line 1700 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((LHR_ZOPC /*primary()*/) >> 30) & 0x03) == 2, "Instruction format error");
    z_emit32(masm, (LHR_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */,24,32) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src */,28,32));
  
#line 16902 "ad_s390.cpp"
  }
}

uint rShiftI16_lShiftI16_regNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void rShiftI24_lShiftI24_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// amount
  {

#line 1700 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((LBR_ZOPC /*primary()*/) >> 30) & 0x03) == 2, "Instruction format error");
    z_emit32(masm, (LBR_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */,24,32) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src */,28,32));
  
#line 16925 "ad_s390.cpp"
  }
}

uint rShiftI24_lShiftI24_regNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void MoveF2I_stack_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1837 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Ridx = as_Register(opnd_array(1)->index(ra_,this,idx1));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.
    if ((L_ZOPC /*primary()*/) > (1L<<32)) {
      z_emit_inst(masm, (L_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, 48) |
                  Assembler::simm20(opnd_array(1)->disp(ra_,this,idx1)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 48));
    } else {
      z_emit_inst(masm, (L_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, 32) |
                  Assembler::uimm12(opnd_array(1)->disp(ra_,this,idx1), 20, 32) |
                  Assembler::reg(Ridx, 12, 32) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 32));
    }
  
#line 16958 "ad_s390.cpp"
  }
}

uint MoveF2I_stack_regNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void MoveI2F_stack_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1837 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Ridx = as_Register(opnd_array(1)->index(ra_,this,idx1));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.
    if ((LE_ZOPC /*primary()*/) > (1L<<32)) {
      z_emit_inst(masm, (LE_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, 48) |
                  Assembler::simm20(opnd_array(1)->disp(ra_,this,idx1)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 48));
    } else {
      z_emit_inst(masm, (LE_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, 32) |
                  Assembler::uimm12(opnd_array(1)->disp(ra_,this,idx1), 20, 32) |
                  Assembler::reg(Ridx, 12, 32) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 32));
    }
  
#line 16991 "ad_s390.cpp"
  }
}

void MoveD2L_stack_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1837 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Ridx = as_Register(opnd_array(1)->index(ra_,this,idx1));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.
    if ((LG_ZOPC /*primary()*/) > (1L<<32)) {
      z_emit_inst(masm, (LG_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, 48) |
                  Assembler::simm20(opnd_array(1)->disp(ra_,this,idx1)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 48));
    } else {
      z_emit_inst(masm, (LG_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, 32) |
                  Assembler::uimm12(opnd_array(1)->disp(ra_,this,idx1), 20, 32) |
                  Assembler::reg(Ridx, 12, 32) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 32));
    }
  
#line 17019 "ad_s390.cpp"
  }
}

uint MoveD2L_stack_regNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void MoveL2D_stack_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1837 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Ridx = as_Register(opnd_array(1)->index(ra_,this,idx1));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.
    if ((LD_ZOPC /*primary()*/) > (1L<<32)) {
      z_emit_inst(masm, (LD_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, 48) |
                  Assembler::simm20(opnd_array(1)->disp(ra_,this,idx1)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 48));
    } else {
      z_emit_inst(masm, (LD_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, 32) |
                  Assembler::uimm12(opnd_array(1)->disp(ra_,this,idx1), 20, 32) |
                  Assembler::reg(Ridx, 12, 32) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 32));
    }
  
#line 17052 "ad_s390.cpp"
  }
}

uint MoveL2D_stack_regNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void MoveI2F_reg_stackNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1837 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Ridx = as_Register(opnd_array(0)->index(ra_,this,idx0));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.
    if ((ST_ZOPC /*primary()*/) > (1L<<32)) {
      z_emit_inst(masm, (ST_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src */, 8, 48) |
                  Assembler::simm20(opnd_array(0)->disp(ra_,this,0)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(0)->base(ra_,this,idx0)), 16, 48));
    } else {
      z_emit_inst(masm, (ST_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src */, 8, 32) |
                  Assembler::uimm12(opnd_array(0)->disp(ra_,this,0), 20, 32) |
                  Assembler::reg(Ridx, 12, 32) |
                  Assembler::regz(reg_to_register_object(opnd_array(0)->base(ra_,this,idx0)), 16, 32));
    }
  
#line 17085 "ad_s390.cpp"
  }
}

uint MoveI2F_reg_stackNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void MoveD2L_reg_stackNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1837 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Ridx = as_Register(opnd_array(0)->index(ra_,this,idx0));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.
    if ((STD_ZOPC /*primary()*/) > (1L<<32)) {
      z_emit_inst(masm, (STD_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src */, 8, 48) |
                  Assembler::simm20(opnd_array(0)->disp(ra_,this,0)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(0)->base(ra_,this,idx0)), 16, 48));
    } else {
      z_emit_inst(masm, (STD_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src */, 8, 32) |
                  Assembler::uimm12(opnd_array(0)->disp(ra_,this,0), 20, 32) |
                  Assembler::reg(Ridx, 12, 32) |
                  Assembler::regz(reg_to_register_object(opnd_array(0)->base(ra_,this,idx0)), 16, 32));
    }
  
#line 17118 "ad_s390.cpp"
  }
}

uint MoveD2L_reg_stackNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void MoveL2D_reg_stackNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1837 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Ridx = as_Register(opnd_array(0)->index(ra_,this,idx0));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.
    if ((STG_ZOPC /*primary()*/) > (1L<<32)) {
      z_emit_inst(masm, (STG_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src */, 8, 48) |
                  Assembler::simm20(opnd_array(0)->disp(ra_,this,0)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(0)->base(ra_,this,idx0)), 16, 48));
    } else {
      z_emit_inst(masm, (STG_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src */, 8, 32) |
                  Assembler::uimm12(opnd_array(0)->disp(ra_,this,0), 20, 32) |
                  Assembler::reg(Ridx, 12, 32) |
                  Assembler::regz(reg_to_register_object(opnd_array(0)->base(ra_,this,idx0)), 16, 32));
    }
  
#line 17151 "ad_s390.cpp"
  }
}

uint MoveL2D_reg_stackNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void convL2F_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1700 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((CEGBR_ZOPC /*primary()*/) >> 30) & 0x03) == 2, "Instruction format error");
    z_emit32(masm, (CEGBR_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */,24,32) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src */,28,32));
  
#line 17173 "ad_s390.cpp"
  }
}

uint convL2F_regNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void convL2D_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1700 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((CDGBR_ZOPC /*primary()*/) >> 30) & 0x03) == 2, "Instruction format error");
    z_emit32(masm, (CDGBR_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */,24,32) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src */,28,32));
  
#line 17195 "ad_s390.cpp"
  }
}

uint convL2D_regNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void convL2I_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 7918 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"
__ lr_if_needed(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */); 
#line 17212 "ad_s390.cpp"
  }
}

void shrL_reg_imm6_L2INode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt
  {

#line 1751 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    z_emit48(masm, (SRAG_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */,8,48) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src */,12,48) |
             Assembler::simm20(opnd_array(2)->constant()));
  
#line 17230 "ad_s390.cpp"
  }
}

uint shrL_reg_imm6_L2INode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void rangeCheck_iReg_uimmI16Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// length
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// index
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {

#line 7954 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"
__ z_clfit(opnd_array(2)->as_Register(ra_,this,idx2)/* length */, opnd_array(3)->constant(), opnd_array(1)->ccode()); 
#line 17250 "ad_s390.cpp"
  }
}

void rangeCheck_iReg_iRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// index
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// length
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cr
  {

#line 7972 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"
__ z_clrt(opnd_array(2)->as_Register(ra_,this,idx2)/* index */, opnd_array(3)->as_Register(ra_,this,idx3)/* length */, opnd_array(1)->ccode()); 
#line 17265 "ad_s390.cpp"
  }
}

void rangeCheck_uimmI16_iRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// index
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// length
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {

#line 7990 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"
__ z_clfit(opnd_array(2)->as_Register(ra_,this,idx2)/* index */, opnd_array(3)->constant(), opnd_array(1)->ccode()); 
#line 17280 "ad_s390.cpp"
  }
}

void zeroCheckP_iReg_imm0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// value
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {

#line 8007 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"
__ z_cgit(opnd_array(2)->as_Register(ra_,this,idx2)/* value */, 0, opnd_array(1)->ccode()); 
#line 17295 "ad_s390.cpp"
  }
}

uint zeroCheckP_iReg_imm0Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void zeroCheckN_iReg_imm0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// value
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {

#line 8024 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"
__ z_cit(opnd_array(2)->as_Register(ra_,this,idx2)/* value */, 0, opnd_array(1)->ccode()); 
#line 17315 "ad_s390.cpp"
  }
}

uint zeroCheckN_iReg_imm0Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void compI_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 1692 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((CR_ZOPC /*primary()*/) >> 14) & 0x03) == 0, "Instruction format error");
    assert( ((CR_ZOPC /*primary()*/) >> 16)         == 0, "Instruction format error");
    z_emit16(masm, (CR_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* op1 */,8,16) |
             Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* op2 */,12,16));
  
#line 17339 "ad_s390.cpp"
  }
}

uint compI_reg_regNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 2, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 2);
}

void compI_reg_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 1737 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((CFI_ZOPC /*primary()*/)>>46) & 0x03) == 3, "Instruction format error");
    z_emit48(masm, (CFI_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* op1 */,8,48) |
             Assembler::simm32(opnd_array(2)->constant(),16,48));
  
#line 17362 "ad_s390.cpp"
  }
}

uint compI_reg_immNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void compI_reg_imm16Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 1715 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((CHI_ZOPC /*primary()*/)>>30) & 0x03) == 2, "Instruction format error");
    z_emit32(masm, (CHI_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* op1 */,8,32) |
             Assembler::simm16(opnd_array(2)->constant(),16,32));
  
#line 17385 "ad_s390.cpp"
  }
}

uint compI_reg_imm16Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void compI_reg_imm0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 1692 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((LTR_ZOPC /*primary()*/) >> 14) & 0x03) == 0, "Instruction format error");
    assert( ((LTR_ZOPC /*primary()*/) >> 16)         == 0, "Instruction format error");
    z_emit16(masm, (LTR_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* op1 */,8,16) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* op1 */,12,16));
  
#line 17409 "ad_s390.cpp"
  }
}

uint compI_reg_imm0Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 2, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 2);
}

void compI_reg_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 1855 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int isize = (C_ZOPC /*secondary()*/) > 1L << 32 ? 48 : 32;
    Register Ridx = as_Register(opnd_array(2)->index(ra_,this,idx2));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.

    if (Displacement::is_shortDisp((long)opnd_array(2)->disp(ra_,this,idx2))) {
      z_emit_inst(masm, (C_ZOPC /*secondary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* op1 */, 8, isize) |
                  Assembler::uimm12(opnd_array(2)->disp(ra_,this,idx2), 20, isize) |
                  Assembler::reg(Ridx, 12, isize) |
                  Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, isize));
    } else if (Displacement::is_validDisp((long)opnd_array(2)->disp(ra_,this,idx2))) {
      z_emit_inst(masm, (CY_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* op1 */, 8, 48) |
                  Assembler::simm20(opnd_array(2)->disp(ra_,this,idx2)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, 48));
    } else {
        __ load_const_optimized(Z_R1_scratch, opnd_array(2)->disp(ra_,this,idx2));
        if (Ridx != Z_R0) { __ z_agr(Z_R1_scratch, Ridx); }
        z_emit_inst(masm, (C_ZOPC /*secondary()*/) |
                    Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* op1 */, 8, isize) |
                    Assembler::uimm12(0, 20, isize) |
                    Assembler::reg(Z_R1_scratch, 12, isize) |
                    Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, isize));
    }
  
#line 17453 "ad_s390.cpp"
  }
}

void compU_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 1692 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((CLR_ZOPC /*primary()*/) >> 14) & 0x03) == 0, "Instruction format error");
    assert( ((CLR_ZOPC /*primary()*/) >> 16)         == 0, "Instruction format error");
    z_emit16(masm, (CLR_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* op1 */,8,16) |
             Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* op2 */,12,16));
  
#line 17472 "ad_s390.cpp"
  }
}

uint compU_reg_regNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 2, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 2);
}

void compU_reg_uimmNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 1744 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((CLFI_ZOPC /*primary()*/)>>46) & 0x03) == 3, "Instruction format error");
    z_emit48(masm, (CLFI_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* op1 */,8,48) |
             Assembler::uimm32(opnd_array(2)->constant(),16,48));
  
#line 17495 "ad_s390.cpp"
  }
}

uint compU_reg_uimmNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void compU_reg_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 1855 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int isize = (CL_ZOPC /*secondary()*/) > 1L << 32 ? 48 : 32;
    Register Ridx = as_Register(opnd_array(2)->index(ra_,this,idx2));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.

    if (Displacement::is_shortDisp((long)opnd_array(2)->disp(ra_,this,idx2))) {
      z_emit_inst(masm, (CL_ZOPC /*secondary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* op1 */, 8, isize) |
                  Assembler::uimm12(opnd_array(2)->disp(ra_,this,idx2), 20, isize) |
                  Assembler::reg(Ridx, 12, isize) |
                  Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, isize));
    } else if (Displacement::is_validDisp((long)opnd_array(2)->disp(ra_,this,idx2))) {
      z_emit_inst(masm, (CLY_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* op1 */, 8, 48) |
                  Assembler::simm20(opnd_array(2)->disp(ra_,this,idx2)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, 48));
    } else {
        __ load_const_optimized(Z_R1_scratch, opnd_array(2)->disp(ra_,this,idx2));
        if (Ridx != Z_R0) { __ z_agr(Z_R1_scratch, Ridx); }
        z_emit_inst(masm, (CL_ZOPC /*secondary()*/) |
                    Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* op1 */, 8, isize) |
                    Assembler::uimm12(0, 20, isize) |
                    Assembler::reg(Z_R1_scratch, 12, isize) |
                    Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, isize));
    }
  
#line 17539 "ad_s390.cpp"
  }
}

void compL_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 1700 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((CGR_ZOPC /*primary()*/) >> 30) & 0x03) == 2, "Instruction format error");
    z_emit32(masm, (CGR_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* op1 */,24,32) |
             Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* op2 */,28,32));
  
#line 17557 "ad_s390.cpp"
  }
}

uint compL_reg_regNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void compL_reg_regINode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 1700 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((CGFR_ZOPC /*primary()*/) >> 30) & 0x03) == 2, "Instruction format error");
    z_emit32(masm, (CGFR_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* op1 */,24,32) |
             Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* op2 */,28,32));
  
#line 17580 "ad_s390.cpp"
  }
}

uint compL_reg_regINode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void compL_reg_imm32Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {

#line 1737 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((CGFI_ZOPC /*primary()*/)>>46) & 0x03) == 3, "Instruction format error");
    z_emit48(masm, (CGFI_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* op1 */,8,48) |
             Assembler::simm32(opnd_array(2)->constantL(),16,48));
  
#line 17603 "ad_s390.cpp"
  }
}

uint compL_reg_imm32Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void compL_reg_imm16Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {

#line 1715 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((CGHI_ZOPC /*primary()*/)>>30) & 0x03) == 2, "Instruction format error");
    z_emit32(masm, (CGHI_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* op1 */,8,32) |
             Assembler::simm16(opnd_array(2)->constantL(),16,32));
  
#line 17626 "ad_s390.cpp"
  }
}

uint compL_reg_imm16Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void compL_reg_imm0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {

#line 1700 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((LTGR_ZOPC /*primary()*/) >> 30) & 0x03) == 2, "Instruction format error");
    z_emit32(masm, (LTGR_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* op1 */,24,32) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* op1 */,28,32));
  
#line 17649 "ad_s390.cpp"
  }
}

uint compL_reg_imm0Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void compL_conv_reg_imm0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {

#line 1700 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((LTGFR_ZOPC /*primary()*/) >> 30) & 0x03) == 2, "Instruction format error");
    z_emit32(masm, (LTGFR_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* op1 */,24,32) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* op1 */,28,32));
  
#line 17672 "ad_s390.cpp"
  }
}

uint compL_conv_reg_imm0Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void compL_reg_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1855 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int isize = (CG_ZOPC /*secondary()*/) > 1L << 32 ? 48 : 32;
    Register Ridx = as_Register(opnd_array(2)->index(ra_,this,idx2));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.

    if (Displacement::is_shortDisp((long)opnd_array(2)->disp(ra_,this,idx2))) {
      z_emit_inst(masm, (CG_ZOPC /*secondary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */, 8, isize) |
                  Assembler::uimm12(opnd_array(2)->disp(ra_,this,idx2), 20, isize) |
                  Assembler::reg(Ridx, 12, isize) |
                  Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, isize));
    } else if (Displacement::is_validDisp((long)opnd_array(2)->disp(ra_,this,idx2))) {
      z_emit_inst(masm, (CG_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */, 8, 48) |
                  Assembler::simm20(opnd_array(2)->disp(ra_,this,idx2)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, 48));
    } else {
        __ load_const_optimized(Z_R1_scratch, opnd_array(2)->disp(ra_,this,idx2));
        if (Ridx != Z_R0) { __ z_agr(Z_R1_scratch, Ridx); }
        z_emit_inst(masm, (CG_ZOPC /*secondary()*/) |
                    Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */, 8, isize) |
                    Assembler::uimm12(0, 20, isize) |
                    Assembler::reg(Z_R1_scratch, 12, isize) |
                    Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, isize));
    }
  
#line 17716 "ad_s390.cpp"
  }
}

uint compL_reg_memNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= Z_DISP3_SIZE, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : Z_DISP3_SIZE);
}

void compL_reg_memINode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1855 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int isize = (CGF_ZOPC /*secondary()*/) > 1L << 32 ? 48 : 32;
    Register Ridx = as_Register(opnd_array(2)->index(ra_,this,idx2));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.

    if (Displacement::is_shortDisp((long)opnd_array(2)->disp(ra_,this,idx2))) {
      z_emit_inst(masm, (CGF_ZOPC /*secondary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */, 8, isize) |
                  Assembler::uimm12(opnd_array(2)->disp(ra_,this,idx2), 20, isize) |
                  Assembler::reg(Ridx, 12, isize) |
                  Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, isize));
    } else if (Displacement::is_validDisp((long)opnd_array(2)->disp(ra_,this,idx2))) {
      z_emit_inst(masm, (CGF_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */, 8, 48) |
                  Assembler::simm20(opnd_array(2)->disp(ra_,this,idx2)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, 48));
    } else {
        __ load_const_optimized(Z_R1_scratch, opnd_array(2)->disp(ra_,this,idx2));
        if (Ridx != Z_R0) { __ z_agr(Z_R1_scratch, Ridx); }
        z_emit_inst(masm, (CGF_ZOPC /*secondary()*/) |
                    Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */, 8, isize) |
                    Assembler::uimm12(0, 20, isize) |
                    Assembler::reg(Z_R1_scratch, 12, isize) |
                    Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, isize));
    }
  
#line 17760 "ad_s390.cpp"
  }
}

uint compL_reg_memINode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= Z_DISP3_SIZE, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : Z_DISP3_SIZE);
}

void compUL_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 1700 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((CLGR_ZOPC /*primary()*/) >> 30) & 0x03) == 2, "Instruction format error");
    z_emit32(masm, (CLGR_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* op1 */,24,32) |
             Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* op2 */,28,32));
  
#line 17783 "ad_s390.cpp"
  }
}

uint compUL_reg_regNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void compUL_reg_imm32Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {

#line 1744 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((CLGFI_ZOPC /*primary()*/)>>46) & 0x03) == 3, "Instruction format error");
    z_emit48(masm, (CLGFI_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* op1 */,8,48) |
             Assembler::uimm32(opnd_array(2)->constantL(),16,48));
  
#line 17806 "ad_s390.cpp"
  }
}

uint compUL_reg_imm32Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void compP_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 1700 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((CLGR_ZOPC /*primary()*/) >> 30) & 0x03) == 2, "Instruction format error");
    z_emit32(masm, (CLGR_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* op1 */,24,32) |
             Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* op2 */,28,32));
  
#line 17829 "ad_s390.cpp"
  }
}

uint compP_reg_regNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void compP_reg_imm0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 1700 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((LTGR_ZOPC /*primary()*/) >> 30) & 0x03) == 2, "Instruction format error");
    z_emit32(masm, (LTGR_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* op1 */,24,32) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* op1 */,28,32));
  
#line 17852 "ad_s390.cpp"
  }
}

uint compP_reg_imm0Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void compP_decode_reg_imm0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 1692 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((LTR_ZOPC /*primary()*/) >> 14) & 0x03) == 0, "Instruction format error");
    assert( ((LTR_ZOPC /*primary()*/) >> 16)         == 0, "Instruction format error");
    z_emit16(masm, (LTR_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* op1 */,8,16) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* op1 */,12,16));
  
#line 17876 "ad_s390.cpp"
  }
}

uint compP_decode_reg_imm0Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 2, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 2);
}

void compP_reg_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1855 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int isize = (CLG_ZOPC /*secondary()*/) > 1L << 32 ? 48 : 32;
    Register Ridx = as_Register(opnd_array(2)->index(ra_,this,idx2));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.

    if (Displacement::is_shortDisp((long)opnd_array(2)->disp(ra_,this,idx2))) {
      z_emit_inst(masm, (CLG_ZOPC /*secondary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */, 8, isize) |
                  Assembler::uimm12(opnd_array(2)->disp(ra_,this,idx2), 20, isize) |
                  Assembler::reg(Ridx, 12, isize) |
                  Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, isize));
    } else if (Displacement::is_validDisp((long)opnd_array(2)->disp(ra_,this,idx2))) {
      z_emit_inst(masm, (CLG_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */, 8, 48) |
                  Assembler::simm20(opnd_array(2)->disp(ra_,this,idx2)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, 48));
    } else {
        __ load_const_optimized(Z_R1_scratch, opnd_array(2)->disp(ra_,this,idx2));
        if (Ridx != Z_R0) { __ z_agr(Z_R1_scratch, Ridx); }
        z_emit_inst(masm, (CLG_ZOPC /*secondary()*/) |
                    Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* dst */, 8, isize) |
                    Assembler::uimm12(0, 20, isize) |
                    Assembler::reg(Z_R1_scratch, 12, isize) |
                    Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, isize));
    }
  
#line 17920 "ad_s390.cpp"
  }
}

uint compP_reg_memNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= Z_DISP3_SIZE, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : Z_DISP3_SIZE);
}

void z196_minI_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 8261 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Rdst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register Rsrc1 = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    Register Rsrc2 = opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */;

    if (Rsrc1 == Rsrc2) {
      if (Rdst != Rsrc1) {
        __ z_lgfr(Rdst, Rsrc1);
      }
    } else if (Rdst == Rsrc1) {   // Rdst preset with src1.
      __ z_cr(Rsrc1, Rsrc2);      // Move src2 only if src1 is NotLow.
      __ z_locr(Rdst, Rsrc2, Assembler::bcondNotLow);
    } else if (Rdst == Rsrc2) {   // Rdst preset with src2.
      __ z_cr(Rsrc2, Rsrc1);      // Move src1 only if src2 is NotLow.
      __ z_locr(Rdst, Rsrc1, Assembler::bcondNotLow);
    } else {
      // Rdst is disjoint from operands, move in either case.
      __ z_cr(Rsrc1, Rsrc2);
      __ z_locr(Rdst, Rsrc2, Assembler::bcondNotLow);
      __ z_locr(Rdst, Rsrc1, Assembler::bcondLow);
    }
  
#line 17959 "ad_s390.cpp"
  }
}

void z10_minI_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 8294 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Rdst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register Rsrc1 = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    Register Rsrc2 = opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */;
    Label done;

    if (Rsrc1 == Rsrc2) {
      if (Rdst != Rsrc1) {
        __ z_lgfr(Rdst, Rsrc1);
      }
    } else if (Rdst == Rsrc1) {
      __ z_crj(Rsrc1, Rsrc2, Assembler::bcondLow, done);
      __ z_lgfr(Rdst, Rsrc2);
    } else if (Rdst == Rsrc2) {
      __ z_crj(Rsrc2, Rsrc1, Assembler::bcondLow, done);
      __ z_lgfr(Rdst, Rsrc1);
    } else {
      __ z_lgfr(Rdst, Rsrc1);
      __ z_crj(Rsrc1, Rsrc2, Assembler::bcondLow, done);
      __ z_lgfr(Rdst, Rsrc2);
    }
    __ bind(done);
  
#line 17994 "ad_s390.cpp"
  }
}

void minI_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 8327 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Rdst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register Rsrc1 = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    Register Rsrc2 = opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */;
    Label done;

    if (Rsrc1 == Rsrc2) {
      if (Rdst != Rsrc1) {
        __ z_lgfr(Rdst, Rsrc1);
      }
    } else if (Rdst == Rsrc1) {
      __ z_cr(Rsrc1, Rsrc2);
      __ z_brl(done);
      __ z_lgfr(Rdst, Rsrc2);
    } else if (Rdst == Rsrc2) {
      __ z_cr(Rsrc2, Rsrc1);
      __ z_brl(done);
      __ z_lgfr(Rdst, Rsrc1);
    } else {
      __ z_lgfr(Rdst, Rsrc1);
      __ z_cr(Rsrc1, Rsrc2);
      __ z_brl(done);
      __ z_lgfr(Rdst, Rsrc2);
    }
    __ bind(done);
  
#line 18032 "ad_s390.cpp"
  }
}

void z196_minI_reg_imm32Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 8363 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Rdst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register Rsrc1 = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    int      Isrc2 = opnd_array(2)->constant();

    if (Rdst == Rsrc1) {
      __ load_const_optimized(Z_R0_scratch, Isrc2);
      __ z_cfi(Rsrc1, Isrc2);
      __ z_locr(Rdst, Z_R0_scratch, Assembler::bcondNotLow);
    } else {
      __ load_const_optimized(Rdst, Isrc2);
      __ z_cfi(Rsrc1, Isrc2);
      __ z_locr(Rdst, Rsrc1, Assembler::bcondLow);
    }
  
#line 18059 "ad_s390.cpp"
  }
}

void minI_reg_imm32Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 8387 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Label done;
    if (opnd_array(0)->as_Register(ra_,this)/* dst */!= opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */) {
      __ z_lgfr(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */);
    }
    __ z_cfi(opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(2)->constant());
    __ z_brl(done);
    __ z_lgfi(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(2)->constant());
    __ bind(done);
  
#line 18081 "ad_s390.cpp"
  }
}

void z196_minI_reg_imm16Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 8407 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Rdst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register Rsrc1 = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    int      Isrc2 = opnd_array(2)->constant();

    if (Rdst == Rsrc1) {
      __ load_const_optimized(Z_R0_scratch, Isrc2);
      __ z_chi(Rsrc1, Isrc2);
      __ z_locr(Rdst, Z_R0_scratch, Assembler::bcondNotLow);
    } else {
      __ load_const_optimized(Rdst, Isrc2);
      __ z_chi(Rsrc1, Isrc2);
      __ z_locr(Rdst, Rsrc1, Assembler::bcondLow);
    }
  
#line 18108 "ad_s390.cpp"
  }
}

void minI_reg_imm16Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 8431 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Label done;
    if (opnd_array(0)->as_Register(ra_,this)/* dst */!= opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */) {
      __ z_lgfr(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */);
    }
    __ z_chi(opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(2)->constant());
    __ z_brl(done);
    __ z_lghi(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(2)->constant());
    __ bind(done);
  
#line 18130 "ad_s390.cpp"
  }
}

void z10_minI_reg_imm8Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 8451 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Label done;
    if (opnd_array(0)->as_Register(ra_,this)/* dst */!= opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */) {
      __ z_lgfr(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */);
    }
    __ z_cij(opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(2)->constant(), Assembler::bcondLow, done);
    __ z_lghi(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(2)->constant());
    __ bind(done);
  
#line 18151 "ad_s390.cpp"
  }
}

void z196_maxI_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 8471 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Rdst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register Rsrc1 = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    Register Rsrc2 = opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */;

    if (Rsrc1 == Rsrc2) {
      if (Rdst != Rsrc1) {
        __ z_lgfr(Rdst, Rsrc1);
      }
    } else if (Rdst == Rsrc1) { // Rdst preset with src1.
      __ z_cr(Rsrc1, Rsrc2);    // Move src2 only if src1 is NotHigh.
      __ z_locr(Rdst, Rsrc2, Assembler::bcondNotHigh);
    } else if (Rdst == Rsrc2) { // Rdst preset with src2.
      __ z_cr(Rsrc2, Rsrc1);    // Move src1 only if src2 is NotHigh.
      __ z_locr(Rdst, Rsrc1, Assembler::bcondNotHigh);
    } else {                    // Rdst is disjoint from operands, move in either case.
      __ z_cr(Rsrc1, Rsrc2);
      __ z_locr(Rdst, Rsrc2, Assembler::bcondNotHigh);
      __ z_locr(Rdst, Rsrc1, Assembler::bcondHigh);
    }
  
#line 18184 "ad_s390.cpp"
  }
}

void z10_maxI_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 8503 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Rdst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register Rsrc1 = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    Register Rsrc2 = opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */;
    Label done;

    if (Rsrc1 == Rsrc2) {
      if (Rdst != Rsrc1) {
        __ z_lgfr(Rdst, Rsrc1);
      }
    } else if (Rdst == Rsrc1) {
      __ z_crj(Rsrc1, Rsrc2, Assembler::bcondHigh, done);
      __ z_lgfr(Rdst, Rsrc2);
    } else if (Rdst == Rsrc2) {
      __ z_crj(Rsrc2, Rsrc1, Assembler::bcondHigh, done);
      __ z_lgfr(Rdst, Rsrc1);
    } else {
      __ z_lgfr(Rdst, Rsrc1);
      __ z_crj(Rsrc1, Rsrc2, Assembler::bcondHigh, done);
      __ z_lgfr(Rdst, Rsrc2);
    }
    __ bind(done);
  
#line 18219 "ad_s390.cpp"
  }
}

void maxI_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 8536 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Rdst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register Rsrc1 = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    Register Rsrc2 = opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */;
    Label done;

    if (Rsrc1 == Rsrc2) {
      if (Rdst != Rsrc1) {
        __ z_lgfr(Rdst, Rsrc1);
      }
    } else if (Rdst == Rsrc1) {
      __ z_cr(Rsrc1, Rsrc2);
      __ z_brh(done);
      __ z_lgfr(Rdst, Rsrc2);
    } else if (Rdst == Rsrc2) {
      __ z_cr(Rsrc2, Rsrc1);
      __ z_brh(done);
      __ z_lgfr(Rdst, Rsrc1);
    } else {
      __ z_lgfr(Rdst, Rsrc1);
      __ z_cr(Rsrc1, Rsrc2);
      __ z_brh(done);
      __ z_lgfr(Rdst, Rsrc2);
    }

    __ bind(done);
  
#line 18258 "ad_s390.cpp"
  }
}

void z196_maxI_reg_imm32Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 8574 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Rdst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register Rsrc1 = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    int      Isrc2 = opnd_array(2)->constant();

    if (Rdst == Rsrc1) {
      __ load_const_optimized(Z_R0_scratch, Isrc2);
      __ z_cfi(Rsrc1, Isrc2);
      __ z_locr(Rdst, Z_R0_scratch, Assembler::bcondNotHigh);
    } else {
      __ load_const_optimized(Rdst, Isrc2);
      __ z_cfi(Rsrc1, Isrc2);
      __ z_locr(Rdst, Rsrc1, Assembler::bcondHigh);
    }
  
#line 18285 "ad_s390.cpp"
  }
}

void maxI_reg_imm32Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 8598 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Label done;
    if (opnd_array(0)->as_Register(ra_,this)/* dst */!= opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */) {
      __ z_lgfr(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */);
    }
    __ z_cfi(opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(2)->constant());
    __ z_brh(done);
    __ z_lgfi(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(2)->constant());
    __ bind(done);
  
#line 18307 "ad_s390.cpp"
  }
}

void z196_maxI_reg_imm16Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 8618 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Rdst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register Rsrc1 = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    int      Isrc2 = opnd_array(2)->constant();
    if (Rdst == Rsrc1) {
      __ load_const_optimized(Z_R0_scratch, Isrc2);
      __ z_chi(Rsrc1, Isrc2);
      __ z_locr(Rdst, Z_R0_scratch, Assembler::bcondNotHigh);
    } else {
      __ load_const_optimized(Rdst, Isrc2);
      __ z_chi(Rsrc1, Isrc2);
      __ z_locr(Rdst, Rsrc1, Assembler::bcondHigh);
    }
  
#line 18333 "ad_s390.cpp"
  }
}

void maxI_reg_imm16Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 8641 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Label done;
    if (opnd_array(0)->as_Register(ra_,this)/* dst */!= opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */) {
      __ z_lgfr(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */);
    }
    __ z_chi(opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(2)->constant());
    __ z_brh(done);
    __ z_lghi(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(2)->constant());
    __ bind(done);
  
#line 18355 "ad_s390.cpp"
  }
}

void z10_maxI_reg_imm8Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 8661 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Label done;
    if (opnd_array(0)->as_Register(ra_,this)/* dst */!= opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */) {
      __ z_lgfr(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */);
    }
    __ z_cij(opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(2)->constant(), Assembler::bcondHigh, done);
    __ z_lghi(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(2)->constant());
    __ bind(done);
  
#line 18376 "ad_s390.cpp"
  }
}

void absI_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1692 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((LPR_ZOPC /*primary()*/) >> 14) & 0x03) == 0, "Instruction format error");
    assert( ((LPR_ZOPC /*primary()*/) >> 16)         == 0, "Instruction format error");
    z_emit16(masm, (LPR_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */,8,16) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src */,12,16));
  
#line 18394 "ad_s390.cpp"
  }
}

void absL_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1700 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((LPGR_ZOPC /*primary()*/) >> 30) & 0x03) == 2, "Instruction format error");
    z_emit32(masm, (LPGR_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */,24,32) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src */,28,32));
  
#line 18411 "ad_s390.cpp"
  }
}

void negabsI_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1692 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((LNR_ZOPC /*primary()*/) >> 14) & 0x03) == 0, "Instruction format error");
    assert( ((LNR_ZOPC /*primary()*/) >> 16)         == 0, "Instruction format error");
    z_emit16(masm, (LNR_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */,8,16) |
             Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* src */,12,16));
  
#line 18430 "ad_s390.cpp"
  }
}

void cmpF_ccNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 8716 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"
__ z_cebr(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */); 
#line 18443 "ad_s390.cpp"
  }
}

uint cmpF_ccNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void cmpD_ccNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 8725 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"
__ z_cdbr(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */); 
#line 18461 "ad_s390.cpp"
  }
}

uint cmpD_ccNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void cmpF_cc_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 1819 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Ridx = as_Register(opnd_array(2)->index(ra_,this,idx2));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.
    if ((CEB_ZOPC /*primary()*/) > (1L << 32)) {
      z_emit_inst(masm, (CEB_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src1 */, 8, 48) |
                  Assembler::uimm12(opnd_array(2)->disp(ra_,this,idx2), 20, 48) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, 48));
    } else {
      z_emit_inst(masm, (CEB_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src1 */, 8, 32) |
                  Assembler::uimm12(opnd_array(2)->disp(ra_,this,idx2), 20, 32) |
                  Assembler::reg(Ridx, 12, 32) |
                  Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, 32));
    }
  
#line 18495 "ad_s390.cpp"
  }
}

uint cmpF_cc_memNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void cmpD_cc_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 1819 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Ridx = as_Register(opnd_array(2)->index(ra_,this,idx2));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.
    if ((CDB_ZOPC /*primary()*/) > (1L << 32)) {
      z_emit_inst(masm, (CDB_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src1 */, 8, 48) |
                  Assembler::uimm12(opnd_array(2)->disp(ra_,this,idx2), 20, 48) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, 48));
    } else {
      z_emit_inst(masm, (CDB_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src1 */, 8, 32) |
                  Assembler::uimm12(opnd_array(2)->disp(ra_,this,idx2), 20, 32) |
                  Assembler::reg(Ridx, 12, 32) |
                  Assembler::regz(reg_to_register_object(opnd_array(2)->base(ra_,this,idx2)), 16, 32));
    }
  
#line 18529 "ad_s390.cpp"
  }
}

uint cmpD_cc_memNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void cmpF0_ccNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 1700 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((LTEBR_ZOPC /*primary()*/) >> 30) & 0x03) == 2, "Instruction format error");
    z_emit32(masm, (LTEBR_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src1 */,24,32) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src1 */,28,32));
  
#line 18552 "ad_s390.cpp"
  }
}

uint cmpF0_ccNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void cmpD0_ccNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 1700 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((LTDBR_ZOPC /*primary()*/) >> 30) & 0x03) == 2, "Instruction format error");
    z_emit32(masm, (LTDBR_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src1 */,24,32) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src1 */,28,32));
  
#line 18575 "ad_s390.cpp"
  }
}

uint cmpD0_ccNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void cmpF_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 8777 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    // compare registers
    __ z_cebr(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    // Convert condition code into -1,0,1, where
    // -1 means unordered or less
    //  0 means equal
    //  1 means greater.
    if (VM_Version::has_LoadStoreConditional()) {
      Register one       = Z_R0_scratch;
      Register minus_one = Z_R1_scratch;
      __ z_lghi(minus_one, -1);
      __ z_lghi(one, 1);
      __ z_lghi( opnd_array(0)->as_Register(ra_,this)/* dst */, 0);
      __ z_locgr(opnd_array(0)->as_Register(ra_,this)/* dst */, one,       Assembler::bcondHigh);
      __ z_locgr(opnd_array(0)->as_Register(ra_,this)/* dst */, minus_one, Assembler::bcondLowOrNotOrdered);
    } else {
      Label done;
      __ clear_reg(opnd_array(0)->as_Register(ra_,this)/* dst */, true, false);
      __ z_bre(done);
      __ z_lhi(opnd_array(0)->as_Register(ra_,this)/* dst */, 1);
      __ z_brh(done);
      __ z_lhi(opnd_array(0)->as_Register(ra_,this)/* dst */, -1);
      __ bind(done);
    }
  
#line 18617 "ad_s390.cpp"
  }
}

uint cmpF_regNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 24, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 24);
}

void cmpD_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 8811 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    // compare registers
    __ z_cdbr(opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_FloatRegister(ra_,this,idx2)/* src2 */);
    // Convert condition code into -1,0,1, where
    // -1 means unordered or less
    //  0 means equal
    //  1 means greater.
    if (VM_Version::has_LoadStoreConditional()) {
      Register one       = Z_R0_scratch;
      Register minus_one = Z_R1_scratch;
      __ z_lghi(minus_one, -1);
      __ z_lghi(one, 1);
      __ z_lghi( opnd_array(0)->as_Register(ra_,this)/* dst */, 0);
      __ z_locgr(opnd_array(0)->as_Register(ra_,this)/* dst */, one,       Assembler::bcondHigh);
      __ z_locgr(opnd_array(0)->as_Register(ra_,this)/* dst */, minus_one, Assembler::bcondLowOrNotOrdered);
    } else {
      Label done;
      // indicate unused result
      (void) __ clear_reg(opnd_array(0)->as_Register(ra_,this)/* dst */, true, false);
      __ z_bre(done);
      __ z_lhi(opnd_array(0)->as_Register(ra_,this)/* dst */, 1);
      __ z_brh(done);
      __ z_lhi(opnd_array(0)->as_Register(ra_,this)/* dst */, -1);
      __ bind(done);
    }
  
#line 18660 "ad_s390.cpp"
  }
}

uint cmpD_regNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 24, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 24);
}

void branchNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {

#line 1895 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Label* p = opnd_array(1)->label();

    // 'p' is `nullptr' when this encoding class is used only to
    // determine the size of the encoded instruction.
    // Use a bound dummy label in that case.
    Label d;
    __ bind(d);
    Label& l = (nullptr == p) ? d : *(p);
    __ z_bru(l);
  
#line 18687 "ad_s390.cpp"
  }
}

uint branchNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void branchFarNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {

#line 1883 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Label* p = opnd_array(1)->label();

    // 'p' is `nullptr' when this encoding class is used only to
    // determine the size of the encoded instruction.
    // Use a bound dummy label in that case.
    Label d;
    __ bind(d);
    Label& l = (nullptr == p) ? d : *(p);
    __ z_brul(l);
  
#line 18714 "ad_s390.cpp"
  }
}

uint branchFarNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void branchConNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lbl
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// 
  {

#line 1919 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Label* p = opnd_array(3)->label();

    // 'p' is `nullptr' when this encoding class is used only to
    // determine the size of the encoded instruction.
    // Use a bound dummy label in that case.
    Label d;
    __ bind(d);
    Label& l = (nullptr == p) ? d : *(p);
    __ z_brc((Assembler::branch_condition)opnd_array(1)->ccode(), l);
  
#line 18743 "ad_s390.cpp"
  }
}

uint branchConNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void branchConFarNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// lbl
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// 
  {

#line 1907 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Label* p = opnd_array(3)->label();

    // 'p' is `nullptr' when this encoding class is used only to
    // determine the size of the encoded instruction.
    // Use a bound dummy label in that case.
    Label d;
    __ bind(d);
    Label& l = (nullptr == p) ? d : *(p);
    __ z_brcl((Assembler::branch_condition)opnd_array(1)->ccode(), l);
  
#line 18772 "ad_s390.cpp"
  }
}

uint branchConFarNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void branchLoopEndNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// labl
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// 
  {

#line 1919 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Label* p = opnd_array(3)->label();

    // 'p' is `nullptr' when this encoding class is used only to
    // determine the size of the encoded instruction.
    // Use a bound dummy label in that case.
    Label d;
    __ bind(d);
    Label& l = (nullptr == p) ? d : *(p);
    __ z_brc((Assembler::branch_condition)opnd_array(1)->ccode(), l);
  
#line 18801 "ad_s390.cpp"
  }
}

uint branchLoopEndNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void branchLoopEndFarNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// labl
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// 
  {

#line 1907 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Label* p = opnd_array(3)->label();

    // 'p' is `nullptr' when this encoding class is used only to
    // determine the size of the encoded instruction.
    // Use a bound dummy label in that case.
    Label d;
    __ bind(d);
    Label& l = (nullptr == p) ? d : *(p);
    __ z_brcl((Assembler::branch_condition)opnd_array(1)->ccode(), l);
  
#line 18830 "ad_s390.cpp"
  }
}

uint branchLoopEndFarNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void testAndBranchLoopEnd_RegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cr
  {

#line 1931 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Label* p = opnd_array(4)->label();

    // 'p' is `nullptr' when this encoding class is used only to
    // determine the size of the encoded instruction.
    // Use a bound dummy label in that case.
    Label d;
    __ bind(d);
    Label& l = (nullptr == p) ? d : *(p);
    Assembler::branch_condition cc = (Assembler::branch_condition)opnd_array(1)->ccode();
    unsigned long instr = (CRJ_ZOPC /*primary()*/);
    if (instr == CRJ_ZOPC) {
      __ z_crj(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */, cc, l);
    } else if (instr == CLRJ_ZOPC) {
      __ z_clrj(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */, cc, l);
    } else if (instr == CGRJ_ZOPC) {
      __ z_cgrj(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */, cc, l);
    } else {
      guarantee(instr == CLGRJ_ZOPC, "opcode not implemented");
      __ z_clgrj(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */, cc, l);
    }
  
#line 18871 "ad_s390.cpp"
  }
}

void cmpb_RegINode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cr
  {

#line 1931 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Label* p = opnd_array(4)->label();

    // 'p' is `nullptr' when this encoding class is used only to
    // determine the size of the encoded instruction.
    // Use a bound dummy label in that case.
    Label d;
    __ bind(d);
    Label& l = (nullptr == p) ? d : *(p);
    Assembler::branch_condition cc = (Assembler::branch_condition)opnd_array(1)->ccode();
    unsigned long instr = (CRJ_ZOPC /*primary()*/);
    if (instr == CRJ_ZOPC) {
      __ z_crj(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */, cc, l);
    } else if (instr == CLRJ_ZOPC) {
      __ z_clrj(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */, cc, l);
    } else if (instr == CGRJ_ZOPC) {
      __ z_cgrj(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */, cc, l);
    } else {
      guarantee(instr == CLGRJ_ZOPC, "opcode not implemented");
      __ z_clgrj(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */, cc, l);
    }
  
#line 18907 "ad_s390.cpp"
  }
}

void cmpbU_RegINode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cr
  {

#line 1931 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Label* p = opnd_array(4)->label();

    // 'p' is `nullptr' when this encoding class is used only to
    // determine the size of the encoded instruction.
    // Use a bound dummy label in that case.
    Label d;
    __ bind(d);
    Label& l = (nullptr == p) ? d : *(p);
    Assembler::branch_condition cc = (Assembler::branch_condition)opnd_array(1)->ccode();
    unsigned long instr = (CLRJ_ZOPC /*primary()*/);
    if (instr == CRJ_ZOPC) {
      __ z_crj(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */, cc, l);
    } else if (instr == CLRJ_ZOPC) {
      __ z_clrj(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */, cc, l);
    } else if (instr == CGRJ_ZOPC) {
      __ z_cgrj(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */, cc, l);
    } else {
      guarantee(instr == CLGRJ_ZOPC, "opcode not implemented");
      __ z_clgrj(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */, cc, l);
    }
  
#line 18943 "ad_s390.cpp"
  }
}

void cmpb_RegLNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cr
  {

#line 1931 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Label* p = opnd_array(4)->label();

    // 'p' is `nullptr' when this encoding class is used only to
    // determine the size of the encoded instruction.
    // Use a bound dummy label in that case.
    Label d;
    __ bind(d);
    Label& l = (nullptr == p) ? d : *(p);
    Assembler::branch_condition cc = (Assembler::branch_condition)opnd_array(1)->ccode();
    unsigned long instr = (CGRJ_ZOPC /*primary()*/);
    if (instr == CRJ_ZOPC) {
      __ z_crj(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */, cc, l);
    } else if (instr == CLRJ_ZOPC) {
      __ z_clrj(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */, cc, l);
    } else if (instr == CGRJ_ZOPC) {
      __ z_cgrj(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */, cc, l);
    } else {
      guarantee(instr == CLGRJ_ZOPC, "opcode not implemented");
      __ z_clgrj(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */, cc, l);
    }
  
#line 18979 "ad_s390.cpp"
  }
}

void cmpb_RegPPNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cr
  {

#line 1931 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Label* p = opnd_array(4)->label();

    // 'p' is `nullptr' when this encoding class is used only to
    // determine the size of the encoded instruction.
    // Use a bound dummy label in that case.
    Label d;
    __ bind(d);
    Label& l = (nullptr == p) ? d : *(p);
    Assembler::branch_condition cc = (Assembler::branch_condition)opnd_array(1)->ccode();
    unsigned long instr = (CLGRJ_ZOPC /*primary()*/);
    if (instr == CRJ_ZOPC) {
      __ z_crj(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */, cc, l);
    } else if (instr == CLRJ_ZOPC) {
      __ z_clrj(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */, cc, l);
    } else if (instr == CGRJ_ZOPC) {
      __ z_cgrj(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */, cc, l);
    } else {
      guarantee(instr == CLGRJ_ZOPC, "opcode not implemented");
      __ z_clgrj(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */, cc, l);
    }
  
#line 19015 "ad_s390.cpp"
  }
}

void cmpb_RegNNNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cr
  {

#line 1931 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Label* p = opnd_array(4)->label();

    // 'p' is `nullptr' when this encoding class is used only to
    // determine the size of the encoded instruction.
    // Use a bound dummy label in that case.
    Label d;
    __ bind(d);
    Label& l = (nullptr == p) ? d : *(p);
    Assembler::branch_condition cc = (Assembler::branch_condition)opnd_array(1)->ccode();
    unsigned long instr = (CLGRJ_ZOPC /*primary()*/);
    if (instr == CRJ_ZOPC) {
      __ z_crj(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */, cc, l);
    } else if (instr == CLRJ_ZOPC) {
      __ z_clrj(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */, cc, l);
    } else if (instr == CGRJ_ZOPC) {
      __ z_cgrj(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */, cc, l);
    } else {
      guarantee(instr == CLGRJ_ZOPC, "opcode not implemented");
      __ z_clgrj(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */, cc, l);
    }
  
#line 19051 "ad_s390.cpp"
  }
}

void testAndBranchLoopEnd_ImmNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cr
  {

#line 1979 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Label* p = opnd_array(4)->label();

    // 'p' is `nullptr' when this encoding class is used only to
    // determine the size of the encoded instruction.
    // Use a bound dummy label in that case.
    Label d;
    __ bind(d);
    Label& l = (nullptr == p) ? d : *(p);

    Assembler::branch_condition cc = (Assembler::branch_condition)opnd_array(1)->ccode();
    unsigned long instr = (CIJ_ZOPC /*primary()*/);
    if (instr == CIJ_ZOPC) {
      __ z_cij(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->constant(), cc, l);
    } else if (instr == CLIJ_ZOPC) {
      __ z_clij(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->constant(), cc, l);
    } else if (instr == CGIJ_ZOPC) {
      __ z_cgij(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->constant(), cc, l);
    } else {
      guarantee(instr == CLGIJ_ZOPC, "opcode not implemented");
      __ z_clgij(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->constant(), cc, l);
    }
  
#line 19088 "ad_s390.cpp"
  }
}

void cmpb_RegI_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cr
  {

#line 1979 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Label* p = opnd_array(4)->label();

    // 'p' is `nullptr' when this encoding class is used only to
    // determine the size of the encoded instruction.
    // Use a bound dummy label in that case.
    Label d;
    __ bind(d);
    Label& l = (nullptr == p) ? d : *(p);

    Assembler::branch_condition cc = (Assembler::branch_condition)opnd_array(1)->ccode();
    unsigned long instr = (CIJ_ZOPC /*primary()*/);
    if (instr == CIJ_ZOPC) {
      __ z_cij(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->constant(), cc, l);
    } else if (instr == CLIJ_ZOPC) {
      __ z_clij(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->constant(), cc, l);
    } else if (instr == CGIJ_ZOPC) {
      __ z_cgij(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->constant(), cc, l);
    } else {
      guarantee(instr == CLGIJ_ZOPC, "opcode not implemented");
      __ z_clgij(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->constant(), cc, l);
    }
  
#line 19125 "ad_s390.cpp"
  }
}

void cmpbU_RegI_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cr
  {

#line 1979 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Label* p = opnd_array(4)->label();

    // 'p' is `nullptr' when this encoding class is used only to
    // determine the size of the encoded instruction.
    // Use a bound dummy label in that case.
    Label d;
    __ bind(d);
    Label& l = (nullptr == p) ? d : *(p);

    Assembler::branch_condition cc = (Assembler::branch_condition)opnd_array(1)->ccode();
    unsigned long instr = (CLIJ_ZOPC /*primary()*/);
    if (instr == CIJ_ZOPC) {
      __ z_cij(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->constant(), cc, l);
    } else if (instr == CLIJ_ZOPC) {
      __ z_clij(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->constant(), cc, l);
    } else if (instr == CGIJ_ZOPC) {
      __ z_cgij(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->constant(), cc, l);
    } else {
      guarantee(instr == CLGIJ_ZOPC, "opcode not implemented");
      __ z_clgij(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->constant(), cc, l);
    }
  
#line 19162 "ad_s390.cpp"
  }
}

void cmpb_RegL_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cr
  {

#line 1979 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Label* p = opnd_array(4)->label();

    // 'p' is `nullptr' when this encoding class is used only to
    // determine the size of the encoded instruction.
    // Use a bound dummy label in that case.
    Label d;
    __ bind(d);
    Label& l = (nullptr == p) ? d : *(p);

    Assembler::branch_condition cc = (Assembler::branch_condition)opnd_array(1)->ccode();
    unsigned long instr = (CGIJ_ZOPC /*primary()*/);
    if (instr == CIJ_ZOPC) {
      __ z_cij(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->constantL(), cc, l);
    } else if (instr == CLIJ_ZOPC) {
      __ z_clij(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->constantL(), cc, l);
    } else if (instr == CGIJ_ZOPC) {
      __ z_cgij(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->constantL(), cc, l);
    } else {
      guarantee(instr == CLGIJ_ZOPC, "opcode not implemented");
      __ z_clgij(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->constantL(), cc, l);
    }
  
#line 19199 "ad_s390.cpp"
  }
}

void cmpb_RegP_immPNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cr
  {

#line 1979 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Label* p = opnd_array(4)->label();

    // 'p' is `nullptr' when this encoding class is used only to
    // determine the size of the encoded instruction.
    // Use a bound dummy label in that case.
    Label d;
    __ bind(d);
    Label& l = (nullptr == p) ? d : *(p);

    Assembler::branch_condition cc = (Assembler::branch_condition)opnd_array(1)->ccode();
    unsigned long instr = (CLGIJ_ZOPC /*primary()*/);
    if (instr == CIJ_ZOPC) {
      __ z_cij(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->constant(), cc, l);
    } else if (instr == CLIJ_ZOPC) {
      __ z_clij(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->constant(), cc, l);
    } else if (instr == CGIJ_ZOPC) {
      __ z_cgij(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->constant(), cc, l);
    } else {
      guarantee(instr == CLGIJ_ZOPC, "opcode not implemented");
      __ z_clgij(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->constant(), cc, l);
    }
  
#line 19236 "ad_s390.cpp"
  }
}

void cmpb_RegN_immP0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cr
  {

#line 1979 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Label* p = opnd_array(4)->label();

    // 'p' is `nullptr' when this encoding class is used only to
    // determine the size of the encoded instruction.
    // Use a bound dummy label in that case.
    Label d;
    __ bind(d);
    Label& l = (nullptr == p) ? d : *(p);

    Assembler::branch_condition cc = (Assembler::branch_condition)opnd_array(1)->ccode();
    unsigned long instr = (CLGIJ_ZOPC /*primary()*/);
    if (instr == CIJ_ZOPC) {
      __ z_cij(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->constant(), cc, l);
    } else if (instr == CLIJ_ZOPC) {
      __ z_clij(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->constant(), cc, l);
    } else if (instr == CGIJ_ZOPC) {
      __ z_cgij(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->constant(), cc, l);
    } else {
      guarantee(instr == CLGIJ_ZOPC, "opcode not implemented");
      __ z_clgij(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->constant(), cc, l);
    }
  
#line 19273 "ad_s390.cpp"
  }
}

void cmpb_RegN_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cr
  {

#line 1979 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Label* p = opnd_array(4)->label();

    // 'p' is `nullptr' when this encoding class is used only to
    // determine the size of the encoded instruction.
    // Use a bound dummy label in that case.
    Label d;
    __ bind(d);
    Label& l = (nullptr == p) ? d : *(p);

    Assembler::branch_condition cc = (Assembler::branch_condition)opnd_array(1)->ccode();
    unsigned long instr = (CLGIJ_ZOPC /*primary()*/);
    if (instr == CIJ_ZOPC) {
      __ z_cij(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->constant(), cc, l);
    } else if (instr == CLIJ_ZOPC) {
      __ z_clij(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->constant(), cc, l);
    } else if (instr == CGIJ_ZOPC) {
      __ z_cgij(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->constant(), cc, l);
    } else {
      guarantee(instr == CLGIJ_ZOPC, "opcode not implemented");
      __ z_clgij(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->constant(), cc, l);
    }
  
#line 19310 "ad_s390.cpp"
  }
}

void testAndBranchLoopEnd_RegFarNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cr
  {

#line 1954 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Label* p = opnd_array(4)->label();

    // 'p' is `nullptr' when this encoding class is used only to
    // determine the size of the encoded instruction.
    // Use a bound dummy label in that case.
    Label d;
    __ bind(d);
    Label& l = (nullptr == p) ? d : *(p);

    unsigned long instr = (CR_ZOPC /*primary()*/);
    if (instr == CR_ZOPC) {
      __ z_cr(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */);
    } else if (instr == CLR_ZOPC) {
      __ z_clr(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */);
    } else if (instr == CGR_ZOPC) {
      __ z_cgr(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */);
    } else {
      guarantee(instr == CLGR_ZOPC, "opcode not implemented");
      __ z_clgr(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */);
    }

    __ z_brcl((Assembler::branch_condition)opnd_array(1)->ccode(), l);
  
#line 19348 "ad_s390.cpp"
  }
}

void cmpb_RegI_FarNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cr
  {

#line 1954 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Label* p = opnd_array(4)->label();

    // 'p' is `nullptr' when this encoding class is used only to
    // determine the size of the encoded instruction.
    // Use a bound dummy label in that case.
    Label d;
    __ bind(d);
    Label& l = (nullptr == p) ? d : *(p);

    unsigned long instr = (CR_ZOPC /*primary()*/);
    if (instr == CR_ZOPC) {
      __ z_cr(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */);
    } else if (instr == CLR_ZOPC) {
      __ z_clr(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */);
    } else if (instr == CGR_ZOPC) {
      __ z_cgr(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */);
    } else {
      guarantee(instr == CLGR_ZOPC, "opcode not implemented");
      __ z_clgr(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */);
    }

    __ z_brcl((Assembler::branch_condition)opnd_array(1)->ccode(), l);
  
#line 19386 "ad_s390.cpp"
  }
}

void cmpbU_RegI_FarNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cr
  {

#line 1954 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Label* p = opnd_array(4)->label();

    // 'p' is `nullptr' when this encoding class is used only to
    // determine the size of the encoded instruction.
    // Use a bound dummy label in that case.
    Label d;
    __ bind(d);
    Label& l = (nullptr == p) ? d : *(p);

    unsigned long instr = (CLR_ZOPC /*primary()*/);
    if (instr == CR_ZOPC) {
      __ z_cr(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */);
    } else if (instr == CLR_ZOPC) {
      __ z_clr(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */);
    } else if (instr == CGR_ZOPC) {
      __ z_cgr(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */);
    } else {
      guarantee(instr == CLGR_ZOPC, "opcode not implemented");
      __ z_clgr(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */);
    }

    __ z_brcl((Assembler::branch_condition)opnd_array(1)->ccode(), l);
  
#line 19424 "ad_s390.cpp"
  }
}

void cmpb_RegL_FarNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cr
  {

#line 1954 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Label* p = opnd_array(4)->label();

    // 'p' is `nullptr' when this encoding class is used only to
    // determine the size of the encoded instruction.
    // Use a bound dummy label in that case.
    Label d;
    __ bind(d);
    Label& l = (nullptr == p) ? d : *(p);

    unsigned long instr = (CGR_ZOPC /*primary()*/);
    if (instr == CR_ZOPC) {
      __ z_cr(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */);
    } else if (instr == CLR_ZOPC) {
      __ z_clr(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */);
    } else if (instr == CGR_ZOPC) {
      __ z_cgr(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */);
    } else {
      guarantee(instr == CLGR_ZOPC, "opcode not implemented");
      __ z_clgr(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */);
    }

    __ z_brcl((Assembler::branch_condition)opnd_array(1)->ccode(), l);
  
#line 19462 "ad_s390.cpp"
  }
}

void cmpb_RegPP_FarNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cr
  {

#line 1954 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Label* p = opnd_array(4)->label();

    // 'p' is `nullptr' when this encoding class is used only to
    // determine the size of the encoded instruction.
    // Use a bound dummy label in that case.
    Label d;
    __ bind(d);
    Label& l = (nullptr == p) ? d : *(p);

    unsigned long instr = (CLGR_ZOPC /*primary()*/);
    if (instr == CR_ZOPC) {
      __ z_cr(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */);
    } else if (instr == CLR_ZOPC) {
      __ z_clr(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */);
    } else if (instr == CGR_ZOPC) {
      __ z_cgr(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */);
    } else {
      guarantee(instr == CLGR_ZOPC, "opcode not implemented");
      __ z_clgr(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */);
    }

    __ z_brcl((Assembler::branch_condition)opnd_array(1)->ccode(), l);
  
#line 19500 "ad_s390.cpp"
  }
}

void cmpb_RegNN_FarNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cr
  {

#line 1954 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Label* p = opnd_array(4)->label();

    // 'p' is `nullptr' when this encoding class is used only to
    // determine the size of the encoded instruction.
    // Use a bound dummy label in that case.
    Label d;
    __ bind(d);
    Label& l = (nullptr == p) ? d : *(p);

    unsigned long instr = (CLGR_ZOPC /*primary()*/);
    if (instr == CR_ZOPC) {
      __ z_cr(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */);
    } else if (instr == CLR_ZOPC) {
      __ z_clr(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */);
    } else if (instr == CGR_ZOPC) {
      __ z_cgr(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */);
    } else {
      guarantee(instr == CLGR_ZOPC, "opcode not implemented");
      __ z_clgr(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */);
    }

    __ z_brcl((Assembler::branch_condition)opnd_array(1)->ccode(), l);
  
#line 19538 "ad_s390.cpp"
  }
}

void testAndBranchLoopEnd_ImmFarNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cr
  {

#line 2003 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Label* p = opnd_array(4)->label();

    // 'p' is `nullptr' when this encoding class is used only to
    // determine the size of the encoded instruction.
    // Use a bound dummy label in that case.
    Label d;
    __ bind(d);
    Label& l = (nullptr == p) ? d : *(p);

    unsigned long instr = (CHI_ZOPC /*primary()*/);
    if (instr == CHI_ZOPC) {
      __ z_chi(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->constant());
    } else if (instr == CLFI_ZOPC) {
      __ z_clfi(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->constant());
    } else if (instr == CGHI_ZOPC) {
      __ z_cghi(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->constant());
    } else {
      guarantee(instr == CLGFI_ZOPC, "opcode not implemented");
      __ z_clgfi(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->constant());
    }

    __ z_brcl((Assembler::branch_condition)opnd_array(1)->ccode(), l);
  
#line 19576 "ad_s390.cpp"
  }
}

void cmpb_RegI_imm_FarNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cr
  {

#line 2003 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Label* p = opnd_array(4)->label();

    // 'p' is `nullptr' when this encoding class is used only to
    // determine the size of the encoded instruction.
    // Use a bound dummy label in that case.
    Label d;
    __ bind(d);
    Label& l = (nullptr == p) ? d : *(p);

    unsigned long instr = (CHI_ZOPC /*primary()*/);
    if (instr == CHI_ZOPC) {
      __ z_chi(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->constant());
    } else if (instr == CLFI_ZOPC) {
      __ z_clfi(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->constant());
    } else if (instr == CGHI_ZOPC) {
      __ z_cghi(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->constant());
    } else {
      guarantee(instr == CLGFI_ZOPC, "opcode not implemented");
      __ z_clgfi(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->constant());
    }

    __ z_brcl((Assembler::branch_condition)opnd_array(1)->ccode(), l);
  
#line 19614 "ad_s390.cpp"
  }
}

void cmpbU_RegI_imm_FarNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cr
  {

#line 2003 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Label* p = opnd_array(4)->label();

    // 'p' is `nullptr' when this encoding class is used only to
    // determine the size of the encoded instruction.
    // Use a bound dummy label in that case.
    Label d;
    __ bind(d);
    Label& l = (nullptr == p) ? d : *(p);

    unsigned long instr = (CLFI_ZOPC /*primary()*/);
    if (instr == CHI_ZOPC) {
      __ z_chi(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->constant());
    } else if (instr == CLFI_ZOPC) {
      __ z_clfi(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->constant());
    } else if (instr == CGHI_ZOPC) {
      __ z_cghi(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->constant());
    } else {
      guarantee(instr == CLGFI_ZOPC, "opcode not implemented");
      __ z_clgfi(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->constant());
    }

    __ z_brcl((Assembler::branch_condition)opnd_array(1)->ccode(), l);
  
#line 19652 "ad_s390.cpp"
  }
}

void cmpb_RegL_imm_FarNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cr
  {

#line 2003 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Label* p = opnd_array(4)->label();

    // 'p' is `nullptr' when this encoding class is used only to
    // determine the size of the encoded instruction.
    // Use a bound dummy label in that case.
    Label d;
    __ bind(d);
    Label& l = (nullptr == p) ? d : *(p);

    unsigned long instr = (CGHI_ZOPC /*primary()*/);
    if (instr == CHI_ZOPC) {
      __ z_chi(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->constantL());
    } else if (instr == CLFI_ZOPC) {
      __ z_clfi(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->constantL());
    } else if (instr == CGHI_ZOPC) {
      __ z_cghi(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->constantL());
    } else {
      guarantee(instr == CLGFI_ZOPC, "opcode not implemented");
      __ z_clgfi(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->constantL());
    }

    __ z_brcl((Assembler::branch_condition)opnd_array(1)->ccode(), l);
  
#line 19690 "ad_s390.cpp"
  }
}

void cmpb_RegP_immP_FarNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cr
  {

#line 2003 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Label* p = opnd_array(4)->label();

    // 'p' is `nullptr' when this encoding class is used only to
    // determine the size of the encoded instruction.
    // Use a bound dummy label in that case.
    Label d;
    __ bind(d);
    Label& l = (nullptr == p) ? d : *(p);

    unsigned long instr = (CLGFI_ZOPC /*primary()*/);
    if (instr == CHI_ZOPC) {
      __ z_chi(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->constant());
    } else if (instr == CLFI_ZOPC) {
      __ z_clfi(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->constant());
    } else if (instr == CGHI_ZOPC) {
      __ z_cghi(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->constant());
    } else {
      guarantee(instr == CLGFI_ZOPC, "opcode not implemented");
      __ z_clgfi(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->constant());
    }

    __ z_brcl((Assembler::branch_condition)opnd_array(1)->ccode(), l);
  
#line 19728 "ad_s390.cpp"
  }
}

void cmpb_RegN_immP0_FarNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cr
  {

#line 2003 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Label* p = opnd_array(4)->label();

    // 'p' is `nullptr' when this encoding class is used only to
    // determine the size of the encoded instruction.
    // Use a bound dummy label in that case.
    Label d;
    __ bind(d);
    Label& l = (nullptr == p) ? d : *(p);

    unsigned long instr = (CLGFI_ZOPC /*primary()*/);
    if (instr == CHI_ZOPC) {
      __ z_chi(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->constant());
    } else if (instr == CLFI_ZOPC) {
      __ z_clfi(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->constant());
    } else if (instr == CGHI_ZOPC) {
      __ z_cghi(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->constant());
    } else {
      guarantee(instr == CLGFI_ZOPC, "opcode not implemented");
      __ z_clgfi(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->constant());
    }

    __ z_brcl((Assembler::branch_condition)opnd_array(1)->ccode(), l);
  
#line 19766 "ad_s390.cpp"
  }
}

void cmpb_RegN_immN_FarNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// labl
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cr
  {

#line 2003 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Label* p = opnd_array(4)->label();

    // 'p' is `nullptr' when this encoding class is used only to
    // determine the size of the encoded instruction.
    // Use a bound dummy label in that case.
    Label d;
    __ bind(d);
    Label& l = (nullptr == p) ? d : *(p);

    unsigned long instr = (CLGFI_ZOPC /*primary()*/);
    if (instr == CHI_ZOPC) {
      __ z_chi(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->constant());
    } else if (instr == CLFI_ZOPC) {
      __ z_clfi(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->constant());
    } else if (instr == CGHI_ZOPC) {
      __ z_cghi(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->constant());
    } else {
      guarantee(instr == CLGFI_ZOPC, "opcode not implemented");
      __ z_clgfi(opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(3)->constant());
    }

    __ z_brcl((Assembler::branch_condition)opnd_array(1)->ccode(), l);
  
#line 19804 "ad_s390.cpp"
  }
}

void cmpL3_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 9341 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Label done;
    // compare registers
    __ z_cgr(opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */);
    // Convert condition code into -1,0,1, where
    // -1 means less
    //  0 means equal
    //  1 means greater.
    if (VM_Version::has_LoadStoreConditional()) {
      Register one       = Z_R0_scratch;
      Register minus_one = Z_R1_scratch;
      __ z_lghi(minus_one, -1);
      __ z_lghi(one, 1);
      __ z_lghi( opnd_array(0)->as_Register(ra_,this)/* dst */, 0);
      __ z_locgr(opnd_array(0)->as_Register(ra_,this)/* dst */, one,       Assembler::bcondHigh);
      __ z_locgr(opnd_array(0)->as_Register(ra_,this)/* dst */, minus_one, Assembler::bcondLow);
    } else {
      __ clear_reg(opnd_array(0)->as_Register(ra_,this)/* dst */, true, false);
      __ z_bre(done);
      __ z_lhi(opnd_array(0)->as_Register(ra_,this)/* dst */, 1);
      __ z_brh(done);
      __ z_lhi(opnd_array(0)->as_Register(ra_,this)/* dst */, -1);
    }
    __ bind(done);
  
#line 19841 "ad_s390.cpp"
  }
}

uint cmpL3_reg_regNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 24, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 24);
}

void safePointNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 5;
  unsigned idx1 = 5; 	// 
  {

#line 1682 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    __ unimplemented("Unimplemented mach node encoding in AD file.", 13);
  
#line 19860 "ad_s390.cpp"
  }
}

void safePoint_pollNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 5;
  unsigned idx1 = 5; 	// cr
  {

#line 9386 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    // Mark the code position where the load from the safepoint
    // polling page was emitted as relocInfo::poll_type.
    __ relocate(relocInfo::poll_type);
    __ load_from_polling_page(opnd_array(1)->as_Register(ra_,this,idx1)/* poll */);
  
#line 19877 "ad_s390.cpp"
  }
}

void CallStaticJavaDirect_dynTOCNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {

#line 2053 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    // Call to fixup routine. Fixup routine uses ScopeDesc info to determine
    // whom we intended to call.
    int ret_offset = 0;

    if (!_method) {
      ret_offset = emit_call_reloc(masm, opnd_array(1)->method(),
                                   relocInfo::runtime_call_w_cp_type, ra_);
    } else {
      int method_index = resolved_method_index(masm);
      if (_optimized_virtual) {
        ret_offset = emit_call_reloc(masm, opnd_array(1)->method(),
                                     opt_virtual_call_Relocation::spec(method_index));
      } else {
        ret_offset = emit_call_reloc(masm, opnd_array(1)->method(),
                                     static_call_Relocation::spec(method_index));
      }
    }
    assert(__ inst_mark() != nullptr, "emit_call_reloc must set_inst_mark()");

    if (_method) { // Emit stub for static call.
      address stub = CompiledDirectCall::emit_to_interp_stub(masm);
      if (stub == nullptr) {
        __ clear_inst_mark();
        ciEnv::current()->record_failure("CodeCache is full");
        return;
      }
    }

    __ clear_inst_mark();
  
#line 19919 "ad_s390.cpp"
  }
}

void CallDynamicJavaDirect_dynTOCNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {

#line 2086 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    unsigned int start_off = __ offset();

    int vtable_index = this->_vtable_index;
    if (vtable_index == -4) {
      Register ic_reg = reg_to_register_object(Matcher::inline_cache_reg_encode());
      address virtual_call_oop_addr = nullptr;

      AddressLiteral empty_ic((address) Universe::non_oop_word());
      virtual_call_oop_addr = __ pc();
      bool success = __ load_const_from_toc(ic_reg, empty_ic);
      if (!success) {
        Compile::current()->env()->record_out_of_memory_failure();
        return;
      }

      // Call to fixup routine. Fixup routine uses ScopeDesc info
      // to determine who we intended to call.
      int method_index = resolved_method_index(masm);
      __ relocate(virtual_call_Relocation::spec(virtual_call_oop_addr, method_index));
      unsigned int ret_off = __ offset();
      assert(__ offset() - start_off == 6, "bad prelude len: %d", __ offset() - start_off);
      ret_off += emit_call_reloc(masm, opnd_array(1)->method(), relocInfo::none, ra_);
      __ clear_inst_mark();
      assert(_method, "lazy_constant may be wrong when _method==null");
    } else {
      assert(!UseInlineCaches, "expect vtable calls only if not using ICs");
      // Go through the vtable. Get receiver klass. Receiver already
      // checked for non-null. If we'll go thru a C2I adapter, the
      // interpreter expects method in Z_method.
      // Use Z_method to temporarily hold the klass oop.
      // Z_R1_scratch is destroyed.
      __ load_klass(Z_method, Z_R2);

      int entry_offset = in_bytes(Klass::vtable_start_offset()) + vtable_index * vtableEntry::size_in_bytes();
      int v_off        = entry_offset + in_bytes(vtableEntry::method_offset());

      if (Displacement::is_validDisp(v_off) ) {
        // Can use load instruction with large offset.
        __ z_lg(Z_method, Address(Z_method /*class oop*/, v_off /*method offset*/));
      } else {
        // Worse case, must load offset into register.
        __ load_const(Z_R1_scratch, v_off);
        __ z_lg(Z_method, Address(Z_method /*class oop*/, Z_R1_scratch /*method offset*/));
      }
      // NOTE: for vtable dispatches, the vtable entry will never be
      // null. However it may very well end up in handle_wrong_method
      // if the method is abstract for the particular class.
      __ z_lg(Z_R1_scratch, Address(Z_method, Method::from_compiled_offset()));
      // Call target. Either compiled code or C2I adapter.
      __ z_basr(Z_R14, Z_R1_scratch);
      unsigned int ret_off = __ offset();
    }
  
#line 19984 "ad_s390.cpp"
  }
}

void CallRuntimeDirectNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {

#line 2029 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    // Save return pc before call to the place where we need it, since
    // callee doesn't.
    unsigned int start_off = __ offset();
    // Compute size of "larl + stg + call_c_opt".
    const int size_of_code = 6 + 6 + MacroAssembler::call_far_patchable_size();
    __ get_PC(Z_R14, size_of_code);
    __ save_return_pc();
    assert(__ offset() - start_off == 12, "bad prelude len: %d", __ offset() - start_off);

    assert((__ offset() & 2) == 0, "misaligned z_enc_java_to_runtime_call");
    address call_addr = __ call_c_opt((address)opnd_array(1)->method());
    if (call_addr == nullptr) {
      Compile::current()->env()->record_out_of_memory_failure();
      return;
    }

#ifdef ASSERT
    // Plausibility check for size_of_code assumptions.
    unsigned int actual_ret_off = __ offset();
    assert(start_off + size_of_code == actual_ret_off, "wrong return_pc");
#endif
  
#line 20018 "ad_s390.cpp"
  }
}

void CallLeafDirectNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {

#line 2029 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    // Save return pc before call to the place where we need it, since
    // callee doesn't.
    unsigned int start_off = __ offset();
    // Compute size of "larl + stg + call_c_opt".
    const int size_of_code = 6 + 6 + MacroAssembler::call_far_patchable_size();
    __ get_PC(Z_R14, size_of_code);
    __ save_return_pc();
    assert(__ offset() - start_off == 12, "bad prelude len: %d", __ offset() - start_off);

    assert((__ offset() & 2) == 0, "misaligned z_enc_java_to_runtime_call");
    address call_addr = __ call_c_opt((address)opnd_array(1)->method());
    if (call_addr == nullptr) {
      Compile::current()->env()->record_out_of_memory_failure();
      return;
    }

#ifdef ASSERT
    // Plausibility check for size_of_code assumptions.
    unsigned int actual_ret_off = __ offset();
    assert(start_off + size_of_code == actual_ret_off, "wrong return_pc");
#endif
  
#line 20052 "ad_s390.cpp"
  }
}

void CallLeafNoFPDirectNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {

#line 2029 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    // Save return pc before call to the place where we need it, since
    // callee doesn't.
    unsigned int start_off = __ offset();
    // Compute size of "larl + stg + call_c_opt".
    const int size_of_code = 6 + 6 + MacroAssembler::call_far_patchable_size();
    __ get_PC(Z_R14, size_of_code);
    __ save_return_pc();
    assert(__ offset() - start_off == 12, "bad prelude len: %d", __ offset() - start_off);

    assert((__ offset() & 2) == 0, "misaligned z_enc_java_to_runtime_call");
    address call_addr = __ call_c_opt((address)opnd_array(1)->method());
    if (call_addr == nullptr) {
      Compile::current()->env()->record_out_of_memory_failure();
      return;
    }

#ifdef ASSERT
    // Plausibility check for size_of_code assumptions.
    unsigned int actual_ret_off = __ offset();
    assert(start_off + size_of_code == actual_ret_off, "wrong return_pc");
#endif
  
#line 20086 "ad_s390.cpp"
  }
}

void TailCalljmpIndNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 5;
  unsigned idx1 = 5; 	// method_ptr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// 
  {

#line 9471 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"
__ z_br(opnd_array(1)->as_Register(ra_,this,idx1)/* jump_target */); 
#line 20099 "ad_s390.cpp"
  }
}

uint TailCalljmpIndNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 2, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 2);
}

void RetNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 5;
  unsigned idx1 = 5; 	// 
  {

#line 9480 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"
__ z_br(Z_R14); 
#line 20116 "ad_s390.cpp"
  }
}

uint RetNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 2, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 2);
}

void tailjmpIndNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 5;
  unsigned idx1 = 5; 	// ex_oop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// 
  {

#line 9495 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    __ z_lg(Z_ARG2/* issuing pc */, _z_abi(return_pc), Z_SP);
    __ z_br(opnd_array(1)->as_Register(ra_,this,idx1)/* jump_target */);
  
#line 20137 "ad_s390.cpp"
  }
}

uint tailjmpIndNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 8, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 8);
}

void CreateExceptionNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  // User did not define which encode class to use.
}

uint CreateExceptionNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void RethrowExceptionNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 5;
  unsigned idx1 = 5; 	// 
  {

#line 9521 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    __ set_inst_mark();
    __ load_const_optimized(Z_R1_scratch, (address)OptoRuntime::rethrow_stub());
    __ z_br(Z_R1_scratch);
    __ clear_inst_mark();
  
#line 20171 "ad_s390.cpp"
  }
}

void ShouldNotReachHereNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 5;
  unsigned idx1 = 5; 	// 
  {

#line 9535 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    if (is_reachable()) {
      __ stop(_halt_reason);
    }
  
#line 20187 "ad_s390.cpp"
  }
}

void partialSubtypeCheckNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// sub
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// super
  {

#line 9555 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    AddressLiteral stub_address(StubRoutines::zarch::partial_subtype_check());
    __ load_const_optimized(Z_ARG4, stub_address);
    __ z_basr(Z_R14, Z_ARG4);
  
#line 20204 "ad_s390.cpp"
  }
}

void partialSubtypeCheck_vs_zeroNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// sub
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// super
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// zero
  {

#line 9570 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    AddressLiteral stub_address(StubRoutines::zarch::partial_subtype_check());
    __ load_const_optimized(Z_ARG4, stub_address);
    __ z_basr(Z_R14, Z_ARG4);
  
#line 20222 "ad_s390.cpp"
  }
}

void cmpFastLockNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// oop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// box
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp2
  {

#line 9587 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"
__ compiler_fast_lock_object(opnd_array(1)->as_Register(ra_,this,idx1)/* oop */, opnd_array(2)->as_Register(ra_,this,idx2)/* box */, opnd_array(3)->as_Register(ra_,this,idx3)/* tmp1 */, opnd_array(4)->as_Register(ra_,this,idx4)/* tmp2 */); 
#line 20237 "ad_s390.cpp"
  }
}

void cmpFastUnlockNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// oop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// box
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp2
  {

#line 9597 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"
__ compiler_fast_unlock_object(opnd_array(1)->as_Register(ra_,this,idx1)/* oop */, opnd_array(2)->as_Register(ra_,this,idx2)/* box */, opnd_array(3)->as_Register(ra_,this,idx3)/* tmp1 */, opnd_array(4)->as_Register(ra_,this,idx4)/* tmp2 */); 
#line 20252 "ad_s390.cpp"
  }
}

void inlineCallClearArrayConstNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// cnt
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// base
  {

#line 9607 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"
__ Clear_Array_Const(opnd_array(1)->constantL(), opnd_array(2)->as_Register(ra_,this,idx2)/* base */); 
#line 20265 "ad_s390.cpp"
  }
}

void inlineCallClearArrayConstBigNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// cnt
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// base
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmpL
  {

#line 9617 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"
__ Clear_Array_Const_Big(opnd_array(1)->constantL(), opnd_array(2)->as_Register(ra_,this,idx2)/* base */, opnd_array(3)->as_Register(ra_,this,idx3)/* tmpL */); 
#line 20279 "ad_s390.cpp"
  }
}

void inlineCallClearArrayNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// cnt
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// base
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmpL
  {

#line 9627 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"
__ Clear_Array(opnd_array(1)->as_Register(ra_,this,idx1)/* cnt */, opnd_array(2)->as_Register(ra_,this,idx2)/* base */, opnd_array(3)->as_Register(ra_,this,idx3)/* tmpL */); 
#line 20293 "ad_s390.cpp"
  }
}

void string_equalsLNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// str2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// cnt
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// oddReg
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// evenReg
  {

#line 9641 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    __ array_equals(false, opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* str2 */,
                    opnd_array(3)->as_Register(ra_,this,idx3)/* cnt */, opnd_array(4)->as_Register(ra_,this,idx4)/* oddReg */, opnd_array(5)->as_Register(ra_,this,idx5)/* evenReg */,
                    opnd_array(0)->as_Register(ra_,this)/* result */, true /* byte */);
  
#line 20313 "ad_s390.cpp"
  }
}

void string_equals_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// str2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// cnt
  {

#line 9655 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    const int cnt_imm = opnd_array(3)->constant();
    if (cnt_imm) { __ z_clc(0, cnt_imm - 1, opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, 0, opnd_array(2)->as_Register(ra_,this,idx2)/* str2 */); }
    __ z_lhi(opnd_array(0)->as_Register(ra_,this)/* result */, 1);
    if (cnt_imm) {
      if (VM_Version::has_LoadStoreConditional()) {
        __ z_lhi(Z_R0_scratch, 0);
        __ z_locr(opnd_array(0)->as_Register(ra_,this)/* result */, Z_R0_scratch, Assembler::bcondNotEqual);
      } else {
        Label Lskip;
        __ z_bre(Lskip);
        __ clear_reg(opnd_array(0)->as_Register(ra_,this)/* result */);
        __ bind(Lskip);
      }
    }
  
#line 20342 "ad_s390.cpp"
  }
}

void string_equalsC_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// str2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// cnt
  {

#line 9680 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    const int cnt_imm = opnd_array(3)->constant(); // positive immI8 (7 bits used)
    if (cnt_imm) { __ z_clc(0, (cnt_imm << 1) - 1, opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, 0, opnd_array(2)->as_Register(ra_,this,idx2)/* str2 */); }
    __ z_lhi(opnd_array(0)->as_Register(ra_,this)/* result */, 1);
    if (cnt_imm) {
      if (VM_Version::has_LoadStoreConditional()) {
        __ z_lhi(Z_R0_scratch, 0);
        __ z_locr(opnd_array(0)->as_Register(ra_,this)/* result */, Z_R0_scratch, Assembler::bcondNotEqual);
      } else {
        Label Lskip;
        __ z_bre(Lskip);
        __ clear_reg(opnd_array(0)->as_Register(ra_,this)/* result */);
        __ bind(Lskip);
      }
    }
  
#line 20371 "ad_s390.cpp"
  }
}

void array_equalsBNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// ary1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// ary2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// oddReg
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// evenReg
  {

#line 9706 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    __ array_equals(true, opnd_array(1)->as_Register(ra_,this,idx1)/* ary1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* ary2 */,
                    noreg, opnd_array(3)->as_Register(ra_,this,idx3)/* oddReg */, opnd_array(4)->as_Register(ra_,this,idx4)/* evenReg */,
                    opnd_array(0)->as_Register(ra_,this)/* result */, true /* byte */);
  
#line 20390 "ad_s390.cpp"
  }
}

void array_equalsCNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// ary1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// ary2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// oddReg
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// evenReg
  {

#line 9720 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    __ array_equals(true, opnd_array(1)->as_Register(ra_,this,idx1)/* ary1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* ary2 */,
                    noreg, opnd_array(3)->as_Register(ra_,this,idx3)/* oddReg */, opnd_array(4)->as_Register(ra_,this,idx4)/* evenReg */,
                    opnd_array(0)->as_Register(ra_,this)/* result */, false /* byte */);
  
#line 20409 "ad_s390.cpp"
  }
}

void string_compareLNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cnt2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// result
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// oddReg
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// evenReg
  {

#line 9735 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    __ string_compare(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                      opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(4)->as_Register(ra_,this,idx4)/* cnt2 */,
                      opnd_array(6)->as_Register(ra_,this,idx6)/* oddReg */, opnd_array(7)->as_Register(ra_,this,idx7)/* evenReg */,
                      opnd_array(5)->as_Register(ra_,this,idx5)/* result */, StrIntrinsicNode::LL);
  
#line 20432 "ad_s390.cpp"
  }
}

void string_compareUNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cnt2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// result
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// oddReg
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// evenReg
  {

#line 9750 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    __ string_compare(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                      opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(4)->as_Register(ra_,this,idx4)/* cnt2 */,
                      opnd_array(6)->as_Register(ra_,this,idx6)/* oddReg */, opnd_array(7)->as_Register(ra_,this,idx7)/* evenReg */,
                      opnd_array(5)->as_Register(ra_,this,idx5)/* result */, StrIntrinsicNode::UU);
  
#line 20455 "ad_s390.cpp"
  }
}

void string_compareLUNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cnt2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// result
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// oddReg
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// evenReg
  {

#line 9765 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    __ string_compare(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                      opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(4)->as_Register(ra_,this,idx4)/* cnt2 */,
                      opnd_array(6)->as_Register(ra_,this,idx6)/* oddReg */, opnd_array(7)->as_Register(ra_,this,idx7)/* evenReg */,
                      opnd_array(5)->as_Register(ra_,this,idx5)/* result */, StrIntrinsicNode::LU);
  
#line 20478 "ad_s390.cpp"
  }
}

void string_compareULNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cnt2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// result
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// oddReg
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// evenReg
  {

#line 9780 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    __ string_compare(opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */, opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */,
                      opnd_array(4)->as_Register(ra_,this,idx4)/* cnt2 */, opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */,
                      opnd_array(6)->as_Register(ra_,this,idx6)/* oddReg */, opnd_array(7)->as_Register(ra_,this,idx7)/* evenReg */,
                      opnd_array(5)->as_Register(ra_,this,idx5)/* result */, StrIntrinsicNode::UL);
  
#line 20501 "ad_s390.cpp"
  }
}

void indexOfChar_UNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// haystack
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// haycnt
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// ch
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// result
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// oddReg
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// evenReg
  {

#line 9796 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    __ string_indexof_char(opnd_array(4)->as_Register(ra_,this,idx4)/* result */,
                           opnd_array(1)->as_Register(ra_,this,idx1)/* haystack */, opnd_array(2)->as_Register(ra_,this,idx2)/* haycnt */,
                           opnd_array(3)->as_Register(ra_,this,idx3)/* ch */, 0 /* unused, ch is in register */,
                           opnd_array(5)->as_Register(ra_,this,idx5)/* oddReg */, opnd_array(6)->as_Register(ra_,this,idx6)/* evenReg */, false /*is_byte*/);
  
#line 20523 "ad_s390.cpp"
  }
}

void indexOfChar_LNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// haystack
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// haycnt
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// ch
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// result
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// oddReg
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// evenReg
  {

#line 9811 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    __ string_indexof_char(opnd_array(4)->as_Register(ra_,this,idx4)/* result */,
                           opnd_array(1)->as_Register(ra_,this,idx1)/* haystack */, opnd_array(2)->as_Register(ra_,this,idx2)/* haycnt */,
                           opnd_array(3)->as_Register(ra_,this,idx3)/* ch */, 0 /* unused, ch is in register */,
                           opnd_array(5)->as_Register(ra_,this,idx5)/* oddReg */, opnd_array(6)->as_Register(ra_,this,idx6)/* evenReg */, true /*is_byte*/);
  
#line 20545 "ad_s390.cpp"
  }
}

void indexOf_imm1_UNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// haystack
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// haycnt
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// needle
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// needlecnt
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// result
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// oddReg
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// evenReg
  {

#line 9826 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    immPOper *needleOper = (immPOper *)opnd_array(3);
    const TypeOopPtr *t = needleOper->type()->isa_oopptr();
    ciTypeArray* needle_values = t->const_oop()->as_type_array();  // Pointer to live char *
    jchar chr;
#ifdef VM_LITTLE_ENDIAN
    Unimplemented();
#else
    chr = (((jchar)(unsigned char)needle_values->element_value(0).as_byte()) << 8) |
           ((jchar)(unsigned char)needle_values->element_value(1).as_byte());
#endif
    __ string_indexof_char(opnd_array(5)->as_Register(ra_,this,idx5)/* result */,
                           opnd_array(1)->as_Register(ra_,this,idx1)/* haystack */, opnd_array(2)->as_Register(ra_,this,idx2)/* haycnt */,
                           noreg, chr,
                           opnd_array(6)->as_Register(ra_,this,idx6)/* oddReg */, opnd_array(7)->as_Register(ra_,this,idx7)/* evenReg */, false /*is_byte*/);
  
#line 20578 "ad_s390.cpp"
  }
}

void indexOf_imm1_LNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// haystack
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// haycnt
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// needle
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// needlecnt
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// result
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// oddReg
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// evenReg
  {

#line 9851 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    immPOper *needleOper = (immPOper *)opnd_array(3);
    const TypeOopPtr *t = needleOper->type()->isa_oopptr();
    ciTypeArray* needle_values = t->const_oop()->as_type_array();  // Pointer to live char *
    jchar chr = (jchar)needle_values->element_value(0).as_byte();
    __ string_indexof_char(opnd_array(5)->as_Register(ra_,this,idx5)/* result */,
                           opnd_array(1)->as_Register(ra_,this,idx1)/* haystack */, opnd_array(2)->as_Register(ra_,this,idx2)/* haycnt */,
                           noreg, chr,
                           opnd_array(6)->as_Register(ra_,this,idx6)/* oddReg */, opnd_array(7)->as_Register(ra_,this,idx7)/* evenReg */, true /*is_byte*/);
  
#line 20605 "ad_s390.cpp"
  }
}

void indexOf_imm1_ULNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// haystack
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// haycnt
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// needle
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// needlecnt
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// result
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// oddReg
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// evenReg
  {

#line 9870 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    immPOper *needleOper = (immPOper *)opnd_array(3);
    const TypeOopPtr *t = needleOper->type()->isa_oopptr();
    ciTypeArray* needle_values = t->const_oop()->as_type_array();  // Pointer to live char *
    jchar chr = (jchar)needle_values->element_value(0).as_byte();
    __ string_indexof_char(opnd_array(5)->as_Register(ra_,this,idx5)/* result */,
                           opnd_array(1)->as_Register(ra_,this,idx1)/* haystack */, opnd_array(2)->as_Register(ra_,this,idx2)/* haycnt */,
                           noreg, chr,
                           opnd_array(6)->as_Register(ra_,this,idx6)/* oddReg */, opnd_array(7)->as_Register(ra_,this,idx7)/* evenReg */, false /*is_byte*/);
  
#line 20632 "ad_s390.cpp"
  }
}

void indexOf_imm_UNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// haystack
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// haycnt
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// needle
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// needlecntImm
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// result
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// oddReg
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// evenReg
  {

#line 9890 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    __ string_indexof(opnd_array(5)->as_Register(ra_,this,idx5)/* result */,
                      opnd_array(1)->as_Register(ra_,this,idx1)/* haystack */, opnd_array(2)->as_Register(ra_,this,idx2)/* haycnt */,
                      opnd_array(3)->as_Register(ra_,this,idx3)/* needle */, noreg, opnd_array(4)->constant(),
                      opnd_array(6)->as_Register(ra_,this,idx6)/* oddReg */, opnd_array(7)->as_Register(ra_,this,idx7)/* evenReg */, StrIntrinsicNode::UU);
  
#line 20655 "ad_s390.cpp"
  }
}

void indexOf_imm_LNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// haystack
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// haycnt
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// needle
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// needlecntImm
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// result
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// oddReg
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// evenReg
  {

#line 9905 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    __ string_indexof(opnd_array(5)->as_Register(ra_,this,idx5)/* result */,
                      opnd_array(1)->as_Register(ra_,this,idx1)/* haystack */, opnd_array(2)->as_Register(ra_,this,idx2)/* haycnt */,
                      opnd_array(3)->as_Register(ra_,this,idx3)/* needle */, noreg, opnd_array(4)->constant(),
                      opnd_array(6)->as_Register(ra_,this,idx6)/* oddReg */, opnd_array(7)->as_Register(ra_,this,idx7)/* evenReg */, StrIntrinsicNode::LL);
  
#line 20678 "ad_s390.cpp"
  }
}

void indexOf_imm_ULNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// haystack
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// haycnt
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// needle
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// needlecntImm
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// result
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// oddReg
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// evenReg
  {

#line 9920 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    __ string_indexof(opnd_array(5)->as_Register(ra_,this,idx5)/* result */,
                      opnd_array(1)->as_Register(ra_,this,idx1)/* haystack */, opnd_array(2)->as_Register(ra_,this,idx2)/* haycnt */,
                      opnd_array(3)->as_Register(ra_,this,idx3)/* needle */, noreg, opnd_array(4)->constant(),
                      opnd_array(6)->as_Register(ra_,this,idx6)/* oddReg */, opnd_array(7)->as_Register(ra_,this,idx7)/* evenReg */, StrIntrinsicNode::UL);
  
#line 20701 "ad_s390.cpp"
  }
}

void indexOf_UNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// haystack
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// haycnt
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// needle
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// needlecnt
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// result
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// oddReg
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// evenReg
  {

#line 9935 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    __ string_indexof(opnd_array(5)->as_Register(ra_,this,idx5)/* result */,
                      opnd_array(1)->as_Register(ra_,this,idx1)/* haystack */, opnd_array(2)->as_Register(ra_,this,idx2)/* haycnt */,
                      opnd_array(3)->as_Register(ra_,this,idx3)/* needle */, opnd_array(4)->as_Register(ra_,this,idx4)/* needlecnt */, 0,
                      opnd_array(6)->as_Register(ra_,this,idx6)/* oddReg */, opnd_array(7)->as_Register(ra_,this,idx7)/* evenReg */, StrIntrinsicNode::UU);
  
#line 20724 "ad_s390.cpp"
  }
}

void indexOf_LNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// haystack
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// haycnt
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// needle
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// needlecnt
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// result
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// oddReg
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// evenReg
  {

#line 9950 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    __ string_indexof(opnd_array(5)->as_Register(ra_,this,idx5)/* result */,
                      opnd_array(1)->as_Register(ra_,this,idx1)/* haystack */, opnd_array(2)->as_Register(ra_,this,idx2)/* haycnt */,
                      opnd_array(3)->as_Register(ra_,this,idx3)/* needle */, opnd_array(4)->as_Register(ra_,this,idx4)/* needlecnt */, 0,
                      opnd_array(6)->as_Register(ra_,this,idx6)/* oddReg */, opnd_array(7)->as_Register(ra_,this,idx7)/* evenReg */, StrIntrinsicNode::LL);
  
#line 20747 "ad_s390.cpp"
  }
}

void indexOf_ULNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// haystack
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// haycnt
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// needle
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// needlecnt
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// result
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// oddReg
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// evenReg
  {

#line 9965 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    __ string_indexof(opnd_array(5)->as_Register(ra_,this,idx5)/* result */,
                      opnd_array(1)->as_Register(ra_,this,idx1)/* haystack */, opnd_array(2)->as_Register(ra_,this,idx2)/* haycnt */,
                      opnd_array(3)->as_Register(ra_,this,idx3)/* needle */, opnd_array(4)->as_Register(ra_,this,idx4)/* needlecnt */, 0,
                      opnd_array(6)->as_Register(ra_,this,idx6)/* oddReg */, opnd_array(7)->as_Register(ra_,this,idx7)/* evenReg */, StrIntrinsicNode::UL);
  
#line 20770 "ad_s390.cpp"
  }
}

void string_compressNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// len
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// result
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp
  {

#line 9980 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    __ string_compress(opnd_array(4)->as_Register(ra_,this,idx4)/* result */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, opnd_array(3)->as_Register(ra_,this,idx3)/* len */,
                       opnd_array(5)->as_Register(ra_,this,idx5)/* tmp */, true, false);
  
#line 20789 "ad_s390.cpp"
  }
}

void string_inflateNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// len
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {

#line 10006 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    __ string_inflate(opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, opnd_array(3)->as_Register(ra_,this,idx3)/* len */, opnd_array(4)->as_Register(ra_,this,idx4)/* tmp */);
  
#line 20806 "ad_s390.cpp"
  }
}

void string_inflate_constNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// len
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {

#line 10018 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    __ string_inflate_const(opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, opnd_array(4)->as_Register(ra_,this,idx4)/* tmp */, opnd_array(3)->constant());
  
#line 20823 "ad_s390.cpp"
  }
}

void count_positivesNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// ary1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// len
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// result
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {

#line 10030 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    __ count_positives(opnd_array(3)->as_Register(ra_,this,idx3)/* result */, opnd_array(1)->as_Register(ra_,this,idx1)/* ary1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* len */, opnd_array(4)->as_Register(ra_,this,idx4)/* tmp */);
  
#line 20840 "ad_s390.cpp"
  }
}

void encode_iso_arrayNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// len
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// result
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp
  {

#line 10043 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    __ string_compress(opnd_array(4)->as_Register(ra_,this,idx4)/* result */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, opnd_array(3)->as_Register(ra_,this,idx3)/* len */,
                       opnd_array(5)->as_Register(ra_,this,idx5)/* tmp */, true, false);
  
#line 20859 "ad_s390.cpp"
  }
}

void encode_ascii_arrayNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// len
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// result
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp
  {

#line 10057 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    __ string_compress(opnd_array(4)->as_Register(ra_,this,idx4)/* result */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, opnd_array(3)->as_Register(ra_,this,idx3)/* len */,
                       opnd_array(5)->as_Register(ra_,this,idx5)/* tmp */, true, true);
  
#line 20878 "ad_s390.cpp"
  }
}

void expand_storeFNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1837 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Ridx = as_Register(opnd_array(0)->index(ra_,this,idx0));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.
    if ((STE_ZOPC /*primary()*/) > (1L<<32)) {
      z_emit_inst(masm, (STE_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src */, 8, 48) |
                  Assembler::simm20(opnd_array(0)->disp(ra_,this,0)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(0)->base(ra_,this,idx0)), 16, 48));
    } else {
      z_emit_inst(masm, (STE_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src */, 8, 32) |
                  Assembler::uimm12(opnd_array(0)->disp(ra_,this,0), 20, 32) |
                  Assembler::reg(Ridx, 12, 32) |
                  Assembler::regz(reg_to_register_object(opnd_array(0)->base(ra_,this,idx0)), 16, 32));
    }
  
#line 20906 "ad_s390.cpp"
  }
}

void expand_LoadLogical_I2LNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// mem
  {

#line 1837 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Ridx = as_Register(opnd_array(1)->index(ra_,this,idx1));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.
    if ((LLGF_ZOPC /*primary()*/) > (1L<<32)) {
      z_emit_inst(masm, (LLGF_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, 48) |
                  Assembler::simm20(opnd_array(1)->disp(ra_,this,idx1)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 48));
    } else {
      z_emit_inst(masm, (LLGF_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, 32) |
                  Assembler::uimm12(opnd_array(1)->disp(ra_,this,idx1), 20, 32) |
                  Assembler::reg(Ridx, 12, 32) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 32));
    }
  
#line 20934 "ad_s390.cpp"
  }
}

void expand_Repl2I_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 10221 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    if (opnd_array(0)->as_Register(ra_,this)/* dst */== opnd_array(1)->as_Register(ra_,this,idx1)/* src */) {
      __ z_sllg(Z_R0_scratch, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, 64-32);
      __ z_ogr(opnd_array(0)->as_Register(ra_,this)/* dst */, Z_R0_scratch);
    }  else {
      __ z_sllg(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, 64-32);
      __ z_ogr( opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
    }
  
#line 20954 "ad_s390.cpp"
  }
}

void Repl8B_reg_risbgNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 10242 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    if (opnd_array(0)->as_Register(ra_,this)/* dst */!= opnd_array(1)->as_Register(ra_,this,idx1)/* src */) {
      __ z_lgr(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
    }
    __ rotate_then_insert(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(0)->as_Register(ra_,this)/* dst */, 48, 55,  8, false);
    __ rotate_then_insert(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(0)->as_Register(ra_,this)/* dst */, 32, 47, 16, false);
    __ rotate_then_insert(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(0)->as_Register(ra_,this)/* dst */,  0, 31, 32, false);
  
#line 20973 "ad_s390.cpp"
  }
}

void Repl8B_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 10259 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int64_t  Isrc8 = opnd_array(1)->constant()& 0x000000ff;
    int64_t Isrc16 =  Isrc8 <<  8 |  Isrc8;
    int64_t Isrc32 = Isrc16 << 16 | Isrc16;
    assert(Isrc8 != 0x000000ff && Isrc8 != 0, "should be handled by other match rules.");

    __ z_llilf(opnd_array(0)->as_Register(ra_,this)/* dst */, Isrc32);
    __ z_iihf(opnd_array(0)->as_Register(ra_,this)/* dst */, Isrc32);
  
#line 20993 "ad_s390.cpp"
  }
}

void Repl8B_imm0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 10277 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"
__ z_laz(opnd_array(0)->as_Register(ra_,this)/* dst */, 0, Z_R0); 
#line 21005 "ad_s390.cpp"
  }
}

void Repl8B_immm1Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 10287 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"
__ z_lghi(opnd_array(0)->as_Register(ra_,this)/* dst */, -1); 
#line 21017 "ad_s390.cpp"
  }
}

void Repl4S_reg_risbgNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 10298 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    if (opnd_array(0)->as_Register(ra_,this)/* dst */!= opnd_array(1)->as_Register(ra_,this,idx1)/* src */) {
      __ z_lgr(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
    }
    __ rotate_then_insert(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(0)->as_Register(ra_,this)/* dst */, 32, 47, 16, false);
    __ rotate_then_insert(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(0)->as_Register(ra_,this)/* dst */,  0, 31, 32, false);
  
#line 21035 "ad_s390.cpp"
  }
}

void Repl4S_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 10314 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int64_t Isrc16 = opnd_array(1)->constant()& 0x0000ffff;
    int64_t Isrc32 = Isrc16 << 16 | Isrc16;
    assert(Isrc16 != 0x0000ffff && Isrc16 != 0, "Repl4S_imm: (src == " INT64_FORMAT
           ") should be handled by other match rules.", opnd_array(1)->constant());

    __ z_llilf(opnd_array(0)->as_Register(ra_,this)/* dst */, Isrc32);
    __ z_iihf(opnd_array(0)->as_Register(ra_,this)/* dst */, Isrc32);
  
#line 21055 "ad_s390.cpp"
  }
}

void Repl4S_imm0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 10332 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"
__ z_laz(opnd_array(0)->as_Register(ra_,this)/* dst */, 0, Z_R0); 
#line 21067 "ad_s390.cpp"
  }
}

void Repl4S_immm1Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 10342 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"
__ z_lghi(opnd_array(0)->as_Register(ra_,this)/* dst */, -1); 
#line 21079 "ad_s390.cpp"
  }
}

void Repl2I_reg_risbgNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 10353 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    if (opnd_array(0)->as_Register(ra_,this)/* dst */!= opnd_array(1)->as_Register(ra_,this,idx1)/* src */) {
      __ z_lgr(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
    }
    __ rotate_then_insert(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(0)->as_Register(ra_,this)/* dst */, 0, 31, 32, false);
  
#line 21096 "ad_s390.cpp"
  }
}

void Repl2I_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 10368 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int64_t Isrc32 = opnd_array(1)->constant();
    assert(Isrc32 != -1 && Isrc32 != 0, "should be handled by other match rules.");

    __ z_llilf(opnd_array(0)->as_Register(ra_,this)/* dst */, Isrc32);
    __ z_iihf(opnd_array(0)->as_Register(ra_,this)/* dst */, Isrc32);
  
#line 21114 "ad_s390.cpp"
  }
}

void Repl2I_imm0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 10384 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"
__ z_laz(opnd_array(0)->as_Register(ra_,this)/* dst */, 0, Z_R0); 
#line 21126 "ad_s390.cpp"
  }
}

void Repl2I_immm1Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 10394 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"
__ z_lghi(opnd_array(0)->as_Register(ra_,this)/* dst */, -1); 
#line 21138 "ad_s390.cpp"
  }
}

void Repl2F_reg_directNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 10422 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert(VM_Version::has_FPSupportEnhancements(), "encoder should never be called on old H/W");
    __ z_lgdr(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_FloatRegister(ra_,this,idx1)/* src */);

    __ z_srlg(Z_R0_scratch, opnd_array(0)->as_Register(ra_,this)/* dst */, 32);  // Floats are left-justified in 64bit reg.
    __ z_iilf(opnd_array(0)->as_Register(ra_,this)/* dst */, 0);                 // Save a "result not ready" stall.
    __ z_ogr(opnd_array(0)->as_Register(ra_,this)/* dst */, Z_R0_scratch);
  
#line 21157 "ad_s390.cpp"
  }
}

void Repl2F_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 10439 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    union {
      int   Isrc32;
      float Fsrc32;
    };
    Fsrc32 = opnd_array(1)->constantF();
    __ z_llilf(opnd_array(0)->as_Register(ra_,this)/* dst */, Isrc32);
    __ z_iihf(opnd_array(0)->as_Register(ra_,this)/* dst */, Isrc32);
  
#line 21177 "ad_s390.cpp"
  }
}

void Repl2F_imm0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 10458 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"
__ z_laz(opnd_array(0)->as_Register(ra_,this)/* dst */, 0, Z_R0); 
#line 21189 "ad_s390.cpp"
  }
}

void storeA8BNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 1855 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int isize = (STG_ZOPC /*secondary()*/) > 1L << 32 ? 48 : 32;
    Register Ridx = as_Register(opnd_array(1)->index(ra_,this,idx1));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.

    if (Displacement::is_shortDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (STG_ZOPC /*secondary()*/) |
                  Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* src */, 8, isize) |
                  Assembler::uimm12(opnd_array(1)->disp(ra_,this,idx1), 20, isize) |
                  Assembler::reg(Ridx, 12, isize) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    } else if (Displacement::is_validDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (STG_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* src */, 8, 48) |
                  Assembler::simm20(opnd_array(1)->disp(ra_,this,idx1)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 48));
    } else {
        __ load_const_optimized(Z_R1_scratch, opnd_array(1)->disp(ra_,this,idx1));
        if (Ridx != Z_R0) { __ z_agr(Z_R1_scratch, Ridx); }
        z_emit_inst(masm, (STG_ZOPC /*secondary()*/) |
                    Assembler::reg(opnd_array(2)->reg(ra_,this,idx2)/* src */, 8, isize) |
                    Assembler::uimm12(0, 20, isize) |
                    Assembler::reg(Z_R1_scratch, 12, isize) |
                    Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    }
  
#line 21228 "ad_s390.cpp"
  }
}

void loadV8Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 1855 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    int isize = (LG_ZOPC /*secondary()*/) > 1L << 32 ? 48 : 32;
    Register Ridx = as_Register(opnd_array(1)->index(ra_,this,idx1));
    if (Ridx == noreg) { Ridx = Z_R0; } // Index is 0.

    if (Displacement::is_shortDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (LG_ZOPC /*secondary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, isize) |
                  Assembler::uimm12(opnd_array(1)->disp(ra_,this,idx1), 20, isize) |
                  Assembler::reg(Ridx, 12, isize) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    } else if (Displacement::is_validDisp((long)opnd_array(1)->disp(ra_,this,idx1))) {
      z_emit_inst(masm, (LG_ZOPC /*primary()*/) |
                  Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, 48) |
                  Assembler::simm20(opnd_array(1)->disp(ra_,this,idx1)) |
                  Assembler::reg(Ridx, 12, 48) |
                  Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, 48));
    } else {
        __ load_const_optimized(Z_R1_scratch, opnd_array(1)->disp(ra_,this,idx1));
        if (Ridx != Z_R0) { __ z_agr(Z_R1_scratch, Ridx); }
        z_emit_inst(masm, (LG_ZOPC /*secondary()*/) |
                    Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */, 8, isize) |
                    Assembler::uimm12(0, 20, isize) |
                    Assembler::reg(Z_R1_scratch, 12, isize) |
                    Assembler::regz(reg_to_register_object(opnd_array(1)->base(ra_,this,idx1)), 16, isize));
    }
  
#line 21266 "ad_s390.cpp"
  }
}

void reinterpretNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  // User did not define which encode class to use.
}

void bytes_reverse_intNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1700 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((LRVR_ZOPC /*primary()*/) >> 30) & 0x03) == 2, "Instruction format error");
    z_emit32(masm, (LRVR_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */,24,32) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src */,28,32));
  
#line 21290 "ad_s390.cpp"
  }
}

uint bytes_reverse_intNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void bytes_reverse_longNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 1700 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert((((LRVGR_ZOPC /*primary()*/) >> 30) & 0x03) == 2, "Instruction format error");
    z_emit32(masm, (LRVGR_ZOPC /*primary()*/) |
             Assembler::reg(opnd_array(0)->reg(ra_,this)/* dst */,24,32) |
             Assembler::reg(opnd_array(1)->reg(ra_,this,idx1)/* src */,28,32));
  
#line 21312 "ad_s390.cpp"
  }
}

void countLeadingZerosINode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 10540 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    // Performance experiments indicate that "FLOGR" is using some kind of
    // iteration to find the leftmost "1" bit.
    //
    // The prior implementation zero-extended the 32-bit argument to 64 bit,
    // thus forcing "FLOGR" to count 32 bits of which we know they are zero.
    // We could gain measurable speedup in micro benchmark:
    //
    //               leading   trailing
    //   z10:   int     2.04       1.68
    //         long     1.00       1.02
    //   z196:  int     0.99       1.23
    //         long     1.00       1.11
    //
    // By shifting the argument into the high-word instead of zero-extending it.
    // The add'l branch on condition (taken for a zero argument, very infrequent,
    // good prediction) is well compensated for by the savings.
    //
    // We leave the previous implementation in for some time in the future when
    // the "FLOGR" instruction may become less iterative.

    // Version 2: shows 62%(z9), 204%(z10), -1%(z196) improvement over original
    __ z_sllg(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, 32); // No need to always count 32 zeroes first.
    __ z_iilh(opnd_array(0)->as_Register(ra_,this)/* dst */, 0x8000);   // Insert "stop bit" to force result 32 for zero src.
    __ z_flogr(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(0)->as_Register(ra_,this)/* dst */);
  
#line 21349 "ad_s390.cpp"
  }
}

uint countLeadingZerosINode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 14, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 14);
}

void countLeadingZerosLNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 10575 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"
__ z_flogr(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */); 
#line 21366 "ad_s390.cpp"
  }
}

uint countLeadingZerosLNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void countTrailingZerosINode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {

#line 10608 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Rdst = opnd_array(2)->as_Register(ra_,this,idx2)/* dst */;
    Register Rsrc = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    // Rtmp only needed for for zero-argument shortcut. With kill effect in
    // match rule Rsrc = roddReg would be possible, saving one register.
    Register Rtmp = opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */;

    assert_different_registers(Rdst, Rsrc, Rtmp);

    // Algorithm:
    // - Isolate the least significant (rightmost) set bit using (src & (-src)).
    //   All other bits in the result are zero.
    // - Find the "leftmost one" bit position in the single-bit result from previous step.
    // - 63-("leftmost one" bit position) gives the # of trailing zeros.

    // Version 2: shows 79%(z9), 68%(z10), 23%(z196) improvement over original.
    Label done;
    __ load_const_optimized(Rdst, 32); // Prepare for shortcut (zero argument), result will be 32.
    __ z_lcgfr(Rtmp, Rsrc);
    __ z_bre(done);                    // Taken very infrequently, good prediction, no BHT entry.

    __ z_nr(Rtmp, Rsrc);               // (src) & (-src) leaves nothing but least significant bit.
    __ z_ahi(Rtmp,  -1);               // Subtract one to fill all trailing zero positions with ones.
                                       // Use 32bit op to prevent borrow propagation (case Rdst = 0x80000000)
                                       // into upper half of reg. Not relevant with sllg below.
    __ z_sllg(Rdst, Rtmp, 32);         // Shift interesting contents to upper half of register.
    __ z_bre(done);                    // Shortcut for argument = 1, result will be 0.
                                       // Depends on CC set by ahi above.
                                       // Taken very infrequently, good prediction, no BHT entry.
                                       // Branch delayed to have Rdst set correctly (Rtmp == 0(32bit)
                                       // after SLLG Rdst == 0(64bit)).
    __ z_flogr(Rdst, Rdst);            // Kills tmp which is the oddReg for dst.
    __ add2reg(Rdst,  -32);            // 32-pos(leftmost1) is #trailing zeros
    __ z_lcgfr(Rdst, Rdst);            // Provide 64bit result at no cost.
    __ bind(done);
  
#line 21420 "ad_s390.cpp"
  }
}

void countTrailingZerosLNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {

#line 10659 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Rdst = opnd_array(2)->as_Register(ra_,this,idx2)/* dst */;
    Register Rsrc = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    assert_different_registers(Rdst, Rsrc); // Rtmp == Rsrc allowed.

    // New version: shows 5%(z9), 2%(z10), 11%(z196) improvement over original.
    __ z_lcgr(Rdst, Rsrc);
    __ z_ngr(Rdst, Rsrc);
    __ add2reg(Rdst,   -1);
    __ z_flogr(Rdst, Rdst); // Kills tmp which is the oddReg for dst.
    __ add2reg(Rdst,  -64);
    __ z_lcgfr(Rdst, Rdst); // Provide 64bit result at no cost.
  
#line 21445 "ad_s390.cpp"
  }
}

void popCountINode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {

#line 10685 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Rdst = opnd_array(2)->as_Register(ra_,this,idx2)/* dst */;
    Register Rsrc = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    Register Rtmp = opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */;

    // Prefer compile-time assertion over run-time SIGILL.
    assert(VM_Version::has_PopCount(), "bad predicate for countLeadingZerosI");
    assert_different_registers(Rdst, Rtmp);

    // Version 2: shows 10%(z196) improvement over original.
    __ z_popcnt(Rdst, Rsrc);
    __ z_srlg(Rtmp, Rdst, 16); // calc  byte4+byte6 and byte5+byte7
    __ z_alr(Rdst, Rtmp);      //   into byte6 and byte7
    __ z_srlg(Rtmp, Rdst,  8); // calc (byte4+byte6) + (byte5+byte7)
    __ z_alr(Rdst, Rtmp);      //   into byte7
    __ z_llgcr(Rdst, Rdst);    // zero-extend sum
  
#line 21475 "ad_s390.cpp"
  }
}

uint popCountINode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 24, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 24);
}

void popCountLNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {

#line 10712 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    Register Rdst = opnd_array(2)->as_Register(ra_,this,idx2)/* dst */;
    Register Rsrc = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    Register Rtmp = opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */;

    // Prefer compile-time assertion over run-time SIGILL.
    assert(VM_Version::has_PopCount(), "bad predicate for countLeadingZerosI");
    assert_different_registers(Rdst, Rtmp);

    // Original version. Using LA instead of algr seems to be a really bad idea (-35%).
    __ z_popcnt(Rdst, Rsrc);
    __ z_ahhlr(Rdst, Rdst, Rdst);
    __ z_sllg(Rtmp, Rdst, 16);
    __ z_algr(Rdst, Rtmp);
    __ z_sllg(Rtmp, Rdst,  8);
    __ z_algr(Rdst, Rtmp);
    __ z_srlg(Rdst, Rdst, 56);
  
#line 21511 "ad_s390.cpp"
  }
}

const MachOper* loadBNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadB2LNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUBNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUB2LNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadSNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadS2LNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUSNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUS2LNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadINode::memory_operand() const { return _opnds[1]; }
const MachOper* loadI2LNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUI2LNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadRangeNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadLNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadL_unalignedNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadPNode::memory_operand() const { return _opnds[1]; }
const MachOper* castP2X_loadPNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadKlassNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadFNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadDNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadD_unalignedNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeBNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeCMNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeCNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeINode::memory_operand() const { return _opnds[1]; }
const MachOper* storeLNode::memory_operand() const { return _opnds[1]; }
const MachOper* storePNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeFNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeDNode::memory_operand() const { return _opnds[1]; }
const MachOper* prefetchAllocNode::memory_operand() const { return _opnds[1]; }
const MachOper* memInitBNode::memory_operand() const { return _opnds[1]; }
const MachOper* memInitCNode::memory_operand() const { return _opnds[1]; }
const MachOper* memInitINode::memory_operand() const { return _opnds[1]; }
const MachOper* memInitLNode::memory_operand() const { return _opnds[1]; }
const MachOper* memInitPNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadNNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadNKlassNode::memory_operand() const { return _opnds[1]; }
const MachOper* decodeLoadNNode::memory_operand() const { return _opnds[1]; }
const MachOper* decodeLoadNKlassNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeNNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeNKlassNode::memory_operand() const { return _opnds[1]; }
const MachOper* addI_mem_imm8_atomic_no_resNode::memory_operand() const { return _opnds[1]; }
const MachOper* addI_mem_imm16_atomicNode::memory_operand() const { return _opnds[1]; }
const MachOper* addI_mem_imm32_atomicNode::memory_operand() const { return _opnds[1]; }
const MachOper* addI_mem_reg_atomicNode::memory_operand() const { return _opnds[1]; }
const MachOper* addL_mem_imm8_atomic_no_resNode::memory_operand() const { return _opnds[1]; }
const MachOper* addL_mem_imm16_atomicNode::memory_operand() const { return _opnds[1]; }
const MachOper* addL_mem_imm32_atomicNode::memory_operand() const { return _opnds[1]; }
const MachOper* addL_mem_reg_atomicNode::memory_operand() const { return _opnds[1]; }
const MachOper* addI_mem_reg_atomic_z196Node::memory_operand() const { return _opnds[1]; }
const MachOper* addL_mem_reg_atomic_z196Node::memory_operand() const { return _opnds[1]; }
const MachOper* xchgI_reg_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* xchgL_reg_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* xchgN_reg_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* xchgP_reg_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* addI_Reg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* addI_Reg_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* addI_mem_immNode::memory_operand() const { return _opnds[1]; }
const MachOper* addL_Reg_memINode::memory_operand() const { return _opnds[2]; }
const MachOper* addL_Reg_memI_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* addL_Reg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* addL_Reg_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* addL_mem_immNode::memory_operand() const { return _opnds[1]; }
const MachOper* addP_mem_immNode::memory_operand() const { return _opnds[1]; }
const MachOper* subI_Reg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* subL_Reg_memINode::memory_operand() const { return _opnds[2]; }
const MachOper* subL_Reg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* mulI_Reg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* mulI_Reg_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* mulL_Reg_memINode::memory_operand() const { return _opnds[2]; }
const MachOper* mulL_Reg_memI_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* mulL_Reg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* mulL_Reg_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* addF_reg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* addF_reg_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* addD_reg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* addD_reg_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* subF_reg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* subD_reg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* mulF_reg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* mulF_reg_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* mulD_reg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* mulD_reg_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* maddF_reg_memNode::memory_operand() const { return _opnds[3]; }
const MachOper* maddD_reg_memNode::memory_operand() const { return _opnds[3]; }
const MachOper* msubF_reg_memNode::memory_operand() const { return _opnds[3]; }
const MachOper* msubD_reg_memNode::memory_operand() const { return _opnds[3]; }
const MachOper* maddF_mem_regNode::memory_operand() const { return _opnds[2]; }
const MachOper* maddD_mem_regNode::memory_operand() const { return _opnds[2]; }
const MachOper* msubF_mem_regNode::memory_operand() const { return _opnds[2]; }
const MachOper* msubD_mem_regNode::memory_operand() const { return _opnds[2]; }
const MachOper* divF_reg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* divD_reg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* sqrtF_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* sqrtD_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* andI_Reg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* andI_Reg_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* andL_Reg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* andL_Reg_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* orI_Reg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* orI_Reg_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* orL_Reg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* orL_Reg_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* xorI_Reg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* xorI_Reg_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* xorL_Reg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* xorL_Reg_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* convF2D_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* convI2L_mem_zexNode::memory_operand() const { return _opnds[1]; }
const MachOper* compI_reg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* compU_reg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* compL_reg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* compL_reg_memINode::memory_operand() const { return _opnds[2]; }
const MachOper* compP_reg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* cmpF_cc_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* cmpD_cc_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* storeA8BNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadV8Node::memory_operand() const { return _opnds[1]; }


bool Matcher::has_match_rule(int opcode) {
  assert(_last_machine_leaf < opcode && opcode < _last_opcode, "opcode in range");
  return _hasMatchRule[opcode];
}

const bool Matcher::_hasMatchRule[_last_opcode] = {
    false,  // Node
    false,  // Set
    false,  // RegN
    false,  // RegI
    false,  // RegP
    false,  // RegF
    false,  // RegD
    false,  // RegL
    false,  // VecA
    false,  // VecS
    false,  // VecD
    false,  // VecX
    false,  // VecY
    false,  // VecZ
    false,  // RegVectMask
    false,  // RegFlags
    false,  // _last_machine_leaf
    true ,  // AbsD
    true ,  // AbsF
    true ,  // AbsI
    true ,  // AbsL
    true ,  // AddD
    true ,  // AddF
    true ,  // AddI
    true ,  // AddL
    true ,  // AddP
    false,  // Allocate
    false,  // AllocateArray
    true ,  // AndI
    true ,  // AndL
    false,  // ArrayCopy
    true ,  // AryEq
    false,  // AtanD
    true ,  // Binary
    false,  // Blackhole
    true ,  // Bool
    false,  // BoxLock
    true ,  // ReverseBytesI
    true ,  // ReverseBytesL
    false,  // ReverseBytesUS
    false,  // ReverseBytesS
    false,  // ReverseBytesV
    false,  // CProj
    false,  // CacheWB
    false,  // CacheWBPreSync
    false,  // CacheWBPostSync
    true ,  // CallDynamicJava
    false,  // CallJava
    true ,  // CallLeaf
    true ,  // CallLeafNoFP
    false,  // CallLeafVector
    true ,  // CallRuntime
    true ,  // CallStaticJava
    true ,  // CastDD
    true ,  // CastFF
    true ,  // CastII
    true ,  // CastLL
    true ,  // CastVV
    true ,  // CastX2P
    true ,  // CastP2X
    true ,  // CastPP
    false,  // Catch
    false,  // CatchProj
    true ,  // CheckCastPP
    true ,  // ClearArray
    false,  // CompressBits
    false,  // ExpandBits
    false,  // CompressBitsV
    false,  // ExpandBitsV
    false,  // ConstraintCast
    true ,  // CMoveD
    true ,  // CMoveF
    true ,  // CMoveI
    true ,  // CMoveL
    true ,  // CMoveP
    true ,  // CMoveN
    true ,  // CmpN
    true ,  // CmpD
    true ,  // CmpD3
    true ,  // CmpF
    true ,  // CmpF3
    true ,  // CmpI
    true ,  // CmpL
    true ,  // CmpL3
    true ,  // CmpLTMask
    true ,  // CmpP
    true ,  // CmpU
    false,  // CmpU3
    true ,  // CmpUL
    false,  // CmpUL3
    false,  // CompareAndSwapB
    false,  // CompareAndSwapS
    true ,  // CompareAndSwapI
    true ,  // CompareAndSwapL
    true ,  // CompareAndSwapP
    true ,  // CompareAndSwapN
    false,  // WeakCompareAndSwapB
    false,  // WeakCompareAndSwapS
    false,  // WeakCompareAndSwapI
    false,  // WeakCompareAndSwapL
    false,  // WeakCompareAndSwapP
    false,  // WeakCompareAndSwapN
    false,  // CompareAndExchangeB
    false,  // CompareAndExchangeS
    false,  // CompareAndExchangeI
    false,  // CompareAndExchangeL
    false,  // CompareAndExchangeP
    false,  // CompareAndExchangeN
    false,  // GetAndAddB
    false,  // GetAndAddS
    true ,  // GetAndAddI
    true ,  // GetAndAddL
    false,  // GetAndSetB
    false,  // GetAndSetS
    true ,  // GetAndSetI
    true ,  // GetAndSetL
    true ,  // GetAndSetP
    true ,  // GetAndSetN
    false,  // Con
    true ,  // ConN
    true ,  // ConNKlass
    true ,  // ConD
    true ,  // ConF
    true ,  // ConI
    true ,  // ConL
    true ,  // ConP
    true ,  // Conv2B
    true ,  // ConvD2F
    true ,  // ConvD2I
    true ,  // ConvD2L
    true ,  // ConvF2D
    true ,  // ConvF2I
    true ,  // ConvF2L
    true ,  // ConvI2D
    true ,  // ConvI2F
    true ,  // ConvI2L
    true ,  // ConvL2D
    true ,  // ConvL2F
    true ,  // ConvL2I
    false,  // ConvF2HF
    false,  // ConvHF2F
    false,  // CountedLoop
    true ,  // CountedLoopEnd
    false,  // OuterStripMinedLoop
    false,  // OuterStripMinedLoopEnd
    false,  // LongCountedLoop
    false,  // LongCountedLoopEnd
    true ,  // CountLeadingZerosI
    true ,  // CountLeadingZerosL
    false,  // CountLeadingZerosV
    true ,  // CountTrailingZerosI
    true ,  // CountTrailingZerosL
    false,  // CountTrailingZerosV
    true ,  // CreateEx
    true ,  // DecodeN
    true ,  // DecodeNKlass
    true ,  // DivD
    true ,  // DivF
    true ,  // DivI
    true ,  // DivL
    false,  // UDivI
    false,  // UDivL
    false,  // DivMod
    true ,  // DivModI
    true ,  // DivModL
    false,  // UDivModI
    false,  // UDivModL
    true ,  // EncodeISOArray
    true ,  // EncodeP
    true ,  // EncodePKlass
    true ,  // FastLock
    true ,  // FastUnlock
    true ,  // FmaD
    true ,  // FmaF
    true ,  // Goto
    true ,  // Halt
    true ,  // CountPositives
    true ,  // If
    false,  // RangeCheck
    false,  // IfFalse
    false,  // IfTrue
    false,  // Initialize
    false,  // JProj
    false,  // Jump
    false,  // JumpProj
    true ,  // LShiftI
    true ,  // LShiftL
    true ,  // LoadB
    true ,  // LoadUB
    true ,  // LoadUS
    true ,  // LoadD
    true ,  // LoadD_unaligned
    true ,  // LoadF
    true ,  // LoadI
    true ,  // LoadKlass
    true ,  // LoadNKlass
    true ,  // LoadL
    true ,  // LoadL_unaligned
    true ,  // LoadP
    true ,  // LoadN
    true ,  // LoadRange
    true ,  // LoadS
    false,  // Lock
    false,  // Loop
    false,  // LoopLimit
    false,  // Mach
    false,  // MachNullCheck
    false,  // MachProj
    false,  // MulAddS2I
    true ,  // MaxI
    false,  // MaxL
    false,  // MaxD
    false,  // MaxF
    true ,  // MemBarAcquire
    true ,  // LoadFence
    true ,  // MemBarAcquireLock
    true ,  // MemBarCPUOrder
    true ,  // MemBarRelease
    true ,  // StoreFence
    true ,  // StoreStoreFence
    true ,  // MemBarReleaseLock
    true ,  // MemBarVolatile
    true ,  // MemBarStoreStore
    false,  // MergeMem
    true ,  // MinI
    false,  // MinL
    false,  // MinF
    false,  // MinD
    false,  // ModD
    false,  // ModF
    true ,  // ModI
    true ,  // ModL
    false,  // UModI
    false,  // UModL
    true ,  // MoveI2F
    true ,  // MoveF2I
    true ,  // MoveL2D
    true ,  // MoveD2L
    false,  // IsInfiniteF
    false,  // IsFiniteF
    false,  // IsInfiniteD
    false,  // IsFiniteD
    true ,  // MulD
    true ,  // MulF
    true ,  // MulHiL
    false,  // UMulHiL
    true ,  // MulI
    true ,  // MulL
    false,  // Multi
    false,  // NegI
    false,  // NegL
    true ,  // NegD
    true ,  // NegF
    false,  // NeverBranch
    false,  // OnSpinWait
    false,  // Opaque1
    false,  // OpaqueLoopInit
    false,  // OpaqueLoopStride
    false,  // OpaqueZeroTripGuard
    false,  // Opaque3
    false,  // Opaque4
    false,  // OpaqueInitializedAssertionPredicate
    false,  // ProfileBoolean
    true ,  // OrI
    true ,  // OrL
    true ,  // OverflowAddI
    true ,  // OverflowSubI
    false,  // OverflowMulI
    true ,  // OverflowAddL
    true ,  // OverflowSubL
    false,  // OverflowMulL
    false,  // PCTable
    false,  // Parm
    false,  // ParsePredicate
    true ,  // PartialSubtypeCheck
    false,  // SubTypeCheck
    false,  // Phi
    true ,  // PopCountI
    true ,  // PopCountL
    false,  // PopCountVI
    false,  // PopCountVL
    false,  // PopulateIndex
    true ,  // PrefetchAllocation
    false,  // Proj
    true ,  // RShiftI
    true ,  // RShiftL
    false,  // Region
    true ,  // Rethrow
    true ,  // Return
    false,  // ReverseI
    false,  // ReverseL
    false,  // ReverseV
    false,  // Root
    true ,  // RoundDouble
    false,  // RoundDoubleMode
    false,  // RoundDoubleModeV
    true ,  // RoundFloat
    false,  // RotateLeft
    false,  // RotateLeftV
    false,  // RotateRight
    false,  // RotateRightV
    true ,  // SafePoint
    false,  // SafePointScalarObject
    false,  // SafePointScalarMerge
    false,  // ShenandoahCompareAndExchangeP
    false,  // ShenandoahCompareAndExchangeN
    false,  // ShenandoahCompareAndSwapN
    false,  // ShenandoahCompareAndSwapP
    false,  // ShenandoahWeakCompareAndSwapN
    false,  // ShenandoahWeakCompareAndSwapP
    false,  // ShenandoahIUBarrier
    false,  // ShenandoahLoadReferenceBarrier
    false,  // SCMemProj
    false,  // CopySignD
    false,  // CopySignF
    false,  // SignumD
    false,  // SignumF
    false,  // SignumVF
    false,  // SignumVD
    true ,  // SqrtD
    true ,  // SqrtF
    false,  // RoundF
    false,  // RoundD
    false,  // Start
    false,  // StartOSR
    true ,  // StoreB
    true ,  // StoreC
    true ,  // StoreCM
    true ,  // StoreD
    true ,  // StoreF
    true ,  // StoreI
    true ,  // StoreL
    true ,  // StoreP
    true ,  // StoreN
    true ,  // StoreNKlass
    true ,  // StrComp
    true ,  // StrCompressedCopy
    true ,  // StrEquals
    true ,  // StrIndexOf
    true ,  // StrIndexOfChar
    true ,  // StrInflatedCopy
    true ,  // SubD
    true ,  // SubF
    true ,  // SubI
    true ,  // SubL
    true ,  // TailCall
    true ,  // TailJump
    false,  // MacroLogicV
    true ,  // ThreadLocal
    false,  // Unlock
    false,  // URShiftB
    false,  // URShiftS
    true ,  // URShiftI
    true ,  // URShiftL
    true ,  // XorI
    true ,  // XorL
    false,  // Vector
    false,  // AddVB
    false,  // AddVS
    false,  // AddVI
    false,  // AddReductionVI
    false,  // AddVL
    false,  // AddReductionVL
    false,  // AddVF
    false,  // AddReductionVF
    false,  // AddVD
    false,  // AddReductionVD
    false,  // SubVB
    false,  // SubVS
    false,  // SubVI
    false,  // SubVL
    false,  // SubVF
    false,  // SubVD
    false,  // MulVB
    false,  // MulVS
    false,  // MulVI
    false,  // MulReductionVI
    false,  // MulVL
    false,  // MulReductionVL
    false,  // MulVF
    false,  // MulReductionVF
    false,  // MulVD
    false,  // MulReductionVD
    false,  // MulAddVS2VI
    false,  // FmaVD
    false,  // FmaVF
    false,  // DivVF
    false,  // DivVD
    false,  // AbsVB
    false,  // AbsVS
    false,  // AbsVI
    false,  // AbsVL
    false,  // AbsVF
    false,  // AbsVD
    false,  // NegVI
    false,  // NegVL
    false,  // NegVF
    false,  // NegVD
    false,  // SqrtVD
    false,  // SqrtVF
    false,  // LShiftCntV
    false,  // RShiftCntV
    false,  // LShiftVB
    false,  // LShiftVS
    false,  // LShiftVI
    false,  // LShiftVL
    false,  // RShiftVB
    false,  // RShiftVS
    false,  // RShiftVI
    false,  // RShiftVL
    false,  // URShiftVB
    false,  // URShiftVS
    false,  // URShiftVI
    false,  // URShiftVL
    false,  // AndV
    false,  // AndReductionV
    false,  // OrV
    false,  // OrReductionV
    false,  // XorV
    false,  // XorReductionV
    false,  // MinV
    false,  // MaxV
    false,  // MinReductionV
    false,  // MaxReductionV
    false,  // CompressV
    false,  // CompressM
    false,  // ExpandV
    true ,  // LoadVector
    false,  // LoadVectorGather
    false,  // LoadVectorGatherMasked
    true ,  // StoreVector
    false,  // StoreVectorScatter
    false,  // StoreVectorScatterMasked
    false,  // LoadVectorMasked
    false,  // StoreVectorMasked
    false,  // VerifyVectorAlignment
    false,  // VectorCmpMasked
    false,  // VectorMaskGen
    false,  // VectorMaskOp
    false,  // VectorMaskTrueCount
    false,  // VectorMaskFirstTrue
    false,  // VectorMaskLastTrue
    false,  // VectorMaskToLong
    false,  // VectorLongToMask
    false,  // Pack
    false,  // PackB
    false,  // PackS
    false,  // PackI
    false,  // PackL
    false,  // PackF
    false,  // PackD
    false,  // Pack2L
    false,  // Pack2D
    true ,  // Replicate
    false,  // RoundVF
    false,  // RoundVD
    false,  // Extract
    false,  // ExtractB
    false,  // ExtractUB
    false,  // ExtractC
    false,  // ExtractS
    false,  // ExtractI
    false,  // ExtractL
    false,  // ExtractF
    false,  // ExtractD
    false,  // Digit
    false,  // LowerCase
    false,  // UpperCase
    false,  // Whitespace
    false,  // VectorBox
    false,  // VectorBoxAllocate
    false,  // VectorUnbox
    false,  // VectorMaskWrapper
    false,  // VectorMaskCmp
    false,  // VectorMaskCast
    false,  // VectorTest
    false,  // VectorBlend
    false,  // VectorRearrange
    false,  // VectorLoadMask
    false,  // VectorLoadShuffle
    false,  // VectorLoadConst
    false,  // VectorStoreMask
    true ,  // VectorReinterpret
    false,  // VectorCast
    false,  // VectorCastB2X
    false,  // VectorCastS2X
    false,  // VectorCastI2X
    false,  // VectorCastL2X
    false,  // VectorCastF2X
    false,  // VectorCastD2X
    false,  // VectorCastF2HF
    false,  // VectorCastHF2F
    false,  // VectorUCastB2X
    false,  // VectorUCastS2X
    false,  // VectorUCastI2X
    false,  // VectorizedHashCode
    false,  // VectorInsert
    false,  // MaskAll
    false,  // AndVMask
    false,  // OrVMask
    false   // XorVMask
};


int Compile::sync_stack_slots() const { return frame::jit_monitor_size_in_4_byte_units; }

uint Matcher::stack_alignment_in_bytes() { return frame::alignment_in_bytes; }

OptoReg::Name Matcher::return_addr() const { return OptoReg::Name(Z_R14_num); }

uint Compile::varargs_C_out_slots_killed() const { return ((frame::z_abi_160_size - frame::z_jit_out_preserve_size) / VMRegImpl::stack_slot_size); }

OptoRegPair Matcher::return_value(uint ideal_reg) {

#line 2328 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert(ideal_reg >= Op_RegI && ideal_reg <= Op_RegL, "only return normal values");
    static int typeToRegLo[Op_RegL+1] = { 0, 0, Z_R2_num, Z_R2_num, Z_R2_num, Z_F0_num, Z_F0_num, Z_R2_num };
    static int typeToRegHi[Op_RegL+1] = { 0, 0, OptoReg::Bad, OptoReg::Bad, Z_R2_H_num, OptoReg::Bad, Z_F0_H_num, Z_R2_H_num };
    return OptoRegPair(typeToRegHi[ideal_reg], typeToRegLo[ideal_reg]);
  
#line 22161 "ad_s390.cpp"

}

OptoRegPair Matcher::c_return_value(uint ideal_reg) {

#line 2319 "/builddir/build/BUILD/java-23-openjdk-23.0.0.0.37-2.rolling.fc39.s390x/jdk-23+37/src/hotspot/cpu/s390/s390.ad"

    assert(ideal_reg >= Op_RegI && ideal_reg <= Op_RegL, "only return normal values");
    static int typeToRegLo[Op_RegL+1] = { 0, 0, Z_R2_num, Z_R2_num, Z_R2_num, Z_F0_num, Z_F0_num, Z_R2_num };
    static int typeToRegHi[Op_RegL+1] = { 0, 0, OptoReg::Bad, OptoReg::Bad, Z_R2_H_num, OptoReg::Bad, Z_F0_H_num, Z_R2_H_num };
    return OptoRegPair(typeToRegHi[ideal_reg], typeToRegLo[ideal_reg]);
  
#line 22174 "ad_s390.cpp"

}

OptoReg::Name Matcher::inline_cache_reg() { return OptoReg::Name(Z_R9_num); }

int Matcher::inline_cache_reg_encode() { return _regEncode[inline_cache_reg()]; }

OptoReg::Name Matcher::interpreter_frame_pointer_reg() { return OptoReg::Name(Z_R7_num); }

OptoReg::Name Matcher::c_frame_pointer() const { return OptoReg::Name(Z_R15_num); }

// Number of callee-save + always-save registers
int  Matcher::number_of_saved_registers() {
  return 0;
};

bool Compile::needs_deep_clone_jvms() { return false; }

// Check consistency of C++ compilation with ADLC options:
// Check adlc -DLINUX=1
#ifndef LINUX
#  error "LINUX must be defined"
#endif // LINUX
// Check adlc -D_GNU_SOURCE=1
#ifndef _GNU_SOURCE
#  error "_GNU_SOURCE must be defined"
#endif // _GNU_SOURCE
// Check adlc -DS390=1
#ifndef S390
#  error "S390 must be defined"
#endif // S390
// Check adlc -D_LP64=1
#ifndef _LP64
#  error "_LP64 must be defined"
#endif // _LP64
// Check adlc -DASSERT=1
#ifndef ASSERT
#  error "ASSERT must be defined"
#endif // ASSERT
